<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: signup2.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

if(!defined('PE_URL')) {
	header('Location: ../pages/index.php');
	exit(0);
}

require_once(PE_PATH.'/framework/class.wb.php');
$wb = new wb('Start', 'start', false, false);

// Create new database object
$database = new database();

// Get details entered
$groups_id = FRONTEND_SIGNUP;
$active = 1;
$username = strtolower(strip_tags($wb->get_post_escaped('username')));
$display_name = strip_tags($wb->get_post_escaped('display_name'));
$email = $wb->get_post('email');

// Create a javascript back link
//$js_back = "javascript: history.go(-1);";
$js_back = PE_URL.'/account/signup.php';

// Check values
if($groups_id == "") {
	$wb->print_error($MESSAGE['USERS']['NO_GROUP'], $js_back, false);
}
if(strlen($username) < 3) {
	$wb->print_error($MESSAGE['USERS']['USERNAME_TOO_SHORT'], $js_back, false);
}
if($email != "") {
	if($wb->validate_email($email) == false) {
		$wb->print_error($MESSAGE['USERS']['INVALID_EMAIL'], $js_back, false);
	}
} else {
	$wb->print_error($MESSAGE['SIGNUP']['NO_EMAIL'], $js_back, false);
}

$email = $wb->add_slashes($email);

// Captcha
if(ENABLED_CAPTCHA) {
	if(isset($_POST['captcha']) AND $_POST['captcha'] != ''){
		// Check for a mismatch
		if(!isset($_POST['captcha']) OR !isset($_SESSION['captcha']) OR $_POST['captcha'] != $_SESSION['captcha']) {
			$wb->print_error($MESSAGE['MOD_FORM']['INCORRECT_CAPTCHA'], $js_back, false);
		}
	} else {
		$wb->print_error($MESSAGE['MOD_FORM']['INCORRECT_CAPTCHA'], $js_back, false);
	}
}
if(isset($_SESSION['captcha'])) { unset($_SESSION['captcha']); }

// Generate a random password then update the database with it
$new_pass = '';
$salt = "abchefghjkmnpqrstuvwxyz0123456789";
srand((double)microtime()*1000000);
$i = 0;
while ($i <= 7) {
	$num = rand() % 33;
	$tmp = substr($salt, $num, 1);
	$new_pass = $new_pass . $tmp;
	$i++;
}
$md5_password = md5($new_pass);

// Check if username already exists
$results = $database->query("SELECT user_id FROM ".TABLE_PREFIX."users WHERE username = '$username'");
if($results->numRows() > 0) {
	$wb->print_error($MESSAGE['USERS']['USERNAME_TAKEN'], $js_back, false);
}

// Check if the email already exists
$results = $database->query("SELECT user_id FROM ".TABLE_PREFIX."users WHERE email = '".$wb->add_slashes($email)."'");
if($results->numRows() > 0) {
	if(isset($MESSAGE['USERS']['EMAIL_TAKEN'])) {
		$wb->print_error($MESSAGE['USERS']['EMAIL_TAKEN'], $js_back, false);
	} else {
		$wb->print_error($MESSAGE['USERS']['INVALID_EMAIL'], $js_back, false);
	}
}

// MD5 supplied password
$md5_password = md5($new_pass);

// Inser the user into the database
$query = "INSERT INTO ".TABLE_PREFIX."users (group_id,groups_id,active,username,password,display_name,email) VALUES ('$groups_id', '$groups_id', '$active', '$username','$md5_password','$display_name','$email')";
$database->query($query);

if($database->is_error()) {
	// Error updating database
	$message = $database->get_error();
} else {
	// Setup email to send
	$mail_to = $email;
	$mail_subject = $MESSAGE['SIGNUP2']['SUBJECT_LOGIN_INFO'];

	// Replace placeholders from language variable with values
	$search = array('{LOGIN_DISPLAY_NAME}', '{LOGIN_WEBSITE_TITLE}', '{LOGIN_NAME}', '{LOGIN_PASSWORD}');
	$replace = array($display_name, WEBSITE_TITLE, $username, $new_pass); 
	$mail_message = str_replace($search, $replace, $MESSAGE['SIGNUP2']['BODY_LOGIN_INFO']);

	// Try sending the email
	if($wb->mail(SERVER_EMAIL,$mail_to,$mail_subject,$mail_message)) { 
		$display_form = false;
		$wb->print_success($MESSAGE['FORGOT_PASS']['PASSWORD_RESET'], PE_URL.'/account/login.php');
	} else {
		$database->query("DELETE FROM ".TABLE_PREFIX."users WHERE username = '$username'");
		$wb->print_error($MESSAGE['FORGOT_PASS']['CANNOT_EMAIL'], $js_back, false);
	}
}

?>
