<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: November 01,2009                                            *
 *    Build Time: 21:00:00                                                    *
 *     File Name: index.php                                                   *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Access', 'access');
$admin->print_sub_header($HEADING['MY_ACCESS'],$HEADING['MY_ACCESS_SUB'],THEME_URL.'/icons/access_point.png');

// Setup template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'access.htt');
$template->set_block('page', 'main_block', 'main');

// Insert values into the template object
$template->set_var(array(
								'ADMIN_URL' => ADMIN_URL,
								'THEME_URL' => THEME_URL,
								'PE_URL' => PE_URL
								)
						);

// Insert permission values into the template object
if($admin->get_permission('users') != true) {
	$template->set_var('DISPLAY_USERS', 'none');
}
if($admin->get_permission('groups') != true) {
	$template->set_var('DISPLAY_GROUPS', 'none');
}

// Insert section names and descriptions
$template->set_var(array(
								'USERS' => $MENU['USERS'],
								'GROUPS' => $MENU['GROUPS'],
								'USERS_OVERVIEW' => $OVERVIEW['USERS'],
								'GROUPS_OVERVIEW' => $OVERVIEW['GROUPS'],
								)
						);
	$who = $Pacer->Pacer_Super_User_Who_Is_Online('');
	
	if (count($who)) {
		$template->set_var(array(
								'TEXT_WHO_IS_ONLINE' => $Pacer->Translate('Who is online'),
								'TEXT_WHO_USER' => $TEXT['USER'],
								'TEXT_WHO_PAGE' => $TEXT['PAGE'],
								'TEXT_WHO_WHEN' => $Pacer->Translate('When'),
								)
						);
		
		$template->set_block('main_block', 'who_list_block', 'who_list');
		$p = '';
		foreach($who as $k => $v){
			foreach($v['trail'] as $action){
				if($page = $Pacer->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '".$action['page_id']."'")){
					$p .= (($p)?', ':'').$page['page_title'];
					break;
				}
			}
			$template->set_var(array(
								'WHO_USER' => (($v['display_name'])?$v['display_name']:$v['username']),
								'WHO_PAGE' => $p,
								'WHO_WHEN' => date(DATE_FORMAT.' '.TIME_FORMAT,$v['when']),
								)
						);
			$template->parse('who_list', 'who_list_block', true);
		}
	} else {
		$template->set_var('DISPLAY_WHO_IS_ONLINE','style="display:none"');
	}

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

// Print admin footer
$admin->print_footer();

?>