<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: November 01,2009                                            *
 *    Build Time: 21:00:00                                                    *
 *     File Name: index.php                                                   *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */


require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Start','start');
$admin->print_sub_header($HEADING['HEADER_START'],$HEADING['HEADER_START_SUB'],THEME_URL.'/icons/home.png');

require_once(PE_PATH.'/framework/functions.php');
if(in_array(1, $admin->get_groups_id())) {
	if(isset($_GET['rminstall'])){
		if(file_exists(PE_PATH.'/install/')) {
			rm_full_dir(PE_PATH.'/install/');
		}
	}
}

// Setup template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'dashboard.htt');
$template->set_block('page', 'main_block', 'main');

// Insert values into the template object
$template->set_var(array(
								'WELCOME_MESSAGE' => $MESSAGE['START']['WELCOME_MESSAGE'],
								'CURRENT_USER' => $MESSAGE['START']['CURRENT_USER'],
								'DISPLAY_NAME' => $admin->get_display_name(),
								'ADMIN_URL' => ADMIN_URL,
								'PE_URL' => PE_URL,
								'THEME_URL' => THEME_URL,
								'PE_VERSION' => PE_VERSION
								)
						);

// Insert permission values into the template object
if($admin->get_permission('pages') != true) {
	$template->set_var('DISPLAY_PAGES', 'style="display:none"');
}
if($admin->get_permission('media') != true) {
	$template->set_var('DISPLAY_MEDIA', 'style="display:none"');
}
if($admin->get_permission('addons') != true) {
	$template->set_var('DISPLAY_ADDONS', 'style="display:none"');
}
if($admin->get_permission('access') != true) {
	$template->set_var('DISPLAY_ACCESS', 'style="display:none"');
}
if($admin->get_permission('settings') != true) {
	$template->set_var('DISPLAY_SETTINGS', 'style="display:none"');
}
if($admin->get_permission('admintools') != true) {
	$template->set_var('DISPLAY_ADMINTOOLS', 'style="display:none"');
}
if($admin->get_group_id()!=1) {
	$template->set_var('DISPLAY_SOFTWARE', 'style="display:none"');
}

// Check if installation directory still exists
if(file_exists(PE_PATH.'/install/')) {
	// Check if user is part of Adminstrators group
	if(in_array(1, $admin->get_groups_id())) {
		$template->set_var('WARNING', $MESSAGE['START']['INSTALL_DIR_EXISTS']);
		$template->set_var('REMOVE_TEXT', $Pacer->Translate('Would you like to remove it now?'));
		$template->set_var('REMOVE_LINK', 'javascript:confirm_link(\''.$Pacer->Translate("Delete /install folder?").'\',\''.ADMIN_URL.'/dashboard/index.php?rminstall=1'.'\')');
	} else {
		$template->set_var('DISPLAY_WARNING', 'style="display:none"');
		$template->set_var('DISPLAY_NOT_AVAILABLE', 'style="display:none"');
	}
} else {
	$template->set_var('DISPLAY_WARNING', 'style="display:none"');
}

// Insert "Add-ons" section overview (pretty complex compared to normal)
$addons_overview = $TEXT['MANAGE'].' ';
$addons_count = 0;
if($admin->get_permission('modules') == true) {
	$addons_overview .= '<br /><a href="'.ADMIN_URL.'/modules/index.php">'.$MENU['MODULES'].'</a>';
	$addons_count = 1;
}
if($admin->get_permission('templates') == true) {
	if($addons_count == 1) { $addons_overview .= ', '; }
	$addons_overview .= '<a href="'.ADMIN_URL.'/templates/index.php">'.$MENU['TEMPLATES'].'</a>';
	$addons_count = 1;
}
if($admin->get_permission('templates') == true) {
	if($addons_count == 1) { $addons_overview .= ', '; }
	$addons_overview .= '<a href="'.ADMIN_URL.'/menus/index.php">'.$MENU['MENUS'].'</a>';
	$addons_count = 1;
}

if($admin->get_permission('languages') == true) {
	if($addons_count == 1) { $addons_overview .= ', '; }
	$addons_overview .= '<a href="'.ADMIN_URL.'/languages/index.php">'.$MENU['LANGUAGES'].'</a>';
}

// Insert "Access" section overview (pretty complex compared to normal)
$access_overview = $TEXT['MANAGE'].' ';
$access_count = 0;
if($admin->get_permission('users') == true) {
	$access_overview .= '<a href="'.ADMIN_URL.'/users/index.php">'.$MENU['USERS'].'</a>';
	$access_count = 1;
}
if($admin->get_permission('groups') == true) {
	if($access_count == 1) { $access_overview .= ', '; }
	$access_overview .= '<a href="'.ADMIN_URL.'/groups/index.php">'.$MENU['GROUPS'].'</a>';
	$access_count = 1;
}

// Insert section names and descriptions
$template->set_var(array(
								'PAGES' => $MENU['PAGES'],
								'MEDIA' => $MENU['MEDIA'],
								'ADDONS' => $MENU['ADDONS'],
								'ACCESS' => $MENU['ACCESS'],
								'PREFERENCES' => $MENU['PREFERENCES'],
								'SETTINGS' => $MENU['SETTINGS'],
								'ADMINTOOLS' => $MENU['ADMINTOOLS'],
								'SOFTWARE' => $MENU['SOFTWARE'],
								'HOME_OVERVIEW' => $OVERVIEW['START'],
								'PAGES_OVERVIEW' => $OVERVIEW['PAGES'],
								'MEDIA_OVERVIEW' => $OVERVIEW['MEDIA'],
								'ADDONS_OVERVIEW' => $addons_overview,
								'ACCESS_OVERVIEW' => $access_overview,
								'PREFERENCES_OVERVIEW' => $OVERVIEW['PREFERENCES'],
								'SETTINGS_OVERVIEW' => $OVERVIEW['SETTINGS'],
								'ADMINTOOLS_OVERVIEW' => $OVERVIEW['ADMINTOOLS'],
								'HEADER_START' => $HEADING['HEADER_START'],
								'HEADER_START_SUB' => $HEADING['HEADER_START_SUB'],
								'HEADER_SOFTWARE' => $HEADING['HEADER_SOFTWARE'],
								'NOT_AVAILABLE' => $Pacer->Translate('Not Available'),
								'HEADER_NOT_AVAILABLE' => $Pacer->Translate('This feature is not yet available'),
								)
						);

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

// Print admin footer
$admin->print_footer();

?>