<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: November 01,2009                                            *
 *    Build Time: 21:00:00                                                    *
 *     File Name: groups.php                                                  *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

// Include config file and admin class file
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');

if(isset($_GET['action']) AND ($_GET['action'] == "modify" OR $_GET['action'] == "delete" OR $_GET['action'] == "add")) {
	if((!isset($_GET['group_id']) OR !is_numeric($_GET['group_id']) OR $_GET['group_id'] == 1) AND ($_GET['action'] != "add")){
		header("Location: index.php");
		exit(0);
	}
	$_POST['action'] = $_GET['action'];
	$_POST['group_id'] = (isset($_GET['group_id'])) ? $_GET['group_id']:0;
	 
} else {
	if(!isset($_POST['action']) OR ($_POST['action'] != "modify" AND $_POST['action'] != "delete")) {
		header("Location: index.php");
		exit(0);
	}

	// Check if group group_id is a valid number and doesnt equal 1
	if(!isset($_POST['group_id']) OR !is_numeric($_POST['group_id']) OR $_POST['group_id'] == 1) {
		header("Location: index.php");
		exit(0);
	}
}

// Create new database object
$database = new database();

if($_POST['action'] == 'modify' OR $_POST['action'] == 'add') {
	$admin = new admin('Access', ($_POST['action'] == 'modify') ? 'groups_modify':'groups_add');
	$admin->print_sub_header($Pacer->Translate('Add Group'),$Pacer->Translate('Setup groups and manage permissions...'),THEME_URL.'/icons/groups.png');

	// Get existing values
	$results = $database->query("SELECT * FROM ".TABLE_PREFIX."groups WHERE group_id = '".$_POST['group_id']."'");
	$group = $results->fetchRow();

	// Setup template object
	$template = new Template(THEME_PATH.'/templates');
	$template->set_file('page', 'groups_form.htt');
	$template->set_block('page', 'main_block', 'main');


	$template->set_var(	array(	
			'GROUP_ID' => ($_POST['action'] == 'modify') ? $group['group_id']:"0",
			'ACTION' => (isset($_GET['action']) AND $_GET['action'] == "add")?"add":"modify",
			'TEXT_CANCEL' => $TEXT['CANCEL'],
			'CANCEL_URL' => ADMIN_URL.'/groups/index.php',

			'HEADING_MODIFY_GROUPS' => $Pacer->Translate(($_POST['action'] == 'modify')?'Modify Group':'Add Group')
										)
							);

	
	$template->set_var(	array(
										'ACTION_URL' => ADMIN_URL.'/groups/save.php',
										'SUBMIT_TITLE' => $TEXT['SAVE'],
										'GROUP_ID' => $group['group_id'],
										'GROUP_NAME' => $group['name'],
										'ADVANCED_ACTION' => 'groups.php'
										)
							);
	
	// Explode system permissions
	$system_permissions = explode(',', $group['system_permissions']);
	// Check system permissions boxes
	foreach($system_permissions AS $name) {
			$template->set_var($name.'_checked', 'checked="checked"');
	}
	// Explode module permissions
	$module_permissions = explode(',', $group['module_permissions']);
		// Explode pacer menu permissions
	$pacer_menu_permissions = explode(',', $group['pacer_menu_permissions']);
	
	// Explode template permissions
	$template_permissions = explode(',', $group['template_permissions']);
	
	// Insert values into module list
	$template->set_block('main_block', 'module_list_block', 'module_list');
	$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'module' AND function = 'page'");
	if($result->numRows() > 0) {
		while($addon = $result->fetchRow()) {
			$template->set_var('VALUE', $addon['directory']);
			$template->set_var('NAME', $addon['name']);
			if(!is_numeric(array_search($addon['directory'], $module_permissions))) {
				$template->set_var('CHECKED', ' checked="checked"');
			} else {
				$template->set_var('CHECKED', '');
			}
			$template->parse('module_list', 'module_list_block', true);
		}
	}
	
		// Insert values into PACER MENU list
	$template->set_block('main_block', 'pacer_menu_list_block', 'pacer_menu_list');
	$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'pacer_menu' AND function = 'pacer_menu'");
	if($result->numRows() > 0) {
		while($addon = $result->fetchRow()) {
			$template->set_var('VALUE', $addon['directory']);
			$template->set_var('NAME', $addon['name']);
			if(!is_numeric(array_search($addon['directory'], $pacer_menu_permissions))) {
				$template->set_var('CHECKED', ' checked="checked"');
			} else {
				$template->set_var('CHECKED', '');
			}
			$template->parse('pacer_menu_list', 'pacer_menu_list_block', true);
		}
	}
		
	// Insert values into template list
	$template->set_block('main_block', 'template_list_block', 'template_list');
	$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'template'");
	if($result->numRows() > 0) {
		while($addon = $result->fetchRow()) {
			$template->set_var('VALUE', $addon['directory']);
			$template->set_var('NAME', $addon['name']);
			if(!is_numeric(array_search($addon['directory'], $template_permissions))) {
				$template->set_var('CHECKED', ' checked="checked"');
			} else {
				$template->set_var('CHECKED', '');
			}
			$template->parse('template_list', 'template_list_block', true);
		}
	}
		
	// Insert language text and messages
	$template->set_var(array(
									'TEXT_RESET' => $TEXT['RESET'],
									'TEXT_ACTIVE' => $TEXT['ACTIVE'],
									'TEXT_DISABLED' => $TEXT['DISABLED'],
									'TEXT_PLEASE_SELECT' => $TEXT['PLEASE_SELECT'],
									'TEXT_USERNAME' => $TEXT['USERNAME'],
									'TEXT_PASSWORD' => $TEXT['PASSWORD'],
									'TEXT_RETYPE_PASSWORD' => $TEXT['RETYPE_PASSWORD'],
									'TEXT_DISPLAY_NAME' => $TEXT['DISPLAY_NAME'],
									'TEXT_EMAIL' => $TEXT['EMAIL'],
									'TEXT_GROUP' => $TEXT['GROUP'],
									'TEXT_SYSTEM_PERMISSIONS' => $TEXT['SYSTEM_PERMISSIONS'],
									'TEXT_MODULE_PERMISSIONS' => $TEXT['MODULE_PERMISSIONS'],
									'TEXT_TEMPLATE_PERMISSIONS' => $TEXT['TEMPLATE_PERMISSIONS'],
									'TEXT_NAME' => $TEXT['NAME'],
									'SECTION_PAGES' => $MENU['PAGES'],
									'SECTION_MEDIA' => $MENU['MEDIA'],
									'SECTION_MODULES' => $MENU['MODULES'],
									'SECTION_TEMPLATES' => $MENU['TEMPLATES'],
									'SECTION_PACER_MENU' => $Pacer->Translate('Pacer Menus'),
									'TEXT_PACER_MENU_PERMISSIONS' => $Pacer->Translate('Pacer Menu Permissions'),
									'SECTION_LANGUAGES' => $MENU['LANGUAGES'],
									'SECTION_SETTINGS' => $MENU['SETTINGS'],
									'SECTION_USERS' => $MENU['USERS'],
									'SECTION_GROUPS' => $MENU['GROUPS'],
									'SECTION_ADMINTOOLS' => $MENU['ADMINTOOLS'],
									'SECTION_ADVANCED_SETTINGS' => $Pacer->Translate('Advanced Settings'),
									'SECTION_PACER' =>  $Pacer->Translate('Pacer'),
									'TEXT_VIEW' => $TEXT['VIEW'],
									'TEXT_ADD' => $TEXT['ADD'],
									'TEXT_LEVEL' => $TEXT['LEVEL'],
									'TEXT_MODIFY' => $TEXT['MODIFY'],
									'TEXT_DELETE' => $TEXT['DELETE'],
									'TEXT_MODIFY_CONTENT' => $TEXT['MODIFY_CONTENT'],
									'TEXT_MODIFY_SETTINGS' => $TEXT['MODIFY_SETTINGS'],
									'HEADING_MODIFY_INTRO_PAGE' => $HEADING['MODIFY_INTRO_PAGE'],
									'TEXT_CREATE_FOLDER' => $TEXT['CREATE_FOLDER'],
									'TEXT_RENAME' => $TEXT['RENAME'],
									'TEXT_UPLOAD_FILES' => $TEXT['UPLOAD_FILES'],
									'TEXT_BASIC' => $TEXT['BASIC'],
									'TEXT_ADVANCED' => $TEXT['ADVANCED'],
									
									'SECTION_RANKING' => $Pacer->Translate('Ranking'),
									'TEXT_GROUP_RANK' => $Pacer->Translate('Rank'),
									'CHANGING_PASSWORD' => $MESSAGE['USERS']['CHANGING_PASSWORD'],
									//'HEADING_MY_ACCESS_ADD_GROUP' => $HEADING['MY_ACCESS_ADD_GROUP']
									)
							);
	/* Ranking
	$template->set_block('main_block', 'ranking_block', 'ranking_list');
	foreach(array('10'=>'Administrator','50'=>'User','70'=>'Restricted User') AS $value => $name) {
		$template->set_var('NAME', $Pacer->Translate($name));
		$template->set_var('VALUE', $value);
		if($group['ranking'] == $value) {
			$template->set_var('SELECTED', ' selected="selected"');
		} else {
			$template->set_var('SELECTED', ' ');
		}
		$template->parse('ranking_list', 'ranking_block', true);
	}
	*/
	// Parse template object
	$template->parse('main', 'main_block', false);
	$template->pparse('output', 'page');
} elseif($_POST['action'] == 'delete') {
	// Create new admin object
	$admin = new admin('Access', 'groups_delete');

	// Get existing values
	$results = $database->query("SELECT * FROM ".TABLE_PREFIX."groups WHERE group_id = '".$_POST['group_id']."'");
	$group = $results->fetchRow();

	// Delete the group
	$database->query("DELETE FROM ".TABLE_PREFIX."groups WHERE group_id = '".$_POST['group_id']."' LIMIT 1");
	if($database->is_error()) {
		$admin->print_error($database->get_error());
	} else {
		// Delete users in the group
		$database->query("DELETE FROM ".TABLE_PREFIX."users WHERE group_id = '".$_POST['group_id']."'");
		if($database->is_error()) {
			$admin->print_error($database->get_error());
		} else {
			$Pacer->LogEvent("Group ".$group['group_id']." ".$group['name']." deleted");
			$admin->print_success($MESSAGE['GROUPS']['DELETED']);
		}
	}
}

// Print admin footer
$admin->print_footer();

?>