<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: April 16,2010                                               *
 *    Build Time: 11:00:00                                                    *
 *     File Name: er_levels.php                                               *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2010 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2010,                                                        *
 * The Pacer Edition CMS                                                      *
 * JCWEBDEN.COM (DARKSTAR INCORPORATED)                                       *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

/*

Error Reporting Level's list file

This file is used to generate a list of PHP
Error Reporting Level's for the user to select

*/

if(!defined('PE_URL')) {
	header('Location: ../index.php');
	exit(0);
}

// Define that this file is loaded
if(!defined('ERROR_REPORTING_LEVELS_LOADED')) {
	define('ERROR_REPORTING_LEVELS_LOADED', true);
}

// Create array
$ER_LEVELS = array();

// Add values to list
if(isset($TEXT['SYSTEM_DEFAULT'])) {
	$ER_LEVELS[''] = $TEXT['SYSTEM_DEFAULT'];
} else {
	$ER_LEVELS[''] = 'System Default';
}
$ER_LEVELS['6135'] = 'E_ALL^E_NOTICE'; // standard: E_ALL without E_NOTICE
$ER_LEVELS['0'] = 'E_NONE';
$ER_LEVELS['6143'] = 'E_ALL';
$ER_LEVELS['8191'] = htmlentities('E_ALL&E_STRICT'); // for programmers


//Value  	Constant  	Description  	Note
$arr_levels 		= array();
$arr_levels['0'] 		= array('DISABLED'			=>'Disabled.');
$arr_levels[''] 		= array('SYSTEM_DEFAULT'			=>'System Default.');
$arr_levels[E_ERROR] 		= array('E_ERROR'			=>'Fatal run-time errors. These indicate errors that can not be recovered from, such as a memory allocation problem. Execution of the script is halted.');
$arr_levels[E_WARNING] 		= array('E_WARNING'			=>'Run-time warnings (non-fatal errors). Execution of the script is not halted.');
$arr_levels[E_PARSE] 		= array('E_PARSE' 			=>'Compile-time parse errors. Parse errors should only be generated by the parser.');
$arr_levels[E_NOTICE] 		= array('E_NOTICE' 			=>'Run-time notices. Indicate that the script encountered something that could indicate an error, but could also happen in the normal course of running a script.'); 	 
$arr_levels[E_CORE_ERROR]		= array('E_CORE_ERROR'		=>'Fatal errors that occur during PHP\'s initial startup. This is like an E_ERROR, except it is generated by the core of PHP.');
$arr_levels[E_CORE_WARNING]		= array('E_CORE_WARNING'	=>'Warnings (non-fatal errors) that occur during PHP\'s initial startup. This is like an E_WARNING, except it is generated by the core of PHP.');
$arr_levels[E_COMPILE_ERROR]		= array('E_COMPILE_ERROR'	=>'Fatal compile-time errors. This is like an E_ERROR, except it is generated by the Zend Scripting Engine.');
$arr_levels[E_COMPILE_WARNING]	= array('E_COMPILE_WARNING'	=>'Compile-time warnings (non-fatal errors). This is like an E_WARNING, except it is generated by the Zend Scripting Engine.');
$arr_levels[E_USER_ERROR]	= array('E_USER_ERROR'		=>'User-generated error message. This is like an E_ERROR, except it is generated in PHP code by using the PHP function trigger_error().');
$arr_levels[E_USER_WARNING]	= array('E_USER_WARNING'	=>'User-generated warning message. This is like an E_WARNING, except it is generated in PHP code by using the PHP function trigger_error().');
$arr_levels[E_USER_NOTICE]	= array('E_USER_NOTICE'		=>'User-generated notice message. This is like an E_NOTICE, except it is generated in PHP code by using the PHP function trigger_error().');
if (defined('E_STRICT'))
	$arr_levels[E_STRICT]	= array('E_STRICT'			=>'Enable to have PHP suggest changes to your code which will ensure the best interoperability and forward compatibility of your code.');
if (defined('E_RECOVERABLE_ERROR'))
	$arr_levels[E_RECOVERABLE_ERROR]	= array('E_RECOVERABLE_ERROR'=>'Catchable fatal error. It indicates that a probably dangerous error occured, but did not leave the Engine in an unstable state. If the error is not caught by a user defined handle (see also set_error_handler()), the application aborts as it was an E_ERROR.');
if (defined('E_DEPRECATED'))
	$arr_levels[E_DEPRECATED]	= array('E_DEPRECATED'		=>'Run-time notices. Enable this to receive warnings about code that will not work in future versions.');
if (defined('E_USER_DEPRECATED'))
	$arr_levels[E_USER_DEPRECATED]	= array('E_USER_DEPRECATED'	=>'User-generated warning message. This is like an E_DEPRECATED, except it is generated in PHP code by using the PHP function trigger_error().');
$arr_levels[E_ALL]	= array('E_ALL'				=>'All errors and warnings, as supported, except of level E_STRICT in PHP < 6. 	32767 in PHP 6, 30719 in PHP 5.3.x, 6143 in PHP 5.2.x, 2047 previously');

ksort($arr_levels);
$total=0;
foreach($arr_levels as $k => $v){
	if ($k>E_ALL) continue;
	$total+=$k;
}
/*
The above values (either numerical or symbolic) are used to build up a bitmask that specifies which errors to report. You can use the bitwise operators to combine these values or mask out certain types of errors. 
Note that only '|', '~', '!', '^' and '&' will be understood within php.ini. 
*/
$arr_ops 		= array(' & '=>'AND',' | '=>'Or (inclusive or)', ' & ~'=>'AND Not', ' ^ '=>'Xor (exclusive or)');
//$arr_ops 		= array('|'=>'AND (inclusive Or)', '^'=>'NOT (XOr, exclusive Or)');
// E_ALL & ~E_WARNING & ~E_NOTICE & ~E_STRICT
$arr_presets = array();
if(isset($TEXT['SYSTEM_DEFAULT'])) {
	$arr_presets[''] = array('code'=>$TEXT['SYSTEM_DEFAULT']);
} else {
	$arr_presets[''] = array('code'=>'System Default');
}
$arr_presets[E_ALL ^ E_NOTICE] = array('code'=>'E_ALL ^ E_NOTICE','narrative'=>'Standard: E_ALL without E_NOTICE');
$arr_presets[-1] = array('code'=>'ALL');
$arr_presets[E_ALL | E_STRICT] = array('code'=>'E_ALL | E_STRICT','narrative'=>'For programmers: E_ALL with E_STICT');
$arr_presets[E_ALL & ~E_WARNING & ~E_NOTICE & ~E_STRICT] = array('code'=>'E_ALL & ~E_WARNING 
& ~E_NOTICE & ~E_STRICT','narrative'=>'To see everything except warnings, notices and comments.');
$arr_presets[0] = array('code'=>'Disabled');
?>