<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: April 16,2010                                               *
 *    Build Time: 11:00:00                                                    *
 *     File Name: timezones.php                                               *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2010 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2010,                                                        *
 * The Pacer Edition CMS                                                      *
 * JCWEBDEN.COM (DARKSTAR INCORPORATED)                                       *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

/*

Timezone list file

This file is used to generate a list of timezones for the user to select

*/

if(!defined('PE_URL')) {
	header('Location: ../index.php');
	exit(0);
}

// Create array
$TIMEZONES = array();

// Add "System Default" to top of list
if(isset($TEXT['SYSTEM_DEFAULT'])) {
	$TIMEZONES['-20'] = array('display'=>$TEXT['SYSTEM_DEFAULT']);
} else {
	$TIMEZONES['-20'] = array('display'=>'System Default');
}
require_once(PACER_PATH.'/pear/Date/TimeZone.php');
$TZS = array();
foreach(timezone_identifiers_list() as $ps_id){
	$zone = explode('/', $ps_id); // 0 => Continent, 1 => City
    // Only use "friendly" continent names
    if ($zone[0] == 'Africa' || $zone[0] == 'America' || $zone[0] == 'Antarctica' || $zone[0] == 'Arctic' || $zone[0] == 'Asia' || $zone[0] == 'Atlantic' || $zone[0] == 'Australia' || $zone[0] == 'Europe' || $zone[0] == 'Indian' || $zone[0] == 'Pacific' || $zone[0] == 'Others')
    {       
        if (isset($zone[1]) != '')
        {
			$tz = new Date_TimeZone($ps_id);
			$off = 0;
			if($tz->getRawOffset()!=0) {
				$off= round($tz->getRawOffset() / 3600000,2);
			};
			$gmtoffset = (($off>0) ? '+':'').$off;
			
			//$TZS[sprintf('%09d %s',$tz->getRawOffset(),$ps_id)] = array('ps_id' => $ps_id, 'longname' => $tz->getLongName(), 'gmtoffset' => $gmtoffset,'shortname' =>$tz->getShortName(),'display'=>str_replace(' ','&nbsp;',sprintf("GMT%-6s|%-4s|%-30s|",(($gmtoffset!='0')?$gmtoffset:''),$tz->getShortName(),substr($tz->getLongName(),0,30))) .trim(substr($ps_id,0,30)));
			$TZS[sprintf('%09d %s',$tz->getRawOffset(),$ps_id)] = array('ps_id' => $ps_id, 'longname' => $tz->getLongName(), 'gmtoffset' => $gmtoffset,'shortname' =>$tz->getShortName(),'display'=>str_replace(' ','&nbsp;',sprintf("GMT%-6s|%-4s|%s",(($gmtoffset!='0')?$gmtoffset:''),$tz->getShortName(),trim(substr($ps_id,0,30)))));

		}
	}
}
/*
foreach(Date_TimeZone::getAvailableIDs() as $ps_id) {
	$tz = new Date_TimeZone($ps_id);
	$off = 0;
	if($tz->getRawOffset()!=0) {
		$off= round($tz->getRawOffset() / 3600000,2);
		/*
		$off = intval($tz->getRawOffset() / 3600000);
		$diff = $tz->getRawOffset()-($off*3600000);
		if ($diff!=0){
			$off .= 
		}
		*/
		/*
	};
	$gmtoffset = (($off>0) ? '+':'').$off;
	$TZS[sprintf('%09d %s',$tz->getRawOffset(),$ps_id)] = array('ps_id' => $ps_id, 'longname' => $tz->getLongName(), 'gmtoffset' => $gmtoffset,'shortname' =>$tz->getShortName());
}
*/
ksort($TZS);
foreach($TZS as $k => $v) {
	$TIMEZONES[$v['ps_id']] = $v;
}
unset($TZS);
/*
$TIMEZONES['-12'] = 'GMT -12 Hours';
$TIMEZONES['-11'] = 'GMT -11 Hours';
$TIMEZONES['-10'] = 'GMT -10 Hours';
$TIMEZONES['-9'] = 'GMT -9 Hours';
$TIMEZONES['-8'] = 'GMT -8 Hours';
$TIMEZONES['-7'] = 'GMT -7 Hours';
$TIMEZONES['-6'] = 'GMT -6 Hours';
$TIMEZONES['-5'] = 'GMT -5 Hours';
$TIMEZONES['-4'] = 'GMT -4 Hours';
$TIMEZONES['-3.5'] = 'GMT -3.5 Hours';
$TIMEZONES['-3'] = 'GMT -3 Hours';
$TIMEZONES['-2'] = 'GMT -2 Hours';
$TIMEZONES['-1'] = 'GMT -1 Hour';
$TIMEZONES['0'] = 'GMT';
$TIMEZONES['1'] = 'GMT +1 Hour';
$TIMEZONES['2'] = 'GMT +2 Hours';
$TIMEZONES['3'] = 'GMT +3 Hours';
$TIMEZONES['3.5'] = 'GMT +3.5 Hours';
$TIMEZONES['4'] = 'GMT +4 Hours';
$TIMEZONES['4.5'] = 'GMT +4.5 Hours';
$TIMEZONES['5'] = 'GMT +5 Hours';
$TIMEZONES['5.5'] = 'GMT +5.5 Hours';
$TIMEZONES['6'] = 'GMT +6 Hours';
$TIMEZONES['6.5'] = 'GMT +6.5 Hours';
$TIMEZONES['7'] = 'GMT +7 Hours';
$TIMEZONES['8'] = 'GMT +8 Hours';
$TIMEZONES['9'] = 'GMT +9 Hours';
$TIMEZONES['9.5'] = 'GMT +9.5 Hours';
$TIMEZONES['10'] = 'GMT +10 Hours';
$TIMEZONES['11'] = 'GMT +11 Hours';
$TIMEZONES['12'] = 'GMT +12 Hours';
$TIMEZONES['13'] = 'GMT +13 Hours';
*/
?>