<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: browse.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Create admin object
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Media', 'media', false);

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');

// Setup template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'media_browse.htt');
$template->set_block('page', 'main_block', 'main');

// Get the current dir
$directory = $admin->strip_slashes($admin->get_get('dir'));

// Work-out if home folder should be shown
if(HOME_FOLDERS) {
	$currentHome = $admin->get_home_folder();
} else {
	$currentHome ='';
}

$directory =	(($currentHome) AND (!array_key_exists('dir',$_GET)))
				? 
				$currentHome
				:
				$admin->strip_slashes($admin->get_get('dir')) ;

if($directory == '/' OR $directory == '\\') {
	$directory = '';
}

// Check to see if it contains ../
if(strstr($directory, '../')) {
	$admin->print_header();
	$admin->print_error($MESSAGE['MEDIA']['DIR_DOT_DOT_SLASH']);
}

if(!file_exists(PE_PATH.MEDIA_DIRECTORY.$directory)) {
	$admin->print_header();
	$admin->print_error($MESSAGE['MEDIA']['DIR_DOES_NOT_EXIST']);
}

// Check to see if the user wanted to go up a directory into the parent folder
if($admin->get_get('up') == 1) {
	$parent_directory = dirname($directory);
	header("Location: browse.php?dir=$parent_directory");	
	exit(0);
}

if ($_SESSION['GROUP_ID'] != 1 && $pathsettings['global']['admin_only']) { // Only show admin the settings link
	$template->set_var('DISPLAY_SETTINGS', 'hide');
}

// Workout the parent dir link
$parent_dir_link = ADMIN_URL.'/media/browse.php?dir='.$directory.'&up=1';
// Workout if the up arrow should be shown
if(($directory == '') or ($directory==$currentHome)) {
	$display_up_arrow = 'hide';
} else {
	$display_up_arrow = '';
}

// Get file extension
function get_filetype($fname) {
	$pathinfo = pathinfo($fname);
	$extension = strtolower($pathinfo['extension']);
	return $extension;
}

// Get file extension for icons
function get_filetype_icon($fname) {
	$pathinfo = pathinfo($fname);
	$extension = strtolower($pathinfo['extension']);
	if (file_exists(THEME_PATH.'/images/files/'.$extension.'.png')) {
		return $extension;
	} else {
		return 'unknown';
	}
}
// Insert values
$template->set_var(array(
								'PE_URL' => PE_URL,
'ADMIN_URL' => ADMIN_URL,
			'TEXT_OK' => $Pacer->Translate('Ok'),
			'TEXT_CANCEL' => $Pacer->Translate('Cancel'),
			
			'TEXT_CONFIRMATION_NEEDED' => $Pacer->Translate('Confirmation needed'),

								'THEME_URL' => THEME_URL,
								'CURRENT_DIR' => $directory,
								'PARENT_DIR_LINK' => $parent_dir_link,
								'DISPLAY_UP_ARROW' => $display_up_arrow
								)
						);

list($resize_width,$resize_heigth,$resize_quality)=unserialize(file_get_contents(PE_PATH.MEDIA_DIRECTORY.'/'.$directory.'/.resize_values'));
$resize_quality=intval($resize_quality);
if(!$resize_quality) $resize_quality=80;
$template->set_var(array(
											'RESIZE_WIDTH' => $resize_width,
											'RESIZE_HEIGHT' => $resize_heigth,
											'RESIZE_QUALITY' => $resize_quality,
											
														)
									);

// Get home folder not to show
$home_folders = get_home_folders();
$INFO=array();
// Generate list
$template->set_block('main_block', 'list_block', 'list');
if($handle = opendir(PE_PATH.MEDIA_DIRECTORY.'/'.$directory)) {
	// Loop through the files and dirs an add to list
   while(false !== ($file = readdir($handle))) {
		if(substr($file, 0, 1) != '.' AND $file != '.svn' AND $file != 'index.php') {
			$fn=PE_PATH.MEDIA_DIRECTORY.$directory.'/'.$file;
			if(is_dir($fn)) {
				if(!isset($home_folders[$directory.'/'.$file])) {
					$DIR[] = $file;
					$INFO[$file]['mtime'] = filemtime($fn);
					$INFO[$file]['perms'] = $Pacer->human_file_perms('',$fn);
				} else continue;
			} else {
				$FILE[] = $file;
				$INFO[$file]['size'] = filesize($fn);
				$INFO[$file]['mtime'] = filemtime($fn);
				$INFO[$file]['image'] = getimagesize($fn);
				$INFO[$file]['perms'] = $Pacer->human_file_perms('',$fn);
			}
		}
	}
	// Now parse these values to the template
	$temp_id = 0;
	$row_bg_color = 'FFF';
	if(isset($DIR)) {
		natcasesort($DIR);
		foreach($DIR AS $name) {
			$link_name = str_replace(' ', '%20', $name);
			$temp_id++;
			$template->set_var(array(
											'NAME' => $name,
											'NAME_SLASHED' => addslashes($name),
											'TEMP_ID' => $temp_id,
											'LINK' => "browse.php?dir=$directory/$link_name",
											'LINK_TARGET' => '',
											'LINK_CLASS' => 'wait',
											'ROW_BG_COLOR' => $row_bg_color,
											'FILETYPE_ICON' => THEME_URL.'/images/folder_16.png',
											'FILE_CLASS' => '',
											'FILE_SIZE' => '',
											'FILE_MTIME' => '',
											'FILE_INFO' => '',
											'FILE_WIDTH' => '',
											'FILE_HEIGHT' => '',
											'FILE_INFO' => '',
											'FILE_INFO_TYPE' => '',
											'FILE_INFO_DIMENSIONS' => '',
											'REL' => '',
											'SIZE' => '',
											'DATE' => date(DATE_FORMAT,$INFO[$name]['mtime'])." ".date(TIME_FORMAT,$INFO[$name]['mtime']),
											'LINK_ONCLICK' =>'',
											)
									);
			$template->parse('list', 'list_block', true);
			// Code to alternate row colors
			if($row_bg_color == 'FFF') {
				$row_bg_color = 'ECF1F3';
			} else {
				$row_bg_color = 'FFF';
			}
		}
	}
	if(isset($FILE)) {
		natcasesort($FILE);
		foreach($FILE AS $name) {
			$temp_id++;
			$CONTENT = PE_URL.MEDIA_DIRECTORY.$directory.'/'.$name;

			$LINK_ONCLICK = 'onclick="javascript:parent.ShadowboxOpenImg(\''.$CONTENT.'\',\''.addslashes($name).'\');return false;"';
			$REL = '';
			$FILE_WIDTH = '';
			$FILE_HEIGHT = '';

			if (preg_match('/\.(jpg)|(png)|(jpeg)|(gif)|(ZZZZZico)|(tif)|(tiff)$/i',$name)) {
				$FILETYPE_ICON = PE_URL.MEDIA_DIRECTORY.$directory.'/'.$name;
				$FILE_CLASS = 'thumb';
				$max_width=50;
				$max_height=50;
				
				$width = $INFO[$name]['image'][0];
				$height = $INFO[$name]['image'][1];
		
						// get the ratio needed
						$x_ratio = $max_width / $width;
						$y_ratio = $max_height / $height;
		
						// if image already meets criteria, load current values in
						// if not, use ratios to load new size info
						if (($width <= $max_width) && ($height <= $max_height) ) {
							$tn_width = $width;
							$tn_height = $height;
						} else if (($x_ratio * $height) < $max_height) {
							$tn_height = ceil($x_ratio * $height);
							$tn_width = $max_width;
						} else {
							$tn_width = ceil($y_ratio * $width);
							$tn_height = $max_height;
						}
				
				
				$FILE_WIDTH = 'width="'.$tn_width.'"';
				$FILE_HEIGHT = 'height="'.$tn_height.'"';
			} else {
				$FILETYPE_ICON = THEME_URL.'/images/files/'.get_filetype_icon(PE_URL.MEDIA_DIRECTORY.$directory.'/'.$name,'iframe').'.png';
				$FILE_CLASS = ''; //'shadowbox';
				$LINK_ONCLICK = 'onclick="javascript:parent.ShadowboxOpenHtml(\''.ADMIN_URL.'/media/getcontent.php?id='.addslashes(str_ireplace(PE_URL,PE_PATH,$CONTENT)).'\',\''.addslashes($name).'\');return false;"';
/*
				//.ini m .js dont need it..
				if (!preg_match('/\.txt$/i',$name) && !preg_match('/\.ini$/i',$name) && !preg_match('/\.js$/i',$name)) {
					$LINK_ONCLICK = 'onclick="javascript:parent.ShadowboxOpen(\''.$CONTENT.'\',\''.addslashes($name).'\',\'html\',\'\',\'\',\''.ADMIN_URL.'/media/getcontent.php?id='.addslashes(str_ireplace(PE_URL,PE_PATH,$CONTENT)).'\');return false;"';
				}
*/
			}
									
			$template->set_var(array(		'LANGUAGE' => strtolower((LANGUAGE)?LANGUAGE:DEFAULT_LANGUAGE),
											//'REL' => $REL,
											'NAME' => $name,
											'TITLE' => $name.$Pacer->TOOLTIP_TITLE_SEPARATOR.$INFO[$name]['perms'],
											
											'NAME_SLASHED' => addslashes($name),
											'TEMP_ID' => $temp_id,
											'LINK' => PE_URL.MEDIA_DIRECTORY.$directory.'/'.$name,
											'LINK' => "#",
											'LINK_CLASS' => '',
											'LINK_ONCLICK' => $LINK_ONCLICK,
											'LINK_TARGET' => '',
											'ROW_BG_COLOR' => $row_bg_color,
											//'FILETYPE_ICON' => THEME_URL.'/images/blank.gif'
											'FILETYPE_ICON' => $FILETYPE_ICON,
											'FILE_CLASS' => $FILE_CLASS,
//											'FILE_CLASS' => 'thumb',

											'FILE_WIDTH' => $FILE_WIDTH,
											'FILE_HEIGHT' => $FILE_HEIGHT,
											'FILE_SIZE' => $TEXT['SIZE'].": ". $Pacer->human_file_size($INFO[$name]['size']),
											'FILE_MTIME' => $TEXT['MODIFY'].": ". $INFO[$name]['mtime'],
											/*
											'FILE_INFO' => '<br />'.$TEXT['MODIFY'].": ".date(DATE_FORMAT." ". TIME_FORMAT,$INFO[$name]['mtime']).' - '.$TEXT['SIZE'].": ".byte_convert($INFO[$name]['size']).(($INFO[$name]['image']['mime']!='')?'<br />'.$TEXT['TYPE'].": ".$INFO[$name]['image']['mime'].' - '.$INFO[$name]['image']['0'].'x'.$INFO[$name]['image']['1']:''),
											*/
											'FILE_INFO' => '<br />'.(($INFO[$name]['image']['mime']!='')?'<br />'.$TEXT['TYPE'].": ".$INFO[$name]['image']['mime'].' - '.$INFO[$name]['image']['0'].'x'.$INFO[$name]['image']['1']:''),
											'FILE_INFO_TYPE' => (($INFO[$name]['image']['mime']!='')?'&nbsp;&nbsp;&nbsp;'.$INFO[$name]['image']['mime']:''),
											'FILE_INFO_DIMENSIONS' => (($INFO[$name]['image']['mime']!='')?
str_repeat('&nbsp;',6).$INFO[$name]['image']['0'].' x '.$INFO[$name]['image']['1'].' px':''),

											'SIZE' => $Pacer->human_file_size($INFO[$name]['size']),
											'DATE' => date(DATE_FORMAT,$INFO[$name]['mtime'])." ".date(TIME_FORMAT,$INFO[$name]['mtime']),
											
											)
									);
			$template->parse('list', 'list_block', true);
			// Code to alternate row colors
			if($row_bg_color == 'FFF') {
				$row_bg_color = 'ECF1F3';
			} else {
				$row_bg_color = 'FFF';
			}
		}
	}
}

// If no files are in the media folder say so
if($temp_id == 0) {
	$template->set_var('DISPLAY_LIST_TABLE', 'hide');
} else {
	$template->set_var('DISPLAY_NONE_FOUND', 'hide');
}

// Insert permissions values
if($admin->get_permission('media_rename') != true) {
	$template->set_var('DISPLAY_RENAME', 'hide');
}
if($admin->get_permission('media_delete') != true) {
	$template->set_var('DISPLAY_DELETE', 'hide');
}

// Insert language text and messages
$template->set_var(array(
								'MEDIA_DIRECTORY' => MEDIA_DIRECTORY,
								'TEXT_CURRENT_FOLDER' => $TEXT['CURRENT_FOLDER'],
								'TEXT_RELOAD' => $TEXT['RELOAD'],
								'TEXT_RENAME' => $TEXT['RENAME'],
								'TEXT_DELETE' => $TEXT['DELETE'],
								'TEXT_UP' => $TEXT['UP'],
								'NONE_FOUND' => $MESSAGE['MEDIA']['NONE_FOUND'],
								'CONFIRM_DELETE' => $MESSAGE['MEDIA']['CONFIRM_DELETE']
								)
						);

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

?>