<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: November 01,2009                                            *
 *    Build Time: 21:00:00                                                    *
 *     File Name: index.php                                                   *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

// Print admin header
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Media', 'media');
$admin->print_sub_header($HEADING['BROWSE_MEDIA'],$HEADING['BROWSE_MEDIA_SUB'],THEME_URL.'/icons/media.png');

// Setup template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'media.htt');
$template->set_block('page', 'main_block', 'main');

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');

// Get home folder not to show
$home_folders = get_home_folders();

// Insert values
$template->set_block('main_block', 'dir_list_block', 'dir_list');
$dirs = directory_list(PE_PATH.MEDIA_DIRECTORY);

// Work-out if home folder should be shown
if(HOME_FOLDERS) {
	$currentHome = $admin->get_home_folder();
} else {
	$currentHome ='';
}

if ($currentHome){
	$dirs = directory_list(PE_PATH.MEDIA_DIRECTORY.$currentHome);
} else {
	$dirs = directory_list(PE_PATH.MEDIA_DIRECTORY);
}
$array_lowercase = array_map('strtolower', $dirs);
array_multisort($array_lowercase, SORT_ASC, SORT_STRING, $dirs);
natcasesort($dirs);
foreach($dirs AS $name) {
	if(!isset($home_folders[str_replace(PE_PATH.MEDIA_DIRECTORY, '', $name)])) {
		$template->set_var('NAME', str_replace(PE_PATH, '', $name));
		$template->parse('dir_list', 'dir_list_block', true);
	}
}

// Insert permissions values
if($admin->get_permission('media_create') != true) {
	$template->set_var('DISPLAY_CREATE', 'hide');
}
if($admin->get_permission('media_upload') != true) {
	$template->set_var('DISPLAY_UPLOAD', 'hide');
}
if ($_SESSION['GROUP_ID'] != 1 && $pathsettings['global']['admin_only']) { // Only show admin the settings link
	$template->set_var('DISPLAY_SETTINGS', 'hide');
}
$display_up_arrow = 'hide';

// Insert language headings
$template->set_var(array(
								'HEADING_BROWSE_MEDIA' => $HEADING['BROWSE_MEDIA'],
								'HEADING_BROWSE_MEDIA_SUB' => $HEADING['BROWSE_MEDIA_SUB'],
								'HOME_DIRECTORY' => $currentHome,
								'DISPLAY_UP_ARROW' => $display_up_arrow,
								'HEADING_CREATE_FOLDER' => $HEADING['CREATE_FOLDER'],
								'HEADING_UPLOAD_FILES' => $HEADING['UPLOAD_FILES']
								)
						);
// Insert language text and messages
$template->set_var(array(
								'MEDIA_DIRECTORY' => MEDIA_DIRECTORY,
								'TEXT_NAME' => $TEXT['TITLE'],
								'TEXT_RELOAD' => $TEXT['RELOAD'],
								'TEXT_TARGET_FOLDER' => $TEXT['TARGET_FOLDER'],
								'TEXT_OVERWRITE_EXISTING' => $TEXT['OVERWRITE_EXISTING'],
								'TEXT_FILES' => $TEXT['FILES'],
								'TEXT_CREATE_FOLDER' => $TEXT['CREATE_FOLDER'],
								'TEXT_UPLOAD_FILES' => $TEXT['UPLOAD_FILES'],
								'CHANGE_SETTINGS' => $TEXT['MODIFY_SETTINGS'],
								'OPTIONS' => $TEXT['OPTION'],
								//'TEXT_UNZIP_FILE' => $TEXT['UNZIP_FILE'],
								//'TEXT_DELETE_ZIP' => $TEXT['DELETE_ZIP'],
								'THEME_URL' => THEME_URL,
								'ADMIN_URL' => ADMIN_URL,
								'PE_URL' => PE_URL,
								'TEXT_RELOAD' => $TEXT['RELOAD'],
								'TEXT_UP' => $TEXT['UP'],
								'TEXT_RESIZE' => $TEXT['RESIZE'],
								'TEXT_WIDTH' => $TEXT['WIDTH'],
								
								'TEXT_QUALITY' => $Pacer->Translate('Quality'),
								'TEXT_SIZE' => $TEXT['SIZE'],
								'TEXT_DATE' => $Pacer->Translate('Date Modified'),
								'TEXT_HEIGTH' => $TEXT['HEIGHT']

								)
						);

/*********************/
						  
$template->set_var('HEADING_UPLOAD_LIST_FILES', $Pacer->Translate('Upload List of files'));
$template->set_var('TEXT_SOURCE_LIST', $Pacer->Translate('File list'));
$template->set_var('HELP_FILE_LIST', $Pacer->Translate('File list comma separated'));
$template->set_var('TOOLTIP_TITLE_SEPARATOR',$Pacer->TOOLTIP_TITLE_SEPARATOR);

$template->set_var('HEADING_UPLOAD_ZIP_FILES',$Pacer->Translate('Upload Zip File'));
$template->set_var('TEXT_REMOVE_UNZIPPED',$Pacer->Translate('Remove unzipped file'));

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

// Print admin 
$admin->print_footer();

?>