<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: upload.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Target location
if(!isset($_POST['target']) OR $_POST['target'] == '') {
	header("Location: index.php");
	exit(0);
} else {
	$target = $_POST['target'];
}
function upld_me($fn,$ftmp){
	global $Pacer, $relative, $overwrite,$file_extensions,$resize,$resize_width,$resize_heigth,$resize_quality;
	$rt = '';
	if($fn) {
		// Remove bad characters
		$filename = media_filename($fn);
		// Check if there is still a filename left
		if($filename != '') {
			// Check for potentially malicious files and append 'txt' to their name
			foreach($file_extensions as $file_ext) {
				$file_ext_len=strlen($file_ext);
				if (substr($filename,-$file_ext_len)==$file_ext) {
					$filename.='.txt';
				}
			}		
			// Move to relative path (in media folder)
			if(file_exists($relative.$filename) AND $overwrite == true) {			
				if(move_uploaded_file($ftmp, $relative.$filename)) {
					$rt=$relative.$filename;
					if ($resize) {
						$Pacer->Pacer_Images_Resize($relative.$filename,$resize_width,$resize_heigth,false,$resize_quality,true);
						file_put_contents(dirname($relative.$filename).'/.resize_values',serialize(array(intval($resize_width),intval($resize_heigth),intval($resize_quality))));
//						resize_file($relative.$filename,$resize_width,$resize_heigth);
					}
					// Chmod the uploaded file
					change_mode($relative.$filename);
				}
			} elseif(!file_exists($relative.$filename)) {
				if(move_uploaded_file($ftmp, $relative.$filename)) {
					$rt=$relative.$filename;
					if ($resize) {
						$Pacer->Pacer_Images_Resize($relative.$filename,$resize_width,$resize_heigth,false,$resize_quality,true);
						file_put_contents(dirname($relative.$filename).'/.resize_values',serialize(array(intval($resize_width),intval($resize_heigth),intval($resize_quality))));
					}
					// Chmod the uploaded file
					change_mode($relative.$filename);
				}
			}
		}
	}
	return $rt;
}
// Print admin header
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Media', 'media_upload');

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');

// Check to see if target contains ../
if(strstr($target, '../')) {
	$admin->print_error($MESSAGE['MEDIA']['TARGET_DOT_DOT_SLASH']);
}
// Create relative path of the target location for the file
$relative = PE_PATH.$target.'/';

// Find out whether we should replace files or give an error
if($admin->get_post('overwrite') != '') {
	$overwrite = true;
} else {
	$overwrite = false;
}
// Find out 
if($admin->get_post('remove_unzipped') != '') {
	$remove_unzipped = true;
} else {
	$remove_unzipped = false;
}

// Find out whether we should resize files
if($admin->get_post('resize') != '') {
	$resize = true;
	$resize_width = (int) $admin->get_post('resize_width');
	$resize_heigth = (int) $admin->get_post('resize_heigth');
	$resize_quality = (int) $admin->get_post('resize_quality');
	if(($resize_width==0) || ($resize_heigth==0) || ($resize_quality==0)) {
		$admin->print_error($TEXT['RESIZE'] . ' ' .$TEXT['ERROR']);
	}
} else {
	$resize = false;
	$resize_width = 0;
	$resize_heigth = 0;
	$resize_quality = 0;
}

// Get list of file types to which we're supposed to append 'txt'
$get_result=$database->query("SELECT value FROM ".TABLE_PREFIX."settings WHERE name='rename_files_on_upload' LIMIT 1");
$file_extension_string='';
if ($get_result->numRows()>0) {
	$fetch_result=$get_result->fetchRow();
	$file_extension_string=$fetch_result['value'];
}
$file_extensions=explode(",",$file_extension_string);


// Loop through the files
$good_uploads = 0;
for($count = 1; $count <= 10; $count++) {
	// If file was upload to tmp
	if(isset($_FILES["file$count"]['name'])) {
		if (upld_me($_FILES["file$count"]['name'],$_FILES["file$count"]['tmp_name'])) $good_uploads++;
	}
}

// If the user chose to unzip the first file, unzip into the current folder
if (isset($_FILES["file_zip"]['name'])) {
	if(isset($_FILES["file_zip"]['name'])) {
		require_once(PE_PATH.'/include/pclzip/pclzip.lib.php');	// Required to unzip file.
		$fn=upld_me($_FILES["file_zip"]['name'],$_FILES["file_zip"]['tmp_name']);
		if ($fn){
			$good_uploads++;
			if (file_exists($fn)) {
				$archive = new PclZip($fn);
				$list = $archive->extract(PCLZIP_OPT_PATH, $relative);
				if($list == 0) {
					// error while trying to extract the archive (most likely wrong format)
					$admin->print_error('UNABLE TO UNZIP FILE' . $archive -> errorInfo(true));
				} else {
					if ($remove_unzipped) @unlink($fn);
				}
			}
		}
	}
}
if (isset($_POST["file_list"])) {
	foreach(explode(",",$_POST["file_list"].",") as $file){
		$file=trim($file);
		if ($file) {
/*	
			echo "<script >";	

			$Pacer->upload_one_file($fileid,$upload_folder,$filename,$only_exts = 'jpg,pdf,xls',$chmod = '0666'){

			echo "</script>";	
*/
		}
	}
}

if($good_uploads == 1) {
	$admin->print_success($good_uploads.$MESSAGE['MEDIA']['SINGLE_UPLOADED']);
} else {
	$admin->print_success($good_uploads.$MESSAGE['MEDIA']['UPLOADED']);
}

// Print admin 
$admin->print_footer();
?>