<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: May 02,2010                                                 *
 *    Build Time: 11:00:00                                                    *
 *     File Name: details.php                                                 *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2010 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2010,                                                        *
 * The Pacer Edition CMS                                                      *
 * JCWEBDEN.COM (DARKSTAR INCORPORATED)                                       *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

// Include the config file
require('../../config.php');
require_once(PE_PATH .'/framework/functions.php');
require_once(PE_PATH .'/framework/module.functions.php');

$header_footer = (isset($_GET['noheader'])) ? false:true;
if($header_footer){
// Get module name
if(!isset($_POST['file']) OR $_POST['file'] == "") {
	header("Location: index.php");
	exit(0);
} else {
$file = $_POST['file'];
	//$file = $admin->add_slashes($_POST['file']);
}
} else {

$file = $_GET['file'];

}
// Check if the module exists
if(!file_exists(PE_PATH.'/modules/'.$file)) {
	header("Location: index.php");
	exit(0);
}

// Print admin header
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Addons', 'modules_view',$header_footer);
$admin->print_sub_header($Pacer->Translate('Module Details'),$Pacer->Translate('Manage The Pacer Edition CMS modules...'),THEME_URL.'/icons/modules.png');

// Setup module object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'modules_details.htt');
$template->set_block('page', 'main_block', 'main');

// Insert values
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'module' AND directory = '$file'");
if($result->numRows() > 0) {
	$module = $result->fetchRow();
}

require(PE_PATH.'/modules/'.$file.'/info.php');

// check if a module description exists for the displayed backend language
$tool_description = false;
if(function_exists('file_get_contents') && file_exists(PE_PATH.'/modules/'.$file.'/languages/'.LANGUAGE .'.php')) {
	// read contents of the module language file into string
	$data = @file_get_contents(PE_PATH .'/modules/' .$file .'/languages/' .LANGUAGE .'.php');
	// use regular expressions to fetch the content of the variable from the string
	$tool_description = get_variable_content('module_description', $data, false, false);
	// replace optional placeholder {PE_URL} with value stored in config.php
	if($tool_description !== false && strlen(trim($tool_description)) != 0) {
		$tool_description = str_replace(array('{PE_URL}','{WB_URL}'), array(PE_URL,PE_URL), $tool_description);
	} else {
		$tool_description = false;
	}
}		
if($tool_description !== false) {
	// Override the module-description with correct desription in users language
	$module['description'] = $tool_description;
}

$template->set_var(array(
                                'PREVIEW_IMG'    => PE_URL.'/modules/'. $module['directory'].'/preview.jpg',
								'NAME'           => $module['name'],
								'AUTHOR'         => $module['author'],
								'AUTHOR_URL'     => $module['author_url'],
								'DATE_CREATED'   => $module['date_created'],
								'SUPPORT'        => $module ['support'],
								'DESIGN'         => (array_key_exists('design',$module))?$module['design']:'',
                                'MODULE_DESIGN'  => (array_key_exists('module_design',$module))?$module['module_design']:'',
								'LICENSE_TERMS'  => $module['license_terms'],
								'DESCRIPTION'    => $module['description'],
                                'LICENSE'        => $module['license'],
								'VERSION'        => $module['version'],
								'SYSTEM'         => $Pacer->Translate('The Pacer Edition CMS'),
                                'FUNCTION'       => $module['function'],
								'PE_GUID'        => $module['pe_guid'],
								'DESIGNED_FOR'   => $module['platform'],
								'STATUS'         => $module['status'],
								'FILE_SIZE'      => $module['file_size'],
								'DATE_RELEASED'  => $module['date_released'], 
								'DATE_MODIFIED'  => $module['date_modified'], 
								)
						);
						
switch ($module['function']) {
	case NULL:
		$type_name = $TEXT['UNKNOWN'];
		break;
	case 'page':
		$type_name = $TEXT['PAGE'];
		break;
	case 'wysiwyg':
		$type_name = $TEXT['WYSIWYG_EDITOR'];
		break;
	case 'tool':
		$type_name = $TEXT['ADMINISTRATION_TOOL'];
		break;
	case 'admin':
		$type_name = $TEXT['ADMIN'];
		break;
	case 'administration':
		$type_name = $TEXT['ADMINISTRATION'];
		break;
	case 'snippet':
		$type_name = $TEXT['CODE_SNIPPET'];
		break;
	default:
		$type_name = $TEXT['UNKNOWN'];
}
$template->set_var('TYPE', $type_name);

// Insert language headings
$template->set_var(array(
								'HEADING_MODULE_DESIGN' => (array_key_exists('MODULE_DESIGN',$HEADING))?$HEADING['MODULE_DESIGN']:''
								)
						);
// Insert language text and messages
$template->set_var(array(
								'TEXT_NAME'                  => $TEXT['NAME'],
								'TEXT_TYPE'                  => $TEXT['TYPE'],
								'TEXT_AUTHOR'                => $Pacer->Translate('Module Developer'),
								'TEXT_AUTHOR_URL'            => $Pacer->Translate('Developers URL'),
								'TEXT_DATE_CREATED'          => $Pacer->Translate('Originally Created'),//ADDED 05-02-2010
								'TEXT_DATE_RELEASED'         => $Pacer->Translate('Release Date'),//ADDED 05-02-2010
								'TEXT_DATE_MODIFIED'         => $Pacer->Translate('Modified on'),//ADDED 05-02-2010
								'TEXT_STATUS'                => $Pacer->Translate('Release Status'),//ADDED 05-02-2010
								'TEXT_FILE_SIZE'             => $Pacer->Translate('File Size'),//ADDED 05-02-2010
								'TEXT_VERSION'               => $Pacer->Translate('Module Version'),
								'TEXT_SUPPORT'               => $Pacer->Translate('Support Forum'),
								'TEXT_LICENSE_TERMS'         => $Pacer->Translate('License Terms'),
								'TEXT_DESIGNED_FOR'          => $Pacer->Translate('Designed For'),
                                'TEXT_LICENSE'               => $Pacer->Translate('License'),
								'TEXT_DESCRIPTION'           => $Pacer->Translate('Description'),
                                'TEXT_MODULE_DESIGN'         => (array_key_exists('MODULE_DESIGN',$TEXT))?$TEXT['MODULE_DESIGN']:'',
								'TEXT_MOD_FUNCTION'          => $Pacer->Translate('Module Fuction'),
								'TEXT_PE_GUID'               => $Pacer->Translate('Pacer Globally Unique Identifier (GUID)'),
								'TEXT_BACK'                  => $Pacer->Translate('Back'),
								'STYLE_BACK'                 =>(!$header_footer)?'display:none':'',
								'TEXT_DEPENDENCIES'          => $Pacer->Translate('Module dependencies'),
								'TEXT_DEPENDENCIES_FRONTEND' => $Pacer->Translate('Frontend'),
								'TEXT_DEPENDENCIES_BACKEND'  => $Pacer->Translate('Backend'),
								)
						);
						
if(!isset($module_dependencies)) {
	$template->set_var('DEPENDENCIES_STYLE','style="display:none;"');
} else {
function setbf($template,$module_dependencies,$type,$module_directory){	
	$template->set_block('main_block', 'dependencies_'.$type.'_block', 'dependencies_'.$type);
	$module_dependencies = check_module_dependencies($module_directory,($type=='frontend')?true:false);
	$row_ab = "row_a";
	foreach($module_dependencies[$type] as $arr) {
		if (is_array($arr))
		foreach($arr as $k => $v) {
			
			if ($v===true) $v='true';
			elseif ($v===false) $v='false';
			elseif ($v==='0') $v='false';

			$template->set_var(array(
				'TR_CLASS' => $row_ab,
				'TEXT_DEPENDENCY' => $k,
				'DEPENDENCY' => str_replace(array(PE_URL,PE_PATH,'\\'),array('','','/'),$v)

			));
			$template->parse('dependencies_'.$type, 'dependencies_'.$type.'_block',true);
			if ($row_ab == "row_a") $row_ab = "row_b"; else $row_ab = "row_a";
		}
	}
}	
	setbf($template,$module_dependencies,'frontend',$file);
	setbf($template,$module_dependencies,'backend',$file);
	
}
// Parse module object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

if($header_footer){
	// Print admin 
	$admin->print_footer();
}
?>