<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: delete.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Function to change all child pages visibility to deleted
function trash_subs($parent = 0) {
	global $database;
	// Query pages
	$query_menu = $database->query("SELECT page_id FROM ".TABLE_PREFIX."pages WHERE parent = '$parent' ORDER BY position ASC");
	// Check if there are any pages to show
	if($query_menu->numRows() > 0) {
		// Loop through pages
		while($page = $query_menu->fetchRow()) {
			// Update the page visibility to 'deleted'
			$database->query("UPDATE ".TABLE_PREFIX."pages SET visibility = 'deleted' WHERE page_id = '".$page['page_id']."' LIMIT 1");
			// Run this function again for all sub-pages
			trash_subs($page['page_id']);
		}
	}
}


// Get page id
$page_ids=array();
if(!isset($_GET['page_id']) OR !is_numeric($_GET['page_id'])) {
	if(!isset($_GET['page_ids'])) {
		header("Location: index.php");
		exit(0);
	} else {
		$page_ids = explode(',',$_GET['page_ids']);
		foreach($page_ids as $k => $v)
			$page_ids[$k] = (int) $v; 
	}
} else {
	$page_id = $_GET['page_id'];
	$page_ids[]=$page_id;
}

// Create new admin object and print admin header
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'pages_delete');

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');

$success=false;
foreach($page_ids as $page_id){
	// Get perms
	if (!$admin->get_page_permission($page_id,'admin')) {
		$admin->print_error($MESSAGE['PAGES']['INSUFFICIENT_PERMISSIONS']);
		$success=false;
		break;
	}
	// Find out more about the page
	$query = "SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'";
	$results = $database->query($query);
	if($database->is_error()) {
		$admin->print_error($database->get_error());
		$success=false;
		break;
	}
	if($results->numRows() == 0) {
		$admin->print_error($MESSAGE['PAGES']['NOT_FOUND']);
		$success=false;
		break;
	}

	$results_array = $results->fetchRow();

	$visibility = $results_array['visibility'];

	// Check if we should delete it or just set the visibility to 'deleted'
	if(PAGE_TRASH != 'disabled' AND $visibility != 'deleted') {
	// Page trash is enabled and page has not yet been deleted
		// Update the page visibility to 'deleted'
		$database->query("UPDATE ".TABLE_PREFIX."pages SET visibility = 'deleted' WHERE page_id = '$page_id.' LIMIT 1");
	
		// Run trash subs for this page
		trash_subs($page_id);
	} else {
		// Really dump the page
		// Delete page subs
		$sub_pages = get_subs($page_id, array());
		foreach($sub_pages AS $sub_page_id) {
			delete_page($sub_page_id);
		}
		// Delete page
		delete_page($page_id);
	}	

	// Check if there is a db error, otherwise say successful
	if($database->is_error()) {
		$admin->print_error($database->get_error());
		$success=false;
		break;
	} else {
		$success=true;
	}
}
if($success)
	$admin->print_success($MESSAGE['PAGES']['DELETED']);

// Print admin footer
$admin->print_footer();

?>