<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: modify.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Get page id
if(!isset($_GET['page_id']) OR !is_numeric($_GET['page_id'])) {
	header("Location: index.php");
	exit(0);
} else {
	$page_id = $_GET['page_id'];
	$section_id = ($_GET['section_id']) ? $_GET['section_id']:0;
	$modify_pgm = ($_GET['modify_pgm']) ? $_GET['modify_pgm']:'';

}

// Create new admin object
require('../../config.php');
require(PACER_PATH .'/pacer.php');

require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'pages_modify');

//$admin = new admin($Pacer,'Pages', 'pages_modify');

// Get perms
if(!$admin->get_page_permission($page_id,'admin')) {
	$admin->print_error($MESSAGE['PAGES']['INSUFFICIENT_PERMISSIONS']);
}
$Pacer->print_page_header($page_id);
/*****************************
// Get page details
$results_array=$admin->get_page_details($page_id);

// Get display name of person who last modified the page
$user=$admin->get_user_details($results_array['modified_by']);

// Convert the unix ts for modified_when to human a readable form
if($results_array['modified_when'] != 0) {
	$modified_ts = gmdate(TIME_FORMAT.', '.DATE_FORMAT, $results_array['modified_when']+TIMEZONE);
} else {
	$modified_ts = 'Unknown';
}

// Include page info script
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'pages_modify.htt');
$template->set_block('page', 'main_block', 'main');
$template->set_var(array(
								'PAGE_ID' => $results_array['page_id'],
								'PAGE_TITLE' => ($results_array['page_title']),
								'MODIFIED_BY' => $user['display_name'],
								'MODIFIED_BY_USERNAME' => $user['username'],
								'MODIFIED_WHEN' => $modified_ts,
								'ADMIN_URL' => ADMIN_URL
								)
						);
if($modified_ts == 'Unknown') {
	$template->set_var('DISPLAY_MODIFIED', 'hide');
} else {
	$template->set_var('DISPLAY_MODIFIED', '');
}

// Work-out if we should show the "manage sections" link
$query_sections = $database->query("SELECT section_id FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' AND module = 'menu_link'");
if($query_sections->numRows() > 0) {
	$template->set_var('DISPLAY_MANAGE_SECTIONS', 'none');
} elseif(MANAGE_SECTIONS == 'enabled') {
	$template->set_var('TEXT_MANAGE_SECTIONS', $HEADING['MANAGE_SECTIONS']);
} else {
	$template->set_var('DISPLAY_MANAGE_SECTIONS', 'none');
}

// Insert language TEXT
$template->set_var(array(
								'TEXT_ID' => $Pacer->Translate('Id'),
								'TEXT_TITLE' => $Pacer->Translate('Title'),

								'TEXT_CURRENT_PAGE' => $TEXT['CURRENT_PAGE'],
								'TEXT_CHANGE_SETTINGS' => $TEXT['CHANGE_SETTINGS'],
								'LAST_MODIFIED' => $MESSAGE['PAGES']['LAST_MODIFIED'],
								'HEADING_MODIFY_PAGE' => $HEADING['MODIFY_PAGE']
								)
						);

// Parse and print header template
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');
*******************************************************/
// get template used for the displayed page (for displaying block details)
if (SECTION_BLOCKS) {
	$sql = "SELECT `template` from `" . TABLE_PREFIX . "pages` WHERE `page_id` = '$page_id' ";
	$result = $database->query($sql);
	if ($result && $result->numRows() == 1) {
		$row = $result->fetchRow();
		$page_template = ($row['template'] == '') ? DEFAULT_TEMPLATE : $row['template'];
		// include template info file if exists
		if (file_exists(PE_PATH . '/templates/' . $page_template . '/info.php')) {
			include_once(PE_PATH . '/templates/' . $page_template . '/info.php');
		}
	}
}
	
// Get sections for this page
$module_permissions = $_SESSION['MODULE_PERMISSIONS'];
$section_map = '';
if ($section_id){
	$section_arr = array();
	$sections=$Pacer->database->queryAll("SELECT page_id,section_id, module, block, note, publ_start, publ_end FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' ORDER BY position ASC");
	if (count($sections)>1){
		$page=$Pacer->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'");
		foreach($sections as $section){
			$block_name='';
			if (SECTION_BLOCKS) {
				if (isset($block[$section['block']]) && trim(strip_tags(($block[$section['block']]))) != '') {
					$block_name = htmlentities(strip_tags($block[$section['block']]));
				} else {
					if ($section['block'] == 1) {
						$block_name = $TEXT['MAIN'];
					} else {
						$block_name = '#' . (int) $section['block'];
					}
				}
			}
			$section_arr[$block_name][] = $section;
		}
		/*
		$section_map = "<table><tr>";
		foreach($section_arr as $block_name => $rows){
			$section_map .="<td>$block_name</td>";
		}
		$section_map .= "</tr>";
		foreach($section_arr as $block_name => $rows){
			$i=0;
			foreach($rows as $section){
				if ($i>=count($section_arr)){
					$section_map .= "</tr><tr>";
					$i=0;
				}
				$i++;
				if ($section['section_id']==$section_id){
					$section_map .="<td>[".$section['section_id'].' '.$section['module']."]</td>";
				} else {
					$section_map .="<td><a href=\"".ADMIN_URL."/pages/modify.php?page_id=$page_id&section_id=".$section['section_id']."\">".$section['section_id'].' '.$section['module']."</a></td>";
				}
			}
		}
		$section_map .= "</tr></table>";
		*/
		$now = time();
		$section_map = "<table><tr>";
		foreach($section_arr as $block_name => $rows){
			$section_map .='<td style="vertical-align:top"><ul class="simpleTree"><li class="root"><span>'.((SECTION_BLOCKS)?$Pacer->Translate('Block').': '.$block_name:$Pacer->Translate('Page').': '.$page['page_title']).'</span>';
			foreach($rows as $ilast=>$section){
				$section_map .='<li class="'.(($section['section_id']==$section_id)?'folder-open':'doc').(($ilast==(count($rows)-1))?'-last':'').'">';
				if( !(($now<=$section['publ_end'] || $section['publ_end']==0) && ($now>=$section['publ_start'] || $section['publ_start']==0)) )
					$cl_active=array('<span style="text-decoration:line-through;">','</span>');
			    else
					$cl_active=array('','');
				$section_map .=$cl_active[0];
				if ($section['section_id']==$section_id){
					$section_map .=$section['section_id'].' '.$section['module']."</li>";
				} else {
					$section_map .="<a href=\"".ADMIN_URL."/pages/modify.php?page_id=$page_id&section_id=".$section['section_id']."\">".$section['section_id'].' '.$section['module']."</a></li>";
				}
				$section_map .=$cl_active[1];
			}
			$section_map .= "</ul></td>";	
		}
		$section_map .= "</tr></table>";
		
		$Pacer->Code_Injection_Add('js_file','jquery.simple.tree.js');
		$Pacer->Code_Injection_Add('css_file','jquery.simple.tree.css');
		
		$Pacer->Code_Injection_Add('css_script','.simpleTree .folder-open, .simpleTree .folder-open-last, .simpleTree .line, .simpleTree .doc, .simpleTree .doc-last {margin-left:1px;font-size:10px;}
.simpleTree .root  {background-position:0 0;padding-left:18px;}
.simpleTree li {overflow:hidden;width:'.intval(640/count($section_arr)).'px;white-space:nowrap;}');

		$Pacer->Code_Injection_Add('js_script','
var simpleTreeCollection;
jQuery(document).ready(function(){
	simpleTreeCollection = jQuery(\'.simpleTree\').simpleTree({
		autoclose: false,
		spath: \''.PACER_URL.'\',
		afterClick:function(node){
			alert("text-"+jQuery(\'span:first\',node).text());
		}
	});
});
');

	}
}
$query_sections = $database->query("SELECT page_id,section_id, module, block, note, publ_start, publ_end FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' ".(($section_id)? " AND section_id = '$section_id'":"")." ORDER BY position ASC");	
if($query_sections->numRows() > 0) {
	while($section = $query_sections->fetchRow()) {
		
		$section_id = $section['section_id'];
		$module = $section['module'];

		$module_name = $Pacer->database->get_one(sprintf("SELECT name FROM %saddons WHERE type='module' AND directory='%s'",TABLE_PREFIX,$section['module']));
		
		//Have permission?
		if(!is_numeric(array_search($module, $module_permissions))) {
			// Include the modules editing script if it exists
			if(file_exists(PE_PATH.'/modules/'.$module.'/modify.php')) {
				echo '<a name="'.$section_id.'"></a>';
				// output block name if blocks are enabled
				if (SECTION_BLOCKS) {
					if (isset($block[$section['block']]) && trim(strip_tags(($block[$section['block']]))) != '') {
						$block_name = htmlentities(strip_tags($block[$section['block']]));
					} else {
						if ($section['block'] == 1) {
							$block_name = $TEXT['MAIN'];
						} else {
							$block_name = '#' . (int) $section['block'];
						}
					}
				}
				$status="";
				if($section['publ_start']!='0' || $section['publ_end']!='0') {
					$query = "SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '".$section['page_id']."'";
					$get_pages = $database->query($query);
					$page = $get_pages->fetchRow();
					if(!$admin->page_is_active($page)) $status=$Pacer->Translate('Not active');
			   }
    
// Insert language TEXT
// Include page info script
	$template = new Template(THEME_PATH.'/templates');
	$template->set_file('page', 'pages_modify_section.htt');
	$template->set_block('page', 'section_block', 'section');

	$template->set_var(array(
								'TEXT_SECTION' => $TEXT['SECTION'],
								'SECTION_ID' => $section_id,
								'TEXT_BLOCK' => (SECTION_BLOCKS)?$Pacer->Translate('Block').':':'',
								'BLOCK_NAME' => (SECTION_BLOCKS)?$block_name:'',
								'TEXT_MODULE' => $Pacer->Translate('Module'),
								'MODULE' => $module_name,
								'STATUS' => '('.$status.')',
								'STATUS_STYLE' => (!$status)?'display:none;':'',
								'TEXT_NOTE' => $Pacer->Translate('Note'),
								'NOTE' => nl2br($section['note']),
								'NOTE_STYLE' => (!$section['note'])?'display:none;"':'',
								'THEME_URL' => THEME_URL,
								'TEXT_CLICK_TO_HIDE' =>  $Pacer->Translate('Click to hide'),
								'TEXT_CLICK_TO_VIEW_INFO' =>  $Pacer->Translate('Click to view info'),
								'LINK_TO_VIEW_INFO' => 'javascript:ShadowboxOpenHtml(\''. ADMIN_URL.'/modules/details.php?file='.$module.'&amp;module='.$module.'&amp;noheader=1\',\''.$Pacer->Translate('Info for module').': '.$module_name.'\');',
								'SECTION_MAP' => $section_map
								)
						);
	// Parse and print header template
	$template->parse('section', 'section_block', false);
	$template->pparse('output', 'page');
	$Pacer->print_page_header_image($module);
    require(PE_PATH.'/modules/'.$module.(($modify_pgm)?'/'.$modify_pgm:'/modify.php'));
   }
  }
//  echo "<br />";
 }
}

// Print admin footer
$Pacer->print_footer();
?>