<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: pages_add.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Insert permissions values
if($admin->get_permission('pages_add') != true) {
	return;
} elseif($admin->get_permission('pages_add_l0') != true AND $editable_pages == 0) {
	return;
}

// Setup template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'pages_add.htt');
$template->set_block('page', 'main_block', 'main');

// Insert values into the add page form

// Group list 1

	$query = "SELECT * FROM ".TABLE_PREFIX."groups";

	$get_groups = $database->query($query);
	$template->set_block('main_block', 'group_list_block', 'group_list');
	// Insert admin group and current group first
	$admin_group_name = $get_groups->fetchRow();
	$template->set_var(array(
									'ID' => 1,
									'TOGGLE' => '',
									'DISABLED' => ' disabled',
									'LINK_COLOR' => '000000',
									'CURSOR' => 'default',
									'NAME' => $admin_group_name['name'],
									'CHECKED' => ' checked'
									)
							);
	$template->parse('group_list', 'group_list_block', true);

	while($group = $get_groups->fetchRow()) {
		// check if the user is a member of this group
		$flag_disabled = '';
		$flag_checked =  '';
		$flag_cursor =   'pointer';
		$flag_color =    '';
		if (in_array($group["group_id"], $admin->get_groups_id())) {
			$flag_disabled = ''; //' disabled';
			$flag_checked =  ' checked';
			$flag_cursor =   'default';
			$flag_color =    '000000';
		}

		// Check if the group is allowed to edit pages
		$system_permissions = explode(',', $group['system_permissions']);
		if(is_numeric(array_search('pages_modify', $system_permissions))) {
			$template->set_var(array(
											'ID' => $group['group_id'],
											'TOGGLE' => $group['group_id'],
											'CHECKED' => $flag_checked,
											'DISABLED' => $flag_disabled,
											'LINK_COLOR' => $flag_color,
											'CURSOR' => $flag_checked,
											'NAME' => $group['name'],
											)
									);
			$template->parse('group_list', 'group_list_block', true);
		}
	}
// Group list 2

	$query = "SELECT * FROM ".TABLE_PREFIX."groups";

	$get_groups = $database->query($query);
	$template->set_block('main_block', 'group_list_block2', 'group_list2');
	// Insert admin group and current group first
	$admin_group_name = $get_groups->fetchRow();
	$template->set_var(array(
									'ID' => 1,
									'TOGGLE' => '',
									'DISABLED' => ' disabled',
									'LINK_COLOR' => '000000',
									'CURSOR' => 'default',
									'NAME' => $admin_group_name['name'],
									'CHECKED' => ' checked'
									)
							);
	$template->parse('group_list2', 'group_list_block2', true);

	while($group = $get_groups->fetchRow()) {
		// check if the user is a member of this group
		$flag_disabled = '';
		$flag_checked =  '';
		$flag_cursor =   'pointer';
		$flag_color =    '';
		if (in_array($group["group_id"], $admin->get_groups_id())) {
			$flag_disabled = ''; //' disabled';
			$flag_checked =  ' checked';
			$flag_cursor =   'default';
			$flag_color =    '000000';
		}

		$template->set_var(array(
										'ID' => $group['group_id'],
										'TOGGLE' => $group['group_id'],
										'CHECKED' => $flag_checked,
										'DISABLED' => $flag_disabled,
										'LINK_COLOR' => $flag_color,
										'CURSOR' => $flag_cursor,
										'NAME' => $group['name'],
										)
								);
		$template->parse('group_list2', 'group_list_block2', true);
	}

// Parent page list
$database = new database();
function parent_list($parent) {
	global $admin, $database, $template;
	$query = "SELECT * FROM ".TABLE_PREFIX."pages WHERE parent = '$parent' AND visibility!='deleted' ORDER BY position ASC";
	$get_pages = $database->query($query);
	while($page = $get_pages->fetchRow()) {
		if($admin->page_is_visible($page)==false)
			continue;
		// Stop users from adding pages with a level of more than the set page level limit
		if($page['level']+1 < PAGE_LEVEL_LIMIT) {
			// Get user perms
			$admin_groups = explode(',', str_replace('_', '', $page['admin_groups']));
			$admin_users = explode(',', str_replace('_', '', $page['admin_users']));
			
			$in_group = FALSE;
			foreach($admin->get_groups_id() as $cur_gid){
			    if (in_array($cur_gid, $admin_groups)) {
			        $in_group = TRUE;
			    }
			}
			if(($in_group) OR is_numeric(array_search($admin->get_user_id(), $admin_users))) {
				$can_modify = true;
			} else {
				$can_modify = false;
			}
			// Title -'s prefix
			$title_prefix = '';
			for($i = 1; $i <= $page['level']; $i++) { $title_prefix .= ' - '; }
				$template->set_var(array(
												'ID' => $page['page_id'],
												'TITLE' => ($title_prefix.$page['page_title'])
												)
										);
				if($can_modify == true) {
					$template->set_var('DISABLED', '');
				} else {
					$template->set_var('DISABLED', ' disabled="disabled" class="disabled"');
				}
				$template->parse('page_list2', 'page_list_block2', true);
		}
		parent_list($page['page_id']);
	}
}
$template->set_block('main_block', 'page_list_block2', 'page_list2');
if($admin->get_permission('pages_add_l0') == true) {
	$template->set_var(array(
									'ID' => '0',
									'TITLE' => $TEXT['NONE'],
									'SELECTED' => ' selected',
									'DISABLED' => ''
									)
							);
	$template->parse('page_list2', 'page_list_block2', true);
}
parent_list(0);

// Clone from list
$playout = $Pacer->PageLayout();
$template->set_block('main_block', 'clone_list_block', 'clone_list');
foreach($playout as $k => $page) {
	// Title -'s prefix
	$title_prefix = '';
	for($i = 1; $i <= $page['level']; $i++) { $title_prefix .= ' - '; }
	$template->set_var(array(
				'VALUE' => $page['page_id'],
				'SELECTED' => '',
				'NAME' => ($title_prefix.$page['page_title'])
				));
	$template->parse('clone_list', 'clone_list_block', true);
}

// Explode module permissions
$module_permissions = $_SESSION['MODULE_PERMISSIONS'];
// Modules list
$template->set_block('main_block', 'module_list_block', 'module_list');
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'module' AND function = 'page' order by name");
if($result->numRows() > 0) {
	while ($module = $result->fetchRow()) {
		// Check if user is allowed to use this module
		if(!is_numeric(array_search($module['directory'], $module_permissions))) {
			$template->set_var('VALUE', $module['directory']);
			$template->set_var('NAME', $module['name']);
			if($module['directory'] == 'wysiwyg') {
				$template->set_var('SELECTED', ' selected');
			} else {
				$template->set_var('SELECTED', '');
			}
			$template->parse('module_list', 'module_list_block', true);
		}
	}
}

// Insert language headings
$template->set_var(array(
								'HEADING_ADD_PAGE' => $HEADING['ADD_PAGE'],
								'HEADING_MODIFY_INTRO_PAGE' => $HEADING['MODIFY_INTRO_PAGE']
								)
						);
// Insert language text and messages
$template->set_var(array(
								'TEXT_TITLE' => $TEXT['TITLE'],
								'TEXT_TYPE' => $TEXT['TYPE'],
								'TEXT_PARENT' => $TEXT['PARENT'],
								'TEXT_VISIBILITY' => $TEXT['VISIBILITY'],
								'TEXT_PUBLIC' => $TEXT['PUBLIC'],
								'TEXT_PRIVATE' => $TEXT['PRIVATE'],
								'TEXT_REGISTERED' => $TEXT['REGISTERED'],
								'TEXT_HIDDEN' => $TEXT['HIDDEN'],
								'TEXT_NONE' => $TEXT['NONE'],
								'TEXT_NONE_FOUND' => $TEXT['NONE_FOUND'],
								'TEXT_ADD' => $TEXT['ADD'],
								'TEXT_ADD_CONTINUE' => $Pacer->Translate('Add & Continue'),
								
								'TEXT_RESET' => $TEXT['RESET'],
								'TEXT_ADMINISTRATORS' => $TEXT['ADMINISTRATORS'],								
								'TEXT_PRIVATE_VIEWERS' => $TEXT['PRIVATE_VIEWERS'],
								'TEXT_REGISTERED_VIEWERS' => $TEXT['REGISTERED_VIEWERS'],
								'INTRO_LINK' => $MESSAGE['PAGES']['INTRO_LINK'],
								'TEXT_CLONE' => $Pacer->Translate('Clone Page'),
								)
						);
	$template->set_var(array(
	
									'TEXT_PAGE_TYPE' => $Pacer->Translate('Page Type'),
									'TEXT_INTRO_PAGE' => $Pacer->Translate('Intro Page'),
									'TEXT_NORMAL_PAGE' => $Pacer->Translate('Normal Page'),
									'TEXT_ERROR400_PAGE' => $Pacer->Translate('Error 400 Page'),									
									'TEXT_ERROR401_PAGE' => $Pacer->Translate('Error 401 Page'),									
									'TEXT_ERROR403_PAGE' => $Pacer->Translate('Error 403 Page'),									
									'TEXT_ERROR404_PAGE' => $Pacer->Translate('Error 405 Page'),									
									'TEXT_ERROR500_PAGE' => $Pacer->Translate('Error 500 Page')								
									)
							);

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');
?>