<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: pages_tree.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */
 
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'pages');
$admin->print_sub_header($HEADING['MODIFY_DELETE_PAGE'],$HEADING['MODIFY_DELETE_PAGE_SUB'],THEME_URL.'/icons/pages.png');

// Get user cookies
$cookies=$Pacer->get_user_cookies('pages');
// Same pg of pages/index.php
$pg = preg_replace('/pages_tree\.php/i','index.php',$_SERVER['PHP_SELF']);
if ((array_key_exists($pg.',page_list_or_tree',$cookies))&&($cookies[$pg.',page_list_or_tree']=='1')) {
} else {
	$url = ADMIN_URL.'/pages/index.php';
	$url .=($_SERVER['QUERY_STRING']!='') ? '?'.$_SERVER['QUERY_STRING']:'';
	$Pacer->Redirect_To($url,'top');
	exit;
}

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');

$Pacer->Code_Injection_Add('js_file','jquery.simple.tree.js');
$Pacer->Code_Injection_Add('css_file','jquery.simple.tree.css');
$Pacer->Code_Injection_Add('js_file','jquery.contextMenu.js');
$Pacer->Code_Injection_Add('css_file','jquery.contextMenu.css');

$Pacer->Code_Injection_Add('js_script','
var simpleTreeCollection;
jQuery(document).ready(function(){
	jQuery(\'li.root\').disableContextMenu();
	simpleTreeCollection = jQuery(\'.simpleTree\').simpleTree({
		autoclose: false,
		spath: \''.PACER_URL.'\',
		afterClick:function(node){
			//alert("text-"+jQuery(\'span:first\',node).text());
		},
		afterDblClick:function(node)
		{
			var i = node[0].id;
			var a = new Array();
			a=i.split(",");
			Shadowbox.open({
        		player: \'iframe\',
        		title: a[5],
        		content: a[4],
        		height: 600,
        		width: 800
      		});
		},
		afterMove:function(destination, source, pos){
			//alert("destination-"+destination.attr(\'id\')+" source-"+source.attr(\'id\')+" pos-"+pos);
		},
		afterAjax:function()
		{
			//alert(\'Loaded\');
		},
		afterContextMenu:function(node)
		{
			var id = node[0].id;
			jQuery(node).showContextMenu({ menu: \'myMenu\'},
   				 function(action, el, pos) {
       				var elem = jQuery(el).attr(\'id\');
					elem = elem.split(\',\');
	
					switch(action) {
						case \'view\':
							Shadowbox.open({content:elem[4],title:\''.$Pacer->Translate('Page preview').': \'+elem[5],player:\'iframe\'});
							break;
						case \'edit\':
							Shadowbox.open({content:\''.ADMIN_URL.'/pages/modify.php?page_id=\'+elem[2]+\'&section_id=\'+elem[1],title:\''.$Pacer->Translate('Edit').': \'+elem[5],player:\'iframe\'});
							break;
						case \'settings\':
							self.location.href = \''.ADMIN_URL.'/pages/settings.php?page_id=\'+elem[2];
							break;
						case \'sections\':
							self.location.href = \''.ADMIN_URL.'/pages/sections.php?page_id=\'+elem[2]+\'#\'+elem[1];
							break;			
						case \'delete\':
							if (elem[0]!=\'page\') {
								confirm_link(\''.$Pacer->Translate('Are you sure you want to delete the selected section?').'\', \''.ADMIN_URL.'/pages/sections.php?page_id=\'+elem[2]+\'&section_id=\'+elem[1]);
							} else {
								confirm_link(\''.$MESSAGE['PAGES']['DELETE_CONFIRM'].'\', \''.ADMIN_URL.'/pages/delete.php?page_id=\'+elem[2]);
							}
							break;
						case \'quit\':
							break;
					};
				}
			)
		},
		animate:true
		//,docToFolderConvert:true
	});
});
');
$Pacer->Code_Injection_Add('css_script','
.contextMenu LI.view A { background-image: url('.THEME_URL.'/images/view_16.png); }
.contextMenu LI.settings A { background-image: url('.THEME_URL.'/images/modify_16.png); }
.contextMenu LI.sections A { background-image: url('.THEME_URL.'/images/noclock_16.png); }
.contextMenu LI.delete A { background-image: url('.THEME_URL.'/images/delete_16.png); }
.contextMenu LI.quit A { background-image: url('.THEME_URL.'/images/door.png); }
');

function make_node($node,$playout) {
	foreach($playout as $k => $v) {
		if (!preg_match('/^'.$node.'/',$k)) continue;
		echo_node($k,$v,$playout);
	}
}
function echo_node($k,$v,$playout) {
	global $admin, $Pacer;
	$follow = false;
	foreach($playout as $kk => $vv) {
		if (preg_match('/^'.$k.'-/',$kk)) {
			$follow = true;
			break;
		}
	}

	if($v['language']!=DEFAULT_LANGUAGE){
				$flag = THEME_URL.'/images/flags/'.strtolower($v['language']).'.png';
				$flag_title = $v['language'];
				$flag ='<img src="'.$flag.'" title="'.$flag_title.'" style="padding-right:5px;" />';
	} else {
				$flag = '';
				$flag_title = '';
	}

		$ptitle= '';
		switch ($v['page_type']){
		case '1':
			$ptitle= '&lt;'.$Pacer->Translate('Intro Page').'&gt;';
			break;
		case '400':
			$ptitle= '&lt;'.$Pacer->Translate('Error 400 Page').'&gt;';
			break;
		case '401':
			$ptitle= '&lt;'.$Pacer->Translate('Error 401 Page').'&gt;';
			break;
		case '403':
			$ptitle= '&lt;'.$Pacer->Translate('Error 403 Page').'&gt;';
			break;
		case '404':
			$ptitle= '&lt;'.$Pacer->Translate('Error 404 Page').'&gt;';
			break;
		case '500':
			$ptitle= '&lt;'.$Pacer->Translate('Error 500 Page').'&gt;';
			break;
		default:
//			echo $v['page_title'];
	}
	$ptitle .= (($ptitle)?"&nbsp;":"").$v['page_title'];
	echo "<li class=\"open\" id='page,".$v['page_id'].",".$v['page_id'].",".$k.",".addslashes($admin->page_link($v['link'])).",".addslashes($ptitle)."'><span style=\"font-weight:bold;\"><img style=\"vertical-align:middle;padding-left:4px; padding-right:4px;\" src=\"".THEME_URL."/images/".$v['visibility_icon']."\" alt=\"".$v['visibility_text']."\" title=\"".$v['visibility_text']."\" />".
	$flag.$ptitle."</span>\n";
	if ($follow) echo "	<ul>\n";
	echo make_node($k.'-',$playout);
	if (isset($_GET['sections']) && $_GET['sections']=='false') {
	} else echo make_sections($v,$k,$ptitle);
	if ($follow) echo "	</ul>\n";
	echo "</li>\n";	
}
function make_sections($v,$k,$ptitle) {
	global $admin;
	if(count($v['sections'])>0) {
		echo "<ul>\n";
		foreach($v['sections'] as $kk => $vv) {
			echo "<li id='section,".$vv['section_id'].",".$vv['page_id'].",".$k.",".addslashes($admin->page_link($v['link']))."#".$vv['section_id'].",".addslashes($ptitle)."'><span>".(($vv['publ_start']!=0 OR $vv['publ_end']!=0)?"<img style=\"vertical-align:middle;padding-left:4px; padding-right:4px;\" src=\"".THEME_URL."/images/".$vv['published_icon']."\" />":"").((SECTION_BLOCKS)? "(".$vv['block_name'].") ":"").$vv['module'].(($vv['note']) ?" - <span style=\"font-weight:bold\">".$vv['note']."</span>":"")."</span>\n";
		}
		echo "</ul>\n";
	}
}

ob_start();
// Page Add
require (ADMIN_PATH.'/pages/pages_add.php');
$add_html = ob_get_contents();
ob_end_clean();

	ob_start();

// Generate pages list
if($admin->get_permission('pages_view') == true) {
	$playout = $Pacer->PageLayout();
	$editable_pages = count($playout);
	echo "<div style=\"float:right\">";
if (isset($_GET['sections']) && $_GET['sections']=='false') {
	$show_sections = " | <a href=\"?sections=true\">".$Pacer->Translate('Show Sections')."</a>";
} else {
	$show_sections = " | <a href=\"?sections=false\">".$Pacer->Translate('Hide Sections')."</a>";
}
echo "</div>";
	foreach($playout as $k => $v) {
		if ($v['level']!='0') continue;
		echo_node($k,$v,$playout);				
	}
	$page_list = ob_get_contents();

} else {
	$editable_pages = 0;
	$page_list ='';
}
	ob_end_clean();
	$page_trash_display = "display:none;";
	if(PAGE_TRASH == 'separate') {
		$query_trash = $database->query("SELECT page_id FROM ".TABLE_PREFIX."pages WHERE visibility = 'deleted'");
		if($query_trash->numRows() > 0) {
			$page_trash_display = "";
		}
	}




// Setup template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'pages_tree.htt');
$template->set_block('page', 'main_block', 'main');

$template->set_var(array(
									'PAGE_ADD' => $add_html,
									'LINK_ADD_PAGE' => ' | <a href="javascript:void(0)" onclick="javascript:show_add_page()">'. $Pacer->Translate('Add page').'</a>',
									
									'MODIFY_DELETE_PAGE' => $HEADING['MODIFY_DELETE_PAGE'],
									'TEXT_DELETE_PAGE'=>$MESSAGE['PAGES']['DELETE_CONFIRM'],
									'TREE_ROOT' => WEBSITE_TITLE,
									'SHOW_SECTIONS' => $show_sections,
									'ADMIN_URL' => ADMIN_URL,
									'PE_URL' => PE_URL,
									'PHP_SELF' => $pg,
									'PACER_URL' => PACER_URL,
									'THEME_URL' => THEME_URL,
									'PAGE_TRASH_STYLE' => $page_trash_display,
									'TEXT_PAGE_TRASH' => $TEXT['PAGE_TRASH'],
									'TEXT_VIEW_DELETED_PAGES' => $TEXT['VIEW_DELETED_PAGES'],
'TEXT_PAGE_TREE_VIEW' => $Pacer->Translate('Pages Tree View'),
									'TEXT_PAGE_LIST_VIEW' => $Pacer->Translate('View pages list'),
									'TEXT_VISIBILITY' => $TEXT['VISIBILITY'],
									'TEXT_PAGE_TITLE' => $TEXT['PAGE_TITLE'],
									'TEXT_MENU_TITLE' => $TEXT['MENU_TITLE'],
									'TEXT_ACTIONS' => $TEXT['ACTIONS'],
									'TEXT_ADD_PAGE' => $HEADING['ADD_PAGE'],
									'TEXT_NONE_FOUND' => $TEXT['NONE_FOUND'],
									'PAGE_LIST' => ($editable_pages==0)?'':$page_list,
									'PAGE_LIST_STYLE' => ($editable_pages == 0)?'display:none;':'',
									'PAGE_LIST_EMPTY_STYLE' => ($editable_pages == 0)?'':'display:none;',
									'TEXT_VIEW' => $TEXT['VIEW'],
									'TEXT_EDIT' => $Pacer->Translate('Edit'),
									'TEXT_DELETE' => $TEXT['DELETE'],
									'TEXT_SECTIONS' => $Pacer->Translate('Sections'),
									'TEXT_SETTINGS' => $TEXT['SETTINGS'],
									'TEXT_QUIT' => $Pacer->Translate('Quit'),
									
	)
);
// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

// Print admin 
$admin->print_footer();
?>