<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: sections.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Include config file
require('../../config.php');

// Make sure people are allowed to access this page
if(MANAGE_SECTIONS != 'enabled') {
	header('Location: '.ADMIN_URL.'/pages/index.php');
	exit(0);
}

// Get page id
if(!isset($_GET['page_id']) OR !is_numeric($_GET['page_id'])) {
	header("Location: index.php");
	exit(0);
} else {
	$page_id = $_GET['page_id'];
}

// Create new admin object
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'pages_modify');

$section_ids=array();

// Check if we are supposed to add or delete a section
if((isset($_GET['section_id']) AND is_numeric($_GET['section_id'])) 
or (isset($_GET['section_ids'])))
{
	if (isset($_GET['section_ids'])){
		$section_ids = explode(',',$_GET['section_ids']);
		foreach($section_ids as $k => $v)
			$section_ids[$k] = (int) $v;
	} else{
		$section_ids[] = $_GET['section_id'];
	}
	$success=false;
	foreach($section_ids as $section_id){ 
		// Get more information about this section
		$query_section = $database->query("SELECT module FROM ".TABLE_PREFIX."sections WHERE section_id = '$section_id'");
		if($query_section->numRows() == 0) {
			$admin->print_error('Section not found');
			$success=false;
			break;
		}
		$section = $query_section->fetchRow();
		// Include the modules delete file if it exists
		if(file_exists(PE_PATH.'/modules/'.$section['module'].'/delete.php')) {
			require(PE_PATH.'/modules/'.$section['module'].'/delete.php');
		}
		$database->query("DELETE FROM ".TABLE_PREFIX."sections WHERE section_id = '$section_id' LIMIT 1");
		if($database->is_error()) {
			$admin->print_error($database->get_error());
			$success=false;
			break;
		} else {
			require_once(PE_PATH.'/framework/class.order.php');
			$order = new order(TABLE_PREFIX.'sections', 'position', 'section_id', 'page_id');
			$order->clean($page_id);
			$success=true;
		}
	}
	if ($success){
		$back=((isset($_GET['back']))?$_GET['back']:ADMIN_URL.'/pages/sections.php?page_id='.$page_id);
		
		$admin->print_success($TEXT['SUCCESS'], $back);
		$admin->print_footer();
		exit();
	}
} elseif(isset($_POST['module']) AND $_POST['module'] != '') {
	// Get section info
	$module = $admin->add_slashes($_POST['module']);
	// Include the ordering class
	require(PE_PATH.'/framework/class.order.php');
	// Get new order
	$order = new order(TABLE_PREFIX.'sections', 'position', 'section_id', 'page_id');
	$position = $order->get_new($page_id);	
	$note = (isset($_POST['note'])) ? $_POST['note'] : '';

	// Insert module into DB
	$database->query("INSERT INTO ".TABLE_PREFIX."sections (page_id,module,position,block,note) VALUES ('$page_id','$module','$position','1','".addslashes($note)."')");
	// Get the section id
	$section_id = $database->get_one("SELECT LAST_INSERT_ID()");	
	// Include the selected modules add file if it exists
	if(file_exists(PE_PATH.'/modules/'.$module.'/add.php')) {
		require(PE_PATH.'/modules/'.$module.'/add.php');
		//$target_section_id=$admin->add_slashes($_POST['target_section_id']);
		$target_section_id=$admin->get_post_escaped('target_section_id');
		$database->query("UPDATE ".TABLE_PREFIX."mod_section_picker SET target_section_id = '$target_section_id' WHERE section_id = '$section_id'");
	}
}

// Get perms
$results = $database->query("SELECT admin_groups,admin_users FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'");
$results_array = $results->fetchRow();
$old_admin_groups = explode(',', $results_array['admin_groups']);
$old_admin_users = explode(',', $results_array['admin_users']);
$in_old_group = FALSE;
foreach($admin->get_groups_id() as $cur_gid){
    if (in_array($cur_gid, $old_admin_groups)) {
	$in_old_group = TRUE;
    }
}
if((!$in_old_group) AND !is_numeric(array_search($admin->get_user_id(), $old_admin_users))) {
	$admin->print_error($MESSAGE['PAGES']['INSUFFICIENT_PERMISSIONS']);
}

// Get page details
$query = "SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_header();
	$admin->print_error($database->get_error());
}
if($results->numRows() == 0) {
	$admin->print_header();
	$admin->print_error($MESSAGE['PAGES']['NOT_FOUND']);
}
$results_array = $results->fetchRow();

// Set module permissions
$module_permissions = $_SESSION['MODULE_PERMISSIONS'];

// Unset block var
unset($block);
// Include template info file (if it exists)
if($results_array['template'] != '') {
	$template_location = PE_PATH.'/templates/'.$results_array['template'].'/info.php';
} else {
	$template_location = PE_PATH.'/templates/'.DEFAULT_TEMPLATE.'/info.php';
}
if(file_exists($template_location)) {
	require($template_location);
}
// Check if $menu is set
if(!isset($block[1]) OR $block[1] == '') {
	// Make our own menu list
	$block[1] = $TEXT['MAIN'];
}
?>

<?php // include jscalendar-setup
	$jscal_use_time = true; // whether to use a clock, too
	require_once(PE_PATH."/include/jscalendar/wb-setup.php");
?>
<?php

$Pacer->print_page_header($page_id);
/*****************************


// Get page details
$results_array=$admin->get_page_details($page_id);

// Get display name of person who last modified the page
$user=$admin->get_user_details($results_array['modified_by']);

// Convert the unix ts for modified_when to human a readable form
if($results_array['modified_when'] != 0) {
	$modified_ts = gmdate(TIME_FORMAT.', '.DATE_FORMAT, $results_array['modified_when']+TIMEZONE);
} else {
	$modified_ts = 'Unknown';
}

// Include page info script
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'sections_modify.htt');
$template->set_block('page', 'main_block', 'main');
$template->set_var(array(
								'PAGE_ID' => $results_array['page_id'],
								'PAGE_TITLE' => ($results_array['page_title']),
								'MODIFIED_BY' => $user['display_name'],
								'MODIFIED_BY_USERNAME' => $user['username'],
								'MODIFIED_WHEN' => $modified_ts,
								'ADMIN_URL' => ADMIN_URL
								)
						);
if($modified_ts == 'Unknown') {
	$template->set_var('DISPLAY_MODIFIED', 'hide');
} else {
	$template->set_var('DISPLAY_MODIFIED', '');
}

// Work-out if we should show the "manage sections" link
$query_sections = $database->query("SELECT section_id FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' AND module = 'menu_link'");
if($query_sections->numRows() > 0) {
	$template->set_var('DISPLAY_MANAGE_SECTIONS', 'stype="display:none;"');
} elseif(MANAGE_SECTIONS == 'enabled') {
	$template->set_var('TEXT_MANAGE_SECTIONS', $HEADING['MODIFY_PAGE']);
} else {
	$template->set_var('DISPLAY_MANAGE_SECTIONS', 'stype="display:none;"');
}

// Insert language TEXT
$template->set_var(array(
								'TEXT_ID' => $Pacer->Translate('Id'),
								'TEXT_TITLE' => $Pacer->Translate('Title'),

								'TEXT_CURRENT_PAGE' => $TEXT['CURRENT_PAGE'],
								'TEXT_CHANGE_SETTINGS' => $TEXT['CHANGE_SETTINGS'],
								'LAST_MODIFIED' => $MESSAGE['PAGES']['LAST_MODIFIED'],
								'HEADING_MODIFY_PAGE' => $HEADING['MANAGE_SECTIONS']
								)
						);

// Parse and print header template
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');
******************************/
?>

<?php
$query_sections = $database->query("SELECT section_id,module,position,block,publ_start,publ_end,note FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' ORDER BY position ASC");
if($query_sections->numRows() > 0) {
?>
<form name="section_properties" action="<?php echo ADMIN_URL; ?>/pages/sections_save.php?page_id=<?php echo $page_id; ?>" method="post">

<table cellpadding="2" cellspacing="0" border="0" width="100%" style="border: 1px solid #35373a; width: 100%; height:28px; margin-bottom:2px">
<tr style="background-color: #ECF1F3; height:20px; vertical-align:top">
		<td width="48px" style="padding:4px;" align="right"><?php echo $Pacer->Translate('Section'); ?></td>
		<td width="310px" style="padding:4px;"><?php echo $TEXT['TYPE']; ?><br /><?php echo $Pacer->Translate('Note'); ?></td>
		<td width="120px" style="padding:4px;"><?php if(SECTION_BLOCKS) echo $TEXT['BLOCK']; ?></td>
		<td width="165px" style="padding:4px;"><?php echo $TEXT['PUBL_START_DATE']; ?>
<!--
        </td>
		<td width="165px" style="padding:4px;">
-->
<br  />		
		<?php echo $TEXT['PUBL_END_DATE']; ?></td>
		<td width="45px" style="padding:4px;"><?php echo $TEXT['ACTIONS']; ?>
			<input type="checkbox" name="section_selected_all" id="section_selected_all" title="<?php echo $Pacer->Translate('Select/Deselect all');?>" onclick="javascript:mysection_selected_all(this);" style="margin-left:27px;"/>
        </td>
</tr>
</table>

<table id="table_section_properties" class="table_dnd" cellpadding="2" cellspacing="0" border="0" align="center" width="100%">
<?php
$a='a';
	$num_sections = $query_sections->numRows();
	while($section = $query_sections->fetchRow()) {
		// Get the modules real name
		$module_name=$database->get_one("SELECT name FROM ".TABLE_PREFIX."addons WHERE directory='".$section['module']."'");
		if ($new_section_id = $Pacer->database->get_one("SELECT target_section_id FROM ".TABLE_PREFIX."mod_section_picker WHERE section_id =".$section['section_id'])) {
			$module_name.=' -> '.$Pacer->database->get_one("SELECT page_id FROM ".TABLE_PREFIX."sections WHERE section_id = '$new_section_id'").((SECTION_BLOCKS)?'#'.$new_section_id:'');	
			$module_name.=' '.$Pacer->database->get_one("SELECT module FROM ".TABLE_PREFIX."sections WHERE section_id = '$new_section_id'");
		}
		if(!is_numeric(array_search($section['module'], $module_permissions))) {
			?>
			<tr class="row_<?php echo $a;?>" height="20" style="vertical-align:top" id="<?php echo $section['section_id']; ?>">
				<td width="20px" class="table_dnd_td" style="padding-left: 5px;"> </td>
				<td width="26px" class="table_dnd_td" align="right"><?php echo $section['section_id']; ?></td>
				<td width="305px" class="table_dnd_td"><a href="<?php echo ADMIN_URL; ?>/pages/modify.php?page_id=<?php echo $page_id; ?>&section_id=<?php echo $section['section_id']; ?>"><?php echo $module_name; ?></a><?php echo '<br style="margin-bottom:10px" /><textarea class="expanding" id="note'.$section['section_id'].'" name="note'.$section['section_id'].'" style="width:305px" type="text" >'.$section['note'].'</textarea>'; ?>
                </td>
				<td width="120px" class="table_dnd_td" >
				<?php if(SECTION_BLOCKS) { ?>

					<select name="block<?php echo $section['section_id']; ?>" class="input_normal">
						<?php
						foreach($block AS $number => $name) {
							?>
							<option value="<?php echo $number; ?>"<?php 
							if($number == $section['block']) { echo ' selected'; } ?>><?php 
							$block_name = htmlentities(strip_tags($name));
							$block_name = ($block_name == '') ? $TEXT['BLOCK'] . '#' . (int) $number : $block_name;
							echo $block_name; ?></option>
							<?php
						}
						?>
					</select>
				<?php } ?>
                </td>
				<?php // jscalendar-stuff following ?>
				<td width="168px" class="table_dnd_td">
                	<input type="text" id="start_date<?php echo $section['section_id']; ?>" name="start_date<?php echo $section['section_id']; ?>" value="<?php if($section['publ_start']==0) print ""; else print date($jscal_format, $section['publ_start'])?>" class="input_normal" />
					<img src="<?php echo THEME_URL ?>/images/clock_16.png" id="trigger_start<?php echo $section['section_id']; ?>" style="cursor: pointer;" title="<?php echo $TEXT['CALENDAR']; ?>" />
					<img src="<?php echo THEME_URL ?>/images/clock_del_16.png" style="cursor: pointer;" title="<?php echo $TEXT['DELETE_DATE']; ?>" onclick="document.section_properties.start_date<?php echo $section['section_id']; ?>.value=''" />
<!--                    
				</td>
				<td width="168px" class="table_dnd_td">
-->
<br />                
                	<input type="text" id="end_date<?php echo $section['section_id']; ?>" name="end_date<?php echo $section['section_id']; ?>" value="<?php if($section['publ_end']==0) print ""; else print date($jscal_format, $section['publ_end'])?>" class="input_normal" />
					<img src="<?php echo THEME_URL ?>/images/clock_16.png" id="trigger_stop<?php echo $section['section_id']; ?>" style="cursor: pointer;" title="<?php echo $TEXT['CALENDAR']; ?>" onmouseover="this.style.background='lightgrey';" onmouseout="this.style.background=''" />
					<img src="<?php echo THEME_URL ?>/images/clock_del_16.png" title="<?php echo $TEXT['DELETE_DATE']; ?>" onclick="document.section_properties.end_date<?php echo $section['section_id']; ?>.value=''"/>
				</td>
				<td class="table_dnd_td" width="20" align="center">
					<a href="javascript: confirm_link('<?php echo $TEXT['ARE_YOU_SURE']; ?>', '<?php echo ADMIN_URL; ?>/pages/sections.php?page_id=<?php echo $page_id; ?>&section_id=<?php echo $section['section_id']; ?>');">
						<img src="<?php echo THEME_URL; ?>/images/delete_16.png" alt="Del" border="0" />
					</a>
				</td>
                <td width="20">
					<input type="checkbox" name="section_selected[]" id="section_selected,<?php echo $section['section_id']; ?>" onclick="javascript:section_selected(this);"/>
				</td>

			</tr>
			<?php
			$a = ($a=='a')?'b':'a';
			}
	}
	?>
	</table>
     <div id="section_selected_list" class="section_selected_list" style="text-align:right;height:18px;vertical-align:middle;padding-right:37px;display:none;"><i><?php echo $Pacer->Translate('With selected');?>:</i> <a href="#"  onclick="javascript:section_selected_delete();" title="<?php echo $TEXT['DELETE'];?>"><img src="<?php echo THEME_URL;?>/images/delete_16.png" alt="X" style="border:1px solid red;padding:0;mardin:0;"/></a></div>
	<table cellpadding="5" cellspacing="0" border="0" align="center" width="100%">
	<tr>
    	<td align="center" ><input type="submit" name="save" value="<?php echo $TEXT['SAVE']; ?>" /></td>
	</tr>
	</table>

</form>
<?php
$cal_script='';
	// now add the calendars -- remember to to set the range to [1970, 2037] if the date is used as timestamp!
	// the loop is simply a copy from above.
	$query_sections = $database->query("SELECT section_id,module FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' ORDER BY position ASC");
	if($query_sections->numRows() > 0) {
		$num_sections = $query_sections->numRows();
		while($section = $query_sections->fetchRow()) {
			// Get the modules real name
			$module_name=$database->get_one("SELECT name FROM ".TABLE_PREFIX."addons WHERE directory='".$section['module']."'");
			if(!is_numeric(array_search($section['module'], $module_permissions))) {
			
				$cal_script.='
					Calendar.setup(
						{
							inputField  : "start_date'.$section['section_id'].'",
							ifFormat    : "'.$jscal_ifformat.'",
							button      : "trigger_start'.$section['section_id'].'",
							firstDay    : '.$jscal_firstday.','.
							((isset($jscal_use_time) && $jscal_use_time==TRUE) ? '
								showsTime   : "true",
								timeFormat  : "24",':'').'
							date        : "'.$jscal_today.'",
							range       : [1970, 2037],
							step        : 1
						}
					);
					Calendar.setup(
						{
							inputField  : "end_date'.$section['section_id'].'",
							ifFormat    : "'.$jscal_ifformat.'",
							button      : "trigger_stop'.$section['section_id'].'",
							firstDay    : '.$jscal_firstday.','.
							((isset($jscal_use_time) && $jscal_use_time==TRUE) ? '
								showsTime   : "true",
								timeFormat  : "24",':'').'
							date        : "'.$jscal_today.'",
							range       : [1970, 2037],
							step        : 1
						}
					);';
				
			}
		}
	}
	if ($cal_script) $Pacer->Code_Injection_Add('js_script','jQuery(document).ready(function() {'.$cal_script.'});');
	$cal_script="function mysection_selected_all(obj){
	if (jQuery(obj).is(':checked') ){
		jQuery('input[name=\"section_selected[]\"]').attr('checked','checked');
		jQuery('#section_selected_list').show();
	} else {
		jQuery('input[name=\"section_selected[]\"]').removeAttr('checked');
		jQuery('#section_selected_list').hide();
	}
	return false;
}
function section_selected(obj){
	if(jQuery('input[name=\"section_selected[]\"]:checked').length) 
		jQuery('#section_selected_list').show();
	else
		jQuery('#section_selected_list').hide();	
	return false;
}
function section_selected_delete(){
	var ids = '';
	jQuery('input[name=\"section_selected[]\"]:checked').each(function(){
		var id=jQuery(this).attr('id');
		id=id.replace('section_selected,','');
		ids=ids+((ids)?',':'')+id;
	});
	confirm_link('".$MESSAGE['PAGES']['DELETE_CONFIRM']."', '".ADMIN_URL."/pages/sections.php?page_id=".$page_id."&section_ids='+ids);
	return false;
}";
	$Pacer->Code_Injection_Add('js_script',$cal_script);
}

// Work-out if we should show the "Add Section" form
$query_sections = $database->query("SELECT section_id FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' AND module = 'menu_link'");
if($query_sections->numRows() == 0) {
	?>
	<h2><?php echo $TEXT['ADD_SECTION']; ?></h2>
	
	<form name="add" action="<?php echo ADMIN_URL; ?>/pages/sections.php?page_id=<?php echo $page_id; ?>" method="post">
	
	<table cellpadding="5" cellspacing="0" border="0" align="center" width="100%">
	<tr>
		<td>
			<select name="module" class="input_full selectdd">
			<?php
			// Insert module list
			$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'module' AND function = 'page' AND directory != 'menu_link' order by name");
			if($result->numRows() > 0) {
				while($module = $result->fetchRow()) {
					// Check if user is allowed to use this module
					if(!is_numeric(array_search($module['directory'], $module_permissions))) {
						?>
						<option value="<?php echo $module['directory']; ?>"<?php if($module['directory'] == 'wysiwyg') { echo 'selected'; } ?>><?php echo $module['name']; ?></option>
						<?php
					}
				}
			}
			?>
			</select>
		</td>
	</tr>
	<tr>
		<td align="center">
			<input type="submit" name="submit" value="<?php echo $TEXT['ADD']; ?>" class="input_narrow" />
		</td>
	</tr>
	</table>
	
	</form>
	<?php
}
$module_directory = 'section_picker';
$module_directory = $Pacer->database->get_one("SELECT directory FROM ".TABLE_PREFIX."addons WHERE directory = '$module_directory'"); 
if (($module_directory) && (file_exists(PE_PATH.'/modules/'.$module_directory.'/save.php'))) {
	require(PE_PATH.'/modules/'.$module_directory.'/functions.php');

	$links = array();
	build_pagelist(0,$page_id);
	if(count($links)){ 
?>
<h2><?php echo $Pacer->Translate('Link to Section'); ?></h2>
<form name="add_link" action="<?php echo ADMIN_URL; ?>/pages/sections.php?page_id=<?php echo $page_id; ?>" method="post">
<input type="hidden" name="page_id" value="<?php echo $page_id ?>" />
<input type="hidden" name="module" value="<?php echo $module_directory ?>" />
<table cellpadding="5" cellspacing="0" border="0" width="100%" >
	<tr>
		<td>
			<select name="target_section_id" class="input_full selectdd" style="font-family:monospace;" />
				<option value="0"><?php echo $TEXT['PLEASE_SELECT']; ?></option>
				<?php options_pagelist($links,0); ?>
			</select>
		</td>
	</tr>    
	<tr>
		<td align="center">
			<input type="submit" name="submit" value="<?php echo $TEXT['ADD']; ?>" class="input_narrow" />
		</td>
	</tr>

</table>
</form>
<?php
	}
}

echo "<br />";


	$Pacer->Code_Injection_Add('js_script','
jQuery(document).ready(function() {
var prevRows_'.$page_id.' = {};
jQuery(\'#table_section_properties\').tableDnD({
	onDragStart: function(table, row) {
   		for (var i=0; i<table.tBodies[0].rows.length;i++) {
			prevRows_'.$page_id.'[i] = table.tBodies[0].rows[i].id;
		}
	},
	onDrop: function(table, row) {
   		for (var i=0; i<table.tBodies[0].rows.length;i++) {
			if (table.tBodies[0].rows[i].id == row.id) {
				if(row.id!=prevRows_'.$page_id.'[i]) {
					jQuery.get("'.ADMIN_URL.'/pages/move_to.php", { page_id : '.$page_id.', section_id : row.id, field_id : row.id, position : i+1 } );
				}
				return true;
			}
		}
		return false;
   	}
});
});
');

	$Pacer->Code_Injection_Add('js_file','tablednd_init.js');
	$Pacer->Code_Injection_Add('js_file','table_row_hover_init.js');
	$Pacer->Code_Injection_Add('css_file','jquery.tablednd.css');
	$Pacer->Code_Injection_Add('css_file',THEME_URL.'/css/jquery.tablednd.css');


// Print admin footer
$Pacer->print_footer();

?>
