<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: settings.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Get page id
if(!isset($_GET['page_id']) OR !is_numeric($_GET['page_id'])) {
	header("Location: index.php");
	exit(0);
} else {
	$page_id = (int)$_GET['page_id'];
}

// Create new admin object
require('../../config.php');
//require(PE_PATH .'/pacer/pacer.php');

// Include the PE functions file
require(ADMIN_PATH.'/pages/functions.php');

require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'pages_settings');

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');
require_once(PE_PATH.'/framework/functions-utf8.php');

// Get perms
$results = $database->query("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'");
$results_array = $results->fetchRow();
$old_admin_groups = explode(',', $results_array['admin_groups']);
$old_admin_users = explode(',', $results_array['admin_users']);

$in_old_group = FALSE;
foreach($admin->get_groups_id() as $cur_gid){
    if (in_array($cur_gid, $old_admin_groups)) {
        $in_old_group = TRUE;
    }
}
if((!$in_old_group) AND !is_numeric(array_search($admin->get_user_id(), $old_admin_users))) {
	$admin->print_error($MESSAGE['PAGES']['INSUFFICIENT_PERMISSIONS']);
}

// Get page details
$query = "SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_header();
	$admin->print_error($database->get_error());
}
if($results->numRows() == 0) {
	$admin->print_header();
	$admin->print_error($MESSAGE['PAGES']['NOT_FOUND']);
}
$results_array = $results->fetchRow();
$Pacer->print_page_header($page_id);


// Get display name of person who last modified the page
$user=$admin->get_user_details($results_array['modified_by']);

// Convert the unix ts for modified_when to human a readable form
if($results_array['modified_when'] != 0) {
	$modified_ts = gmdate(TIME_FORMAT.', '.DATE_FORMAT, $results_array['modified_when']+TIMEZONE);
} else {
	$modified_ts = 'Unknown';
}

// Setup template object, parse vars to it, then parse it
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'pages_settings.htt');
$template->set_block('page', 'main_block', 'main');
$template->set_var(array(
								'PAGE_ID' => $results_array['page_id'],
								'PAGE_TITLE' => ($results_array['page_title']),
								'PAGE_TITLE_DISPLAY' => ($results_array['page_title_display']),
								'PAGE_SUB_TITLE_DISPLAY' => ($results_array['page_sub_title_display']),
								'MENU_TITLE' => ($results_array['menu_title']),
								'DESCRIPTION' => ($results_array['description']),
								'KEYWORDS' => ($results_array['keywords']),
								'PAGE_CODE' => ($results_array['page_code']),
								'MODIFIED_BY' => $user['display_name'],
								'MODIFIED_BY_USERNAME' => $user['username'],
								'MODIFIED_WHEN' => $modified_ts,
								'ADMIN_URL' => ADMIN_URL,
								'PE_URL' => PE_URL,
								'PE_PATH' => PE_PATH,
								'THEME_URL' => THEME_URL
								)
						);
$template->set_var(array(
								'TEXT_ID' => $Pacer->Translate('Id'),
								'TEXT_TITLE' => $Pacer->Translate('Title'),

								'TEXT_YES' => $Pacer->Translate('Yes'),
								'TEXT_NO' => $Pacer->Translate('No'),
								'TEXT_N_A' => $Pacer->Translate('N/A'),
								'TEXT_SEO' => $Pacer->Translate('Search Engines Optimization'),
								'TEXT_PAGE_SETTINGS' => $Pacer->Translate('Page Settings'),
								'TEXT_SEO_FREQ' => $Pacer->Translate('Seo Sitemap Freq.'),
								'SEO_FREQ' =>$results_array['seo_freq'],
								'TEXT_SEO_INDEX' => $Pacer->Translate('Seo Meta Robots Index'),
								'TEXT_SEO_FOLLOW' => $Pacer->Translate('Seo Meta Robots Follow'),
								'TEXT_SEO_ARCHIVE' => $Pacer->Translate('Seo Meta Robots Archive'),
								'TEXT_SEO_SNIPPET' => $Pacer->Translate('Seo Meta Robots Snippet')
								)
						);
		
foreach(array('seo_index','seo_follow','seo_archive', 'seo_snippet') as $v) {
	if ($results_array[$v]=='1') $template->set_var(strtoupper($v).'_SELECTED_YES','selected="selected"');
	elseif ($results_array[$v]=='0') $template->set_var(strtoupper($v).'_SELECTED_NO','selected="selected"');
	elseif ($results_array[$v]=='-1') $template->set_var(strtoupper($v).'_SELECTED_N_A','selected="selected"');
}

// Work-out if we should show the "manage sections" link
$query_sections = $database->query("SELECT section_id FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' AND module = 'menu_link'");
if($query_sections->numRows() > 0) {
	$template->set_var('DISPLAY_MANAGE_SECTIONS', 'none');
} elseif(MANAGE_SECTIONS == 'enabled') {
	$template->set_var('TEXT_MANAGE_SECTIONS', $HEADING['MANAGE_SECTIONS']);
} else {
	$template->set_var('DISPLAY_MANAGE_SECTIONS', 'none');
}

// Visibility
//print_r($results_array);
if($results_array['page_type'] == '1') {
	$template->set_var('INTRO_PAGE_SELECTED', ' selected="selected"');
} elseif($results_array['page_type'] == '401') {
	$template->set_var('ERROR401_PAGE_SELECTED', ' selected="selected"');
} elseif($results_array['page_type'] == '403') {
	$template->set_var('ERROR403_PAGE_SELECTED', ' selected="selected"');
} elseif($results_array['page_type'] == '404') {
	$template->set_var('ERROR404_PAGE_SELECTED', ' selected="selected"');
} elseif($results_array['page_type'] == '500') {
	$template->set_var('ERROR500_PAGE_SELECTED', ' selected="selected"');
} else {
	$template->set_var('NORMAL_PAGE_SELECTED', ' selected="selected"');
} 
if($results_array['visibility'] == 'public') {
	$template->set_var('PUBLIC_SELECTED', ' selected="selected"');
} elseif($results_array['visibility'] == 'private') {
	$template->set_var('PRIVATE_SELECTED', ' selected="selected"');
} elseif($results_array['visibility'] == 'registered') {
	$template->set_var('REGISTERED_SELECTED', ' selected="selected"');
} elseif($results_array['visibility'] == 'hidden') {
	$template->set_var('HIDDEN_SELECTED', ' selected="selected"');
} elseif($results_array['visibility'] == 'none') {
	$template->set_var('NO_VIS_SELECTED', ' selected="selected"');
}

// Group list 1 (admin_groups)
	$admin_groups = explode(',', str_replace('_', '', $results_array['admin_groups']));

	$query = "SELECT * FROM ".TABLE_PREFIX."groups";
	
	$get_groups = $database->query($query);
	$template->set_block('main_block', 'group_list_block', 'group_list');
	// Insert admin group and current group first
	$admin_group_name = $get_groups->fetchRow();
	$template->set_var(array(
									'ID' => 1,
									'TOGGLE' => '',
									'DISABLED' => ' disabled="disabled"',
									'LINK_COLOR' => '000000',
									'CURSOR' => 'default',
									'NAME' => $admin_group_name['name'],
									'CHECKED' => ' checked="checked"'
									)
							);

	$template->set_var(array(
	
									'TEXT_PAGE_TYPE' => $Pacer->Translate('Page Type'),
									'TEXT_INTRO_PAGE' => $Pacer->Translate('Intro Page'),
									'TEXT_NORMAL_PAGE' => $Pacer->Translate('Normal Page'),
									'TEXT_ERROR400_PAGE' => $Pacer->Translate('Error 400 Page'),									
									'TEXT_ERROR401_PAGE' => $Pacer->Translate('Error 401 Page'),									
									'TEXT_ERROR403_PAGE' => $Pacer->Translate('Error 403 Page'),									
									'TEXT_ERROR404_PAGE' => $Pacer->Translate('Error 404 Page'),									
									'TEXT_ERROR500_PAGE' => $Pacer->Translate('Error 500 Page')								
									)
							);

	$template->parse('group_list', 'group_list_block', true);
	/*
	if(!in_array(1, $admin->get_groups_id())) {
		$users_groups = $admin->get_groups_name();
		foreach ($admin->get_groups_id() as $users_group_id) {
			$template->set_var(array(
										'ID' => $users_group_id,
										'TOGGLE' => '',
										'DISABLED' => ' disabled',
										'LINK_COLOR' => '000000',
										'CURSOR' => 'default',
										'NAME' => $users_groups[$users_group_id],
										'CHECKED' => ' checked'
										)
								);
			$template->parse('group_list', 'group_list_block', true);
		}
	}
	*/
	while($group = $get_groups->fetchRow()) {
		// check if the user is a member of this group
		$flag_disabled = '';
		$flag_checked =  '';
		$flag_cursor =   'pointer';
		$flag_color =    '';
		if (in_array($group["group_id"], $admin->get_groups_id())) {
			$flag_disabled = ''; //' disabled';
			$flag_checked =  ''; //' checked';
			$flag_cursor =   'default';
			$flag_color =    '000000';
		}

		// Check if the group is allowed to edit pages
		$system_permissions = explode(',', $group['system_permissions']);
		if(is_numeric(array_search('pages_modify', $system_permissions))) {
			$template->set_var(array(
											'ID' => $group['group_id'],
											'TOGGLE' => $group['group_id'],
											'DISABLED' => $flag_disabled,
											'LINK_COLOR' => $flag_color,
											'CURSOR' => $flag_cursor,
											'NAME' => $group['name'],
											'CHECKED' => $flag_checked
											)
									);
			if(is_numeric(array_search($group['group_id'], $admin_groups))) {
				$template->set_var('CHECKED',' checked="checked"');
			} else {
				if (!$flag_checked) $template->set_var('CHECKED', '');
			}
			$template->parse('group_list', 'group_list_block', true);
		}
	}
// Group list 2 (viewing_groups)
	$viewing_groups = explode(',', str_replace('_', '', $results_array['viewing_groups']));

	$query = "SELECT * FROM ".TABLE_PREFIX."groups";

	$get_groups = $database->query($query);
	$template->set_block('main_block', 'group_list_block2', 'group_list2');
	// Insert admin group and current group first
	$admin_group_name = $get_groups->fetchRow();
	$template->set_var(array(
									'ID' => 1,
									'TOGGLE' => '',
									'DISABLED' => ' disabled="disabled"',
									'LINK_COLOR' => '000000',
									'CURSOR' => 'default',
									'NAME' => $admin_group_name['name'],
									'CHECKED' => ' checked="checked"'
									)
							);
	$template->parse('group_list2', 'group_list_block2', true);


	while($group = $get_groups->fetchRow()) {
		// check if the user is a member of this group
		$flag_disabled = '';
		$flag_checked =  '';
		$flag_cursor =   'pointer';
		$flag_color =    '';
		if (in_array($group["group_id"], $admin->get_groups_id())) {
			$flag_disabled = ''; //' disabled';
			$flag_checked =  ''; //' checked';
			$flag_cursor =   'default';
			$flag_color =    '000000';
		}

		$template->set_var(array(
										'ID' => $group['group_id'],
										'TOGGLE' => $group['group_id'],
										'DISABLED' => $flag_disabled,
										'LINK_COLOR' => $flag_color,
										'CURSOR' => $flag_cursor,
										'NAME' => $group['name'],
										'CHECKED' => $flag_checked
										)
								);
		if(is_numeric(array_search($group['group_id'], $viewing_groups))) {
			$template->set_var('CHECKED', ' checked="checked"');
		} else {
			if (!$flag_checked) $template->set_var('CHECKED', '');
		}
		$template->parse('group_list2', 'group_list_block2', true);
	}
// Show private viewers
if($results_array['visibility'] == 'private' OR $results_array['visibility'] == 'registered') {
	$template->set_var('DISPLAY_VIEWERS', '');
} else {
	$template->set_var('DISPLAY_VIEWERS', 'none');
}

$template->set_var('DISPLAY_LANGUAGE_LIST', (PAGE_LANGUAGES)?'':'style="display:none;"');
// Parent page list
$database = new database();
function parent_list($parent) {
	global $admin, $database, $template, $results_array;
	$query = "SELECT * FROM ".TABLE_PREFIX."pages WHERE parent = '$parent' ORDER BY position ASC";
	$get_pages = $database->query($query);
	while($page = $get_pages->fetchRow()) {
		if($admin->page_is_visible($page)==false)
			continue;
		// if psrent = 0 set flag_icon
		$template->set_var('FLAG_ROOT_ICON',' none ');
		if( $page['parent'] == 0 ) {
			$template->set_var('FLAG_ROOT_ICON','url('.THEME_URL.'/images/flags/'.strtolower($page['language']).'.png)');
		}
		// If the current page cannot be parent, then its children neither
		$list_next_level = true;
		// Stop users from adding pages with a level of more than the set page level limit
		if($page['level']+1 < PAGE_LEVEL_LIMIT) {
			// Get user perms
			$admin_groups = explode(',', str_replace('_', '', $page['admin_groups']));
			$admin_users = explode(',', str_replace('_', '', $page['admin_users']));

			$in_group = FALSE;
			foreach($admin->get_groups_id() as $cur_gid){
			    if (in_array($cur_gid, $admin_groups)) {
			        $in_group = TRUE;
			    }
			}
			
			if(($in_group) OR is_numeric(array_search($admin->get_user_id(), $admin_users))) {
				$can_modify = true;
			} else {
				$can_modify = false;
			}
			// Title -'s prefix
			$title_prefix = '';
			for($i = 1; $i <= $page['level']; $i++) { $title_prefix .= ' - '; }
			$template->set_var(array(
											'ID' => $page['page_id'],
											'TITLE' => ($title_prefix.$page['page_title']),
											'FLAG_ICON' => 'none',
											));

			if($results_array['parent'] == $page['page_id']) {
				$template->set_var('SELECTED', ' selected="selected"');
			} elseif($results_array['page_id'] == $page['page_id']) {
				$template->set_var('SELECTED', ' disabled="disabled" class="disabled"');
				$list_next_level=false;
			} elseif($can_modify != true) {
				$template->set_var('SELECTED', ' disabled="disabled" class="disabled"');
			} else {
				$template->set_var('SELECTED', '');
			}
			$template->parse('page_list2', 'page_list_block2', true);
		}
		if ($list_next_level)
			parent_list($page['page_id']);
	}
}
$template->set_block('main_block', 'page_list_block2', 'page_list2');
if($admin->get_permission('pages_add_l0') == true OR $results_array['level'] == 0) {
	if($results_array['parent'] == 0) { $selected = ' selected="selected"'; } else { $selected = ''; }
	$template->set_var(array(
									'ID' => '0',
									'TITLE' => $TEXT['NONE'],
									'SELECTED' => $selected
									)
							);
	$template->parse('page_list2', 'page_list_block2', true);
}
parent_list(0);

if($modified_ts == 'Unknown') {
	$template->set_var('DISPLAY_MODIFIED', 'hide');
} else {
	$template->set_var('DISPLAY_MODIFIED', '');
}
// Templates list
$template->set_block('main_block', 'template_list_block', 'template_list');
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'template' and function = 'template' order by name");
if($result->numRows() > 0) {
	while($addon = $result->fetchRow()) { 
		// Check if the user has perms to use this template
		if($addon['directory'] == $results_array['template'] OR $admin->get_permission($addon['directory'], 'template') == true) {
			$template->set_var('VALUE', $addon['directory']);
			$template->set_var('NAME', $addon['name']);
			if($addon['directory'] == $results_array['template']) {
				$template->set_var('SELECTED', ' selected="selected"');
			} else {
				$template->set_var('SELECTED', '');
			}
			$template->parse('template_list', 'template_list_block', true);
		}
	}
}

// Menu list
if(MULTIPLE_MENUS == false) {
	$template->set_var('DISPLAY_MENU_LIST', 'style="display: none"');
}
// Include template info file (if it exists)
if($results_array['template'] != '') {
	$template_location = PE_PATH.'/templates/'.$results_array['template'].'/info.php';
} else {
	$template_location = PE_PATH.'/templates/'.DEFAULT_TEMPLATE.'/info.php';
}
if(file_exists($template_location)) {
	require($template_location);
}
// Check if $menu is set
if(!isset($menu[1]) OR $menu[1] == '') {
	// Make our own menu list
	$menu[1] = $TEXT['MAIN'];
}
// Add menu options to the list
$template->set_block('main_block', 'menu_list_block', 'menu_list');
foreach($menu AS $number => $name) {
	$template->set_var('NAME', $name);
	$template->set_var('VALUE', $number);
	if($results_array['menu'] == $number) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('menu_list', 'menu_list_block', true);
}

// Insert language values
$template->set_block('main_block', 'language_list_block', 'language_list');
$template->set_var(array(
							'SELECTED_FLAG' => strtolower($results_array['language']),
							));
foreach($Pacer->Languages_List() as $k => $v) {
	// Insert code and name
	$template->set_var(array(
							'CODE' => $v['directory'],
							'NAME' => $v['name'],
							'FLAG' => strtolower($v['directory']),
							'SELECTED' => ($results_array['language'] == $v['directory'])?' selected="selected"':'',
							));
	$template->parse('language_list', 'language_list_block', true);
}

// Select disabled if searching is disabled
if($results_array['searching'] == 0) {
	$template->set_var('SEARCHING_DISABLED', ' selected="selected"');
}
// Select what the page target is
switch ($results_array['target']) {
	case '_top':
		$template->set_var('TOP_SELECTED', ' selected="selected"');
		break;
	case '_self':
		$template->set_var('SELF_SELECTED', ' selected="selected"');
		break;
	case '_blank':
		$template->set_var('BLANK_SELECTED', ' selected="selected"');
		break;
	case 'popup':
		$template->set_var('POPUP_SELECTED', ' selected="selected"');
		break;
	case 'modal':
		$template->set_var('MODAL_SELECTED', ' selected="selected"');
		break;
}

// Insert accesskey values
$template->set_block('main_block', 'accesskey_list_block', 'accesskey_list');
foreach(array_merge(array('-'),range(0,9),range('a','z')) as $accesskey){
	$pt = $Pacer->database->queryRow("SELECT page_title,page_id FROM ".TABLE_PREFIX."pages WHERE `page_id` != '".$page_id."' AND `accesskey` = '".$accesskey."' LIMIT 1");
	$template->set_var('NAME', $Pacer->Translate('Alt').' + '.$accesskey.(($pt['page_id']&&$pt['page_id']!=$page_id)?'  -> '.$Pacer->Translate('Used for page').': '.$pt['page_id']. ' '. $pt['page_title']:''));
	$template->set_var('VALUE', $accesskey);
	$template->set_var('SELECTED', (($results_array['accesskey'] === $accesskey) ?' selected="selected"':''));
	$template->parse('accesskey_list', 'accesskey_list_block', true);
}
// Insert menu_icon values
$template->set_block('main_block', 'menu_icon_list_block', 'menu_icon_list');
$template->set_var(array(
							'SELECTED_MENU_ICON' => $results_array['menu_icon'],
							));
// glob
if (is_dir(PE_PATH.'/menus/iconset')) {
	$a = 'a';
	foreach(directory_list(PE_PATH.'/menus/iconset') as $dlk => $dlv) {
		foreach(file_list($dlv) as $k => $v) {
			// Insert code and name
			$size = getimagesize($v);
			if ($size['mime']=='') continue;
			$code = str_replace(PE_PATH,'',$v);
			$d = preg_replace('|/.*/|i','',dirname($code));
	
			$template->set_var(array(
							'CODE' => $code,
							'NAME' => $d.DIRECTORY_SEPARATOR.basename($code),
							'ROW_BG' => 'background-color: #'.$a.$a.$a.';',
							'MENU_ICON' => $code,
							'SELECTED' => ($results_array['menu_icon'] == $code)?' selected="selected"':'',
							));
			$template->parse('menu_icon_list', 'menu_icon_list_block', true);
			$a = ($a=='a')?'b':'a';
		}
	}
}


// Insert language text
$template->set_var(array(
								'HEADING_MODIFY_PAGE_SETTINGS' => $HEADING['MODIFY_PAGE_SETTINGS'],
								'TEXT_CURRENT_PAGE' => $TEXT['CURRENT_PAGE'],
								'TEXT_MODIFY' => $TEXT['MODIFY'],
								'TEXT_MODIFY_PAGE' => $HEADING['MODIFY_PAGE'],
								'LAST_MODIFIED' => $MESSAGE['PAGES']['LAST_MODIFIED'],
								'TEXT_PAGE_TITLE' => $TEXT['PAGE_TITLE'],
								'TEXT_PAGE_TITLE_DISPLAY' => $Pacer->Translate('Display Title'),
								'TEXT_PAGE_SUB_TITLE_DISPLAY' => $Pacer->Translate('Sub Title'),
								'TEXT_MENU_TITLE' => $TEXT['MENU_TITLE'],
								'TEXT_TYPE' => $TEXT['TYPE'],
								'TEXT_MENU' => $TEXT['MENU'],
								'TEXT_PARENT' => $TEXT['PARENT'],
								'TEXT_VISIBILITY' => $TEXT['VISIBILITY'],
								'TEXT_PUBLIC' => $TEXT['PUBLIC'],
								'TEXT_PRIVATE' => $TEXT['PRIVATE'],
								'TEXT_REGISTERED' => $TEXT['REGISTERED'],
								'TEXT_NONE' => $TEXT['NONE'],
								'TEXT_HIDDEN' => $TEXT['HIDDEN'],
								'TEXT_TEMPLATE' => $TEXT['TEMPLATE'],
								'TEXT_TARGET' => $TEXT['TARGET'],
								'TEXT_SYSTEM_DEFAULT' => $TEXT['SYSTEM_DEFAULT'],
								'TEXT_PLEASE_SELECT' => $TEXT['PLEASE_SELECT'],
								'TEXT_NEW_WINDOW' => $TEXT['NEW_WINDOW'],
								'TEXT_SAME_WINDOW' => $TEXT['SAME_WINDOW'],
								'TEXT_TOP_FRAME' => $TEXT['TOP_FRAME'],
								
								'TEXT_POPUP_FRAME' => $Pacer->Translate('Popup'),
								'TEXT_MODAL_FRAME' => $Pacer->Translate('Modal'),
								
								'TEXT_ADMINISTRATORS' => $TEXT['ADMINISTRATORS'],
								'TEXT_ALLOWED_VIEWERS' => $TEXT['ALLOWED_VIEWERS'],
								'TEXT_DESCRIPTION' => $TEXT['DESCRIPTION'],
								'TEXT_KEYWORDS' => $TEXT['KEYWORDS'],
								'TEXT_SEARCHING' => $TEXT['SEARCHING'],
								'TEXT_LANGUAGE' => $TEXT['LANGUAGE'],
								'TEXT_ENABLED' => $TEXT['ENABLED'],
								'TEXT_DISABLED' => $TEXT['DISABLED'],
								'TEXT_SAVE' => $TEXT['SAVE'],
								'TEXT_SAVE_CLOSE' => $Pacer->Translate('Save & Close'),
								'TEXT_RESET' => $TEXT['RESET'],
								'LAST_MODIFIED' => $MESSAGE['PAGES']['LAST_MODIFIED'],
								'HEADING_MODIFY_PAGE' => $HEADING['MODIFY_PAGE'],
								'TEXT_PAGE_CODE' => $Pacer->Translate('Page code'),
								'TEXT_MENU_ACCESS' => $Pacer->Translate('Navigation'),
								'TEXT_ACCESSKEY' => $Pacer->Translate('AccessKey'),
								'TEXT_ANCHOR' => $Pacer->Translate('Anchor'),
								'ANCHOR' => $results_array['anchor'],
								'TEXT_MENU_ICON' => $Pacer->Translate('Menu Icon'),
								
								'TEXT_PAGE_TAGS'=> $Pacer->Translate('Tags'),
								'TEXT_ADD_PAGE_TAGS'=> $Pacer->Translate('Add new tags'),
								'TEXT_ADD_PAGE_TAGS_HELP'=> $Pacer->Translate('(one per line)'),
								
								'TEXT_PAGE_TAG'=> $Pacer->Translate('Tag'),
								'TEXT_ACTION'=> $Pacer->Translate('Action'),
								
								'TEXT_DESIGNING_NOTES'=> $Pacer->Translate('Designing Notes'),
								'TEXT_PAGE_NOTE'=> $Pacer->Translate('Notes'),
								'PAGE_NOTE'=> $results_array['designing_note'],
								'TEXT_PAGE_STATUS'=> $Pacer->Translate('Status'),
								'PAGE_STATUS'=> $results_array['designing_status'],
								'TEXT_PAGE_PRIORITY'=> $Pacer->Translate('Priority'),
								'PAGE_PRIORITY'=> $results_array['designing_priority'],
								
								'TEXT_PAGE_TAGS_SHOW' => $Pacer->Translate('Shown'),
								'SHOW_TAGS_CHECKED_1' => ($results_array['show_tags']=='1' || $results_array['show_tags']=='3')?' checked="checked"':'', 
								'TEXT_YES' => $TEXT['YES'],
								'SHOW_TAGS_CHECKED_2' => ($results_array['show_tags']=='2' || $results_array['show_tags']=='3')?' checked="checked"':'', 
								'TEXT_ALL'=> $Pacer->Translate('All'),
								'TEXT_CONFIRM_DELETE'=> $Pacer->Translate('Confirm deletion of this Tag from all pages?'),
								'TOOLTIP_TAGS_PAGE'=>$Pacer->Translate('Tags will be displayed on this page'),
								'TOOLTIP_TAGS_ALL'=>$Pacer->Translate('All tags will be displayed'),
								)
						);
// Status
$template->set_block('main_block', 'page_designing_block', 'page_designing_list');
foreach(Decode_Page_Designing_Status() as $k => $v) {
	$template->set_var('PAGE_STATUS', $v);
	$template->set_var('PAGE_STATUS_VALUE', $k);
	$template->set_var('PAGE_STATUS_SELECTED',(($results_array['designing_status'] == (int) $k)?' selected="selected"':''));
	$template->parse('page_designing_list', 'page_designing_block', true);
}
// Priority
$template->set_block('main_block', 'page_designing_priority_block', 'page_designing_priority_list');
foreach(Decode_Page_Designing_Priority() as $k => $v) {
	$template->set_var('PAGE_PRIORITY', $v);
	$template->set_var('PAGE_PRIORITY_VALUE', $k);
	$template->set_var('PAGE_PRIORITY_SELECTED',(($results_array['designing_priority'] == (int) $k)?' selected="selected"':''));
	$template->parse('page_designing_priority_list', 'page_designing_priority_block', true);
}
$template->set_block('main_block', 'page_tags_block', 'page_tags_list');
$a = 'a';
foreach($Pacer->Tags_List($results_array['page_id']) as $k => $v) {
	$template->set_var(array(
							'PAGE_TAG_ID' => $v['id'],
							'NAME' => $k,
							'TAG_V' => ($v['checked'])?'1':'0',	
							'TAG_UN' => ($v['checked'])?'':'un',
							'ROW_AB' => $a,
							'PAGE_TAG_SELECT'=>$Pacer->Translate('Select / Deselect Tag for this page'),
							'CHECKED' => ($v['checked'])?' checked="checked"':'',
							));
	$template->parse('page_tags_list', 'page_tags_block', true);
	$a = ($a=='a')?'b':'a';
}
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

if (isset($_GET['open_notes'])){
	$script='
	jQuery(document).ready(function(){
	setTimeout(\'jQuery("#accordion-elem4").click()\',100);
});';
	$Pacer->Code_Injection_Add('js_script',$script);
}

// Print admin footer
$admin->print_footer();

?>
