<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: settings2.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// Get page id
if(!isset($_POST['page_id']) OR !is_numeric($_POST['page_id'])) {
	header("Location: index.php");
	exit(0);
} else {
	$page_id = $_POST['page_id'];
}

// Create new admin object and print admin header
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'pages_settings');

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');

// Get values
$page_title = $admin->get_post_escaped('page_title');
$page_title = htmlspecialchars($page_title);
$menu_title = $admin->get_post_escaped('menu_title');
$menu_title = htmlspecialchars($menu_title);
$description = htmlspecialchars($admin->add_slashes($admin->get_post('description')));
$keywords = htmlspecialchars($admin->add_slashes($admin->get_post('keywords')));
$page_code = htmlspecialchars($admin->add_slashes($admin->get_post('page_code')));
$parent = $admin->get_post_escaped('parent');
$visibility = $admin->get_post_escaped('visibility');
$page_type = $admin->get_post_escaped('page_type');
$template = $admin->get_post_escaped('template');
$target = $admin->get_post_escaped('target');
$admin_groups = $admin->get_post_escaped('admin_groups');
$viewing_groups = $admin->get_post_escaped('viewing_groups');
$searching = $admin->get_post_escaped('searching');
$language = $admin->get_post_escaped('language');
$menu = $admin->get_post_escaped('menu');

$show_tags = ((int) $admin->get_post_escaped('show_tags_1')) + ((int) $admin->get_post_escaped('show_tags_2'));
$new_tags = array();

if ($tags = preg_split('/[\n|\r]/',$admin->get_post_escaped('add_page_tags'))){
	foreach ($tags as $k){
		if ($k)	$new_tags[$k]=$k;
	}
}
// delete tags marked to delete
$tags=array();
foreach($_POST as $k => $v) {
	if (!preg_match('/^delete_tag_/i',$k)) continue;
	if ($admin->get_post_escaped($k)=='1') {
		$tags[$admin->get_post_escaped(preg_replace('/^delete_/i','name_',$k))]=$admin->get_post_escaped(preg_replace('/^delete_/i','name_',$k));
	}
}
$Pacer->Tags_Delete($tags);
// update tags marked
$tags=array();
foreach($_POST as $k => $v) {
	if (!preg_match('/^tag_/i',$k)) continue;
	// is it selected?
	if ($admin->get_post_escaped($k)!='1') continue;
	// was it deleted?
	if ($admin->get_post_escaped('delete_'.$k)=='1') continue; 
	$tags[$admin->get_post_escaped('name_'.$k)]=$admin->get_post_escaped('name_'.$k);
}
$tags=array_merge($tags,$new_tags);
$tags=serialize($Pacer->Tags_Order($tags));

$update_sql = '';
foreach(array('seo_index','seo_follow','seo_archive', 'seo_snippet','seo_snippet','seo_freq','accesskey','anchor','menu_icon','designing_note','designing_status','designing_priority','page_title_display','page_sub_title_display') as $v) {
	${$v} = $admin->get_post_escaped($v);
	$update_sql .=  ",$v = '${$v}'";
}
$page_title_display = htmlspecialchars($page_title_display);

$update_sql .=  ",tags = '$tags'";
$update_sql .=  ",show_tags = '$show_tags'";

// Validate data
if($page_title == '' || substr($page_title,0,1)=='.') {
	$admin->print_error($MESSAGE['PAGES']['BLANK_PAGE_TITLE']);
}
if($menu_title == '' || substr($menu_title,0,1)=='.') {
	$admin->print_error($MESSAGE['PAGES']['BLANK_MENU_TITLE']);
}

// Validate Intro page
if ($page_type!='0') {
	$visibility = 'hidden';
	$parent = '0'; // None
}

// Get existing perms
$database = new database();
$results = $database->query("SELECT parent,link,position,admin_groups,admin_users FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'");
$results_array = $results->fetchRow();
$old_parent = $results_array['parent'];
$old_link = $results_array['link'];
$old_position = $results_array['position'];
$old_admin_groups = explode(',', str_replace('_', '', $results_array['admin_groups']));
$old_admin_users = explode(',', str_replace('_', '', $results_array['admin_users']));

$in_old_group = FALSE;
foreach($admin->get_groups_id() as $cur_gid){
    if (in_array($cur_gid, $old_admin_groups)) {
	$in_old_group = TRUE;
    }
}
if((!$in_old_group) AND !is_numeric(array_search($admin->get_user_id(), $old_admin_users))) {
	$admin->print_error($MESSAGE['PAGES']['INSUFFICIENT_PERMISSIONS']);
}

// Setup admin groups
$admin_groups[] = 1;
//if(!in_array(1, $admin->get_groups_id())) {
//	$admin_groups[] = implode(",",$admin->get_groups_id());
//}
$admin_groups = implode(',', $admin_groups);
// Setup viewing groups
$viewing_groups[] = 1;
//if(!in_array(1, $admin->get_groups_id())) {
//	$viewing_groups[] = implode(",",$admin->get_groups_id());
//}
$viewing_groups = implode(',', $viewing_groups);

// If needed, get new order
if($parent != $old_parent) {
	// Include ordering class
	require(PE_PATH.'/framework/class.order.php');
	$order = new order(TABLE_PREFIX.'pages', 'position', 'page_id', 'parent');
	// Get new order
	$position = $order->get_new($parent);
	// Clean new order
	$order->clean($parent);
} else {
	$position = $old_position;
}

// Work out level and root parent
if ($parent!='0') {
	$level = level_count($parent)+1;
	$root_parent = root_parent($parent);
}
else {
	$level = '0';
	$root_parent = '0';
}

// Work-out what the link should be
if($parent == '0') {
	$link = '/'.page_filename($menu_title);
	// rename menu titles: index && intro to prevent clashes with intro page feature and PE core file /pages/index.php
	if($link == '/index' || $link == '/intro') {
		$link .= '_' .$page_id;
		$filename = PE_PATH.PAGES_DIRECTORY.'/'.page_filename($menu_title).'_'.$page_id .PAGE_EXTENSION; 
	} else {
		$filename = PE_PATH.PAGES_DIRECTORY.'/'.page_filename($menu_title).PAGE_EXTENSION; 
	}
} else {
	$parent_section = '';
	$parent_titles = array_reverse(get_parent_titles($parent));
	foreach($parent_titles AS $parent_title) {
		$parent_section .= page_filename($parent_title).'/';
	}
	if($parent_section == '/') { $parent_section = ''; }
	$link = '/'.$parent_section.page_filename($menu_title);
	$filename = PE_PATH.PAGES_DIRECTORY.'/'.$parent_section.page_filename($menu_title).PAGE_EXTENSION;  
}

// Check if a page with same page filename exists
$database = new database();
$get_same_page = $database->query("SELECT page_id,page_title FROM ".TABLE_PREFIX."pages WHERE link = '$link' and page_id != '$page_id'");
if($get_same_page->numRows() > 0) {
	$admin->print_error($MESSAGE['PAGES']['PAGE_EXISTS']);
}

// Update page with new order
$query = "UPDATE ".TABLE_PREFIX."pages SET parent = '$parent', position = '$position' WHERE page_id = '$page_id'";
$database = new database();
$database->query($query);

// Get page trail
$page_trail = get_page_trail($page_id);

// Update page settings in the pages table
$query = "UPDATE ".TABLE_PREFIX."pages SET parent = '$parent', page_title = '$page_title', menu_title = '$menu_title', menu = '$menu', level = '$level', page_trail = '$page_trail', root_parent = '$root_parent', link = '$link', template = '$template', target = '$target', description = '$description', keywords = '$keywords', position = '$position', visibility = '$visibility', searching = '$searching', language = '$language', admin_groups = '$admin_groups', viewing_groups = '$viewing_groups', page_type = '$page_type', page_code = '$page_code' $update_sql WHERE page_id = '$page_id'";

$database->query($query);

if ($page_type!='0') {
	//die($query);
	//die("UPDATE ".TABLE_PREFIX."pages SET intro_page = '0' WHERE page_id != '$page_id' AND intro_page = '1'");
	$database->query( "UPDATE ".TABLE_PREFIX."pages SET page_type = '0' WHERE page_id != '$page_id' AND page_type = '".$page_type."'");
}
$database->query( "UPDATE ".TABLE_PREFIX."pages SET accesskey = '' WHERE page_id != '$page_id' AND accesskey = '".$accesskey."'");

// Clean old order if needed
if($parent != $old_parent) {
	$order->clean($old_parent);
}

/* BEGIN page "access file" code */

// Create a new file in the /pages dir if title changed
if(!is_writable(PE_PATH.PAGES_DIRECTORY.'/')) {
	$admin->print_error($MESSAGE['PAGES']['CANNOT_CREATE_ACCESS_FILE']);
} else {
	// First check if we need to create a new file
	if($old_link != $link) {
		// Delete old file
		$old_filename = PE_PATH.PAGES_DIRECTORY.$old_link.PAGE_EXTENSION;
		if(file_exists($old_filename)) {
			unlink($old_filename);
		}
		// Create access file
		create_access_file($filename,$page_id,$level);
		// Move a directory for this page
		if(file_exists(PE_PATH.PAGES_DIRECTORY.$old_link.'/') AND is_dir(PE_PATH.PAGES_DIRECTORY.$old_link.'/')) {
			rename(PE_PATH.PAGES_DIRECTORY.$old_link.'/', PE_PATH.PAGES_DIRECTORY.$link.'/');
		}
		// Update any pages that had the old link with the new one
		$old_link_len = strlen($old_link);
		$query_subs = $database->query("SELECT page_id,link,level FROM ".TABLE_PREFIX."pages WHERE link LIKE '%$old_link/%' ORDER BY LEVEL ASC");
		if($query_subs->numRows() > 0) {
			while($sub = $query_subs->fetchRow()) {
				// Double-check to see if it contains old link
				if(substr($sub['link'], 0, $old_link_len) == $old_link) {
					// Get new link
					$replace_this = $old_link;
					$old_sub_link_len =strlen($sub['link']);
					$new_sub_link = $link.'/'.substr($sub['link'],$old_link_len+1,$old_sub_link_len);
					// Work out level
					$new_sub_level = level_count($sub['page_id']);
					// Update level and link
					$database->query("UPDATE ".TABLE_PREFIX."pages SET link = '$new_sub_link', level = '$new_sub_level' WHERE page_id = '".$sub['page_id']."' LIMIT 1");
					// Re-write the access file for this page
					$old_subpage_file = PE_PATH.PAGES_DIRECTORY.$new_sub_link.PAGE_EXTENSION;
					if(file_exists($old_subpage_file)) {
						unlink($old_subpage_file);
					}
					create_access_file(PE_PATH.PAGES_DIRECTORY.$new_sub_link.PAGE_EXTENSION, $sub['page_id'], $new_sub_level);
				}
			}
		}
	}
}

// Function to fix page trail of subs
function fix_page_trail($parent,$root_parent) {
	// Get objects and vars from outside this function
	global $admin, $template, $database, $TEXT, $MESSAGE;
	// Get page list from database
	$database = new database();
	$query = "SELECT page_id FROM ".TABLE_PREFIX."pages WHERE parent = '$parent'";
	$get_pages = $database->query($query);
	// Insert values into main page list
	if($get_pages->numRows() > 0)	{
		while($page = $get_pages->fetchRow()) {
			// Fix page trail
			$database->query("UPDATE ".TABLE_PREFIX."pages SET ".($root_parent != 0 ?"root_parent = '$root_parent', ":"")." page_trail = '".get_page_trail($page['page_id'])."' WHERE page_id = '".$page['page_id']."'");
			// Run this query on subs
			fix_page_trail($page['page_id'],$root_parent);
		}
	}
}
// Fix sub-pages page trail
fix_page_trail($page_id,$root_parent);

/* END page "access file" code */

// Check if there is a db error, otherwise say successful
if($database->is_error()) {
	$admin->print_error($database->get_error(), ADMIN_URL.'/pages/settings.php?page_id='.$page_id);
} else {
	if ($admin->get_post_escaped('submit_close'))
		$admin->print_success($MESSAGE['PAGES']['SAVED_SETTINGS'], ADMIN_URL.'/pages/index.php');
	else
		$admin->print_success($MESSAGE['PAGES']['SAVED_SETTINGS'], ADMIN_URL.'/pages/settings.php?page_id='.$page_id);
}

// Print admin footer
$admin->print_footer();

?>
