<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: November 01,2009                                            *
 *    Build Time: 21:00:00                                                    *
 *     File Name: index.inc.php                                               *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */
require_once(PE_PATH.'/framework/functions-utf8.php');
// Create new template object for the preferences form
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', $template_file);
$template->set_block('page', 'main_block', 'main');
$template->set_var('PE_URL', PE_URL);
$template->set_var('ADMIN_URL', ADMIN_URL);
$template->set_var('FROMWHERE',$fromwhere );
$template->set_var('ACTION_URL',ADMIN_URL.'/preferences/save.php' );
if($fromwhere=='frontend'){
	$template->set_var('COMMENT_MAINBOX_OPEN','<!--' );
	$template->set_var('COMMENT_MAINBOX_CLOSE','-->' );
}
// Get existing value from database
$database = new database();
$query = "SELECT * FROM ".TABLE_PREFIX."users WHERE user_id = '".$admin->get_user_id()."'";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_error($database->get_error(), 'index.php');
}
$details = $results->fetchRow();
$user = $details;

// Insert values into form
$template->set_var('DISPLAY_NAME', $details['display_name']);
$template->set_var('EMAIL', $details['email']);

// Insert language values
$template->set_block('main_block', 'language_list_block', 'language_list');
$template->set_var(array(
							'SELECTED_FLAG' => strtolower($details['language']),
							));
foreach($Pacer->Languages_List() as $k => $v) {
	// Insert code and name
	$template->set_var(array(
							'CODE' => $v['directory'],
							'NAME' => $v['name'],
							'FLAG' => strtolower($v['directory']),
							'SELECTED' => ($details['language'] == $v['directory'])?' selected="selected"':'',
							));
	$template->parse('language_list', 'language_list_block', true);
}

// Insert default timezone values
require(ADMIN_PATH.'/interface/timezones.php');
$template->set_var('TEXT_PLEASE_SELECT', $TEXT['PLEASE_SELECT']);

$template->set_block('main_block', 'timezone_list_block', 'timezone_list');
/*
foreach($TIMEZONES AS $hour_offset => $title) {
	$template->set_var('VALUE', $hour_offset);
	$template->set_var('NAME', $title);
	if($admin->get_timezone() == $hour_offset*60*60) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('timezone_list', 'timezone_list_block', true);
}
*/
/*
$template->set_var('NAME', $TEXT['SYSTEM_DEFAULT']);	
$template->parse('timezone_list', 'timezone_list_block', true);
*/
foreach($TIMEZONES AS $value => $tz) {
//	$offset = ((int) $tz['gmtoffset'])*60*60;
	$template->set_var('VALUE', $value);
	$template->set_var('NAME', $tz['display']);	
	if($details['timezone_name'] == $value) {
		$template->set_var('SELECTED', 'selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('timezone_list', 'timezone_list_block', true);
}
// Insert date format list
$user_time = true;
require(ADMIN_PATH.'/interface/date_formats.php');
$template->set_block('main_block', 'date_format_list_block', 'date_format_list');
foreach($DATE_FORMATS AS $format => $title) {
	$format = str_replace('|', ' ', $format); // Add's white-spaces (not able to be stored in array key)
	if($format != 'system_default') {
		$template->set_var('VALUE', $format);
	} else {
		$template->set_var('VALUE', '');
	}
	$template->set_var('NAME', $title);
	if(DATE_FORMAT == $format AND !isset($_SESSION['USE_DEFAULT_DATE_FORMAT'])) {
		$template->set_var('SELECTED', ' selected="selected"');
	} elseif($format == 'system_default' AND isset($_SESSION['USE_DEFAULT_DATE_FORMAT'])) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('date_format_list', 'date_format_list_block', true);
}

// Insert time format list
require(ADMIN_PATH.'/interface/time_formats.php');
$template->set_block('main_block', 'time_format_list_block', 'time_format_list');
foreach($TIME_FORMATS AS $format => $title) {
	$format = str_replace('|', ' ', $format); // Add's white-spaces (not able to be stored in array key)
	if($format != 'system_default') {
		$template->set_var('VALUE', $format);
	} else {
		$template->set_var('VALUE', '');
	}
	$template->set_var('NAME', $title);
	if(TIME_FORMAT == $format AND !isset($_SESSION['USE_DEFAULT_TIME_FORMAT'])) {
		$template->set_var('SELECTED', ' selected="selected"');
	} elseif($format == 'system_default' AND isset($_SESSION['USE_DEFAULT_TIME_FORMAT'])) {
		$template->set_var('SELECTED', 'selected');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('time_format_list', 'time_format_list_block', true);
}

// Insert language headings
$template->set_var(array(
								'HEADING_MY_SETTINGS' => $HEADING['MY_SETTINGS'],
								'HEADING_MY_EMAIL' => $HEADING['MY_EMAIL'],
								'HEADING_MY_PASSWORD' => $HEADING['MY_PASSWORD'],
								'HEADING_MY_PREFRENCE' => $Pacer->Translate('Preferences'),
								'HEADING_MY_PREFRENCE_SUB' => $Pacer->Translate('Edit / update your Preferences...')
								)
						);
// Insert language text and messages
$template->set_var(array(
								'TEXT_SAVE' => $TEXT['SAVE'],
								'TEXT_RESET' => $TEXT['RESET'],
								'TEXT_DISPLAY_NAME' => $TEXT['DISPLAY_NAME'],
								'TEXT_EMAIL' => $TEXT['EMAIL'],
								'TEXT_LANGUAGE' => $TEXT['LANGUAGE'],
								'TEXT_TIMEZONE' => $TEXT['TIMEZONE'],
								'TEXT_DATE_FORMAT' => $TEXT['DATE_FORMAT'],
								'TEXT_TIME_FORMAT' => $TEXT['TIME_FORMAT'],
								'TEXT_CURRENT_PASSWORD' => $TEXT['CURRENT_PASSWORD'],
								'TEXT_NEW_PASSWORD' => $TEXT['NEW_PASSWORD'],
								'TEXT_RETYPE_NEW_PASSWORD' => $TEXT['RETYPE_NEW_PASSWORD']
								
								)
						);

$imagefolder=$Pacer->Pacer_Super_User_ImageFolder($user['user_id']).'/'.$user['user_id'].'_';

$template->set_var(array(
'TEXT_IMAGES_SETTINGS' =>$Pacer->Translate('My Images Settings'),
'TEXT_DELETE' =>$TEXT['DELETE'],
'TEXT_USER_IMAGE' =>$Pacer->Translate('User Image'),
'TEXT_USER_IMAGE_SMALL' =>$Pacer->Translate('User Image (small)'),
'THEME_URL' => THEME_URL,
'RESIZER' => PACER_URL.'/pacer_img_resizer.php?force_jpg=true&max_width=160&max_height=160&imgfile=',
'RESIZER_SMALL' => PACER_URL.'/pacer_img_resizer.php?force_jpg=true&max_width=60&max_height=60&imgfile=',
'RESIZER_AVATAR' => PACER_URL.'/pacer_img_resizer.php?force_jpg=true&max_width=100&max_height=100&imgfile=',
									
'ACTION' => (isset($_GET['action']) AND $_GET['action'] == "add")?"add":"modify",

'TEXT_UPLOAD' =>$Pacer->Translate('Upload'),
'TEXT_UPLOADING' =>$Pacer->Translate('Uploading...'),
'TEXT_INVALID_FILE_EXTENSION' =>$Pacer->Translate('Error: invalid file extension'),
'TEMP_NAME' => uniqid(),
'USER_ID' => $user['user_id'],
'USER_IMAGE_NAME' => (file_exists($imagefolder.'user_image.jpg')) ? $imagefolder.'user_image.jpg':'',
'USER_IMAGE_SMALL_NAME' => (file_exists($imagefolder.'user_image_small.jpg')) ? $imagefolder.'user_image_small.jpg':'',
'USER_AVATAR_NAME' => (file_exists($imagefolder.'user_avatar.jpg')) ? $imagefolder.'user_avatar.jpg':'',
'USER_IMAGE_SHOW' => (file_exists($imagefolder.'user_image.jpg')) ? str_replace(PE_PATH,PE_URL,$imagefolder).'/user_image.jpg':'',
'USER_IMAGE_SMALL_SHOW' => (file_exists($imagefolder.'user_image_small.jpg')) ? str_replace(PE_PATH,PE_URL,$imagefolder).'user_image_small.jpg':'',

'USER_AVATAR_SHOW' => (file_exists($imagefolder.'user_avatar.jpg')) ? str_replace(PE_PATH,PE_URL,$imagefolder).'user_avatar.jpg':'',
'TEXT_CALENDAR' =>$Pacer->Translate('Calendar'),
'TEXT_DELETE_DATE' =>$Pacer->Translate('Delete date'),
'TEXT_USER_AVATAR' =>$Pacer->Translate('User Avatar'),
// Extra settings
'TEXT_EXTRA_SETTINGS' =>$Pacer->Translate('My Extra Settings'),
'TEXT_USER_FIRSTNAME' => $Pacer->Translate('Firstname'),
'USER_FIRSTNAME' => $user['user_firstname'],
'TEXT_USER_LASTNAME' => $Pacer->Translate('Lastname'),
'USER_LASTNAME' => $user['user_lastname'],
'TEXT_USER_DOB' => $Pacer->Translate('Date of birth'),
'USER_DOB' => ( $user['user_dob']) ? date(DATE_FORMAT,$user['user_dob']):'',
'TEXT_USER_GENDER' => $Pacer->Translate('Gender'),
'TEXT_USER_GENDER_M' => $Pacer->Translate('Male'),
'TEXT_USER_GENDER_F' => $Pacer->Translate('Female'),
'USER_GENDER_'.(($user['user_gender']!='F') ?'M':'F') => ' checked="checked" ',
'TEXT_USER_ADDRESS' => $Pacer->Translate('Address'),
'USER_ADDRESS' => $user['user_address'],
'TEXT_USER_ZIP' => $Pacer->Translate('Zip'),
'USER_ZIP' => $user['user_zip'],
'TEXT_USER_CITY' => $Pacer->Translate('City'),
'USER_CITY' => $user['user_city'],
'TEXT_USER_COUNTRY' => $Pacer->Translate('Country'),
'USER_COUNTRY' => $user['user_country'],
'TEXT_USER_TELEPHONE' => $Pacer->Translate('Telephone'),
'USER_TELEPHONE' => $user['user_telephone'],
'TEXT_USER_SIGNATURE' => $Pacer->Translate('Signature'),
'USER_SIGNATURE' => $user['user_signature'],
									'USER_FAX' => $user['user_fax'],
									'TEXT_USER_FAX' => $Pacer->Translate('Fax'),
									'USER_SKYPE' => $user['user_skype'],
									'TEXT_USER_SKYPE' => $Pacer->Translate('Skype'),
									
									'TEXT_USER_PM' => 'Private Messaging',
									'TEXT_USER_PM_EMAIL_NOTIFICATION' => $Pacer->Translate('Email notification of new messages'),
									'USER_PM_EMAIL_NOTIFICATION_ENABLED_CHECKED' => ($user['user_pm_email_notification']=='1') ? ' selected="selected" ':'',
									'USER_PM_EMAIL_NOTIFICATION_DISABLED_CHECKED' => ($user['user_pm_email_notification']=='0') ? ' selected="selected" ': '',
									'TEXT_USER_PM_SHOW_IN_LIST' => $Pacer->Translate('Show in the members list'),
									'USER_PM_SHOW_IN_LIST_ENABLED_CHECKED' => ($user['user_pm_show_in_list']=='1') ? ' selected="selected" ':'',
									'USER_PM_SHOW_IN_LIST_DISABLED_CHECKED' => ($user['user_pm_show_in_list']=='0') ? ' selected="selected" ':'',
									'TEXT_USER_PM_SHOW_EMAIL_IN_LIST' => $Pacer->Translate('Show email in the members list'),
									'USER_PM_SHOW_EMAIL_IN_LIST_ENABLED_CHECKED' => ($user['user_pm_show_email_in_list']=='1') ? ' selected="selected" ':'',
									'USER_PM_SHOW_EMAIL_IN_LIST_DISABLED_CHECKED' =>($user['user_pm_show_email_in_list']=='0') ? ' selected="selected" ':'',
									'TEXT_SYSTEM_DEFAULT' => $Pacer->Translate('System default'),
									'TEXT_YES' => $TEXT['YES'],
									'TEXT_NO' => $TEXT['NO'],

'TEXT_USER_PM_ENABLED' => $Pacer->Translate('Enabled'),
									'USER_PM_ENABLED_CHECKED' => ($user['user_pm_enabled']=='1') ? ' checked="checked" ':'',
									'USER_PM_DISABLED_CHECKED' =>($user['user_pm_enabled']=='0') ? ' checked="checked" ':'',
								)
						);
	// Private Messages..
	$module_directory = 'pacer_private_messages';
	$pms = PE_PATH.'/modules/'.$module_directory.'/functions.php';
	if (file_exists($pms)){
		require($pms);
		if(get_pm_active()) 
			$template->set_var(array(							
				'START_PMS_ENABLED' => '-->',
				'END_PMS_ENABLED' => '<!--'
			));	
	}

$Pacer->Code_Injection_Add('js_file','jquery.ajax-upload.js');
$Pacer->Code_Injection_Add('css_file','jquery.ajax-upload.css');
$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/calendar.js');
$Pacer->Code_Injection_Add('css_file',PE_URL.'/include/jscalendar/calendar-system.css');

		if(file_exists(PE_PATH .'/include/jscalendar/lang/calendar-'.strtolower(LANGUAGE) .'.js')) {
			$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/lang/calendar-'.strtolower(LANGUAGE) .'.js');
		} else {
			$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/lang/calendar-en.js');
		}
		
		$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/calendar-setup.js');
		$date_format ='';
		// today
		$jscal_use_time=true;
		$jscal_today = date('Y/m/d');
		// first-day-of-week
		$jscal_firstday = '1'; // monday
		if(LANGUAGE=='EN') $jscal_firstday = '0'; // sunday

	

		foreach(array('user_dob') as $k) {
			$jscal_ifformat = $Pacer->convert_datetime_format('','',($k=='user_dob')?false:true, $Pacer->get_user_id());
			$jscal_use_time = ($k=='user_dob')?false:true; // whether to use a clock, too
			if ($date_format) $jscal_ifformat = $date_format; //"%Y-%m-%d"; // - format for jscalendar (default: from wb-backend-date-format)
		
			$Pacer->Code_Injection_Add('js_script','
jQuery(document).ready(function() {
Calendar.setup({
	inputField  : "'.$k.'",
	ifFormat    : "'.$jscal_ifformat.'",
	button      : "'.$k.'_trigger",
	firstDay    : '.$jscal_firstday.',
'.
	((isset($jscal_use_time) && $jscal_use_time==TRUE) ? 'showsTime   : true, timeFormat  : "24",':'showsTime   : false,').'
	date        : "'.$jscal_today.'",
	range       : ['.(($k!='user_dob')?"1970, 2037":"1870,".date('Y')).'],
	step        : 1
});
});
');
		}
$Pacer->Code_Injection_Add('js_file','jquery.autogrow.js');

$Pacer->Code_Injection_Add('js_file','accordion.js');
$Pacer->Code_Injection_Add('css_file',THEME_PATH.'/css/accordion.css');

// Parse template for preferences form
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');
?>