<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: May 24,2010                                                 *
 *    Build Time: 21:00:00                                                    *
 *     File Name: index.php                                                   *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
if(isset($_GET['advanced']) AND $_GET['advanced'] == 'yes') {
	$admin = new admin('Settings', 'settings_advanced');
} else {
	$admin = new admin('Settings', 'settings_basic');
}
$admin->print_sub_header($HEADING['MY_GEN_SET'],$HEADING['MY_GEN_SET_SUB'],THEME_URL.'/icons/settings.png');

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');
require_once(PE_PATH.'/framework/functions-utf8.php');

// Editor
$id_list=array('website_header','website_footer','website_disclaimer','search_header','search_results_header','search_results_loop','search_results_footer','search_no_results','search_footer');
require_once(PE_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');

// Create new template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'settings.htt');
$template->set_block('page', 'main_block', 'main');

$template->set_var('ACTION',ADMIN_URL.'/settings/save.php');

// Query current settings in the db, then loop through them and print them
$query = "SELECT * FROM ".TABLE_PREFIX."settings";
$results = $database->query($query);
while($setting = $results->fetchRow()) {
	$setting_name = $setting['name'];
	$setting_value = htmlspecialchars($setting['value']);
	switch($setting_name) {
		case 'website_header':
		case 'website_footer':
		case 'website_disclaimer':
			$setting_value = show_wysiwyg_editor($setting_name, $setting_name, $setting_value,'','',array('no_output'=>true,'class'=>'expanding20-200 settings_textarea'));
		break;
	}
	$template->set_var(strtoupper($setting_name),$setting_value);
}

// Query current settings in the db, then loop through them and print them
$query = "SELECT * FROM ".TABLE_PREFIX."search WHERE extra = ''";
$results = $database->query($query);
while($setting = $results->fetchRow()) {
	$setting_name = $setting['name'];
	$setting_value = htmlspecialchars(($setting['value']));
	switch($setting_name) {
		// Search header
		case 'header':
			$template->set_var('SEARCH_HEADER', show_wysiwyg_editor('search_header', 'search_header', $setting_value,'','',array('no_output'=>true,'class'=>'expanding20-200 settings_textarea')));
		break;
		// Search results header
		case 'results_header':
			$template->set_var('SEARCH_RESULTS_HEADER', $setting_value);
			$template->set_var('SEARCH_RESULTS_HEADER', show_wysiwyg_editor('search_results_header', 'search_results_header', $setting_value,'','',array('no_output'=>true,'class'=>'expanding20-200 settings_textarea')));
		break;
		// Search results loop
		case 'results_loop':
			//$template->set_var('SEARCH_RESULTS_LOOP', $setting_value);
			$template->set_var('SEARCH_RESULTS_LOOP', show_wysiwyg_editor('search_results_loop', 'search_results_loop', $setting_value,'','',array('no_output'=>true,'class'=>'expanding20-200 settings_textarea')));
		break;
		// Search results footer
		case 'results_footer':
			//$template->set_var('SEARCH_RESULTS_FOOTER', $setting_value);
			$template->set_var('SEARCH_RESULTS_FOOTER', show_wysiwyg_editor('search_results_footer', 'search_results_footer', $setting_value,'','',array('no_output'=>true,'class'=>'expanding20-200 settings_textarea')));
		break;
		// Search no results
		case 'no_results':
			//$template->set_var('SEARCH_NO_RESULTS', $setting_value);
			$template->set_var('SEARCH_NO_RESULTS', show_wysiwyg_editor('search_no_results', 'search_no_results', $setting_value,'','',array('no_output'=>true,'class'=>'expanding20-200 settings_textarea')));
		break;
		// Search footer
		case 'footer':
			//$template->set_var('SEARCH_FOOTER', $setting_value);
			$template->set_var('SEARCH_FOOTER', show_wysiwyg_editor('search_footer', 'search_footer', $setting_value,'','',array('no_output'=>true,'class'=>'expanding20-200 settings_textarea')));
		break;
		// Search module-order
		case 'module_order':
			$template->set_var('SEARCH_MODULE_ORDER', $setting_value);
		break;
		// Search max lines of excerpt
		case 'max_excerpt':
			$template->set_var('SEARCH_MAX_EXCERPT', $setting_value);
		break;
		// time-limit
		case 'time_limit':
			$template->set_var('SEARCH_TIME_LIMIT', $setting_value);
		break;
		// Search template
		case 'template':
			$search_template = $setting_value;
		break;
	}
}

// Do the same for settings stored in config file as with ones in db
$database_type = '';

// Tell the browser whether or not to show advanced options
//if(isset($_GET['advanced']) AND $_GET['advanced'] == 'yes') {
	$template->set_var('DISPLAY_ADVANCED', '');
	$template->set_var('ADVANCED', 'yes');
	$template->set_var('ADVANCED_BUTTON', '&lt;&lt; '.$TEXT['HIDE_ADVANCED']);
	$template->set_var('ADVANCED_LINK', 'index.php?advanced=no');
	$template->set_var('BASIC_FILE_PERMS_ID', '');
	$template->set_var('ADVANCED_FILE_PERMS_ID', 'file_perms_box');
/*
} else {
	$template->set_var('DISPLAY_ADVANCED', '');
	$template->set_var('ADVANCED', 'no');
	$template->set_var('ADVANCED_BUTTON', $TEXT['SHOW_ADVANCED'].' &gt;&gt;');
	$template->set_var('ADVANCED_LINK', 'index.php?advanced=yes');
	$template->set_var('BASIC_FILE_PERMS_ID', 'file_perms_box');
	$template->set_var('ADVANCED_FILE_PERMS_ID', 'hide');
}
*/
$template->set_var(array(	
									'PAGES_DIRECTORY' => PAGES_DIRECTORY,
									'MEDIA_DIRECTORY' => MEDIA_DIRECTORY,
									'PAGE_EXTENSION' => PAGE_EXTENSION,
									'PAGE_SPACER' => PAGE_SPACER,
									'PE_PATH' => PE_PATH,
									'PE_URL' => PE_URL,
									'THEME_URL' => THEME_URL,
									'ADMIN_PATH' => ADMIN_PATH,
									'ADMIN_URL' => ADMIN_URL,
									'DATABASE_TYPE' => $Pacer->database->get_db_setting('DB_TYPE'),
									'DATABASE_HOST' => $Pacer->database->get_db_setting('DB_HOST'),
									'DATABASE_USERNAME' => $Pacer->database->get_db_setting('DB_USERNAME'),
									'DATABASE_NAME' => $Pacer->database->get_db_setting('DB_NAME'),
									'TABLE_PREFIX' => TABLE_PREFIX
								 )
						 );

// Insert language values
$template->set_block('main_block', 'language_list_block', 'language_list');


$template->set_var(array(
							'SELECTED_FLAG' => strtolower(DEFAULT_LANGUAGE),
							));
foreach($Pacer->Languages_List() as $k => $v) {
	// Insert code and name
	$template->set_var(array(
							'CODE' => $v['directory'],
							'NAME' => $v['name'],
							'FLAG' => strtolower($v['directory']),
							'SELECTED' => (DEFAULT_LANGUAGE == $v['directory'])?' selected="selected"':'',
							));
	$template->parse('language_list', 'language_list_block', true);
}

// Insert default timezone values
require(ADMIN_PATH.'/interface/timezones.php');
unset($TIMEZONES['-20']);

/*
$template->set_block('main_block', 'timezone_list_block', 'timezone_list');
foreach($TIMEZONES AS $hour_offset => $title) {
	// Make sure we dont list "System Default" as we are setting this value!
	if($hour_offset != '-20') {
		$template->set_var('VALUE', $hour_offset);
		$template->set_var('NAME', $title);
		if(DEFAULT_TIMEZONE == $hour_offset*60*60) {
			$template->set_var('SELECTED', ' selected="selected"');
		} else {
			$template->set_var('SELECTED', '');
		}
		$template->parse('timezone_list', 'timezone_list_block', true);
	}
}
*/

$template->set_block('main_block', 'timezone_list_block', 'timezone_list');
$default_timezone_name = (defined('DEFAULT_TIMEZONE_NAME')) ?DEFAULT_TIMEZONE_NAME:'';
foreach($TIMEZONES AS $value => $tz) {
//	$offset = ((int) $tz['gmtoffset'])*60*60;
	$template->set_var('VALUE', $value);
	$template->set_var('NAME', $tz['display']);	
	if($default_timezone_name == $value) {
		$template->set_var('SELECTED', 'selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('timezone_list', 'timezone_list_block', true);
}

$tz = new DateTimeZone($default_timezone_name);

foreach (timezone_transitions_get($tz) as $tr){
 	if ($tr['ts'] > time())
        break;
}
$d = new DateTime( "@{$tr['ts']}" );
$timezone_transition = sprintf($Pacer->Translate("The timezone %s switches to %s on %s. The new GMT offset will be: %d (%s)"),
    $tz->getName(), $tr['isdst'] ? "DST" : $Pacer->Translate("standard time"),
    $d->format('d M Y @ H:i T'), $tr['offset'], $tr['abbr']
);

/* PHP 5.3 */
if (version_compare(PHP_VERSION, '5.3.0') >= 0) {
	$d=$tz->getLocation();
	$timezone_transition .= ' '.sprintf($Pacer->Translate("Country code %s, Lat. %d Lon. %d Comments: %s"), $d['country_code'],$d['latitude'],$d['longitude'],$d['comments']);
}

$template->set_var('TIMEZONE_TRANSITION', $timezone_transition);

// Insert default charset values
require(ADMIN_PATH.'/interface/charsets.php');
$template->set_block('main_block', 'charset_list_block', 'charset_list');
foreach($CHARSETS AS $code => $title) {
	$template->set_var('VALUE', $code);
	$template->set_var('NAME', $title);
	if(DEFAULT_CHARSET == $code) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('charset_list', 'charset_list_block', true);
}

// Insert date format list
require(ADMIN_PATH.'/interface/date_formats.php');
$template->set_block('main_block', 'date_format_list_block', 'date_format_list');
foreach($DATE_FORMATS AS $format => $title) {
	$format = str_replace('|', ' ', $format); // Add's white-spaces (not able to be stored in array key)
	if($format != 'system_default') {
		$template->set_var('VALUE', $format);
	} else {
		$template->set_var('VALUE', '');
	}
	$template->set_var('NAME', $title);
	if(DEFAULT_DATE_FORMAT == $format) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('date_format_list', 'date_format_list_block', true);
}

// Insert time format list
require(ADMIN_PATH.'/interface/time_formats.php');
$template->set_block('main_block', 'time_format_list_block', 'time_format_list');
foreach($TIME_FORMATS AS $format => $title) {
	$format = str_replace('|', ' ', $format); // Add's white-spaces (not able to be stored in array key)
	if($format != 'system_default') {
		$template->set_var('VALUE', $format);
	} else {
		$template->set_var('VALUE', '');
	}
	$template->set_var('NAME', $title);
	if(DEFAULT_TIME_FORMAT == $format) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('time_format_list', 'time_format_list_block', true);
}

// Insert templates
$template->set_block('main_block', 'template_list_block', 'template_list');
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'template' AND function != 'theme' order by name");
if($result->numRows() > 0) {
	while($addon = $result->fetchRow()) {
		$template->set_var('FILE', $addon['directory']);
		$template->set_var('NAME', $addon['name']);
		if(($addon['directory'] == DEFAULT_TEMPLATE) ? $selected = ' selected="selected"' : $selected = '');
		$template->set_var('SELECTED', $selected);
		$template->parse('template_list', 'template_list_block', true);
	}
}

// Insert backend theme
$template->set_block('main_block', 'theme_list_block', 'theme_list');
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'template' AND function = 'theme' order by name");
if($result->numRows() > 0) {
	while($addon = $result->fetchRow()) {
		$template->set_var('FILE', $addon['directory']);
		$template->set_var('NAME', $addon['name']);
		if(($addon['directory'] == DEFAULT_THEME) ? $selected = ' selected="selected"' : $selected = '');
		$template->set_var('SELECTED', $selected);
		$template->parse('theme_list', 'theme_list_block', true);
	}
}

// Insert WYSIWYG modules
$template->set_block('main_block', 'editor_list_block', 'editor_list');
$file='none';  
$module_name=$TEXT['NONE'];  
$template->set_var('FILE', $file);  
$template->set_var('NAME', $module_name);  
if((!defined('WYSIWYG_EDITOR') OR $file == WYSIWYG_EDITOR) ? $selected = ' selected="selected"' : $selected = '');
$template->set_var('SELECTED', $selected);
$template->parse('editor_list', 'editor_list_block', true);  
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'module' AND function = 'wysiwyg'");
if($result->numRows() > 0) {
	while($addon = $result->fetchRow()) {
		$template->set_var('FILE', $addon['directory']);
		$template->set_var('NAME', $addon['name']);
		if((defined('WYSIWYG_EDITOR') AND $addon['directory'] == WYSIWYG_EDITOR) ? $selected = ' selected="selected"' : $selected = '');
		$template->set_var('SELECTED', $selected);
		$template->parse('editor_list', 'editor_list_block', true);
	}
}

// Insert templates for search settings
$template->set_block('main_block', 'search_template_list_block', 'search_template_list');
if($search_template == '') { $selected = ' selected="selected"'; } else { $selected = ''; }
$template->set_var(array('FILE' => '', 'NAME' => $TEXT['SYSTEM_DEFAULT'], 'SELECTED' => $selected));
$template->parse('search_template_list', 'search_template_list_block', true);
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'template' order by name");
if($result->numRows() > 0) {
	while($addon = $result->fetchRow()) {
		$template->set_var('FILE', $addon['directory']);
		$template->set_var('NAME', $addon['name']);
		if($addon['directory'] == $search_template ? $selected = ' selected="selected"' : $selected = '');
		$template->set_var('SELECTED', $selected);
		$template->parse('search_template_list', 'search_template_list_block', true);
	}
}

// Insert default error reporting values
require(ADMIN_PATH.'/interface/er_levels.php');
	$template->set_var('HEADER_PHP_ERROR_LEVEL',$Pacer->Translate('Error Reporting'));
	$template->set_var('TEXT_FORMULA',$Pacer->Translate('Formula'));
	$template->set_var('TEXT_VALUE',$Pacer->Translate('Value'));
	$template->set_var('ER_FORMULA', ER_FORMULA);
	$template->set_var('ER_LEVEL', ER_LEVEL);
	$template->set_var('TEXT_PRESETS',$Pacer->Translate('Presets'));
	$template->set_var('TEXT_ERROR_BACKTRACE',$Pacer->Translate('Error backtrace'));
	$template->set_var('ER_BACKTRACE', ER_BACKTRACE);
	$template->set_var('TEXT_YES',$Pacer->Translate('Yes'));
	$template->set_var('TEXT_NO',$Pacer->Translate('No'));
	$template->set_var('ERROR_BACKTRACE_'.((ER_BACKTRACE) ?'1' :'0').'_SELECTED',' checked="checked"');
	$template->set_var('TEXT_SUPPRESS_WARNINGS',$Pacer->Translate('Suppress All Warnings'));
	$template->set_var('ER_BACKTRACE', ER_BACKTRACE);
	$template->set_var('TEXT_YES',$Pacer->Translate('Yes'));
	$template->set_var('TEXT_NO',$Pacer->Translate('No'));
//	$template->set_var('SUPPRESS_WARNINGS_'.((ER_SUPPRESS_WARNINGS) ?'1' :'0').'_SELECTED',' checked="checked"');
	$template->set_var('TEXT_FORMULA',$Pacer->Translate('Formula'));
	
	
$template->set_block('main_block', 'error_reporting_list_block', 'error_reporting_list');
/*
foreach($ER_LEVELS AS $value => $title) {
	$template->set_var('VALUE', $value);
	$template->set_var('NAME', $title);
	if(ER_LEVEL == $value) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('error_reporting_list', 'error_reporting_list_block', true);
}
*/
$tb = '';
$tbn=0;
foreach($arr_levels as $k => $v){
$tbn++;
if ($tbn<=2) continue;
$tb .= ($tb) ?'<br />':'<hr />';
	foreach($v as $kk => $vv){
		$tb .= '['.$k.'] '.$kk ." ".$vv;
	}
}
foreach($arr_presets as $k => $v){
	$template->set_var('VALUE', $v['code']);
	$template->set_var('LABEL', $k);
	$template->set_var('TITLE', (array_key_exists('narrative',$v) && $v['narrative'])? ' class="settings_button tooltip" title="'.$Pacer->Translate('Preset').$Pacer->TOOLTIP_TITLE_SEPARATOR.$v['narrative'].$tb.'" ':'');
	$template->parse('error_reporting_list', 'error_reporting_list_block', true);
}

$template->set_var('TEXT_ER_NAME', $Pacer->Translate('Error type'));
$template->set_var('TEXT_LABEL_1', $Pacer->Translate('Report'));
//$template->set_var('TEXT_LABEL_0', $Pacer->Translate('Don\'t report'));
$template->set_var('TEXT_LABEL_2', $Pacer->Translate('Suppress reporting'));

$template->set_block('main_block', 'er_reporting_list_block', 'er_reporting_list');

$checked=array();
$formula=@unserialize(ER_FORMULA);
if (!is_array($formula)) $formula=array();
$formula=array_flip($formula);
$en=0;
$total = ER_LEVEL;
$arr = $arr_levels;
krsort($arr);
foreach($arr as $k => $v){
	$arr_levels[$k]['checked']='';
	if ($k>E_ALL) continue;
	if ($total>=$k) {
		$arr_levels[$k]['checked']=' checked="checked"';
		$total -= $k;
	}
}

foreach($arr_levels as $k => $v){
	if ($k>E_ALL) break;
	foreach($v as $kk => $vv)
		break;

	if ($en<2 /*|| $kk=='E_ALL'*/){
		$en++;
		continue;
	}

	$checked_1=$arr_levels[$k]['checked'];
	$checked_0='';
	$checked_2=(array_key_exists($k,$formula))?' checked="checked"':'';
	
	
	$template->set_var('ER_CODE',$k);
	$template->set_var('ER_NAME',$kk);
	$template->set_var('CHECKED_1', $checked_1);
	$template->set_var('CHECKED_0', $checked_0);
	$template->set_var('CHECKED_2', $checked_2);
	$template->set_var('VALUE', $k);

	$template->set_var('LV', $en);
	$template->set_var('TITLE', $kk.' ['.$k.']'.$Pacer->TOOLTIP_TITLE_SEPARATOR.$vv);
	$template->parse('er_reporting_list', 'er_reporting_list_block', true);		
	$en++;	
}

	



// Insert permissions values
if($admin->get_permission('settings_advanced') != true) {
	$template->set_var('DISPLAY_ADVANCED_BUTTON', 'hide');
}

// Insert page level limits
$template->set_block('main_block', 'page_level_limit_list_block', 'page_level_limit_list');
for($i = 1; $i <= 10; $i++) {
	$template->set_var('NUMBER', $i);
	if(PAGE_LEVEL_LIMIT == $i) {
		$template->set_var('SELECTED', ' selected="selected"');
	} else {
		$template->set_var('SELECTED', '');
	}
	$template->parse('page_level_limit_list', 'page_level_limit_list_block', true);
}

// Work-out if multiple menus feature is enabled
if(defined('MULTIPLE_MENUS') AND MULTIPLE_MENUS == true) {
	$template->set_var('MULTIPLE_MENUS_ENABLED', ' checked="checked"');
} else {
	$template->set_var('MULTIPLE_MENUS_DISABLED', ' checked="checked"');
}

// Work-out if page languages feature is enabled
if(defined('PAGE_LANGUAGES') AND PAGE_LANGUAGES == true) {
        $template->set_var('PAGE_LANGUAGES_ENABLED', ' checked="checked"');
} else {
        $template->set_var('PAGE_LANGUAGES_DISABLED', ' checked="checked"');
}

// Work-out if smart login feature is enabled
if(defined('SMART_LOGIN') AND SMART_LOGIN == true) {
	$template->set_var('SMART_LOGIN_ENABLED', ' checked="checked"');
} else {
	$template->set_var('SMART_LOGIN_DISABLED', ' checked="checked"');
}

if(extension_loaded('gd') AND function_exists('imageCreateFromJpeg')) { /* Make's sure GD library is installed */
	$template->set_var('GD_EXTENSION_ENABLED', '');
} else {
	$template->set_var('GD_EXTENSION_ENABLED', 'none');
}

// Work-out if section blocks feature is enabled
if(defined('SECTION_BLOCKS') AND SECTION_BLOCKS == true) {
	$template->set_var('SECTION_BLOCKS_ENABLED', ' checked="checked"');
} else {
	$template->set_var('SECTION_BLOCKS_DISABLED', ' checked="checked"');
}

// Work-out if homepage redirection feature is enabled
if(defined('HOMEPAGE_REDIRECTION') AND HOMEPAGE_REDIRECTION == true) {
	$template->set_var('HOMEPAGE_REDIRECTION_ENABLED', ' checked="checked"');
} else {
	$template->set_var('HOMEPAGE_REDIRECTION_DISABLED', ' checked="checked"');
}
$JS_ACTION ="jQuery('#file_perms_box1').hide();jQuery('#file_perms_box2').hide();jQuery('#file_perms_box3').hide();";
// Work-out which server os should be checked
if(OPERATING_SYSTEM == 'linux') {
	$template->set_var('LINUX_SELECTED', ' checked="checked"');
	if(STRING_FILE_MODE != '0777' OR STRING_DIR_MODE != '0777') $JS_ACTION ="jQuery('#file_perms_box1').show();jQuery('#file_perms_box2').show();jQuery('#file_perms_box3').show();";
} elseif(OPERATING_SYSTEM == 'windows') {
	$template->set_var('WINDOWS_SELECTED', ' checked="checked"');
}
$template->set_var('JS_ACTION',$JS_ACTION);

// Work-out if manage sections feature is enabled
if(MANAGE_SECTIONS) {
	$template->set_var('MANAGE_SECTIONS_ENABLED', ' checked="checked"');
} else {
	$template->set_var('MANAGE_SECTIONS_DISABLED', ' checked="checked"');
}

// Work-out which wbmailer routine should be checked
if(WBMAILER_ROUTINE == 'phpmail') {
	$template->set_var('PHPMAIL_SELECTED', ' checked="checked"');
	$template->set_var('SMTP_VISIBILITY', 'none');
	$template->set_var('SMTP_VISIBILITY_AUTH', 'none');
} elseif(WBMAILER_ROUTINE == 'smtp') {
	$template->set_var('SMTPMAIL_SELECTED', ' checked="checked"');
	$template->set_var('SMTP_VISIBILITY', '');
}

// Work-out if SMTP authentification should be checked
if(WBMAILER_SMTP_AUTH) {
	$template->set_var('SMTP_AUTH_SELECTED', ' checked="checked"');
	if(WBMAILER_ROUTINE == 'smtp') {
		$template->set_var('SMTP_VISIBILITY_AUTH', '');
	} else {
		$template->set_var('SMTP_VISIBILITY_AUTH', 'none');
	}
} else {
	$template->set_var('SMTP_VISIBILITY_AUTH', 'none');
}

// Work-out if intro feature is enabled
if(INTRO_PAGE) {
	$template->set_var('INTRO_PAGE_ENABLED', ' checked="checked"');
} else {
	$template->set_var('INTRO_PAGE_DISABLED', ' checked="checked"');
}

// Work-out if frontend login feature is enabled
if(FRONTEND_LOGIN) {
	$template->set_var('PRIVATE_ENABLED', ' checked="checked"');
} else {
	$template->set_var('PRIVATE_DISABLED', ' checked="checked"');
}

// Work-out if page trash feature is disabled, in-line, or separate
if(PAGE_TRASH == 'disabled') {
	$template->set_var('PAGE_TRASH_DISABLED', ' checked="checked"');
	$template->set_var('DISPLAY_PAGE_TRASH_SEPARATE', ' display: none;');
} elseif(PAGE_TRASH == 'inline') {
	$template->set_var('PAGE_TRASH_INLINE', ' checked="checked"');
	$template->set_var('DISPLAY_PAGE_TRASH_SEPARATE', ' display: none;');
} elseif(PAGE_TRASH == 'separate') {
	$template->set_var('PAGE_TRASH_SEPARATE', ' checked="checked"');
	$template->set_var('DISPLAY_PAGE_TRASH_SEPARATE', ' display: inline;');
}

// Work-out if media home folde feature is enabled
if(HOME_FOLDERS) {
	$template->set_var('HOME_FOLDERS_ENABLED', ' checked="checked"');
} else {
	$template->set_var('HOME_FOLDERS_DISABLED', ' checked="checked"');
}

// Insert search select
if(SEARCH == 'private') {
	$template->set_var('PRIVATE_SEARCH', ' selected="selected"');
} elseif(SEARCH == 'registered') {
	$template->set_var('REGISTERED_SEARCH', ' selected="selected"');
} elseif(SEARCH == 'none') {
	$template->set_var('NONE_SEARCH', ' selected="selected"');
}

// Work-out if 755 permissions are set
if(STRING_FILE_MODE == '0755' AND STRING_DIR_MODE == '0755') {
	$template->set_var('SAFER_WRITEABLE_SELECTED', ' checked="checked"');
}
// Work-out if 777 permissions are set
if(STRING_FILE_MODE == '0777' AND STRING_DIR_MODE == '0777') {
	$template->set_var('WORLD_WRITEABLE_SELECTED', ' checked="checked"');
}

// Work-out which file mode boxes are checked
if(extract_permission(STRING_FILE_MODE, 'u', 'r')) {
	$template->set_var('FILE_U_R_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'u', 'w')) {
	$template->set_var('FILE_U_W_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'u', 'e')) {
	$template->set_var('FILE_U_E_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'g', 'r')) {
	$template->set_var('FILE_G_R_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'g', 'w')) {
	$template->set_var('FILE_G_W_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'g', 'e')) {
	$template->set_var('FILE_G_E_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'o', 'r')) {
	$template->set_var('FILE_O_R_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'o', 'w')) {
	$template->set_var('FILE_O_W_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_FILE_MODE, 'o', 'e')) {
	$template->set_var('FILE_O_E_CHECKED', ' checked="checked"');
}
// Work-out which dir mode boxes are checked
if(extract_permission(STRING_DIR_MODE, 'u', 'r')) {
	$template->set_var('DIR_U_R_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'u', 'w')) {
	$template->set_var('DIR_U_W_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'u', 'e')) {
	$template->set_var('DIR_U_E_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'g', 'r')) {
	$template->set_var('DIR_G_R_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'g', 'w')) {
	$template->set_var('DIR_G_W_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'g', 'e')) {
	$template->set_var('DIR_G_E_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'o', 'r')) {
	$template->set_var('DIR_O_R_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'o', 'w')) {
	$template->set_var('DIR_O_W_CHECKED', ' checked="checked"');
}
if(extract_permission(STRING_DIR_MODE, 'o', 'e')) {
	$template->set_var('DIR_O_E_CHECKED', ' checked="checked"');
}

// Insert Server Email value into template
$template->set_var('SERVER_EMAIL', SERVER_EMAIL);

// Insert groups into signup list
$template->set_block('main_block', 'group_list_block', 'group_list');
$results = $database->query("SELECT group_id, name FROM ".TABLE_PREFIX."groups WHERE group_id != '1'");
if($results->numRows() > 0) {
	while($group = $results->fetchRow()) {
		$template->set_var('ID', $group['group_id']);
		$template->set_var('NAME', $group['name']);
		if(FRONTEND_SIGNUP == $group['group_id']) {
			$template->set_var('SELECTED', ' selected="selected"');
		} else {
			$template->set_var('SELECTED', '');
		}
		$template->parse('group_list', 'group_list_block', true);
	}
} else {
	$template->set_var('ID', 'disabled');
	$template->set_var('NAME', $MESSAGE['GROUPS']['NO_GROUPS_FOUND']);
	$template->parse('group_list', 'group_list_block', true);
}

$arr = array('title','description','keywords','author','generator');
foreach($arr as $k){
	$template->set_var(array('WEBSITE_'.strtoupper($k).'_CHECKED'		=> (($Pacer->pacer_settings['website_'.$k.'_autoinclude'])?'checked="checked"':'')
	));
}

// Insert language headings
$template->set_var(array(
								'HEADING_GENERAL_SETTINGS'              => $HEADING['GENERAL_SETTINGS'],
								'HEADING_DEFAULT_SETTINGS'              => $HEADING['DEFAULT_SETTINGS'],
								'HEADING_SEARCH_SETTINGS'               => $HEADING['SEARCH_SETTINGS'],
								'HEADING_SERVER_SETTINGS'               => $HEADING['SERVER_SETTINGS'],
								'HEADING_WBMAILER_SETTINGS'             => $HEADING['WBMAILER_SETTINGS'],
								'HEADING_ADMINISTRATION_TOOLS'          => $HEADING['ADMINISTRATION_TOOLS']
								)
						);
// Insert language text and messages
$template->set_var(array(
								'TEXT_WEBSITE_TITLE'                    => $TEXT['WEBSITE_TITLE'],
								'TEXT_WEBSITE_DESCRIPTION'              => $TEXT['WEBSITE_DESCRIPTION'],
								'TEXT_WEBSITE_KEYWORDS'                 => $TEXT['WEBSITE_KEYWORDS'],
								'TEXT_WEBSITE_HEADER'                   => $TEXT['WEBSITE_HEADER'],
								'TEXT_WEBSITE_FOOTER'                   => $TEXT['WEBSITE_FOOTER'],
								'TEXT_WEBSITE_GENERATOR'                => $Pacer->Translate('Website Generator'),//new
								'TEXT_WEBSITE_AUTHOR'                   => $Pacer->Translate('Website Author'),//new
								'TEXT_WEBSITE_DISCLAIMER'               => $Pacer->Translate('Website Disclaimer'),								
								'TEXT_HEADER'                           => $TEXT['HEADER'],
								'TEXT_FOOTER'                           => $TEXT['FOOTER'],
								'TEXT_VISIBILITY'                       => $TEXT['VISIBILITY'],
								'TEXT_RESULTS_HEADER'                   => $TEXT['RESULTS_HEADER'],
								'TEXT_RESULTS_LOOP'                     => $TEXT['RESULTS_LOOP'],
								'TEXT_WEBSITE_SEARCH_TITLE_DISPLAY'     => $Pacer->Translate('Search Display Title'),
								'TEXT_WEBSITE_SEARCH_SUB_TITLE_DISPLAY' => $Pacer->Translate('Search Display Sub Title'),
								'TEXT_RESULTS_FOOTER'                   => $TEXT['RESULTS_FOOTER'],
								'TEXT_NO_RESULTS'                       => $TEXT['NO_RESULTS'],
								'TEXT_TEXT'                             => $TEXT['TEXT'],
								'TEXT_DEFAULT'                          => $TEXT['DEFAULT'],
								'TEXT_LANGUAGE'                         => $TEXT['LANGUAGE'],
								'TEXT_TIMEZONE'                         => $TEXT['TIMEZONE'],
								'TEXT_CHARSET'                          => $TEXT['CHARSET'],
								'TEXT_DATE_FORMAT'                      => $TEXT['DATE_FORMAT'],
								'TEXT_TIME_FORMAT'                      => $TEXT['TIME_FORMAT'],
								'TEXT_TEMPLATE'                         => $TEXT['TEMPLATE'],
								'TEXT_THEME'                            => $TEXT['THEME'],
								'TEXT_WYSIWYG_EDITOR'                   => $TEXT['WYSIWYG_EDITOR'],
								'TEXT_PAGE_LEVEL_LIMIT'                 => $TEXT['PAGE_LEVEL_LIMIT'],
								'TEXT_INTRO_PAGE'                       => $TEXT['INTRO_PAGE'],
								'TEXT_FRONTEND'                         => $TEXT['FRONTEND'],
								'TEXT_LOGIN'                            => $TEXT['LOGIN'],
								'TEXT_REDIRECT_AFTER'                   => $TEXT['REDIRECT_AFTER'],
								'TEXT_SIGNUP'                           => $TEXT['SIGNUP'],
								'TEXT_PHP_ERROR_LEVEL'                  => $TEXT['PHP_ERROR_LEVEL'],
								'TEXT_PAGES_DIRECTORY'                  => $TEXT['PAGES_DIRECTORY'],
								'TEXT_MEDIA_DIRECTORY'                  => $TEXT['MEDIA_DIRECTORY'],
								'TEXT_PAGE_EXTENSION'                   => $TEXT['PAGE_EXTENSION'],
								'TEXT_PAGE_SPACER'                      => $TEXT['PAGE_SPACER'],
								'TEXT_RENAME_FILES_ON_UPLOAD'           => $TEXT['RENAME_FILES_ON_UPLOAD'],
								'TEXT_APP_NAME'                         => $TEXT['APP_NAME'],
								'TEXT_SESSION_IDENTIFIER'               => $TEXT['SESSION_IDENTIFIER'],
								'TEXT_SEC_ANCHOR'                       => $TEXT['SEC_ANCHOR'],
								'TEXT_SERVER_OPERATING_SYSTEM'          => $TEXT['SERVER_OPERATING_SYSTEM'],
								'TEXT_LINUX_UNIX_BASED'                 => $TEXT['LINUX_UNIX_BASED'],
								'TEXT_WINDOWS'                          => $TEXT['WINDOWS'],
								'TEXT_ADMIN'                            => $TEXT['ADMIN'],
								'TEXT_TYPE'                             => $TEXT['TYPE'],
								'TEXT_DATABASE'                         => $TEXT['DATABASE'],
								'TEXT_HOST'                             => $TEXT['HOST'],
								'TEXT_USERNAME'                         => $TEXT['USERNAME'],
								'TEXT_PASSWORD'                         => $TEXT['PASSWORD'],
								'TEXT_NAME'                             => $TEXT['NAME'],
								'TEXT_TABLE_PREFIX'                     => $TEXT['TABLE_PREFIX'],
								'TEXT_SAVE'                             => $TEXT['SAVE'],
								'TEXT_RESET'                            => $TEXT['RESET'],
								'TEXT_CHANGES'                          => $TEXT['CHANGES'],
								'TEXT_ENABLED'                          => $TEXT['ENABLED'],
								'TEXT_DISABLED'                         => $TEXT['DISABLED'],
								'TEXT_MANAGE_SECTIONS'                  => $HEADING['MANAGE_SECTIONS'],
								'TEXT_MANAGE'                           => $TEXT['MANAGE'],
								'TEXT_SEARCH'                           => $TEXT['SEARCH'],
								'TEXT_PUBLIC'                           => $TEXT['PUBLIC'],
								'TEXT_PRIVATE'                          => $TEXT['PRIVATE'],
								'TEXT_REGISTERED'                       => $TEXT['REGISTERED'],
								'TEXT_NONE'                             => $TEXT['NONE'],
								'TEXT_FILES'                            => strtoupper(substr($TEXT['FILES'], 0, 1)).substr($TEXT['FILES'], 1),
								'TEXT_DIRECTORIES'                      => $TEXT['DIRECTORIES'],
								'TEXT_FILESYSTEM_PERMISSIONS'           => $TEXT['FILESYSTEM_PERMISSIONS'],
								'TEXT_USER'                             => $TEXT['USER'],
								'TEXT_GROUP'                            => $TEXT['GROUP'],
								'TEXT_OTHERS'                           => $TEXT['OTHERS'],
								'TEXT_READ'                             => $TEXT['READ'],
								'TEXT_WRITE'                            => $TEXT['WRITE'],
								'TEXT_EXECUTE'                          => $TEXT['EXECUTE'],
								'TEXT_SMART_LOGIN'                      => $TEXT['SMART_LOGIN'],
								'TEXT_MULTIPLE_MENUS'                   => $TEXT['MULTIPLE_MENUS'],
								'TEXT_HOMEPAGE_REDIRECTION'             => $TEXT['HOMEPAGE_REDIRECTION'],
								'TEXT_SECTION_BLOCKS'                   => $TEXT['SECTION_BLOCKS'],
								'TEXT_PLEASE_SELECT'                    => $TEXT['PLEASE_SELECT'],
								'TEXT_PAGE_TRASH'                       => $TEXT['PAGE_TRASH'],
								'TEXT_PAGE_LANGUAGES'                   => $TEXT['PAGE_LANGUAGES'],
								'TEXT_INLINE'                           => $TEXT['INLINE'],
								'TEXT_SEPARATE'                         => $TEXT['SEPARATE'],
								'TEXT_HOME_FOLDERS'                     => $TEXT['HOME_FOLDERS'],
								'TEXT_WYSIWYG_STYLE'                    => $TEXT['WYSIWYG_STYLE'],
								'TEXT_WORLD_WRITEABLE_FILE_PERMISSIONS' => $TEXT['WORLD_WRITEABLE_FILE_PERMISSIONS'],
								'TEXT_SAFER_WRITEABLE_FILE_PERMISSIONS' => $Pacer->Translate('Safer-writeable file permissions'),
								'TEXT_WBMAILER_DEFAULT_SETTINGS_NOTICE' => $TEXT['WBMAILER_DEFAULT_SETTINGS_NOTICE'],
								'TEXT_WBMAILER_DEFAULT_SENDER_MAIL'     => $TEXT['WBMAILER_DEFAULT_SENDER_MAIL'],
								'TEXT_WBMAILER_DEFAULT_SENDER_NAME'     => $TEXT['WBMAILER_DEFAULT_SENDER_NAME'],
								'TEXT_WBMAILER_NOTICE'                  => $TEXT['WBMAILER_NOTICE'],
								'TEXT_WBMAILER_FUNCTION'                => $TEXT['WBMAILER_FUNCTION'],
								'TEXT_WBMAILER_SMTP_HOST'               => $TEXT['WBMAILER_SMTP_HOST'],
								'TEXT_WBMAILER_PHP'                     => $TEXT['WBMAILER_PHP'],
								'TEXT_WBMAILER_SMTP'                    => $TEXT['WBMAILER_SMTP'],
								'TEXT_WBMAILER_SMTP_AUTH'               => $TEXT['WBMAILER_SMTP_AUTH'],
								'TEXT_WBMAILER_SMTP_AUTH_NOTICE'        => $TEXT['WBMAILER_SMTP_AUTH_NOTICE'],
								'TEXT_WBMAILER_SMTP_USERNAME'           => $TEXT['WBMAILER_SMTP_USERNAME'],
								'TEXT_WBMAILER_SMTP_PASSWORD'           => $TEXT['WBMAILER_SMTP_PASSWORD'],
								'MODE_SWITCH_WARNING'                   => $MESSAGE['SETTINGS']['MODE_SWITCH_WARNING'],
								'WORLD_WRITEABLE_WARNING'               => $MESSAGE['SETTINGS']['WORLD_WRITEABLE_WARNING'],
								'TEXT_MODULE_ORDER'                     => $TEXT['MODULE_ORDER'],
								'TEXT_MAX_EXCERPT'                      => $TEXT['MAX_EXCERPT'],
								'TEXT_TIME_LIMIT'                       => $TEXT['TIME_LIMIT'],
								'HEADING_PAGE_CONFG'                    => $HEADING['PAGE_CONFG'],
								'HEADING_PAGE_WYS'                      => $HEADING['PAGE_WYS'],
								'TEXT_AUTOINCLUDE'						=> $Pacer->Translate('Auto include
into page'),
								'TEXT_WEBSITE_TITLE_TEMPLATE'			=> $Pacer->Translate('Website Title\'s template')
								)
						);

// Parse template objects output
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

$admin->print_footer();

?>
