<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: November 01,2009                                            *
 *    Build Time: 21:00:00                                                    *
 *     File Name: browse.php                                                  *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

// Create admin object
require('../../config.php');
require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Access', 'users',false);

// Include the WB functions file
require_once(PE_PATH.'/framework/functions.php');

// Setup template object
$template = new Template(THEME_PATH.'/templates');
$template->set_file('page', 'users_browse.htt');
$template->set_block('page', 'main_block', 'main');

// Insert values
$template->set_var(array(
								'PE_URL' => PE_URL,
								'THEME_URL' => THEME_URL,
								'TEXT_OK' => $Pacer->Translate('Ok'),
								'TEXT_CANCEL' => $Pacer->Translate('Cancel'),
								'TEXT_CONFIRMATION_NEEDED' => $Pacer->Translate('Confirmation needed')
								)
						);

// Generate list
// Get existing value from database
$database = new database();
$query = "SELECT user_id, username, display_name FROM ".TABLE_PREFIX."users WHERE user_id != '1' ORDER BY username";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_error($database->get_error(), 'index.php');
}
if($results->numRows() > 0) {
	// Insert values into the modify/remove menu
	$template->set_block('main_block', 'list_block', 'list');
	$row_bg_color = 'FFF';
	// Loop through users
	while($user = $results->fetchRow()) {
		$template->set_var('ROW_BG_COLOR', $row_bg_color);
		$template->set_var('USER_ID', $user['user_id']);
		$template->set_var('USERNAME', $user['username']);
		$template->set_var('DISPLAYNAME', $user['display_name']);
		
		$template->set_var('CONFIRM_DELETE', $MESSAGE['USERS']['CONFIRM_DELETE']);
		$template->set_var('NAME_SLASHED',addslashes($user['username']));

		if($admin->get_permission('users_modify') != true) {
			$template->set_var('DISPLAY_MODIFY', 'display:none');
		}
		if($admin->get_permission('users_delete') != true) {
			$template->set_var('DISPLAY_DELETE', 'display:none');
		}
		$template->parse('list', 'list_block', true);
		// Code to alternate row colors
		if($row_bg_color == 'FFF') {
			$row_bg_color = 'ECF1F3';
		} else {
			$row_bg_color = 'FFF';
		}
	}
} else {
	$template->set_var('DISPLAY_ROW', '; display:none');
	// Insert single value to say no users were found
	$template->parse('list', 'list_block', true);
}

// Insert language text and messages
$template->set_var(array(
								'MEDIA_DIRECTORY' => MEDIA_DIRECTORY,
								'TEXT_CURRENT_FOLDER' => $TEXT['CURRENT_FOLDER'],
								'TEXT_RELOAD' => $TEXT['RELOAD'],
								'TEXT_MODIFY' => $TEXT['MODIFY'],
								'TEXT_DELETE' => $TEXT['DELETE'],
								'TEXT_UP' => $TEXT['UP'],
								'NONE_FOUND' => $MESSAGE['MEDIA']['NONE_FOUND'],
								'HEADING_ADD_USER_SUB' => $HEADING['ADD_USER_SUB'],
								'CONFIRM_DELETE' => $MESSAGE['MEDIA']['CONFIRM_DELETE']
								)
						);

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

?>