<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: November 01,2009                                            *
 *    Build Time: 21:00:00                                                    *
 *     File Name: class.admin.php                                             *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2009 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)                   *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

/*

Admin class

This class will be used for every program that will be included
in the administration section of The Pacer Edition CMS.

*/

if(!defined('PE_URL')) {
	header('Location: ../index.php');
	exit(0);
}

// Set wich side we are on...
if (!defined('BACKEND')) define('BACKEND',true);

require_once(PACER_PATH.'/pacer.php');

require_once(PE_PATH.'/framework/class.wb.php');

// Include PHPLIB template class
require_once(PE_PATH."/include/phplib/template.inc");

// Get PE version
require_once(ADMIN_PATH.'/interface/version.php');

// Include EditArea wrapper functions
require_once(PE_PATH . '/include/editarea/wb_wrapper_edit_area.php');

/*
Begin user changeable settings
*/


class admin extends wb {
	// Authenticate user then auto print the header
	function admin($section_name, $section_permission = 'start', $auto_header = true, $auto_auth = true) {
		global $Pacer;
		$Pacer->GzPage_Start();
		
		$this->wb();
		global $MESSAGE;
		// Specify the current applications name
		$this->section_name = $section_name;
		$this->section_permission = $section_permission;
		// Authenticate the user for this application
		if($auto_auth == true) {
			// First check if the user is logged-in
			if($this->is_authenticated() == false) {
				$Pacer->Redirect_To(ADMIN_URL.'/login/index.php');

				//header('Location: '.ADMIN_URL.'/login/index.php');
				
				exit(0);
			}
			// Now check if they are allowed in this section
			if($this->get_permission($section_permission) == false) {
				$header_template = new Template(THEME_PATH.'/templates');
				$header_template->set_file('page', 'insufficient_privileges.htt');
				$header_template->set_block('page', 'header_block', 'header');
				$header_template->set_var(array('THEME_URL'=> THEME_URL,				
												'LOGIN_URL'=> ADMIN_URL.'/logout',
												'TEXT_LOGIN'=> $Pacer->Translate('Login'),
												'MESSAGE'=> $MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES']
										));	
				$header_template->parse('header', 'header_block', false);
				$header_template->pparse('output', 'page');
				die();
				//die($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES']);
			}
		}
		
		// Check if the backend language is also the selected language. If not, send headers again.
		global $database;
		// if language was set at login
//		print_r($_SESSION);
		if($this->get_session('LOGIN_LANGUAGE')) {
			$user_language = $this->get_session('LOGIN_LANGUAGE');
		} else {
			$user_language = $database->get_one("SELECT language FROM ".TABLE_PREFIX.
				"users WHERE user_id = '" .(int) $this->get_user_id() ."'");
			// prevent infinite loop if language file is not XX.php (e.g. DE_du.php)
			$user_language = substr($user_language,0,2);
		}
		// obtain the admin folder (e.g. /admin)
		$admin_folder = str_replace(PE_PATH, '', ADMIN_PATH);
		if((LANGUAGE != $user_language) && file_exists(PE_PATH .'/languages/' .$user_language .'.php')
			&& strpos($_SERVER['PHP_SELF'],$admin_folder.'/') !== false) {
			// check if page_id is set
			$page_id_url = (isset($_GET['page_id'])) ? '&page_id=' .(int) $_GET['page_id'] : '';
			$section_id_url = (isset($_GET['section_id'])) ? '&section_id=' .(int) $_GET['section_id'] : '';
			if(isset($_SERVER['QUERY_STRING']) && $_SERVER['QUERY_STRING'] != '') { // check if there is an query-string
				header('Location: '.$_SERVER['PHP_SELF'] .'?lang='.$user_language .$page_id_url .$section_id_url.'&'.$_SERVER['QUERY_STRING']);
			} else {
				header('Location: '.$_SERVER['PHP_SELF'] .'?lang='.$user_language .$page_id_url .$section_id_url);
			}
			exit();
		}

		// Auto header code
		if($auto_header == true) {
			$this->print_header();
		}
	}
	
	// Print the admin header
	function print_header($body_tags = '') {
		global $Pacer;

		// Get vars from the language file
		global $MENU;
		global $MESSAGE;
		global $TEXT;
		// Connect to database and get website title
		$title = $Pacer->database->get_one("SELECT value FROM ".TABLE_PREFIX."settings WHERE name = 'website_title'");
		$header_template = new Template(THEME_PATH.'/templates','remove');
		$header_template->set_file('page', 'header.htt');

// hide pacer is not auth
if($this->get_permission('pacer') == false) {
	$header_template->set_block('page', 'pacer_control_panel_block');
	$header_template->clear_var('pacer_control_panel_block');
}	
		
		$header_template->set_block('page', 'header_block', 'header');
		$charset=((defined('DEFAULT_CHARSET'))?DEFAULT_CHARSET:'utf-8');	
	
$info_area = '';

		// work out the URL for the 'View menu' link in the PE backend
		// if the page_id is set, show this page otherwise show the root directory of PE
		$view_url = PE_URL;
		if(isset($_GET['page_id'])) {
			// extract page link from the database
			if ($row = $Pacer->database->queryRow("SELECT * FROM " .TABLE_PREFIX ."pages WHERE page_id = '" .(int) addslashes($_GET['page_id']) ."'")){
				$view_url .= PAGES_DIRECTORY .$row['link']. PAGE_EXTENSION;
				if ($Pacer->pacer_settings['designing_note']){
					if (!function_exists('Build_Page_Designing_Note')) {
						require_once(ADMIN_PATH.'/pages/functions.php');
					}
					$info_area .= Build_Page_Designing_Note($row);
				}
			}
		}
		$jscal_ifformat = $Pacer->convert_datetime_format('','',true, $Pacer->get_user_id());

if ($this->get_session('error')) {
	$info_area .= 'jQuery.jGrowl("'.$Pacer->Translate('Error').': '.$Pacer->Pacer_all_nlcr_2_br($this->get_session('error')).'", {theme:"error",header: "'.$Pacer->Translate('Error').'",sticky: '.(($this->get_session('error_class')=='stiky')?'true':'false').'});';	
	$submission_id = ($this->get_post('submission_id'))?$this->get_post('submission_id'):$this->get_get('submission_id');
	if ($submission_id) {
		foreach($_SESSION['FORM'][$submission_id]['ERRORS'] as $k => $v){
			$info_area .= 'jQuery.jGrowl("'.$v.'", {theme:"error",header: "'.$Pacer->Pacer_all_nlcr_2_br($k).'",sticky: false});';
		}
	}
} elseif ($this->get_session('success')) {
	$info_area = 'jQuery.jGrowl("'.$Pacer->Pacer_all_nlcr_2_br($this->get_session('success')).'", {theme:"success",header: "'.$Pacer->Translate('Success').'",sticky: false});';
}
unset($_SESSION['error']);
unset($_SESSION['error_class']);
unset($_SESSION['success']);

// text for the OK button
// text for the Cancel button
$info_area .= '
 jQuery.alerts.okButton = \'&nbsp;'.$Pacer->Translate('Ok').'&nbsp;\'
 jQuery.alerts.cancelButton = \'&nbsp;'.$Pacer->Translate('Cancel').'&nbsp;\';';

// Scheduled Jobs Async / Sync			
if (($Pacer->pacer_settings['scheduled_jobs_run_on']=='2') || // backend
	($Pacer->pacer_settings['scheduled_jobs_run_on']=='3')) { // or always
	require_once(PACER_PATH.'/pacer_scheduled_jobs.php');	
	if (array_key_exists('scheduled_jobs_async',$Pacer->pacer_settings) && ($Pacer->pacer_settings['scheduled_jobs_async'])) {
		$fc = new Pacer_Scheduled_Jobs(0,true);
		$info_area .= $fc->pacer_scheduled_jobs_build_ajax();
	} else {
		$fc = new Pacer_Scheduled_Jobs();
	}
	unset($fc);
}
/*
// Now check if they are allowed to see Pacer
if($this->get_permission('pacer') != false) {
	$info_area .= '
jQuery(\'#navigation\').show();
jQuery(\'#pe_left_navigation\').show();
jQuery(\'#pe_nav_info\').show();
jQuery(\'#pe_version-info\').show();
';
}
*/

		$header_template->set_var(array(
			'IFFORMAT'=>$jscal_ifformat,
			'IFOFFSET'=>$this->get_timezone() / 3600,
			'TEXT_OK' => $Pacer->Translate('Ok'),
			'TEXT_CANCEL' => $Pacer->Translate('Cancel'),
			'TEXT_BACK_TOP' => $Pacer->Translate('Back to top'),
			'TEXT_BACK_BOTTOM' => $Pacer->Translate('Go to bottom'),
			'TEXT_CONFIRMATION_NEEDED' => $Pacer->Translate('Confirmation needed'),
			'TEXT_JUST_A_MOMENT' => $Pacer->Translate('Just a moment...'),
			'LANGUAGE' => strtolower((LANGUAGE)?LANGUAGE:DEFAULT_LANGUAGE),
			'LANGUAGE_SHADOWBOX'=>((file_exists(PACER_PATH.'/shadowbox/languages/shadowbox-'.strtolower(LANGUAGE).'.js'))?strtolower(LANGUAGE):'en'),
			'JS_INFO_AREA' => $info_area,
			'SALUTATION' => $Pacer->get_salutation(),
			'TEXT_PACER_CONTROL_PANEL' => $Pacer->Translate('Pacer Control Panel'),
			'TEXT_PACER_SVN_INFO' => $Pacer->Translate('Version Release Info'),
			'TEXT_PACER_DASHBOARD' => $Pacer->Translate('Dashboard'),
			'TEXT_PACER_VERSION_CHECK' => $Pacer->Translate('Version Check'),
			'TEXT_PACER_SWITCHBOARD' => $Pacer->Translate('Switchboard'),
			'TEXT_PACER_MAINTENANCE' => $Pacer->Translate('Site Maintenance'),
			'TEXT_PACER_SETTINGS' => $Pacer->Translate('Settings'),
			'TEXT_PACER_COMPRESS_OUTPUT' => $Pacer->Translate('Compress Output'),
			'TEXT_PACER_CODE_INJECTION' => $Pacer->Translate('Code Injection'),
			'TEXT_PACER_EVENT_LOG' => $Pacer->Translate('Event Log'),
			'TEXT_PACER_SYSTEM_LOG' => $Pacer->Translate('System Log'),
			'TEXT_PACER_ONLINE_DEBUG' => $Pacer->Translate('Online Debug'),
			'TEXT_PACER_CACHE_LITE' => $Pacer->Translate('Cache Lite'),
			'TEXT_PACER_DB_ABSTRACTION' => $Pacer->Translate('Db Abstraction'),
			'TEXT_PACER_MAIL_SYSTEM' => $Pacer->Translate('Mail System'),
			'TEXT_PACER_PACK_N_GO' => $Pacer->Translate('Pack n\' Go'),
			'TEXT_PACER_TRANSLATIONS' => $Pacer->Translate('Translations'),
			'TEXT_PACER_TRACKING_STATISTICS' => htmlentities($Pacer->Translate('Tracking & Statistics')),
			'TEXT_PACER_SEARCH_ENGINES' => $Pacer->Translate('Search Engines'),
			'TEXT_PACER_FOLDER_PROTECTION' => $Pacer->Translate('Folder Protection'),
			'TEXT_PACER_FLOOD_CONTROL' => $Pacer->Translate('Flood Control'),
			'TEXT_PACER_SYSTEM_INFO' => $Pacer->Translate('System Info'),
			'TEXT_PACER_MENU_A_LA_CARTE' => $Pacer->Translate('Menu a\' la carte'),
			'TEXT_PACER_TEMPLATE_A_LA_CARTE' => $Pacer->Translate('Template a\' la carte'),
			'TEXT_PACER_DESIGNERS_BRIEFCASE' => $Pacer->Translate('Designer\'s briefcase'),
			'TEXT_PACER_SCHEDULED_JOBS' => $Pacer->Translate('Scheduled Jobs'),
//			'TEXT_PACER_PRIVATE_MESSAGES' => $Pacer->Translate('Private Messages'),
			'TEXT_PACER_VERSION' => $Pacer->Translate('Version'),
			'TEXT_PACER_SVN_REV' => $Pacer->Translate('SVN Build'),
			'TEXT_PACER_SVN_RELEASE' => $Pacer->Translate('Release Date'),
			));

		$image=$Pacer->Pacer_Super_User_ImageFolder($Pacer->get_user_id()).'/'.$Pacer->get_user_id().'_user_image_small.jpg';
		
		if (file_exists($image)) {
			$header_template->set_var(array(
				'STYLE_USER_ICON' => 'style="display:none"',
				'USER_SMALL_IMAGE' => $Pacer->Pacer_Super_User_ImageUrl($Pacer->get_user_id()).'/'.$Pacer->get_user_id().'_user_image_small.jpg'
											)
									);
		} else {
			$header_template->set_var(array(	
				'STYLE_USER_IMAGE' => 'style="display:none"'
											)
									);
		
		}
		// Private Messages..
		$pms = PE_PATH.'/modules/pacer_private_messages/functions.php';
		if (file_exists($pms)){
			require($pms);
			if (get_pm_active_for_user()){
				$tm=get_pm_refresh_time();
				$pms = "function jpms() {
	jQuery.post('".PE_URL."/modules/pacer_private_messages/get_pm_info.php',{
				type:'new'},function(data){
		jQuery('#jpms').html(data);
		jQuery('a.tooltip','#jpms').tooltip({track: true,delay: 0,showURL: false,showBody: '_-_',			extraClass: 'pm_tooltip',fixPNG: true,opacity: 0.95});
	});
}
jQuery(document).ready(function() {
 jpms(); ".(($tm)?"setInterval('jpms()',".$tm.");":"")."
});";
				$header_template->set_var('PMS',$pms);
			};
		};
	
		$header_template->set_var(	array(
													'SECTION_NAME' => (array_key_exists(strtoupper($this->section_name),$MENU)) ? $MENU[strtoupper($this->section_name)]:'',
													'BODY_TAGS' => $body_tags,
													'WEBSITE_TITLE' => ($title),
													'TEXT_ADMINISTRATION' => $TEXT['ADMINISTRATION'],
													'CURRENT_USER' => $MESSAGE['START']['CURRENT_USER'],
													'DISPLAY_NAME' => $this->get_display_name(),
													'CHARSET' => $charset,
													'VERSION' => VERSION,
													'EDITION' => EDITION,
													'SVN_REV' => SVN_REV,
													'PE_SYS_REL_INFO' => PE_SYS_REL_INFO,
													'PE_URL' => PE_URL,
													'ADMIN_URL' => ADMIN_URL,
													'THEME_URL' => THEME_URL,													
													'TITLE_DASHBOARD' => $Pacer->Translate('Dashboard'),
													'TITLE_VIEW_SITE' => $Pacer->Translate('View Site'),
													'TITLE_SUPPORT' => $Pacer->Translate('Support'),
													'TITLE_LOG_OUT' =>  $Pacer->Translate('Log Out'),
													'TEXT_DASHBOARD' => $Pacer->Translate('Dashboard'),
													'TEXT_VIEW_SITE' => $Pacer->Translate('View Site'),
													'TEXT_SUPPORT' => $Pacer->Translate('Support'),
													'TEXT_LOG_OUT' => $Pacer->Translate('Log Out'),													
													'URL_VIEW' => $view_url,
													'URL_HELP' => 'http://www.thepaceredition.com/?pid=7',
													'BACKEND_MODULE_CSS' => $this->register_backend_modfiles('css'),	// adds backend.css
													'BACKEND_MODULE_JS'  => $this->register_backend_modfiles('js')		// adds backend.js
													)
											);

		// Create the menu
		$menu = array(
					array(ADMIN_URL.'/pages/index.php', '', $MENU['PAGES'], 'pages', 1),
					array(ADMIN_URL.'/media/index.php', '', $MENU['MEDIA'], 'media', 1),
					array(ADMIN_URL.'/addons/index.php', '', $MENU['ADDONS'], 'addons', 1),
					array(ADMIN_URL.'/preferences/index.php', '', $MENU['PREFERENCES'], 'preferences', 0),
					array(ADMIN_URL.'/settings/index.php', '', $MENU['SETTINGS'], 'settings', 1),
					array(ADMIN_URL.'/admintools/index.php', '', $MENU['ADMINTOOLS'], 'admintools', 1),
					array(ADMIN_URL.'/access/index.php', '', $MENU['ACCESS'], 'access', 1)
					);
		$header_template->set_block('header_block', 'linkBlock', 'link');
		foreach($menu AS $menu_item) {
			$link = $menu_item[0];
			$target = ($menu_item[1] == '') ? '_self' : $menu_item[1];
			$title = $menu_item[2];
			$permission_title = $menu_item[3];
			$required = $menu_item[4];
			$replace_old = array(ADMIN_URL, PE_URL, '/', 'index.php');
			if($required == false OR $this->get_link_permission($permission_title)) {
				$header_template->set_var('LINK', $link);
				$header_template->set_var('TARGET', $target);
				// If link is the current section apply a class name
				if($permission_title == strtolower($this->section_name)) {
					$header_template->set_var('CLASS', $menu_item[3] . ' current');
				} else {
					$header_template->set_var('CLASS', $menu_item[3]);
				}
				$header_template->set_var('TITLE', $title);
				// Print link
				$header_template->parse('link', 'linkBlock', true);
			}
		}
		$header_template->parse('header', 'header_block', false);
		$header_template->pparse('output', 'page');
		
		$Pacer->Page_Scrollers();

		unset($header_template);
	}
	
	// Print the admin sub-header
	function print_sub_header($header='',$sub_header='',$icon='') {
		// Get vars from the language file
		$header_template = new Template(THEME_PATH.'/templates');
		$header_template->set_file('page', 'sub_header.htt');
		$header_template->set_block('page', 'sub_header_block', 'sub_header');
		$header_template->set_var(array(
			'HEADER' 		=> $header,
			'SUB_HEADER' 	=> $sub_header,
			'ICON' 			=> $icon,
			'THEME' 		=> THEME_URL

		));
		$header_template->parse('sub_header', 'sub_header_block', false);
		$header_template->pparse('output', 'page');
		unset($header_template);
	}
	
	// Print the admin footer
	function print_footer($show_footer=true) {
		global $Pacer;
		$Pacer->print_footer($show_footer);		
	}
	
	// Return a system permission
	function get_permission($name, $type = 'system') {
		// Append to permission type
		$type .= '_permissions';
		// Check if we have a section to check for
		if($name == 'start') {
			return true;
		} else {
			// Set system permissions var
			$system_permissions = $this->get_session('SYSTEM_PERMISSIONS');
			// Set module permissions var
			$module_permissions = $this->get_session('MODULE_PERMISSIONS');
			// Set pacer menu permissions var
			$pacer_menu_permissions = $this->get_session('PACER_MENU_PERMISSIONS');
			// Set template permissions var
			$template_permissions = $this->get_session('TEMPLATE_PERMISSIONS');
			// Return true if system perm = 1
			if (isset($$type) && is_array($$type) && is_numeric(array_search($name, $$type))) {
				if($type == 'system_permissions') {
					return true;
				} else {
					return false;
				}
			} else {
				if($type == 'system_permissions') {
					return false;
				} else {
					return true;
				}
			}
		}
	}
		
	function get_user_details($user_id) {
		global $database;
		$query_user = "SELECT username,display_name FROM ".TABLE_PREFIX."users WHERE user_id = '$user_id'";
		$get_user = $database->query($query_user);
		if($get_user->numRows() != 0) {
			$user = $get_user->fetchRow();
		} else {
			$user['display_name'] = 'Unknown';
			$user['username'] = 'unknown';
		}
		return $user;
	}	
	
	function get_page_details($page_id) {
		global $database;
		$query = "SELECT page_id,page_title,modified_by,modified_when FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'";
		$results = $database->query($query);
		if($database->is_error()) {
			$this->print_header();
			$this->print_error($database->get_error());
		}
		if($results->numRows() == 0) {
			$this->print_header();
			$this->print_error($MESSAGE['PAGES']['NOT_FOUND']);
		}
		$results_array = $results->fetchRow();
		return $results_array;
	}	
	
	/** Function get_page_permission takes either a numerical page_id,
	 * upon which it looks up the permissions in the database,
	 * or an array with keys admin_groups and admin_users  
	 */
	function get_page_permission($page,$action='admin') {
		if ($action!='viewing') $action='admin';
		$action_groups=$action.'_groups';
		$action_users=$action.'_users';
		if (is_array($page)) {
				$groups=$page[$action_groups];
				$users=$page[$action_users];
		} else {				
			global $database;
			$results = $database->query("SELECT $action_groups,$action_users FROM ".TABLE_PREFIX."pages WHERE page_id = '$page'");
			$result = $results->fetchRow();
			$groups = explode(',', str_replace('_', '', $result[$action_groups]));
			$users = explode(',', str_replace('_', '', $result[$action_users]));
		}

		$in_group = FALSE;
		foreach($this->get_groups_id() as $cur_gid){
		    if (in_array($cur_gid, $groups)) {
		        $in_group = TRUE;
		    }
		}
		if((!$in_group) AND !is_numeric(array_search($this->get_user_id(), $users))) {
			return false;
		}
		return true;
	}
		
	// Returns a system permission for a menu link
	function get_link_permission($title) {
		$title = str_replace('_blank', '', $title);
		$title = strtolower($title);
		// Set system permissions var
		$system_permissions = $this->get_session('SYSTEM_PERMISSIONS');
		// Set module permissions var
		$module_permissions = $this->get_session('MODULE_PERMISSIONS');
		// Set pacer_menu permissions var
		$pacer_menu_permissions = $this->get_session('PACER_MENU_PERMISSIONS');		
		if($title == 'start') {
			return true;
		} else {
			// Return true if system perm = 1
			if(is_numeric(array_search($title, $system_permissions))) {
				return true;
			} else {
				return false;
			}
		}
	}

	// Function to add optional module Javascript or CSS stylesheets into the <head> section of the backend
	function register_backend_modfiles($file_id="css") {
		// sanity check of parameter passed to the function
		$file_id = strtolower($file_id);
		if($file_id !== "css" && $file_id !== "javascript" && $file_id !== "js") { 
			return;
		}

		global $database;
		// define default baselink and filename for optional module javascript and stylesheet files
		$head_links = "";
		if($file_id == "css") {
      	$base_link = '<link href="'.PE_URL.'/modules/{MODULE_DIRECTORY}/backend.css"'; 
			$base_link.= ' rel="stylesheet" type="text/css" media="screen" />';
			$base_file = "backend.css";
		} else {
			$base_link = '<script type="text/javascript" src="'.PE_URL.'/modules/{MODULE_DIRECTORY}/backend.js"></script>';
			$base_file = "backend.js";
		}

		// check if backend.js or backend.css files needs to be included to the <head></head> section of the backend
		if(isset($_GET['tool'])) {
			// check if displayed page contains a installed admin tool
			$result = $database->query("SELECT * FROM " .TABLE_PREFIX ."addons 
				WHERE type = 'module' AND function = 'tool' AND directory = '".addslashes($_GET['tool'])."'");

			if($result->numRows()) {
				// check if admin tool directory contains a backend.js or backend.css file to include
				$tool = $result->fetchRow();
				if(file_exists(PE_PATH ."/modules/" .$tool['directory'] ."/$base_file")) {
        			// return link to the backend.js or backend.css file
					return str_replace("{MODULE_DIRECTORY}", $tool['directory'], $base_link);
				}
			}
		} elseif(isset($_GET['page_id'])) {
			// check if displayed page in the backend contains a page module
			$page_id = (int) addslashes($_GET['page_id']);

    		// gather information for all models embedded on actual page
			$query_modules = $database->query("SELECT module FROM " .TABLE_PREFIX ."sections 
				WHERE page_id=$page_id");

    		while($row = $query_modules->fetchRow()) {
				// check if page module directory contains a backend.js or backend.css file
      		if(file_exists(PE_PATH ."/modules/" .$row['module'] ."/$base_file")) {
					// create link with backend.js or backend.css source for the current module
					$tmp_link = str_replace("{MODULE_DIRECTORY}", $row['module'], $base_link);
        			// ensure that backend.js or backend.css is only added once per module type
        			if(strpos($head_links, $tmp_link) === false) {
						$head_links .= $tmp_link ."\n";
					}
				}
    		}
    		// write out links with all external module javascript/CSS files, remove last line feed
			return rtrim($head_links);
		}
	}
}

?>