<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: class.order.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

/*

Ordering class

This class will be used to change the order of an item in a table
which contains a special order field (type must be integer)

*/

// Stop this file from being accessed directly
if(!defined('PE_URL')) {
	header('Location: ../index.php');
	exit(0);
}

// Load the other required class files if they are not already loaded
require_once(PE_PATH."/framework/class.database.php");

class order extends database{
	
	// Get the db values
	function __construct($table, $order_field, $id_field = 'id', $common_field) {
		parent::__construct();
		$this->table = $table;
		$this->order_field = $order_field;
		$this->id_field = $id_field;
		$this->common_field = $common_field;
	}
	
	// Move a row up
	function move_up($id) {
		// Get current order
		$query_order = "SELECT ".$this->order_field.",".$this->common_field." FROM ".$this->table." WHERE ".$this->id_field." = '$id'";
		$fetch_order = $this->queryRow($query_order);		
		$order = $fetch_order[$this->order_field];
		$parent = $fetch_order[$this->common_field];
		// Find out what row is before current one
		$query_previous = "SELECT ".$this->id_field.",".$this->order_field." FROM ".$this->table." WHERE ".$this->order_field." < '$order' AND ".$this->common_field." = '$parent' ORDER BY ".$this->order_field." DESC LIMIT 1";
		
		$fetch_previous = $this->queryRow($query_previous);
		if($fetch_previous) {
			// Change the previous row to the current order
			$previous_id = $fetch_previous[$this->id_field];
			$decremented_order = $fetch_previous[$this->order_field];
			$query = "UPDATE ".$this->table." SET ".$this->order_field." = '$order' WHERE ".$this->id_field." = '$previous_id' LIMIT 1";
			$this->query($query);
			// Change the row we want to the decremented order
			$query = "UPDATE ".$this->table." SET ".$this->order_field." = '$decremented_order' WHERE ".$this->id_field." = '$id' LIMIT 1";
			$this->query($query);
			
			if($this->is_error()) {
				return false;
			} else {
				return true;
			}
		} else {
			return false;
		}
	}
	// Move a row up
	function move_down($id) {
		// Get current order
		$query_order = "SELECT ".$this->order_field.",".$this->common_field." FROM ".$this->table." WHERE ".$this->id_field." = '$id'";
		$fetch_order = $this->queryRow($query_order);		
		$order = $fetch_order[$this->order_field];
		$parent = $fetch_order[$this->common_field];
		// Find out what row is before current one
		$query_next = "SELECT $this->id_field,".$this->order_field." FROM ".$this->table." WHERE ".$this->order_field." > '$order' AND ".$this->common_field." = '$parent' ORDER BY ".$this->order_field." ASC LIMIT 1";
		$fetch_next = $this->queryRow($query_next);
		if($fetch_next) {
			// Change the previous row to the current order
			$next_id = $fetch_next[$this->id_field];
			$incremented_order = $fetch_next[$this->order_field];
			$query = "UPDATE ".$this->table." SET ".$this->order_field." = '$order' WHERE ".$this->id_field." = '$next_id' LIMIT 1";
			$this->query($query);
			// Change the row we want to the decremented order
			$query = "UPDATE ".$this->table." SET ".$this->order_field." = '$incremented_order' WHERE ".$this->id_field." = '$id' LIMIT 1";
			$this->query($query);
			if($this->is_error()) {
				return false;
			} else {
				return true;
			}
		} else {
			return false;
		}
	}
	
	// Get new number for order
	function get_new($cf_value) {
		// Get last order
		$query_last = "SELECT ".$this->order_field." FROM ".$this->table." WHERE ".$this->common_field." = '$cf_value' ORDER BY ".$this->order_field." DESC LIMIT 1";
		$last_order = (int)$this->get_one($query_last);
		return $last_order+1;
	}
	
	// Clean ordering (should be called if a row in the middle has been deleted)
	function clean($cf_value) {
		// Loop through all records and give new order
		$query_all = "SELECT * FROM ".$this->table." WHERE ".$this->common_field." = '$cf_value' ORDER BY ".$this->order_field." ASC";
		$rows = $this->queryAll($query_all);
		if(count($rows) > 0) {
			$count = 1;
			foreach($rows as $row) {
				// Update row with new order
				$this->query("UPDATE ".$this->table." SET ".$this->order_field." = '$count' WHERE ".$this->id_field." = '".$row[$this->id_field]."'");
				$count = $count+1;
			}
		} else {
			 return true;
		}
	}
	
// Clean ordering (should be called if a row in the middle has been deleted)
	function move_to($cf_value,$field_id,$position,$ordering='ASC') {
		// Get current index
		$order = $this->get_position($field_id);
		
		if ($order === false) return false;

		if ($order == $position) return true;
		
		if ($ordering=='ASC'){
			if($order < $position)
				$sql = "UPDATE `".$this->table ."` SET `".$this->order_field."` = `".$this->order_field."` - 1 ".
	 					" WHERE `".$this->common_field."` = '".$cf_value."' ".
	 					" AND `".$this->order_field."` > '".$order ."' AND `".$this->order_field."` <= '".$position."'";
			else
				$sql = "UPDATE `".$this->table ."` SET `".$this->order_field."` = `".$this->order_field."` + 1 ".
	 					" WHERE `".$this->common_field."` = '".$cf_value."' ".
	 					" AND `".$this->order_field."` >= '".$position ."' AND `".$this->order_field."` < '".$order."'";
		} elseif ($ordering=='DESC'){
			if($order > $position)
				$sql = "UPDATE `".$this->table ."` SET `".$this->order_field."` = `".$this->order_field."` + 1 ".
	 					" WHERE `".$this->common_field."` = '".$cf_value."' ".
	 					" AND `".$this->order_field."` < '".$order ."' AND `".$this->order_field."` >= '".$position."'";
			else
				$sql = "UPDATE `".$this->table ."` SET `".$this->order_field."` = `".$this->order_field."` - 1 ".
	 					" WHERE `".$this->common_field."` = '".$cf_value."' ".
	 					" AND `".$this->order_field."` <= '".$position ."' AND `".$this->order_field."` > '".$order."'";
		}
		$this->query($sql);
		if($this->is_error()) {
			echo $sql."<br>".$this->get_error();
			return false;
		}
		$sql = "UPDATE `".$this->table ."` SET `".$this->order_field."` = '".$position."'".
				 	" WHERE `".$this->id_field."` = '".$field_id. "'";

		$this->query($sql);
		if($this->is_error()) {
			echo $sql."<br>".$this->get_error();
			return false;
		}
		return true;
	}
	
	function get_position($field_id) {
		// Get current index
		$query_order ="SELECT `".$this->order_field."` FROM `".$this->table."` WHERE `".$this->id_field."` = '$field_id'";
		$order = $this->get_one($query_order);
		if($this->is_error()) {
			echo $query_order."<br>".$this->get_error();
			return false;
		}		
		return $order;
	}
}
?>