<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: May 24,2010                                                 *
 *    Build Time: 11:00:00                                                    *
 *     File Name: frontend.functionc.php                                      *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2010 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2010,                                                        *
 * The Pacer Edition CMS                                                      *
 * JCWEBDEN.COM (DARKSTAR INCORPORATED)                                       *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */  

/*
	This file is purely for ensuring compatibility with 3rd party
	contributions made for WB version 2.5.2 or below
*/
if(!defined('PE_URL')) {
	header('Location: ../index.php');
	exit(0);
}

// Set wich side we are on...
if ((!defined('FRONTEND')) && (!defined('BACKEND'))) define('FRONTEND',true);

// references to objects and variables that changed their names

$admin = &$wb;

$default_link=&$wb->default_link;

$page_trail=&$wb->page_trail;
$page_description=&$wb->page_description;
$page_keywords=&$wb->page_keywords;

$website_generator=&$wb->website_generator;
$website_author=&$wb->website_author;
$website_disclaimer=&$wb->website_disclaimer;


$page_link=&$wb->link;

// extra_sql is not used anymore - this is basically a register_globals exploit prevention...
$extra_sql=&$wb->extra_sql;
$extra_where_sql=&$wb->extra_where_sql;

$query="SELECT directory FROM ".TABLE_PREFIX."addons WHERE type = 'module' AND function = 'snippet'";
$query_result=$database->query($query);
if ($query_result->numRows()>0) {
	while ($row = $query_result->fetchRow()) {
		$module_dir = $row['directory'];
		if (file_exists(PE_PATH.'/modules/'.$module_dir.'/include.php')) {
			include(PE_PATH.'/modules/'.$module_dir.'/include.php');
		}
	}
}

// Frontend functions
if (!function_exists('page_link')) {
	function page_link($link,$params='') {
		global $wb;
		return $wb->page_link($link,$params);
	}
}

//function to highlight search results
if(!function_exists('search_highlight')) {
function search_highlight($foo='', $arr_string=array()) {
	require_once(PE_PATH.'/framework/functions.php');
	static $string_ul_umlaut = FALSE;
	static $string_ul_regex = FALSE;
	if($string_ul_umlaut===FALSE || $string_ul_regex===FALSE)
		require(PE_PATH.'/search/search_convert.php');
	$foo = entities_to_umlauts($foo, 'UTF-8');
	array_walk($arr_string, create_function('&$v,$k','$v = preg_quote($v, \'~\');'));
	$search_string = implode("|", $arr_string);
	$string = str_replace($string_ul_umlaut, $string_ul_regex, $search_string);
	// the highlighting
	// match $string, but not inside <style>...</style>, <script>...</script>, <!--...--> or HTML-Tags
	// split $string into pieces - "cut away" styles, scripts, comments, HTML-tags and eMail-addresses
	// we have to cut <pre> and <code> as well.
	// for HTML-Tags use <(?:[^<]|<.*>)*> which will match strings like <input ... value="<b>value</b>" >
	$matches = preg_split("~(<style.*</style>|<script.*</script>|<pre.*</pre>|<code.*</code>|<!--.*-->|<(?:[^<]|<.*>)*>|\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,8}\b)~iUs",$foo,-1,(PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY));
	if(is_array($matches) && $matches != array()) {
		$foo = "";
		foreach($matches as $match) {
			if($match{0}!="<" && !preg_match('/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,8}$/i', $match)) {
				$match = str_replace(array('&lt;', '&gt;', '&amp;', '&quot;', '&#039;', '&nbsp;'), array('<', '>', '&', '"', '\'', "\xC2\xA0"), $match);
				$match = preg_replace('~('.$string.')~ui', '_span class=_highlight__$1_/span_',$match);
				$match = str_replace(array('&', '<', '>', '"', '\'', "\xC2\xA0"), array('&amp;', '&lt;', '&gt;', '&quot;', '&#039;', '&nbsp;'), $match);
				$match = str_replace(array('_span class=_highlight__', '_/span_'), array('<span class="highlight">', '</span>'), $match);
			}
			$foo .= $match;
		}
	}
	
	if(DEFAULT_CHARSET != 'utf-8') {
		$foo = umlauts_to_entities($foo, 'UTF-8');
	}
	return $foo;
}
}

// Old menu call invokes new menu function
if (!function_exists('page_menu')) {
	function page_menu($parent = 0, $menu_number = 1, $item_template = '<li[class]>[a] [menu_title] [/a]</li>', $menu_header = '<ul>', $menu_footer = '</ul>', $default_class = ' class="menu_default"', $current_class = ' class="menu_current"', $recurse = LEVEL) {
		global $wb;
		$wb->menu_number=$menu_number;
		$wb->menu_item_template=$item_template;
		$wb->menu_item_footer='';
		$wb->menu_parent = $parent;
		$wb->menu_header = $menu_header; 
		$wb->menu_footer = $menu_footer;
		$wb->menu_default_class = $default_class;
		$wb->menu_current_class = $current_class;
		$wb->menu_recurse = $recurse+2; 	
		$wb->menu();
		unset($wb->menu_parent);
		unset($wb->menu_number);
		unset($wb->menu_item_template);
		unset($wb->menu_item_footer);
		unset($wb->menu_header);
		unset($wb->menu_footer);
		unset($wb->menu_default_class);
		unset($wb->menu_current_class);
		unset($wb->menu_start_level);
		unset($wb->menu_collapse);
		unset($wb->menu_recurse);
	}
}

if (!function_exists('show_menu')) {
	function show_menu($menu_number = NULL, $start_level=NULL, $recurse = NULL, $collapse = NULL, $item_template = NULL, $item_footer = NULL, $menu_header = NULL, $menu_footer = NULL, $default_class = NULL, $current_class = NULL, $parent = NULL) {
		global $wb;
		if (isset($menu_number))
			$wb->menu_number=$menu_number;
		if (isset($start_level))
			$wb->menu_start_level=$start_level;
		if (isset($recurse))
			$wb->menu_recurse=$recurse;
		if (isset($collapse))
			$wb->menu_collapse=$collapse;
		if (isset($item_template))
			$wb->menu_item_template=$item_template;
		if (isset($item_footer))
			$wb->menu_item_footer=$item_footer;
		if (isset($menu_header))
			$wb->menu_header=$menu_header;
		if (isset($menu_footer))
			$wb->menu_footer=$menu_footer;
		if (isset($default_class))
			$wb->menu_default_class=$default_class;
		if (isset($current_class))
			$wb->menu_current_class=$current_class;
		if (isset($parent))
			$wb->menu_parent=$parent;
		$wb->menu();
		unset($wb->menu_recurse);
		unset($wb->menu_parent);
		unset($wb->menu_start_level);
	}
}

if (!function_exists('page_content')) {
	function page_content($block = 1) {
		// Get outside objects
		global $TEXT,$MENU,$HEADING,$MESSAGE;
		global $globals;
		global $database;
		global $wb;
        global $Pacer;
        
		$admin = & $wb;
		if ($wb->page_access_denied==true) {
	        echo $MESSAGE['FRONTEND']['SORRY_NO_VIEWING_PERMISSIONS'];
			return;
            //exit();
		}
		if ($wb->page_no_active_sections==true) {
	        echo $MESSAGE['FRONTEND']['SORRY_NO_ACTIVE_SECTIONS'];
			return;
            //exit();
		}
		if(isset($globals) AND is_array($globals)) { foreach($globals AS $global_name) { global $$global_name; } }
		// Make sure block is numeric
		if(!is_numeric($block)) { $block = 1; }
		// Include page content
		if(!defined('PAGE_CONTENT') OR $block!=1) {
			$page_id=$wb->page_id;
			// First get all sections for this page
			$query_sections = $database->query("SELECT section_id,module,publ_start,publ_end FROM ".TABLE_PREFIX."sections WHERE page_id = '".$page_id."' AND block = '$block' ORDER BY position");
			// If none were found, check if default content is supposed to be shown
			if($query_sections->numRows() == 0) {
				if ($wb->default_block_content=='none') {
					return;
				}
				if (is_numeric($wb->default_block_content)) {
					$page_id=$wb->default_block_content;
				} else {
					$page_id=$wb->default_page_id;
				}				
				$query_sections = $database->query("SELECT section_id,module,publ_start,publ_end FROM ".TABLE_PREFIX."sections WHERE page_id = '".$page_id."' AND block = '$block' ORDER BY position");
				// Still no cotent found? Give it up, there's just nothing to show!
				if($query_sections->numRows() == 0) {
					return;
				}
			}
			// Loop through them and include their module file
			while($section = $query_sections->fetchRow()) {
				// skip this section if it is out of publication-date
				$now = time();
				if( !(($now<=$section['publ_end'] || $section['publ_end']==0) && ($now>=$section['publ_start'] || $section['publ_start']==0)) ) {
					continue;
				}
				$section_id = $section['section_id'];
				$module = $section['module'];
				// make a anchor for every section.
				if(defined('SEC_ANCHOR') && SEC_ANCHOR!='') {
					echo '<a class="section_anchor" id="'.SEC_ANCHOR.$section_id.'" name="'.SEC_ANCHOR.$section_id.'"></a>';
				}
		     	
                // fetch content -- this is where to place possible output-filters (before highlighting)
				ob_start(); // fetch original content
                require(PE_PATH.'/modules/'.$module.'/view.php');
                $content = ob_get_contents();
                if(ob_get_level()) ob_end_clean();
                $content=page_hcf_vars($content);
                
				// highlights searchresults
				if(isset($_GET['searchresult']) && is_numeric($_GET['searchresult']) && !isset($_GET['nohighlight']) && isset($_GET['sstring']) && !empty($_GET['sstring'])) {
					$arr_string = explode(" ", $_GET['sstring']);
					if($_GET['searchresult']==2) { // exact match
						$arr_string[0] = str_replace("_", " ", $arr_string[0]);
					}
					echo add_module_comment($module,search_highlight($content, $arr_string));
				} else {
					if (!$content)
						echo $Pacer->Pacer_Zone_Warning($section_id);
					else {
	                	echo add_module_comment($module,$content);
					}
                }
			}
		} else {
			require(PAGE_CONTENT);
		}
	}
}
if (!function_exists('add_module_comment')) {
	function add_module_comment($module,$content) {
    	require(PE_PATH.'/modules/'.$module.'/info.php');
    	return sprintf('%s<!-- Start - Module: %s ver.%s -->%s',PHP_EOL,$module_name,$module_version,PHP_EOL).
              $content.sprintf('%s<!-- End - Module: %s ver.%s -->%s',PHP_EOL,$module_name,$module_version,PHP_EOL); 
    }
}
if (!function_exists('show_content')) {
	function show_content($block=1) {
		page_content($block);
	}
}

if (!function_exists('show_breadcrumbs')) {
	function show_breadcrumbs($sep=' > ',$tier=1,$links=true,$depth=-1) {
		global $wb;
		$page_id=$wb->page_id;
		if ($page_id!=0)
		{
	 		global $database;
			$bca=$wb->page_trail;
			$counter=0;
			foreach ($bca as $temp)
			{
		        if ($counter>=($tier-1) AND ($depth<0 OR $tier+$depth>$counter))
		        {
					if ($counter>=$tier) echo $sep;
					$query_menu=$database->query("SELECT menu_title,link FROM ".TABLE_PREFIX."pages WHERE page_id=$temp");
					$page=$query_menu->fetchRow();
					if ($links==true AND $temp!=$page_id)
						echo '<a href="'.page_link($page['link']).'">'.$page['menu_title'].'</a>';
					else
					    echo $page['menu_title'];
		        }
	            $counter++;
			}
		}
	}
}

// Function for page title
if (!function_exists('page_title')) {
	function page_title($spacer = ' - ', $template = '[WEBSITE_TITLE][SPACER][PAGE_TITLE]') {
		$vars = array('[WEBSITE_TITLE]', '[PAGE_TITLE]', '[MENU_TITLE]', '[SPACER]');
		$values = array(WEBSITE_TITLE, PAGE_TITLE, MENU_TITLE, $spacer);
		echo str_replace($vars, $values, $template);
	}
}

// Function for page description
if (!function_exists('page_description')) {
	function page_description() {
		global $wb;
		if ($wb->page_description!='') {
			echo $wb->page_description;
		} else {
			echo WEBSITE_DESCRIPTION;
		}
	}
}

// Function for page keywords
if (!function_exists('page_keywords')) {
	function page_keywords() {
		global $wb;
		if ($wb->page_keywords!='') {
			echo $wb->page_keywords;
		} else {
			echo WEBSITE_KEYWORDS;
		}
	}
}

// Function for page website_generator
if (!function_exists('website_generator')) {
	function website_generator() {
		global $wb;
		if ($wb->website_generator!='') {
			echo $wb->website_generator;
		} else {
			echo WEBSITE_GENERATOR;
		}
	}
}

// Function for page website_author
if (!function_exists('website_author')) {
	function website_author() {
		global $wb;
		if ($wb->website_author!='') {
			echo $wb->website_author;
		} else {
			echo WEBSITE_AUTHOR;
		}
	}
}

// Function for page page_title_display
if (!function_exists('page_title_display')) {
	function page_title_display() {
		global $wb;
		if ($wb->page_title_display!='') {
			echo $wb->page_title_display;
		} else {
			echo PAGE_TITLE_DISPLAY;
		}
	}
}

// Function for page page_sub_title_display
if (!function_exists('page_sub_title_display')) {
	function page_sub_title_display() {
		global $wb;
		if ($wb->page_sub_title_display!='') {
			echo $wb->page_sub_title_display;
		} else {
			echo PAGE_SUB_TITLE_DISPLAY;
		}
	}
}


// Function for page website_disclaimer
if (!function_exists('website_disclaimer')) {
	function website_disclaimer() {
		global $wb;
		if ($wb->website_disclaimer!='') {
			echo $wb->website_disclaimer;
		} elseif(WEBSITE_DISCLAIMER) {
			echo WEBSITE_DISCLAIMER;
		} else {
        	global $Pacer;
        	echo $Pacer->Pacer_Zone_Warning('website_disclaimer');
		}
    }
}

// Function for page Search Display Title
if (!function_exists('search_title_display')) {
	function search_title_display() {
		global $wb;
		if ($wb->search_title_display!='') {
			echo $wb->search_title_display;
		} else {
			echo SEARCH_TITLE_DISPLAY;
		}
	}
}

// Function for page search_sub_title_display
if (!function_exists('search_sub_title_display')) {
	function search_sub_title_display() {
		global $wb;
		if ($wb->search_sub_title_display!='') {
			echo $wb->search_sub_title_display;
		} else {
			echo SEARCH_SUB_TITLE_DISPLAY;
		}
	}
}
// Function for page_[header|content|footer] vars replacement
if (!function_exists('page_hcf_vars')) {
	function page_hcf_vars($string,$optional_vars_values=array(),$date_format = 'Y') {
    	global $Pacer;
        $vars = array('[YEAR]','[PAGE_MODIFIED_WHEN]','[PAGE_MODIFIED_WHEN_RAW]','[PAGE_MODIFIED_BY]','[LAST_MODIFIED_PAGE_LINK]','[LAST_MODIFIED_PAGE_TITLE]','[LAST_MODIFIED_PAGE_WHEN]','[LAST_MODIFIED_PAGE_BY]','[SITE_MODIFIED_WHEN]','[SITE_MODIFIED_WHEN_RAW]','[TEXT_PAGE_MODIFIED_ON]','[TEXT_PAGE_MODIFIED_BY]','[TEXT_LATEST_MODIFIED_PAGE_ON]','[TEXT_LATEST_MODIFIED_PAGE_BY]','[TEXT_SITE_MODIFIED_ON]','[TEXT_SITE_MODIFIED_BY]','[TEXT_ON]','[TEXT_BY]');
		$values = array(date($date_format),((defined('PAGE_MODIFIED_WHEN'))?PAGE_MODIFIED_WHEN:''),((defined('PAGE_MODIFIED_WHEN_RAW'))?PAGE_MODIFIED_WHEN_RAW:0),((defined('PAGE_MODIFIED_BY'))?PAGE_MODIFIED_BY:''),((defined('LAST_MODIFIED_PAGE_LINK'))?LAST_MODIFIED_PAGE_LINK:''),((defined('LAST_MODIFIED_PAGE_TITLE'))?LAST_MODIFIED_PAGE_TITLE:''),((defined('LAST_MODIFIED_PAGE_WHEN'))?LAST_MODIFIED_PAGE_WHEN:''),((defined('LAST_MODIFIED_PAGE_WHEN_RAW'))?LAST_MODIFIED_PAGE_WHEN_RAW:0),((defined('LAST_MODIFIED_PAGE_BY'))?LAST_MODIFIED_PAGE_BY:''),((defined('SITE_MODIFIED_WHEN'))?SITE_MODIFIED_WHEN:''),((defined('SITE_MODIFIED_WHEN_RAW'))?SITE_MODIFIED_WHEN_RAW:0),$Pacer->Translate('Page modified on'),$Pacer->Translate('Page modified by'),$Pacer->Translate('Latest modified page on'),$Pacer->Translate('Latest modified page by'),$Pacer->Translate('Site modified on'),$Pacer->Translate('Site modified by'),$Pacer->Translate('on'),$Pacer->Translate('by'));        
        foreach ($optional_vars_values as $k => $v){
        	$vars[]=$k;
            $values[]=$v;
        }
        return str_replace($vars, $values, $string);
    }
}

// Function for page header
if (!function_exists('page_header')) {
	function page_header($date_format = 'Y') {
    	global $Pacer;
     	$string=page_hcf_vars(WEBSITE_HEADER,array(),$date_format);
        if(strlen($string)==0) echo $Pacer->Pacer_Zone_Warning('page_header');
        else echo $string;
	}
}

// Function for page footer
if (!function_exists('page_footer')) {
	function page_footer($date_format = 'Y') {
		global $starttime, $Pacer;
        $processtime=array_sum(explode(" ",microtime()))-$starttime;
		$string=page_hcf_vars(WEBSITE_FOOTER,array('[PROCESS_TIME]'=>$processtime),$date_format);
        if(strlen($string)==0) echo $Pacer->Pacer_Zone_Warning('page_footer');
        else echo $string;
    }
}

// Function to add optional module Javascript or CSS stylesheets into the <head> section of the frontend
if(!function_exists('register_frontend_modfiles')) {
	function register_frontend_modfiles($file_id="css") {
		// sanity check of parameter passed to the function
		$file_id = strtolower($file_id);
		if($file_id !== "css" && $file_id !== "javascript" && $file_id !== "js") { 
			return;
		}

		global $wb, $database;
		// define default baselink and filename for optional module javascript and stylesheet files
		$head_links = "";
		if($file_id == "css") {
            $base_link = '<link href="'.PE_URL.'/modules/{MODULE_DIRECTORY}/frontend.css"'; 
			$base_link.= ' rel="stylesheet" type="text/css" media="screen" />';
			$base_file = "frontend.css";
		} else {
			$base_link = '<script type="text/javascript" src="'.PE_URL.'/modules/{MODULE_DIRECTORY}/frontend.js"></script>';
			$base_file = "frontend.js";
		}

  	// gather information for all models embedded on actual page
		$page_id = $wb->page_id;
    $query_modules = $database->query("SELECT module FROM " .TABLE_PREFIX ."sections 
			WHERE page_id=$page_id AND module<>'wysiwyg'");

    while($row = $query_modules->fetchRow()) {
		// check if page module directory contains a frontend.js or frontend.css file
    	if(file_exists(PE_PATH ."/modules/" .$row['module'] ."/$base_file")) {
				// create link with frontend.js or frontend.css source for the current module
				$tmp_link = str_replace("{MODULE_DIRECTORY}", $row['module'], $base_link);

        // define constant indicating that the register_frontent_files was invoked
				if($file_id == 'css') {
					if(!defined('MOD_FRONTEND_CSS_REGISTERED')) define('MOD_FRONTEND_CSS_REGISTERED', true);
				} else {
					if(!defined('MOD_FRONTEND_JAVASCRIPT_REGISTERED')) define('MOD_FRONTEND_JAVASCRIPT_REGISTERED', true);
				}

        // ensure that frontend.js or frontend.css is only added once per module type
        if(strpos($head_links, $tmp_link) === false) {
					$head_links .= $tmp_link ."\n";
				}
			}
    }
  	// include the Javascript email protection function
  	if($file_id != 'css' && file_exists(PE_PATH .'/modules/output_filter/js/mdcr.js')) {
			$head_links .= '<script type="text/javascript" src="'.PE_URL.'/modules/output_filter/js/mdcr.js"></script>' ."\n";
		}
  		
		// write out links with all external module javascript/CSS files, remove last line feed
		echo $head_links;
	}
}

// Begin WB < 2.4.x template compatibility code
	// Make extra_sql accessable through private_sql
	$private_sql = $extra_sql;
	$private_where_sql = $extra_where_sql;
	// Query pages for menu
	$menu1 = $database->query("SELECT page_id,menu_title,page_title,link,target,visibility$extra_sql FROM ".TABLE_PREFIX."pages WHERE parent = '0' AND $extra_where_sql ORDER BY position ASC");
	// Check if current pages is a parent page and if we need its submenu
	if(PARENT == 0) {
		// Get the pages submenu
		$menu2 = $database->query("SELECT page_id,menu_title,page_title,link,target,visibility$extra_sql FROM ".TABLE_PREFIX."pages WHERE parent = '".PAGE_ID."' AND $extra_where_sql ORDER BY position ASC");
	} else {
		// Get the pages submenu
		$menu2 = $database->query("SELECT page_id,menu_title,page_title,link,target,visibility$extra_sql FROM ".TABLE_PREFIX."pages WHERE parent = '".PARENT."' AND $extra_where_sql ORDER BY position ASC");
	}
// End WB < 2.4.x template compatibility code
// Include template file

function resolve_template_dependencies($template_directory) {
    global $Pacer;	
	
	if (!defined('VERSION')) define('VERSION','');
	if (!defined('EDITION')) define('EDITION','');
	
    require(PE_PATH.'/templates/'.$template_directory.'/info.php');
		
	if (isset($template_dependencies) && is_array($template_dependencies)){
		foreach($template_dependencies['frontend'] as $karr => $varr) {
			if (is_array($varr)) {
				foreach($varr as $k => $v) {
					switch ($k){
						case 'js_file':
						case 'css_file':
							$Pacer->Code_Injection_Add($k,$v);
							break;
						case 'require_language_file':							
							if ($v) {
								$v = get_module_language_file($template_directory);
								if (($v) && (file_exists($v))) require($v);
							}
							break;
						case 'require_captcha_file':							
							if ($v) {
								$v = PE_PATH.'/include/captcha/captcha.php';
								if (($v) && (file_exists($v))) require_once($v);
							}
							break;
						case 'require_php_file':
							if (file_exists($v)) require_once($v);
							break;
					}
				}
			}
		}
	}
}
?>
