<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: initialize.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */
 
//if (file_exists(PE_PATH.'/framework/class.database.php')) {
	
	@date_default_timezone_set(date_default_timezone_get());

	require_once(PE_PATH.'/framework/class.database.php');

	// Create database class
	$database = new database();
	
	set_magic_quotes_runtime(0);
	
	// Get website settings (title, keywords, description, header, and footer)
	$settings = $database->queryAll("SELECT name,value FROM ".TABLE_PREFIX."settings");
	if($database->is_error()) { 
		$html='<html><head><meta http-equiv="Refresh" content="10"></head><body style="text-align:center"><br><br><h3>Database error: '.$database->get_error().'<br><br>Page will reload in 10secs<br><br><br>Sorry for the inconvenience...</body></html>';
		die($html);
	}
	if(count($settings) == 0) { 
		$html='<html><head><meta http-equiv="Refresh" content="10"></head><body style="text-align:center"><br><br><h3>Settings not found!<br><br>Page will reload in 10secs<br><br>Sorry for the inconvenience...</body></html>';
		die($html); 
	}
	
	foreach($settings as $setting) {
		$setting_name=strtoupper($setting['name']);
		$setting_value=$setting['value'];
		if ($setting_value=='false')
			$setting_value=false;
		if ($setting_value=='true')
			$setting_value=true;
		@define($setting_name,$setting_value);
	}
	$string_file_mode = STRING_FILE_MODE;
	define('OCTAL_FILE_MODE',(int) octdec($string_file_mode));
	$string_dir_mode = STRING_DIR_MODE;
	define('OCTAL_DIR_MODE',(int) octdec($string_dir_mode));
	
	if (!defined("PE_INSTALL_PROCESS")) {
		// get CAPTCHA and ASP settings	
		if($setting = $database->queryRow("SELECT * FROM ".TABLE_PREFIX."mod_captcha_control LIMIT 1")) {
			if($setting['enabled_captcha'] == '1') define('ENABLED_CAPTCHA', true);
			else define('ENABLED_CAPTCHA', false);
			if($setting['enabled_asp'] == '1') define('ENABLED_ASP', true);
			else define('ENABLED_ASP', false);
			define('CAPTCHA_TYPE', $setting['captcha_type']);
			define('ASP_SESSION_MIN_AGE', (int)$setting['asp_session_min_age']);
			define('ASP_VIEW_MIN_AGE', (int)$setting['asp_view_min_age']);
			define('ASP_INPUT_MIN_AGE', (int)$setting['asp_input_min_age']);
		} else {
			die("CAPTCHA-Settings not found");
		}
	}

	// set error-reporting
	if(is_numeric(ER_LEVEL)) {
		error_reporting(ER_LEVEL);
	}
	
	// Get Pacer Session Control settings
	$pacer_settings = array();
	$rows = $database->queryAll("SELECT `name`,`value` FROM `".TABLE_PREFIX."pacer_settings` WHERE `name` LIKE 'pacer_session_%'");
	foreach($rows as $row) {
		$pacer_settings[str_replace('pacer_','',$row['name'])] = $row['value'];
	}
	
	// Start a session
	if(!defined('SESSION_STARTED')) {
		session_name(APP_NAME.'_session_id');
		// Mark session lifetime
		if((isset($pacer_settings['session_lifetime'])) && ($pacer_settings['session_lifetime'])){
			session_cache_expire(round($pacer_settings['session_lifetime']/60,0));
			ini_set("session.gc_maxlifetime",$pacer_settings['session_lifetime']);
		}
		@session_start();
		define('SESSION_STARTED', true);
	}
	
	// Mark session time start
	if(!isset($_SESSION['session_started']))
		$_SESSION['session_started'] = time();
	
	// Get users language
	if(isset($_GET['lang']) AND $_GET['lang'] != '' AND !is_numeric($_GET['lang']) AND strlen($_GET['lang']) == 2) {
	  	define('LANGUAGE', strtoupper($_GET['lang']));
		$_SESSION['LANGUAGE']=LANGUAGE;
	} else {
		if(isset($_SESSION['LANGUAGE']) AND $_SESSION['LANGUAGE'] != '') {
			define('LANGUAGE', $_SESSION['LANGUAGE']);
		} else {
			define('LANGUAGE', DEFAULT_LANGUAGE);
		}
	}
	
	// Load Language file
	if(!defined('LANGUAGE_LOADED')) {
		if(!file_exists(PE_PATH.'/languages/'.LANGUAGE.'.php')) {
			exit('Error loading language file '.LANGUAGE.', please check configuration');
		} else {
			require_once(PE_PATH.'/languages/'.LANGUAGE.'.php');
		}
	}
	
	// Get users timezone
	if(isset($_SESSION['TIMEZONE'])) {
		define('TIMEZONE', $_SESSION['TIMEZONE']);
		if(isset($_SESSION['TIMEZONE_NAME']))
			define('TIMEZONE_NAME', $_SESSION['TIMEZONE_NAME']);
	} else {
		define('TIMEZONE', DEFAULT_TIMEZONE);
		define('TIMEZONE_NAME', DEFAULT_TIMEZONE_NAME);
	}
	if (defined('TIMEZONE_NAME'))
		@date_default_timezone_set(TIMEZONE_NAME);
	
	
	// Get users date format
	if(isset($_SESSION['DATE_FORMAT'])) {
		define('DATE_FORMAT', $_SESSION['DATE_FORMAT']);
	} else {
		define('DATE_FORMAT', DEFAULT_DATE_FORMAT);
	}
	// Get users time format
	if(isset($_SESSION['TIME_FORMAT'])) {
		define('TIME_FORMAT', $_SESSION['TIME_FORMAT']);
	} else {
		define('TIME_FORMAT', DEFAULT_TIME_FORMAT);
	}
	
	// Set Theme dir
	define('THEME_URL', PE_URL.'/templates/'.DEFAULT_THEME);
	define('THEME_PATH', PE_PATH.'/templates/'.DEFAULT_THEME);
	
//}
?>