<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: module.function.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

/**
	This file contains routines to edit the optional module files: frontend.css and backend.css
	Mechanism was introduced with WB 2.7 to provide a global solution for all modules
	To use this function, include this file from your module (e.g. from modify.php)
	Then simply call the function edit_css('your_module_directory') - thats it
	NOTE: Some functions were added for module developers to make the creation of own module easier
*/

// prevent this file from being accessed directly
if(!defined('PE_PATH')) die(header('Location: index.php'));  

/*
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 FUNCTIONS REQUIRED TO EDIT THE OPTIONAL MODULE CSS FILES
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/ 

// this function checks the validity of the specified module directory
if(!function_exists('check_module_dir')) {
	function check_module_dir($mod_dir) {
		// check if module directory is formal correct (only characters: "a-z,0-9,_,-")
		if(!preg_match('/^[a-z0-9_-]+$/iD', $mod_dir)) return '';
		// check if the module folder contains the required info.php file
		return (file_exists(PE_PATH .'/modules/' .$mod_dir .'/info.php')) ? $mod_dir : '';
	}
}

// this function checks if the specified optional module file exists
if (!function_exists('mod_file_exists')) {
	function mod_file_exists($mod_dir, $mod_file='frontend.css') {
  	// check if the module file exists
		return file_exists(PE_PATH .'/modules/' .$mod_dir .'/' .$mod_file);
	}
}

// this function displays the "Edit CSS" button in modify.php 
if (!function_exists('edit_module_css')) {
	function edit_module_css($mod_dir,$force_type='',$extra_dir='') {
		global $page_id, $section_id;
				
		// check if the required edit_module_css.php file exists
		if(!file_exists(PE_PATH .'/modules/edit_module_files.php')) return;
		
		// check if specified module directory is valid
		if(check_module_dir($mod_dir) == '') return;
		
		$frontend_css = true;
		// check if frontend.css or backend.css exist
		$frontend_css_name = 'css/frontend_'.$section_id.'.css';
		
		if (!mod_file_exists($mod_dir, $frontend_css_name)) {
			$frontend_css_name = 'frontend.css';
			if (!mod_file_exists($mod_dir, $frontend_css_name)) {
				$frontend_css_name = '';
				$frontend_css = false;
			}
		}
		$backend_css = mod_file_exists($mod_dir, 'backend.css');
		
		switch($force_type){
			case 'frontend':
				$frontend_css = true;
			case 'backend':
				$backend_css = true;
		}
		// output the edit CSS submtin button if required
		if($frontend_css || $backend_css) {
			// default text used for the edit CSS routines if not defined in the WB core language files
			$edit_css_caption = (isset($GLOBALS['TEXT']['CAP_EDIT_CSS'])) ?$GLOBALS['TEXT']['CAP_EDIT_CSS'] :'Edit CSS';
			?>
			<form name="edit_module_file" action="<?php echo PE_URL .'/modules/edit_module_files.php?page_id='.$page_id;?>" 
				method="post" style="margin: 0; align:right;">
				<input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
				<input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
				<input type="hidden" name="mod_dir" value="<?php echo $mod_dir; ?>" />
				<input type="hidden" name="edit_file" value="<?php echo ($frontend_css) ?$frontend_css_name : 'backend.css';?>" />
				<input type="hidden" name="action" value="edit" />
				<input type="submit" value="<?php echo $edit_css_caption;?>" class="mod_<?php echo $mod_dir;?>_edit_css" />
			</form>
			<?php
    }
  }
}

// this function displays a button to toggle between CSS files (invoked from edit_css.php)
if (!function_exists('toggle_css_file')) {
	function toggle_css_file($mod_dir, $base_css_file = 'frontend.css') {
		global $page_id, $section_id;
		// check if the required edit_module_css.php file exists
		if(!file_exists(PE_PATH .'/modules/edit_module_files.php')) return;

		// check if specified module directory is valid
		if(check_module_dir($mod_dir) == '') return;

		// do sanity check of specified css file
		if(!in_array($base_css_file, array('frontend.css', 'backend.css'))) return;
		
		// display button to toggle between the two CSS files: frontend.css, backend.css
		$toggle_file = ($base_css_file == 'frontend.css') ? 'backend.css' : 'frontend.css';
		if(mod_file_exists($mod_dir, $toggle_file)) {
			?>
			<form name="toggle_module_file" action="<?php echo PE_URL .'/modules/edit_module_files.php?page_id='.$page_id;?>" method="post" style="margin: 0; align:right;">
				<input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
				<input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
				<input type="hidden" name="mod_dir" value="<?php echo $mod_dir; ?>" />
				<input type="hidden" name="edit_file" value="<?php echo $toggle_file; ?>" />
				<input type="hidden" name="action" value="edit" />
				<input type="submit" value="<?php echo ucwords($toggle_file);?>" class="mod_<?php echo $mod_dir;?>_edit_css" />
			</form>
			<?php
		}
  }
}

/*
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 FUNCTIONS WHICH CAN BE USED BY MODULE DEVELOPERS FOR OWN MODULES (E.G. VIEW.PHP, MODIFY.PHP)
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/ 

// function to obtain the module language file depending on the backend language of the current user
if (!function_exists('get_module_language_file')) {
	function get_module_language_file($mymod_dir) {
		$mymod_dir = strip_tags($mymod_dir);
		if(file_exists(PE_PATH .'/modules/' .$mymod_dir .'/languages/' .LANGUAGE .'.php')) {
			// a module language file exists for the users backend language
			return (PE_PATH .'/modules/' .$mymod_dir .'/languages/' .LANGUAGE .'.php');
		} else {
			// an English module language file must exist in all multi-lingual modules
			if(file_exists(PE_PATH .'/modules/' .$mymod_dir .'/languages/EN.php')) {
				return (PE_PATH .'/modules/' .$mymod_dir .'/languages/EN.php');
			} else {
				echo '<p><strong>Error: </strong>';
				echo 'Default language file (EN.php) of module "' .htmlentities($mymod_dir) .'" does not exist.</p><br />';
				return false;
			}
		}
	}
}

// function to include module CSS files in <body> (only if WB < 2.6.7 or register_frontend_modfiles('css') not invoked in template)
if (!function_exists('include_module_css')) {
	function include_module_css($mymod_dir, $css_file) {
		if(!in_array(strtolower($css_file), array('frontend.css', 'backend.css'))) return;
		
		if($css_file == 'frontend.css') {
			// check if frontend.css needs to be included into the <body> section
			if(!((!function_exists('register_frontend_modfiles') || !defined('MOD_FRONTEND_CSS_REGISTERED')) && 
					file_exists(PE_PATH .'/modules/' .$mymod_dir .'/frontend.css'))) {
				return false;
			} 
		} else {
			// check if backend.css needs to be included into the <body> section
			global $admin;
			if(!(!method_exists($admin, 'register_backend_modfiles') && file_exists(PE_PATH .'/modules/' .$mymod_dir .'/backend.css'))) {
				return false;
			}
		}
		// include frontend.css or backend.css into the <body> section
		echo "\n".'<style type="text/css">'."\n";
  	include(PE_PATH .'/modules/' .$mymod_dir .'/' .$css_file);
  	echo "\n</style>\n";
		return true;
	}
}

// function to check if the optional module Javascript files are loaded into the <head> section
if (!function_exists('requires_module_js')) {
	function requires_module_js($mymod_dir, $js_file) {
		if(!in_array(strtolower($js_file), array('frontend.js', 'backend.js'))) {
			echo '<strong>Note: </strong>Javascript file "' .htmlentities($js_file) .'" 
			specified in module "' .htmlentities($mymod_dir) .'" not valid.'; 
			return false;
		}
		
		if($js_file == 'frontend.js') {
			// check if frontend.js is included to the <head> section
			if(!defined('MOD_FRONTEND_JAVASCRIPT_REGISTERED')) {
				echo '<p><strong>Note:</strong> The module: "' .htmlentities($mymod_dir) .'" requires WB 2.6.7 or higher</p>
				<p>This module uses Javascript functions contained in frontend.js of the module.<br />
				Add the code below to the &lt;head&gt; section in the index.php of your template
				to ensure that module frontend.js files are automatically loaded if required.</p>
				<code style="color: #800000;">&lt;?php<br />if(function_exists(\'register_frontend_modfiles\')) { <br />
				&nbsp;&nbsp;register_frontend_modfiles(\'js\');<br />?&gt;</code><br />
				<p><strong>Tip:</strong> For WB 2.6.7 copy the code above to the index.php of your template. 
				Then open the view.php of the "' .htmlentities($mymod_dir) .'" module and set the variable 
				<code>$requires_frontend_js</code> to false. This may do the trick.</p><p>All WB versions below 2.6.7 needs 
				to be upgraded to work with this module.</p>
				';
				return false;
			}
		} else {
			// check if backend.js is included to the <head> section
			global $admin;
				if(!method_exists($admin, 'register_backend_modfiles') && file_exists(PE_PATH .'/modules/' .$mymod_dir .'/backend.js')) {
				echo '<p><strong>Note:</strong> The module: "' .htmlentities($mymod_dir) .'" requires WB 2.6.7 or higher</p>
				<p>This module uses Javascript functions contained in backend.js of the module.<br />
				You need WB 2.6.7 or higher to ensure that module backend.js files are automatically loaded if required.</p>
				<p>Sorry, you can not use this tool with your WB installation, please upgrade to the latest WB version available.</p><br />
				';
				return false;
			}
		}
		return true;
	}
}
// function to check if the optional module Javascript files are loaded into the <head> section
if (!function_exists('insert_into_table')) {
	function insert_into_table($table,$fields) {
		global $Pacer;
		if ((TABLE_PREFIX) && (!preg_match('/^'.TABLE_PREFIX.'.*/',$table))) 
			$table = TABLE_PREFIX.$table;
		// Create sql statement
		$sql_values='';
		$sql_fields='';
		foreach($fields as $field => $value) {
			if (is_array($value)){
				$sql_fields .= (($sql_fields)? ',':'').'`'.addslashes($field).'`';
				$sql_values .= (($sql_values)? ',':'').'\''.addslashes($value['value']).'\'';

			} else {
				$sql_fields .= (($sql_fields)? ',':'').'`'.addslashes($field).'`';
				$sql_values .= (($sql_values)? ',':'').'\''.addslashes($value).'\'';
			}
		}
		// Execute insert sql
		//die("INSERT INTO `".$table.'` ('.$sql_fields.') VALUES ('.$sql_values.')');
		$Pacer->database->query("INSERT INTO `".$table.'` ('.$sql_fields.') VALUES ('.$sql_values.')');
		return (($Pacer->database->is_error())?false:true);
	}
}
if (!function_exists('update_into_table')) {
	function update_into_table($table,$fields,$keys) {
		global $Pacer;

		if ((TABLE_PREFIX) && (!preg_match('/^'.TABLE_PREFIX.'.*/',$table))) 
			$table = TABLE_PREFIX.$table;

		//print_r($fields);
		// Create sql statement
		$sql_values='';
		foreach($fields as $field => $value) {
			if (is_array($value)){
				$sql_values .= (($sql_values)? ',':'').'`'.addslashes($field).'` = \''.addslashes($value['value']).'\'';
			} else {
				$sql_values .= (($sql_values)? ',':'').'`'.addslashes($field).'` = \''.addslashes($value).'\'';
			}
		}
		$sql_keys='';
		foreach($keys as $key => $value) {
			$sql_keys .= (($sql_keys)? ' AND ':'').'`'.addslashes($key).'` = \''.addslashes($value).'\'';
		}

		// Execute insert sql
		//die('UPDATE `'.$table.'` SET '.$sql_values.' WHERE ( '.$sql_keys.' )');
		$Pacer->database->query('UPDATE `'.$table.'` SET '.$sql_values.' WHERE ( '.$sql_keys.' )');
		//die('UPDATE `'.$table.'` SET '.$sql_values.' WHERE ( '.$sql_keys.' )');
		//die(__FILE__.__LINE__."UPDATE `".$table.'` SET '.$sql_values.' WHERE ( '.$sql_keys.' )');
		return (($Pacer->database->is_error())?false:true);
	}
}

if (!function_exists('resolve_module_dependencies')) {
	function resolve_module_dependencies($module_directory,$frontend = true,$globalize_this = '',$section_id_param='') {
		if($globalize_this) global ${$globalize_this};
		global $Pacer;
		// obtain module directory
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');

		// auto Upgrade via Ajax 
		// if Backend 
		// and Module Version < Installed module version
		if ((!$frontend) && ($module_version)) {
			module_dependencies_upgrade($module_directory);
		}
		
		if (is_array($module_dependencies)){
			foreach($module_dependencies[($frontend)?'frontend':'backend'] as $karr => $varr) {
				if (is_array($varr)) {
				foreach($varr as $k => $v) {
					switch ($k){
						case 'js_file':
							$Pacer->Code_Injection_Add($k,$v);
							break;
						case 'css_file':							
							$replaced = false;
							if(($section_id_param) && preg_match('/frontend\.css$/iU',$v)){
								$vcss = preg_replace('/frontend\.css$/iU','css/frontend_'.$section_id_param.'.css',$v);
								if (file_exists(str_replace(PE_URL,PE_PATH,$vcss))){
									$Pacer->Code_Injection_Add($k,$vcss);
									$replaced = true;
								}
							} 
							if (!$replaced)
								$Pacer->Code_Injection_Add($k,$v);
							break;
						case 'require_language_file':							
							if ($v) {
								$v = get_module_language_file($module_directory);
								if (($v) && (file_exists($v))) require($v);
							}
							break;
						case 'require_captcha_file':							
							if ($v) {
								$v = PE_PATH.'/include/captcha/captcha.php';
								if (($v) && (file_exists($v))) require_once($v);
							}
							break;
						case 'require_php_file':
							if (file_exists($v)) require_once($v);
							break;
					}
				}
				}
			}
		}
	}
}
if (!function_exists('check_module_dependencies')) {
	function check_module_dependencies($module_directory,$frontend = true) {
		global $Pacer;	
		// obtain module directory
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		if (is_array($module_dependencies)){
			foreach($module_dependencies[($frontend)?'frontend':'backend'] as $karr => $varr) {
				if (is_array($varr))
				foreach($varr as $k => $v) {
					if (!$v) continue;
					switch ($k){
						case 'js_file':
							$v = str_replace(PE_URL,PE_PATH,(dirname($v)=='.') ? PACER_PATH.'/js/'.$v:$v);
							if (!file_exists($v)) unset($module_dependencies[($frontend)?'frontend':'backend'][$karr]);
							else $module_dependencies[($frontend)?'frontend':'backend'][$karr][$k]=$v;							
							break;				
						case 'css_file':
							$v = str_replace(PE_URL,PE_PATH,(dirname($v)=='.') ? PACER_PATH.'/css/'.$v:$v);
							if (!file_exists($v)) unset($module_dependencies[($frontend)?'frontend':'backend'][$karr]);
							else $module_dependencies[($frontend)?'frontend':'backend'][$karr][$k]=$v;
							break;				
						case 'require_language_file':							
							$v = get_module_language_file($module_directory);
							if (!$v) unset($module_dependencies[($frontend)?'frontend':'backend'][$karr]);							
							break;
						case 'require_captcha_file':							
							$v = PE_PATH.'/include/captcha/captcha.php';
							if (!file_exists($v)) unset($module_dependencies[($frontend)?'frontend':'backend'][$karr]);
							break;
						case 'require_php_file':
							if (!file_exists($v)) unset($module_dependencies[($frontend)?'frontend':'backend'][$karr]);
							break;
					}
				}
			}
		}
		return $module_dependencies;
	}
}

if (!function_exists('module_dependencies_upgrade')) {
	function module_dependencies_upgrade($module_directory) {
		global $Pacer;	
		// obtain module directory
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		
		if ($module_version) {
			$file = '/modules/'.$module_directory.'/upgrade.php';
			if (file_exists(PE_PATH.$file)){
				$row = $Pacer->database->queryRow(sprintf("SELECT version, name FROM %saddons WHERE type = 'module' AND directory = '%s' LIMIT 1",TABLE_PREFIX,addslashes($module_directory)));
				$installed_module_version = $row['version'];
				$module_name = $row['name'];
				if (version_compare($module_version,$installed_module_version)==1){ 
					$Pacer->database->query(sprintf("UPDATE %saddons SET version = '%s' WHERE type = 'module' AND directory = '%s' LIMIT 1",TABLE_PREFIX,$module_version,addslashes($module_directory)));
					if($Pacer->database->is_error()) {
						die($Pacer->database->get_error());	
					}
					//run
					ob_start();
					require(PE_PATH.$file);
					$data = ob_get_clean();
					$script = '
jQuery(document).ready(function() {
	var ret="'.(($data)?'error':'success').'";
	var data="'.(($data)?$data:$Pacer->Translate('The required changes have been made to your database.')).'";
	jQuery.jGrowl(data, {theme:ret,header:"'.$Pacer->Translate('Module: ').$module_name.'",sticky: true});
	if (ret == "success") {
		self.location.reload(true);
	}
});
';
					$Pacer->Code_Injection_Add('js_script',$script);
				}
			}
		}
	}
}

if (!function_exists('resolve_module_backend_modify_body')) {
	function resolve_module_backend_modify_body($fields,$headers = '',$section='settings',$edit_css=true, $tr_d = 3) {
		global $page_id, $section_id, $Pacer, $module_name, $module_directory,$TEXT,$MENU,$submission_id;
	// include template parser class and set template
		module_dependencies_upgrade($module_directory);
		
		require_once(PE_PATH . '/include/phplib/template.inc');
		$file = PE_PATH.'/modules/'.$module_directory.'/htt/backend_template_'.$section.'.htt';
		if (!file_exists($file)) $file = PE_PATH.'/modules/'.$module_directory.'/htt/backend_template_'.$section.'.htt';
		if (!file_exists($file)) $file = str_replace(PE_URL,PE_PATH,THEME_PATH).'/templates/backend_template_'.$section.'.htt';
		if (!file_exists($file)) $file = str_replace(PE_URL,PE_PATH,THEME_PATH).'/templates/backend_template_modify.htt';
		
		
		$template = new Template(dirname($file));	
		$template->set_file('page', basename($file));
		$template->set_block('page', 'main_block', 'main');
		
		if (count($fields))
			$width = intval(100/count($fields));
		else $width = 0;
		
		$template->set_var(array(
			'TXT_HEADER'						=> $module_name
		));
		
		if(is_array($headers)) $template->set_var($headers);

		$template->set_block('main_block', 'body_list_block', 'body_list');
		foreach($fields as $k => $fv){
			$template->set_var(array(
			'TXT_BUTTON'						=> $k,
			'PAGE_ID'							=> (int) $page_id,
			'SECTION_ID'						=> (int) $section_id,
			'ADMIN_URL'							=> ADMIN_URL,
			'PE_URL'							=> PE_URL,
			'WIDTH'								=> $width.'%',
			'MOD_DIR'							=> $module_directory,
			'TXT_SAVE'							=> $TEXT['SAVE'],
			'TXT_CANCEL'						=> $TEXT['CANCEL'],
			'MOD_CANCEL_URL'					=> ADMIN_URL,
			'PGM'								=> $fv['PGM'],
			'RAWPGM'							=> ((isset($fv['RAWPGM']))?$fv['RAWPGM']:''),
			'START_RAWPGM'						=> ((isset($fv['RAWPGM']))?'<!--':''),
			'END_RAWPGM'						=> ((isset($fv['RAWPGM']))?'-->':''),
			'PARAMS'							=> ((isset($fv['PARAMS']))?$fv['PARAMS']:''),
			'INPUT_EXTRA'						=> ((isset($fv['INPUT_EXTRA']))?$fv['INPUT_EXTRA']:'')
			));	
			$template->parse('body_list', 'body_list_block', true);
		}
		// Parse template objects output
		$template->parse('main', 'main_block', false);
		$template->pparse('output', 'page',false, false);	
	
	}
}
if (!function_exists('resolve_module_backend_body')) {
	function resolve_module_backend_body($fields,$headers = '',$section='settings',$edit_css=true, $tr_d = 3,$show_presets=false) {
		global $page_id, $section_id, $Pacer, $module_name, $module_directory,$TEXT,$submission_id;

//		print_r($fields);
		if ($headers==='') $headers=array();

		if ($edit_css && function_exists('edit_module_css')){
			ob_start();
			$extra_dir = '';
			edit_module_css($module_directory,'frontend',$extra_dir);
			$edit_module_css = ob_get_contents();
			ob_end_clean();
		} else $edit_module_css = '';
		
		// include template parser class and set template
		require_once(PE_PATH . '/include/phplib/template.inc');
		
		$file = PE_PATH.'/modules/'.$module_directory.'/htt/backend_template_'.$section.'.htt';
		if (!file_exists($file)) $file = PE_PATH.'/modules/'.$module_directory.'/htt/backend_template_'.$section.'.htt';
		if (!file_exists($file)) $file = str_replace(PE_URL,PE_PATH,THEME_PATH).'/templates/backend_template_'.$section.'.htt';
		if (!file_exists($file)) $file = str_replace(PE_URL,PE_PATH,THEME_PATH).'/templates/backend_template_settings.htt';
		
		$template = new Template(dirname($file));
		
		$template->set_file('page', basename($file));
		
		$template->set_block('page', 'main_block', 'main');
		
		// Are there some presets?
		$presets=array(''=>'');
		if ($show_presets) {
			$folder = PE_PATH.'/modules/'.$module_directory.'/presets';
			if (is_dir($folder)){
				$file_list=file_list($folder);
				natsort($file_list);
				foreach($file_list AS $filename) {
					if(preg_match('|/thumbs/|i',$filename)) continue;
					if(preg_match('|/index\.php|i',$filename)) continue;
					if(preg_match('|/\.htaccess|i',$filename)) continue;
					$filename=preg_replace('/\.php/i','',basename($filename));
					$presets[$filename]=ucwords(str_replace('_',' ',$filename));
				}
			}
		}
		if (count($presets)>1){ 
			$presets_html ='';
			foreach($presets as $k=>$v){
				$presets_html .= '<option value="'.$k.'">'.$v.'</option>';
			}
			$template->set_var(array(
				'TXT_PRESETS'					=> $Pacer->Translate('Apply this preset'),
				'PRESETS'						=> $presets_html,
				'TXT_CHANGE_ALL'				=> $Pacer->Translate('to'),
				'TXT_ALL_SECTIONS'				=> $Pacer->Translate('All sections'),
				'TXT_THIS_SECTION'				=> $Pacer->Translate('Just this section'),
			));
		} else {
			$template->set_var(array(
				'DISPLAY_PRESETS'				=> 'style="display:none;"'
			));
		}
		
		// replace static template placeholders with values from language file
		$template->set_var(array(
		// variables from Website Baker framework
		'EDIT_MODULE_CSS'					=> $edit_module_css,
		'DISPLAY_EDIT_CSS_BUTTON' 			=> (($edit_module_css)?((array_key_exists('DISPLAY_EDIT_CSS_BUTTON',$headers))?$headers['DISPLAY_EDIT_CSS_BUTTON']:''):'display:none'),
		'PAGE_ID'							=> (int) $page_id,
		'SECTION_ID'						=> (int) $section_id,
		'ADMIN_URL'							=> ADMIN_URL,
		'PE_URL'							=> PE_URL,
		'THEME_URL'							=> THEME_URL,
		'PE_PATH'							=> PE_PATH,
		'ADMIN_PATH'						=> ADMIN_PATH,
		'SUBMISSION_ID'						=> $submission_id,

		// variables from global WB language files
		'TXT_PREVIEW'						=> $Pacer->Translate('Preview'),
		'TXT_HELP'							=> $Pacer->Translate('Help'),

		'MOD_DIR'							=> $module_directory,
		'MOD_NAME'							=> $module_name,
		'TXT_SAVE'							=> $TEXT['SAVE'],
		'TXT_CANCEL'						=> $TEXT['CANCEL'],
		'MODULE_NAME'						=> $module_name,
		'TXT_ENABLED'						=> $TEXT['ENABLED'],
		'TXT_DISABLED'						=> $TEXT['DISABLED'],

		// module settings
		'MOD_SAVE_URL'						=> PE_URL. '/modules/'.$module_directory.'/save_'.$section.'.php',
		'MOD_CANCEL_URL'					=> ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'&amp;section_id='.$section_id,
		'MOD_PREVIEW_URL'					=> PE_URL. '/modules/'.$module_directory.'/preview.php?page_id='.$page_id.'amp;section_id='.$section_id.'&amp;what=',
		'MOD_HELP_URL'						=> PE_URL.'/modules/'.$module_directory.'/help.php?page_id='.$page_id.'&amp;section_id='.$section_id,
		'DISPLAY_PREVIEW_BUTTON'			=> ((array_key_exists('DISPLAY_PREVIEW_BUTTON',$headers))?$headers['DISPLAY_PREVIEW_BUTTON']:'display:none'),
		'DISPLAY_HELP_BUTTON'			=> ((array_key_exists('DISPLAY_HELP_BUTTON',$headers))?$headers['DISPLAY_HELP_BUTTON']:'display:none')
		));
		$td_width=2;
		if(array_key_exists('DISPLAY_HELP_BUTTON',$headers)) $td_width++;
		if(array_key_exists('DISPLAY_EDIT_CSS_BUTTON',$headers)) $td_width++;
		if(array_key_exists('DISPLAY_PREVIEW_BUTTON',$headers)) $td_width++;

		if($edit_module_css) $td_width++;
		$td_width= round(100/$td_width,0);
		$template->set_var(array(
			'TD_WIDTH' => $td_width.'%'
		));
	
	
		if($headers!=array()) $template->set_var($headers);
		
		// Body
		$template->set_block('main_block', 'body_list_block', 'body_list');
		$cla = array();
		global $id_list;

		$id_list = array();
		$date_format = '';
		$ab='a';
		$n_narrative=0;
		
		$cookies=$Pacer->get_user_cookies('editor');
		
		foreach($fields as $k => $fv){
			$class_tr = ((array_key_exists('class_tr',$fv)) ? $fv['class_tr']:'');
			
			$template->set_var('CLASS_TR','class="row_'.$ab.' '.$class_tr.'"');
			$v = ((array_key_exists('value',$fv)) ? $fv['value']:'');
			$v = str_replace('{','&#0123;',str_replace('}','&#0125;',htmlspecialchars($v)));

			if (array_key_exists('section',$fv)) {
				$section = $Pacer->Translate(str_replace('_',' ',$fv['section']));
				$section ='<tr class="'.$class_tr.'"><td colspan="'.$tr_d.'" class="settings_section">'.$section.'</td></tr>';
			} else $section = '';
			$template->set_var('SECTION_TITLE',$section);
	
			$label = ((array_key_exists('label',$fv)) ? $fv['label']:ucwords(str_replace('_',' ',preg_replace('/^temp_/i','',$k))));
			if (!array_key_exists('dont_translate',$fv)) {	
				$label = $Pacer->Translate($label, (isset($MODULE_SPECIFIC)) ? $MODULE_SPECIFIC:'');
			}
			if (array_key_exists('force_label',$fv)){
				$label = nl2br($fv['force_label']);
				$label_dots='';
			}elseif (array_key_exists('raw_label',$fv)){
				$label_dots='';
				$label = str_replace('{','&#0123;',str_replace('}','&#0125;',$label));
				$label = nl2br($label);
			}else{
				$label_dots=':';
				$label = str_replace('{','&#0123;',str_replace('}','&#0125;',htmlspecialchars($label)));
				$label = nl2br($label);
				$label = str_replace(' ','&nbsp;',$label);
			}
			$display_editor_script = '';
			if ($fv['type']==='wysiwyg') {
				// Has the editor to be hidden?
				$display_editor=false;
				if ((array_key_exists($_SERVER['PHP_SELF'].','.$k,$cookies))&&($cookies[$_SERVER['PHP_SELF'].','.$k]=='1')) {
					$display_editor=true;
				}
				
				$display_editor_script.='<a class="toggle_mce_editor" href="javascript:PEtoggleEditor(\''.$k.'\',true);"><span id="button_add_editor_'.$k.'" style="background-image: url(\''.THEME_URL.'/images/open_tab.png\');'.(($display_editor)?' display:none;':'').'" title="'.$Pacer->Translate('Add editor').'">'.$Pacer->Translate('Add editor').'</span><span id="button_remove_editor_'.$k.'" style="background-image: url(\''.THEME_URL.'/images/close_tab.png\');'.(($display_editor)?'':' display:none;').'" title="'.$Pacer->Translate('Remove editor').'">'.$Pacer->Translate('Remove editor').'</span></a';
			}
			
			if(array_key_exists('multicolumn',$fv)) {
				$template->set_var('LABEL', ($label)?$label.$label_dots:'');				
				$template->set_var('MULTICOLUMN', ' colspan="'.$fv['multicolumn'].'"'.(($display_editor_script)?'>':'').$display_editor_script);
				$template->set_var('MULTICOLUMN_START', '</tr><!--');
				$template->set_var('MULTICOLUMN_END', '-->');
			} else {
				$template->set_var('LABEL', (($label)?$label.$label_dots:'').$display_editor_script.(($display_editor_script)?'>':''));
				$template->set_var('MULTICOLUMN_START', '');
				$template->set_var('MULTICOLUMN_END', '');
				$template->set_var('MULTICOLUMN', '');
			}
			
			if (array_key_exists('sub_label',$fv)){
				$sub_label = $fv['sub_label'];
				$template->set_var('SUB_LABEL', $sub_label);
				$template->set_var('SUB_LABEL_STYLE', '');
			} else {
				$sub_label = '';
				$template->set_var('SUB_LABEL_STYLE', 'style="display:none;"');
			}
			if (isset($fv['id'])) $idx = $fv['id']; else $idx = $k;
	
			$ex = '';
			if (isset($fv['readonly']) && $fv['readonly']==true) $ex .= " readonly=\"readonly\" ";
			if (isset($fv['disabled']) && $fv['disabled']==true) $ex .= " disabled=\"disabled\" ";
	
			$buttons = '';
			if (isset($fv['html'])) $buttons .= $fv['html'];
	
			$act = '';
			if (isset($fv['action'])) $act = $fv['action'];
			$fv['min_width'] = ((array_key_exists('min_width',$fv))?$fv['min_width']:400);
			$fv['min_height'] = ((array_key_exists('min_height',$fv))?$fv['min_height']:300);
	
			$help = array('','','','');
			if (array_key_exists('narrative',$fv)) {
				$help[0]=' tooltip';
				$help[1]=' class="tooltip"';
				$help[2]=' title="'.$label.$Pacer->TOOLTIP_TITLE_SEPARATOR.$fv['narrative'] .'"';
				$help[3]=' tooltip" title="'.$label.$Pacer->TOOLTIP_TITLE_SEPARATOR.$fv['narrative'];
				$n_narrative++;
			}
			$template->set_var('LABEL_HELP', $help[3]);
	
			$fld= '';	
			$validation_class = '';
			$fld_append='';

			if (array_key_exists('append',$fv)) {
				$fld_append = $fv['append'];
			}

			
			if (array_key_exists('hidden',$fv)) {
				$fld = $fv['hidden'];
			}

			if (array_key_exists('initial',$fv)) {
				if (is_null($v)) $v = $fv['initial'];
			}

			if (array_key_exists('initial_forced',$fv)) {
				$v = $fv['initial_forced'];
				$v = str_replace('{','&#0123;',str_replace('}','&#0125;',htmlspecialchars($v)));
			}

			if (array_key_exists('relation',$fv)) {
				$v = $Pacer->database->get_one($fv['relation']."'".$v."'");
			}
			if (array_key_exists('validation_class',$fv)) {
				$validation_class .= ' '.$fv['validation_class'];
			}
 
			if (array_key_exists('FORM',$_SESSION) && array_key_exists($submission_id,$_SESSION['FORM']) && array_key_exists('ERRORS',$_SESSION['FORM'][$submission_id]) && array_key_exists($k,$_SESSION['FORM'][$submission_id]['ERRORS'])) {
				$validation_class .= ' error';
			}

			switch ($fv['type']) {
				case 'select':
					$fld.="<select class=\"settings_select".$validation_class.$help[0]."\"".$help[2]." name=\"${k}\" id=\"${k}\" $ex $act >";
					foreach($fv['options'] as $kk => $vv){
						$option_style='';
						if (array_key_exists('option_style',$fv)) {
							$option_style = $fv['option_style'];
							$lc_opt = strtolower($vv);
							$uc_opt = strtoupper($vv);
							$ci_opt = $vv;
							$option_style = str_replace(array('[LC_OPTION_VALUE]','[UC_OPTION_VALUE]','[CI_OPTION_VALUE]'), array($lc_opt,$uc_opt,$ci_opt),$option_style);
						}
						if (array_key_exists('options_title',$fv)) {
							$option_title = 'title="'.$fv['options_title'][$kk].'"';
						} else $option_title = '';
						
						$fld.="<option value=\"${vv}\" ".(($vv==$v) ? 'selected="selected"':'')." $option_style $option_title >";		
						if (array_key_exists('skip_translation',$fv)) {
							$fld.= (is_numeric($kk))?$vv:$kk;
						} else {
							$fld.= $Pacer->Translate(((is_numeric($kk))?$vv:$kk));
						}
						$fld.="&nbsp;&nbsp;</option>";
					}
					$fld.="</select>$buttons";
					break;
				case 'boolean':
					$v = (int) $v ;
					for($i=1;$i>=0;$i--){
						$fld.="<input class=\"settings_radio".$validation_class.$help[0]."\"".$help[2]." type=\"radio\" name=\"${k}\" id=\"${k}_${i}\" value=\"${i}\" style=\"width:14px;\" ".(($v===$i) ? " checked=\"checked\" ":"" )." $ex /><label for=\"${k}_${i}\" class=\"settings_label\"> ".$Pacer->Translate(($i===1) ? "Enabled":"Disabled")." </label>";
					}
					break;
				case 'radio':
					foreach($fv['options'] as $kk => $vv){
						$fld.="<input class=\"settings_radio".$validation_class.$help[0]."\"".$help[2]." type=\"radio\" name=\"${k}\" id=\"${k}_${kk}\" value=\"${vv}\" style=\"width:14px;\" ".(($v===$vv) ? " checked=\"checked\" ":"" )." $ex $act /><label for=\"${k}_${kk}\" class=\"settings_label\"> ".$Pacer->Translate($kk)." </label>";
					}
					break;
				case 'checkbox':
					foreach($fv['options'] as $kk => $vv){
						$fld.="<input class=\"settings_radio".$validation_class.$help[0]."\"".$help[2]." type=\"checkbox\" name=\"${k}\" id=\"${k}_${kk}\" value=\"${vv}\" style=\"width:14px;\" ".(($v===$vv) ? " checked=\"checked\" ":"" )." $ex $act /><label for=\"${k}_${kk}\" class=\"settings_label\"> ".$Pacer->Translate($kk)." </label>";
					}
					break;
				case 'text':
					$min_max = '';
					if((array_key_exists('min_height',$fv)) && (array_key_exists('max_height',$fv))) {
						$min_max = $fv['min_height'].'-'.$fv['max_height'];
					}
					$fld.="<textarea class=\"expanding".$min_max." settings_textarea".$validation_class.$help[0]."\"".$help[2]." name=\"${idx}\" id=\"${idx}\" cols=\"".((array_key_exists('cols',$fv))?$fv['cols']:"115")."\" rows=\"".((array_key_exists('rows',$fv))?$fv['rows']:"25")."\" $ex >".$v."</textarea>";
					break;
				case 'integer':
				case 'float':
					if (array_key_exists('initial',$fv)) {
						if (is_null($v) || $v=='') $v = $fv['initial'];
					}
					$v = floatval( $v ) ;
				case 'string':
			   		$fld= "<input class=\"settings_input".$validation_class.$help[0]."\"".$help[2]." type=\"text\" name=\"$k\" id=\"${k}\" value=\"". htmlspecialchars($v)."\" maxlength=\"".$fv['length']."\" $ex $act/>";
					break;
				case 'editarea':
					$fld= "<textarea class=\"settings_input".$validation_class.$help[0]."\"".$help[2]." name=\"$k\" id=\"$k\" cols=\"".(($fv['cols'])?$fv['cols']:"115")."\" rows=\"".(($fv['rows'])?$fv['rows']:"25")."\" wrap=\"VIRTUAL\" $ex >".$v."</textarea>";
					$fld .= registerEditArea($k, 'html', false,'no',true,true,(($fv['min_width'])?$fv['min_width']:400), (($fv['min_height'])?$fv['min_height']:300),'default');
					break;
				case 'wysiwyg':
					$min_max = '';
					if((array_key_exists('min_height',$fv)) && (array_key_exists('max_height',$fv))) {
						$min_max = $fv['min_height'].'-'.$fv['max_height'];
					}
					$fld = ((array_key_exists('multicolumn',$fv))?'<tr class="row_'.$ab.' '.$class_tr.'"><td colspan="'.$fv['multicolumn'].'">':'');
					$id_list[]=$k;
				//	$fld .= '<textarea name="'.$k.'" id="'.$k.'" style="width: '.$fv['min_width'].'; height: '.$fv['min_height'].';" '.((isset($class))? 'class="'.$class.'"':'').'>'.$v.'</textarea>';
					$use_tiny_mce_smart_buttons=true;
					require_once(PE_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.func.php');
					
					$fld .= show_wysiwyg_editor($k, $k, $v, -1, -1,array('use_tiny_mce_smart_buttons'=>$use_tiny_mce_smart_buttons,'no_output'=>true,'class'=>'expanding'.$min_max.' settings_textarea ','cols'=>((array_key_exists('cols',$fv))?$fv['cols']:"115"),'rows'=>((array_key_exists('rows',$fv))?$fv['rows']:"25")));
					
					break;
				case 'date':
				case 'datetime':
					if ($v) {
						$v = date( ((isset($fv['format'])) ? $fv['format'] : DATE_FORMAT." ".TIME_FORMAT), $v);
					} else {
						//$v = date( ((isset($fv['format'])) ? $fv['format'] : DATE_FORMAT." ".TIME_FORMAT));
						$v='';
					}
					$fv['length'] = 22;
					$cla[$k] = $k;
					$fld = 	'<table cellpadding="0" cellspacing="0" border="0"><tr><td>'.
							'<input class="settings_input_date'.$validation_class.$help[3].'" type="text" name="'.$k.'" id="'.$k.'" value="'. $v.'" size="'.$fv['length'].'" '.$ex.' />'.
							'</td><td>'.
     						'<img src="'.PACER_URL .'/images/cal.gif" id="'.$k.'_trigger" class="settings_input_date_img" title="'.$Pacer->Translate('Calendar').'" />'.
						'</td></tr></table>';
					break;
				case 'file':
			   		$fld = "<input class=\"settings_input".$validation_class.$help[0]."\"".$help[2]." type=\"file\" name=\"$k\" id=\"${k}\" value=\"\"  $ex $act/>";
					break;
			}
			
			$template->set_var('FIELD',$fld.$fld_append);
			$template->parse('body_list', 'body_list_block', true);
			if ($ab=='a') $ab='b'; else $ab='a';
		}
		// Is there a module icon= Then display it... 
		$file='/modules/'.$module_directory.'/preview.jpg';
		if (file_exists(PE_PATH.$file)){
			$Pacer->Code_Injection_Add('js_script','jQuery(document).ready(function() {
	jQuery(\'div#page-image img\').attr(\'src\',\''.PE_URL.$file.'\').attr(\'display\',\'block\');
});');
		}
		if (count($id_list)){
			require(PE_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');
		}
		// Is there a 'calendar' field ? if Yes include code...
		if (count($cla)>0) {
			$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/calendar.js');
			$Pacer->Code_Injection_Add('css_file',PE_URL.'/include/jscalendar/calendar-system.css');
		/*	ob_start();
			require_once(PE_PATH.'/include/jscalendar/calendar-system.css');
			$css = ob_get_contents();
			ob_end_clean();
			$Pacer->Code_Injection_Add('css_script',$css);
		*/
			if(file_exists(PE_PATH .'/include/jscalendar/lang/calendar-'.strtolower(LANGUAGE) .'.js')) {
				$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/lang/calendar-'.strtolower(LANGUAGE).'.js');
			} else {
				$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/lang/calendar-en.js');
			}
			$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/calendar-setup.js');
			// today
			$jscal_use_time = true;
			$jscal_today = date('Y/m/d');
			// first-day-of-week
			$jscal_firstday = '1'; // monday
			if(LANGUAGE=='EN') $jscal_firstday = '0'; // sunday
			
			$jscal_ifformat = $Pacer->convert_datetime_format('','',true, $Pacer->get_user_id());
			// load scripts for jscalendar
			$jscal_use_time = true; // whether to use a clock, too
			if ($date_format) $jscal_ifformat = $date_format; //"%Y-%m-%d"; // - format for jscalendar (default: from wb-backend-date-format)
			$script='';
			foreach($cla as $k => $v) {
				$script.='
Calendar.setup({
	inputField  : "'.$k.'",
	ifFormat    : "'.$jscal_ifformat.'",
	button      : "'.$k.'_trigger",
	firstDay    : '.$jscal_firstday.','.
	((isset($jscal_use_time) && $jscal_use_time==TRUE) ? '
	showsTime   : "true",
	timeFormat  : "24",':'').'
	date        : "'.$jscal_today.'",
	range       : [1970, 2037],
	step        : 1
});';
			}
			$Pacer->Code_Injection_Add('js_script','jQuery(document).ready(function() {'.$script.'});');
		}
		/*
		if ($n_narrative>0 && $Pacer->TOOLTIP_TITLE_SEPARATOR!=="_-_") {
			$Pacer->Code_Injection_Add('js_script','
jQuery(document).ready(function() {
jQuery("*").each(function(idx){ 
	if(jQuery(this).hasClass("tooltip")){ 
		if(typeof jQuery(this).tooltip!="function") {
		 jQuery(this).tooltip({
			track: true,
			delay: 0,
			showURL: false,
			showBody: "'.$Pacer->TOOLTIP_TITLE_SEPARATOR.'",
			extraClass: "pretty",
			fixPNG: true,
			opacity: 0.95,
		 });	
		};
	};
 });
});
');
}
*/
		// Parse template objects output
		$template->parse('main', 'main_block', false);
		$template->pparse('output', 'page',false, false);
		
		
	}
}

if (!function_exists('get_module_backend_body')) {
	function get_module_backend_body($fields) {
		global $Pacer, $admin,$submission_id;
		require_once(PE_PATH."/include/jscalendar/jscalendar-functions.php");

		// Reset error honeypot
		$_SESSION['FORM']=array();
		$_SESSION['FORM']['SUBMISSION_ID']=$submission_id;
		$_SESSION['FORM'][$submission_id]=array('ERRORS'=>array(),'VALUES'=>array());

		foreach($fields as $k => $fv){
			//if (preg_match('/^temp_/i',$k)) continue;
			switch ($fv['type']) {
				case 'boolean':
					$fields[$k]['value'] = (int) $admin->get_post($k);
					break;
				case 'integer':
					$fields[$k]['value'] = (int) $admin->get_post($k);
					break;
				case 'float':
					$fields[$k]['value'] = (float) $admin->get_post($k);
					break;
				case 'datetime':
				case 'date':
				case 'time':
					//$fields[$k]['value'] = (int) strtotime($admin->get_post($k));
					$fields[$k]['value']=jscalendar_to_timestamp($admin->get_post($k));
					break;
				case 'wysiwyg':
					$fields[$k]['value'] = $Pacer->strip_slashes($admin->get_post($k));
					//$fields[$k]['value'] = umlauts_to_entities(strip_tags($fields[$k]['value']), strtoupper(DEFAULT_CHARSET),0);
					break;
				default:
					$fields[$k]['value'] = $Pacer->strip_slashes($admin->get_post($k));
					break;
			}
			//$_SESSION['FORM']['VALUES'][$k] = $fields[$k]['value'];
			$_SESSION['FORM'][$_SESSION['FORM']['SUBMISSION_ID']]['VALUES'][$k]=$fields[$k]['value'];

		}
		if (array_key_exists('modified_when',$fields)) $fields['modified_when'] = array('type'=>'integer','value'=>time());
		if (array_key_exists('modified_by',$fields)) $fields['modified_by'] = array('type'=>'integer','value'=>$admin->get_user_id());
		return $fields;
	}
}
if (!function_exists('load_module_backend_fields_value')) {
	function load_module_backend_fields_value($fields,$settings){
		global $Pacer,$admin,$submission_id;
		if (!is_array($settings)) $settings=array();
		/*
		if(!isset($_SESSION['FORM'])) $_SESSION['FORM']=array();
		if(!isset($_SESSION['FORM'][$submission_id])) $_SESSION['FORM'][$submission_id]=array();
		if(!isset($_SESSION['FORM'][$submission_id]['VALUES'])) $_SESSION['FORM'][$submission_id]['VALUES']=array();
		*/
		if(!isset($_SESSION['FORM']) || !isset($_SESSION['FORM']['SUBMISSION_ID']) || $submission_id!=$_SESSION['FORM']['SUBMISSION_ID']) $_SESSION['FORM'][$submission_id]['VALUES']=array();
		foreach($fields as $k => $v) {
			if (!array_key_exists($k,$fields)) $fields[$k]=array();
			
			$fields[$k]['value'] = ((array_key_exists($k,$_SESSION['FORM'][$submission_id]['VALUES']))?$_SESSION['FORM'][$submission_id]['VALUES'][$k]:((array_key_exists($k,$settings))?$settings[$k]:''));
		}
		return $fields;
	}
}
if (!function_exists('module_backend_fields_check')) {
	function module_backend_fields_check($js_back){
		global $Pacer,$submission_id;
		if($_SESSION['FORM'][$submission_id]['ERRORS']!=array()) $Pacer->print_error($Pacer->Translate("Failed")." ".$Pacer->Translate("Field(s) not correct") , $js_back);
	}
}
// Generate temp submission id
if (!function_exists('form_submission_id')) {
	function form_submission_id($force_new=false) {
		global $admin,$Pacer;
		if (!$force_new) {
			$submission_id = ($admin->get_post('submission_id'))?$admin->get_post('submission_id'):$admin->get_get('submission_id');
			if ($submission_id) return $submission_id;
		}
		return $Pacer->new_submission_id();
	}
}
if (!function_exists('table_dragdrop_js')) {
	function table_dragdrop_js($selector,$section_id,$page_id,$field_id,$module_directory,$offset=1,$abs_prg='') {
		global $Pacer;
		if($abs_prg=='') $abs_prg=PE_URL.'/modules/'.$module_directory;
		
		return 'jQuery(document).ready(function() {
var prevRows'.$section_id.' = {};
jQuery(\''.$selector.'\').tableDnD({
	onDragStart: function(table, row) {
   		for (var i=0;i<table.tBodies[0].rows.length;i++) {
			prevRows'.$section_id.'[i] = table.tBodies[0].rows[i].id;
		}
	},
	onDrop: function(table, row) {
   		for (var i=0;i<table.tBodies[0].rows.length;i++) {
			if (table.tBodies[0].rows[i].id == row.id) {
				if(row.id!=prevRows'.$section_id.'[i]) {
					
					jQuery.get("'.$abs_prg.'/move_to.php", { page_id : '.$page_id.', section_id : '.$section_id.', '.$field_id.' : row.id, position : i+'.$offset.' },function(data){
						if (data==\'1\') {
							jQuery.jGrowl(\''.$Pacer->Translate('Success').'\', {theme:\'success\',header: \''.$Pacer->Translate('Success').'\', sticky: false});
						} else {
							if(data) jQuery.jGrowl(data, {theme:\'error\',header: \''.$Pacer->Translate('Error').'\', sticky: false});
						}
					});
				}
				return true;
			}
		}
		return false;
   	}
}).find(\'tr\').hover(function() {
	jQuery(this.cells[0]).addClass(\'showDragHandle\');
}, function() {
	jQuery(this.cells[0]).removeClass(\'showDragHandle\');
});

});
';
	}
}
if (!function_exists('check_pacer_menu_dependencies')) {
	function check_pacer_menu_dependencies($pacer_menu_directory) {
		global $Pacer;	
		// obtain pacer_menu directory
		require(PE_PATH.'/menus/'.$pacer_menu_directory.'/info.php');
		if (is_array($pacer_menu_dependencies)){
			foreach($pacer_menu_dependencies['frontend'] as $karr => $varr) {
				foreach($varr as $k => $v) {
					if (!$v) continue;
					switch ($k){
						case 'js_file':
							$v = str_replace(PE_URL,PE_PATH,(dirname($v)=='.') ? PACER_PATH.'/js/'.$v:$v);
							if (!file_exists($v)) unset($pacer_menu_dependencies['frontend'][$karr]);
							else $pacer_menu_dependencies['frontend'][$karr][$k]=$v;							
							break;				
						case 'css_file':
							$v = str_replace(PE_URL,PE_PATH,(dirname($v)=='.') ? PACER_PATH.'/css/'.$v:$v);
							if (!file_exists($v)) unset($pacer_menu_dependencies['frontend'][$karr]);
							else $pacer_menu_dependencies['frontend'][$karr][$k]=$v;
							break;				
					}
				}
			}
		}
		return $pacer_menu_dependencies;
	}
}
if (!function_exists('resolve_module_fields_dependencies')) {
	function resolve_module_fields_dependencies($module_directory,$values,$fields){
		global $wb;

		foreach($fields as $k => $v){
			if (($fields[$k]['type']==='wysiwyg') && ($values[$k])){
				if($wb)	$wb->preprocess($values[$k]);			
			}
		}
		
		return $values;
	}
}
if (!function_exists('install_module_files')) {
	function install_module_files($module_directory){
		global $Pacer,$admin;
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		uninstall_module_files($module_directory);
		foreach($module_dependencies['files'] as $file => $file_structure){
			$Pacer->database->query('CREATE TABLE `'.TABLE_PREFIX.$file.'` ( '.$file_structure['structure'].' )');
			if ($Pacer->database->is_error()) {				
				$admin->print_error($Pacer->database->get_error(),ADMIN_URL);
			}
		}
	}
}
if (!function_exists('uninstall_module_files')) {
	function uninstall_module_files($module_directory){
		global $Pacer;
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		foreach($module_dependencies['files'] as $file => $file_structure){
			$Pacer->database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX.$file."`");
			$Pacer->database->query("DELETE FROM ".TABLE_PREFIX."search WHERE name = 'module' AND value = '".$module_directory."'");
			$Pacer->database->query("DELETE FROM ".TABLE_PREFIX."search WHERE extra = '".$module_directory."'");		
		}
	}
}
if (!function_exists('delete_module_files')) {
	function delete_module_files($module_directory,$section_id,$key="section_id"){
		global $Pacer;
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		foreach($module_dependencies['files'] as $file => $file_structure){
			$Pacer->database->query("DELETE FROM `".TABLE_PREFIX.$file."` WHERE ".$key." = '".(int)$section_id."'");
		}
	}
}
if (!function_exists('upgrade_module_files')) {
	//$module_dependencies['files']['mod_'.$module_directory.'_settings']['upgrade'] = 	 
	//    array(array('action'=>'add','field'=>'step_legend','definition'=>'TEXT NULL DEFAULT NULL'));
	function upgrade_module_files($module_directory,$silent=false){
		global $Pacer;
		$err='';
		$one=false;
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		foreach($module_dependencies['files'] as $file => $v){
		  if (isset($v['upgrade']))
		  foreach($v['upgrade'] as $def){
			$sql = '';
			// Obtain file fields
			$field_exists=(($Pacer->database->get_one("DESCRIBE `".TABLE_PREFIX.$file."` `".$def['field']."`")=='')?false:true);
			switch ($def['action']){
				case 'add';
					if ($field_exists) continue;
					$sql="ADD `".$def['field']."` ".$def['definition'];
					break;
				case 'change';	
					if (!$field_exists) continue;
					$sql = "CHANGE `".$def['field']."` `".$def['field']."` ".$def['definition'];
					break;
				case 'drop';
					if (!$field_exists) continue;
					$sql="DROP `".$def['field']."`";
					break;
			}
			if ($sql) {
				$sql = "ALTER TABLE `".TABLE_PREFIX.$file."` ".$sql;
				$Pacer->database->query($sql);
				if($Pacer->database->is_error()) {
					$e = "OOPS, something went wrong. If it's a duplicate error then it's okay - it means that your database has already been modified.<br/>The error was: ".$Pacer->database->get_error();
					if ($err!=$e)
						$err.=$e;
				} else $one=true;
			}
		  }
		}
		echo $err;
		if (!$silent){
			if($one){
				echo $Pacer->Translate('The required changes have been made to your database.');
			};
		}
	}
}

if (!function_exists('module_help')) {
	function module_help($module_directory,$help_sections=array()){
		//die($module_directory);
		global $Pacer, $page_id, $section_id;
		
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		// include the module language file depending on the backend language of the current user
		@include(get_module_language_file($module_directory));

		// include template parser class and set template
		require_once(PE_PATH . '/include/phplib/template.inc');
		
		$file = THEME_PATH.'/templates/backend_template_help.htt';
		$template = new Template(dirname($file));		
		$template->set_file('page', basename($file));
		$template->set_block('page', 'main_block', 'main');
		// replace static template placeholders with values from language file
		foreach(array('page_id','section_id','module_directory','module_name','module_function','module_version','module_platform','module_author','module_author_url','module_support','module_date_created','module_license','module_license_terms','module_description') as $k){
			if(isset(${$k})) $template->set_var(strtoupper($k),${$k});
			if (preg_match('/^module_/',$k)){
				$kk=preg_replace('/^module_/','',$k);
				$template->set_var('TXT_'.strtoupper($kk),$Pacer->Translate(ucwords($kk)));
			}
		}
		foreach(array('ADMIN_URL','PE_URL','THEME_URL','PE_PATH','ADMIN_PATH') as $k){
			if(defined($k)) $template->set_var($k,constant($k));
		}
		foreach(array('Back','Help') as $k){
			$template->set_var('TXT_'.strtoupper($k),$Pacer->Translate($k));
		}
		$template->set_var(array(
			'BACK_URL'		=> ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'amp;section_id='.$section_id,
			'LIVE_TITLE'	=> $Pacer->Translate('Live Support Option <a href="#Disclaimer"><span>(Disclaimer)</span></a> <img src="'.ADMIN_URL.'/pacer/live_help/images/new_ico.gif" alt="" title="Live Support"/>'),
			'LIVE_CONTENT'	=> $Pacer->Translate('We are currently implementing live support within the modules created by our team. When you select the settings tab under the '.$module_name.' module you will see on of the two images as illustrated below<br>
<img src="'.ADMIN_URL.'/pacer/live_help/images/1.gif" alt="" title="Live Help"/><img src="'.ADMIN_URL.'/pacer/live_help/images/2.gif" alt="" title="Live Help"/><br>
I am pretty sure no explanation is needed for what the two images mean.'),
			'LIVE_URL'		=> '<a target="_blank" href="http://thepaceredition.com/livehelp/modules/'.$module_directory.'/help.'.LANGUAGE.'.php">http://thepaceredition.com/livehelp</a>',
			'DISCLAIMER_TITLE'	=> $Pacer->Translate('*DISCLAIMER'),
			'DISCLAIMER_CONTENT'=> $Pacer->Translate(module_disclaimer()),
			'UPDATE_TITLE'		=> $Pacer->Translate('Update Features'),
			'UPDATE_CONTENT'	=> $Pacer->Translate('This section explains the updates to '.$module_name.'.<br>
The '.$module_name.' now has the ability to determine if you are using a current updated version of '.$module_name.' only. What this feature does is when you select the settings tab within the '.$module_name.' the updater then checks to see if the version you are using is current and up to date. If their is a newer version available you will have the option to download it at that time. As illustrated below.<br>	
<h4>If the current version you are using is outdated it will show the following as an example</h4>
<img src="'.ADMIN_URL.'/pacer/pesus/images/outdated.png" alt="" title="Update Features" /><br>
<h4>If the current version you are using is up to date it will show the following as an example</h4><img src="'.ADMIN_URL.'/pacer/pesus/images/updated.png" alt="" title="Update Features" /><br>
<h3></h3>')
		));
		
		$template->set_block('main_block', 'body_list_block', 'body_list');

		foreach($help_sections as $k => $v){
			$template->set_var(array(
				'HELP_TITLE'	=> $k,
				'HELP_CONTENT'	=> $v
			));
			$template->parse('body_list', 'body_list_block', true);
		}
		
		// Parse template objects output
		$template->parse('main', 'main_block', false);
		$template->pparse('output', 'page',false, false);
	}
}
if (!function_exists('module_disclaimer')) {
	function module_disclaimer($module_directory=''){
		global $Pacer;
		$disclaimer = "THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS 
IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.<br>IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.<br>THE LIVE HELP FEATURE HAS BEEN IMPLEMENTED FOR THE SOLE PURPOSE OF LIVE SUPPORT ONLY FOR THE MODULES THIS TEAM HAS DONE.<br>WE DO NOT OFFER FREE SUPPORT TO ANY OTHER MODULE OR SUPPORT ISSUES YOU MIGHT HAVE WITHIN YOUR WEBSITE BAKER INSTALLATION.<br>IF YOU NEED SUPPORT FOR ANY OTHER REASON OTHER THEN WITHIN THIS MODULE OR MODULES THIS TEAM HAS CREATED, YOU MUST FIRST USE THE SUPPORT FORUM PROVIDED BY THE WEBSITE BAKER COMMUNITY AT NO CHARGE.<br>THOUGH WE CAN OFFER SUPPORT FOR THESE ISSUES FOR A FEE. BEFORE USING THE LIVE HELP FEATURE YOU MUST FIRST VISIT THE SUPPORT FORUM PROVIDED ABOVE.<br>IF YOU FIND YOU NEED MORE HELP YOU THEN MUST FIRST POST A REQUEST ON WEBSITE BAKER COMMUNITY SUPPORT FORUM AS LISTED ABOVE.<br>FAILURE TO FOLLOW THESE STEPS WILL ONLY JUST PROLONG YOUR SUPPORT REQUEST.<br>WE ONLY OFFER LIMITED SUPPORT AT THIS LEVEL AT NO CHARGE, BUT IF IT IS DETERMINED A NEED TO EXAMINE YOUR WEBSITE BAKER INSTALLATION AND OR MODULE INSTALLATION, CONFIGURATION, OR MODIFICATION YOU HAVE DONE MEANING THE SOURCE CODE OF THE MODULE HAS BEEN ALTERED BY YOU OR SOMEONE OTHER THEN THIS TEAMS OFFICIAL RELEASE THERE WILL BE A FEE DETERMINED AT THAT TIME AND WILL BE DUE BEFORE ANY WORK PERFORMED IS DONE.<br>WE WILL NOT BE HELD RESPONSIBLE FOR ALTERATIONS YOU OR SOMEONE YOU HAVE HAD DONE TO THIS MODULE OR MODULES THIS TEAM PRODUCES.<br>AT NO TIME WILL WE TOLERATE ANY ABUSE TO THE FEATURES WE PROVIDED WITHIN THE MODULES THIS TEAM PRODUCES. IF YOU FEEL YOU DO NOT AGREE WITH SAID DISCLAIMER THEN YOU CAN REQUEST A LIGHT VERSION THAT DOES NOT INCLUDE SAID FEATURES.";
		return $Pacer->Translate($disclaimer);
	}
}
if (!function_exists('separate_css')) {
	function separate_css($module_directory,$separate_css,$section_id,$css='frontend.css'){
		global $Pacer;
		
		$source = PE_PATH.'/modules/'.$module_directory.'/'.$css;
		if (file_exists($source)){
			$section_id = (int) $section_id;
			$frontend_css = PE_PATH.'/modules/'.$module_directory.'/css/frontend_'.$section_id.'.css'; 	
			if(!$separate_css){
				if (file_exists($frontend_css)) 
					unlink($frontend_css);
			} else {
				if (file_exists($source) && !file_exists($frontend_css)) {
					$folder = PE_PATH.'/modules/'.$module_directory.'/css';
					if (!is_dir($folder)) {
						make_dir($folder);
						$Pacer->create_empty_index_php($folder,3);
					}
					copy($source,$frontend_css);
					change_mode($frontend_css);
				}
			}
		}
	}
}
if (!function_exists('apply_preset')) {
	function apply_preset($module_directory,$preset,$section_id){
		global $Pacer;
		if (!$preset) return;
		
		require(PE_PATH.'/modules/'.$module_directory.'/info.php');
		$file=PE_PATH.'/modules/'.$module_directory.'/presets/'.$preset.'.php';
		if (!file_exists($file)) return;
		require($file);
			   
		$rows = $Pacer->database->queryAll(sprintf("SELECT * FROM %ssections WHERE module = '%s' %s",TABLE_PREFIX,$module_directory,(($section_id)?sprintf("AND section_id = '%d'",$section_id):'')));
																																	
		foreach($rows as $row){
			// update settings
			if (isset($new_settings) && is_array($new_settings) && (count($new_settings)>0)){
				update_into_table('mod_'.$module_directory.'_settings',$new_settings,array('section_id'=>$row['section_id']));
			}
			// update css
			if (isset($new_css) && ($new_css)){
				$file = PE_PATH.'/modules/'.$module_directory.'/frontend.css';
				file_put_contents($file,$new_css);
				clearstatcache();
				$separate_css = $Pacer->database->get_one(sprintf("SELECT separate_css FROM %s%s_settings WHERE section_id = '%d'",TABLE_PREFIX,$module_directory,$row['section_id']));
				separate_css($module_directory,$separate_css,$row['section_id']);
			}
			$Pacer->LogEvent(sprintf($Pacer->Translate("Module %s - Preset %s applied"),$module_name,str_replace('_',' ',$preset)));

		}
	}
}
if (!function_exists('do_apply_preset')) {
	function do_apply_preset($preset,$module_directory,$section_id,$js_back=''){
		global $Pacer;
		if ($preset) {
			apply_preset($module_directory,$preset,$section_id);
			require(PE_PATH.'/modules/'.$module_directory.'/info.php');
    		$Pacer->print_success(sprintf($Pacer->Translate("Module %s - Preset %s applied"),$module_name,str_replace('_',' ',$preset)), $js_back);
		}
	}
}
?>