<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: index.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

$starttime = array_sum(explode(" ",microtime()));

// Include config file
require_once(dirname(__FILE__).'/config.php');

// Check if the config file has been set-up
if(!defined('PE_PATH')) {
	header("Location: install/index.php");
	exit(0);
}

// Set which side are we on...
if ((!defined('FRONTEND')) && (!defined('BACKEND'))) define('FRONTEND',true);

if ((isset($_GET['pid'])) && (is_numeric($_GET['pid']))) $page_id = (int) $_GET['pid'];

// Core - Pacer
require_once(PACER_PATH .'/pacer.php');

// Change Template - Admin Console
if (array_key_exists('admin_console',$Pacer->pacer_settings) && ($Pacer->pacer_settings['admin_console'])) {
	$Pacer->Change_Template();
}

// Async Scheduled Jobs
if (array_key_exists('scheduled_jobs_async',$Pacer->pacer_settings) && ($Pacer->pacer_settings['scheduled_jobs_async']) && (isset($_POST['scheduled_jobs_async'])) ) {
	ignore_user_abort(true);
	set_time_limit(0);																																	
	require_once(PACER_PATH.'/pacer_scheduled_jobs.php');	
	new Pacer_Scheduled_Jobs();
	exit();
}

// Core - Pacer - Flood Control
if (array_key_exists('flood_control_enabled',$Pacer->pacer_settings) && $Pacer->pacer_settings['flood_control_enabled']){
	require_once(PACER_PATH.'/pacer_flood_control.php');	
	new Pacer_Flood_Control();
}
$script_scheduled_jobs='';
if ((array_key_exists('scheduled_jobs_run_on',$Pacer->pacer_settings) &&
	(($Pacer->pacer_settings['scheduled_jobs_run_on']=='1') || // frontend
    ($Pacer->pacer_settings['scheduled_jobs_run_on']=='3')))) { // or always
	require_once(PACER_PATH.'/pacer_scheduled_jobs.php');	
	
	if (array_key_exists('scheduled_jobs_async',$Pacer->pacer_settings) && ($Pacer->pacer_settings['scheduled_jobs_async'])) {
		$fc = new Pacer_Scheduled_Jobs(0,true);
		$script_scheduled_jobs=$fc->pacer_scheduled_jobs_build_ajax();
		unset($fc);
	} else {
		new Pacer_Scheduled_Jobs();
	}
}
$Pacer->GzPage_Start();
$Pacer->Cache_Start(); // If page in cache is valid, echo it and die()...

require_once(PE_PATH.'/framework/class.frontend.php');
// Create new frontend object
$wb = new frontend();

// Figure out which page to display
// Stop processing if intro page was shown
$wb->page_select() or die();

// Collect info about the currently viewed page
// and check permissions
$wb->get_page_details();

// Collect general website settings
$wb->get_website_settings();

// Load functions available to templates, modules and code sections
// also, set some aliases for backward compatibility
require(PE_PATH.'/framework/frontend.functions.php');

// Redirect if menu-link
$this_page_id = PAGE_ID;
if ($res = $Pacer->database->queryRow("SELECT s.module, s.block, l.target_page_id, l.anchor, l.extern, l.redirect_type FROM ".TABLE_PREFIX."sections as s INNER JOIN ".TABLE_PREFIX."mod_menu_link as l ON s.page_id = l.page_id WHERE s.page_id = '$this_page_id' AND s.module = 'menu_link'")) {
	$target_page_id = $res['target_page_id'];
	$r_type = (($res['redirect_type']=='301')?'301':'');
	$anchor = $res['anchor'];
	$extern = $res['extern'];
	$target = $wb->page['target'];
	if($anchor != '0') 
		$anchor = ''.$anchor;
	else 
		$anchor = FALSE;
	
	if($target_page_id == -1) {
		if($extern!='') {
			$Pacer->Redirect_To($extern.($anchor?'#'.$anchor:''),$target,$r_type);
			exit;
		}
	} else {
		// get link of target-page
		if($target_page_link=$Pacer->database->get_one("SELECT link FROM ".TABLE_PREFIX."pages WHERE page_id='$target_page_id'")) {
			$Pacer->Redirect_To($wb->page_link($target_page_link).(($anchor)?'#'.$anchor:''),$target,$r_type);
			exit;
		}
	}
}

$Pacer->Pacer_Styled_Menu_Init(array('template_name'=>TEMPLATE,'action'=>'render'));

require(PE_PATH.'/templates/'.TEMPLATE.'/index.php');

resolve_template_dependencies(TEMPLATE);

$html=ob_get_contents();
/* NOT NEEDED ANYMORE TO INCLUDE THIS INTO YOUR TEMPLATE!!!
Mailto links can be encrypted by a Javascript function. To make use of this option, one needs to add the PHP code <?php register_frontend_modfiles('js'); ? > into the <head> section of the index.php of your template. Without this modification, only the @ character in the mailto part will be replaced.
*/
if(file_exists(PE_PATH .'/modules/output_filter/filter-routines.php')) {
	// include the output filter module routines
	require_once(PE_PATH .'/modules/output_filter/filter-routines.php');	
	if(function_exists('filter_frontend_output')) {
		$filter_settings = get_output_filter_settings();
		if($filter_settings['mailto_filter'] == '1') { // inject email protection routines
			$Pacer->Code_Injection_Add('js_file',PE_URL .'/modules/output_filter/js/mdcr.js');
		}
		$html = filter_frontend_output($html);
	}
}
if (ob_get_level() && ob_get_length()) 
	ob_clean();

if (array_key_exists('page_debug',$Pacer->pacer_settings) && $Pacer->pacer_settings['page_debug']){
	require_once(PACER_PATH.'/pacer_debug.php');
	Pacer_Debug();
}
$Pacer->Print_Seo($this_page_id);
$Pacer->Pacer_Super_User_Trace($this_page_id);
$html=$Pacer->Print_Tracking_Code($html);
$Pacer->Print_Site_Activated();

$Pacer->Page_Scrollers();
$Pacer->Page_Hide_Status_Bar();
$Pacer->Page_Disable_Right_Click();

// Get error msgs
$info_area = '';
if ($wb->get_session('error')) {
	$info_area = 'jQuery.jGrowl("'.$Pacer->Translate('Error').': '.$wb->get_session('error').'", {theme:"error",header: "'.$Pacer->Translate('Error').'",sticky: false});';	
	$submission_id = ($wb->get_post('submission_id'))?$wb->get_post('submission_id'):$wb->get_get('submission_id');
	if ($submission_id) {
		foreach($_SESSION['FORM'][$submission_id]['ERRORS'] as $k => $v){
			$info_area .= '
	jQuery.jGrowl("'.$v.'", {theme:"error",header: "'.$k.'",sticky: false});';
		}
	}
} elseif ($wb->get_session('success')) {
	$info_area = 'jQuery.jGrowl("'.$wb->get_session('success').'", {theme:"success",header: "'.$Pacer->Translate('Success').'",sticky: false});';
}
if ($info_area) {
	$Pacer->Code_Injection_Add('js_file','jquery.js');
	$Pacer->Code_Injection_Add('js_file','jquery.jgrowl.js');
	$Pacer->Code_Injection_Add('css_file','jquery.jgrowl.css');
	$Pacer->Code_Injection_Add('css_file',THEME_URL.'/css/jquery.jgrowl.css');
	$Pacer->Code_Injection_Add('js_script','
jQuery(document).ready(function() {
	'.$info_area.'
});
');
}
unset($_SESSION['error']);
unset($_SESSION['success']);

if ($script_scheduled_jobs)
	$Pacer->Code_Injection_Add('js_script','jQuery(document).ready(function() {'.$script_scheduled_jobs.'});');

// Session Control
if (array_key_exists('session_lifetime',$Pacer->pacer_settings) && ($Pacer->pacer_settings['session_lifetime'])) {
	require_once(PACER_PATH.'/pacer_session_control.php');
	$sc = new Pacer_Session_Control();
	$sc->Pacer_Session_Control_Check();
	unset($sc);
}

//$html = $Pacer->Code_Injection($html);
if (array_key_exists('admin_console',$Pacer->pacer_settings) && $Pacer->pacer_settings['admin_console']){
	require_once(PACER_PATH.'/pacer_admin_console.php');
	$Pac = new Pacer_Admin_Console($html);
	$html = $Pacer->Code_Injection($html);
	$Pac->Pacer_Admin_Edit_Update_Files();
	unset($Pac);
} else {
	$html = $Pacer->Code_Injection($html);
}
echo $html;

$Pacer->Cache_Finish(); 
$Pacer->Print_Page_Generated('no-cache');
$Pacer->Tidy();
$Pacer->GzPage_Finish();
?>