<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : Form_PE                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : modify.php                                                 *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************

*/

// prevent this file from being accessed directly
if (!defined('PE_PATH')) die(header('Location: ../../index.php'));

// obtain module directory
$mod_dir = basename(dirname(__FILE__));
require(PE_PATH.'/modules/'.$mod_dir.'/info.php');
// include module.functions.php (introduced with PE 2.7)
require_once(PE_PATH . '/framework/module.functions.php');

// include the module language file depending on the backend language of the current user
if (!@include(get_module_language_file($mod_dir))) return;

// include module backend.css file in <body> (only for PE < 2.6.7)
//include_module_css($mod_dir, 'backend.css');

//Delete all form fields with no title
$database->query("DELETE FROM `".TABLE_PREFIX."mod_Form_PE_fields`  WHERE `page_id` = '$page_id' and `section_id` = '$section_id' and `title` = '';");

// include template parser class and set template
require_once(PE_PATH . '/include/phplib/template.inc');
$tpl = new Template(dirname(__FILE__) . '/htt/');
$tpl->set_file('page', 'backend_template_modify.htt');
$tpl->set_block('page', 'main_block', 'main');

// ensure that page and section id are numeric
$page_id = (isset($page_id)) ? (int) $page_id : '';
$section_id = (isset($section_id)) ? (int) $section_id : '';
/*
if (isset($_GET['error'])) {
	$info_area = '<div id="info_area" class="error_page">'.$_GET['error'].'</div>';
} elseif (isset($_GET['success'])) {
	$info_area = '<div id="info_area" class="success_page">'.$_GET['success'].'</div>';
} else $info_area = '';
*/
/*
if(file_exists(PE_PATH .'/pacer/pacer.php')) {
	require_once(PE_PATH .'/pacer/pacer.php');
	$Pacer->print_header();
}

$info_area = '';
if (isset($_GET['error'])) {
$info_area = '<script type="text/javascript">
$(document).ready(function() {
	$.jGrowl("<p></p>'.$Pacer->Translate('Error').': '.$_GET['error'].'", {theme:"error",header: "'.$Pacer->Translate('Error').'",sticky: false});	
});
</script>';	
} elseif (isset($_GET['success'])) {
$info_area = '<script type="text/javascript">
$(document).ready(function() {
	$.jGrowl("<p></p>'.$_GET['success'].'", {theme:"success",header: "'.$Pacer->Translate('Success').'",sticky: false});	
});
</script>';	
}
*/
$tpl->set_var(
	array(
		// variables from Website Baker framework
//		'EDIT_MODULE_CSS'					=> function_exists('edit_module_css') ? edit_module_css($mod_dir) : '',
		'PAGE_ID'							=> (int) $page_id,
		'SECTION_ID'						=> (int) $section_id,
		'ADMIN_URL'							=> ADMIN_URL,
		'PE_URL'							=> PE_URL,
		'THEME_URL'							=> THEME_URL,

		'LANGUAGE'							=> ((file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/' . LANGUAGE .'.php')) ? LANGUAGE : 'EN'),
		'HELP_LANGUAGE'						=> ((file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/help.' . LANGUAGE .'.php')) ? LANGUAGE : 'EN'),

		'INFO_AREA'							=> (isset($info_area)) ? $info_area :'',

		// variables from global PE language files
		'TXT_SAVE'							=> $TEXT['SAVE'],
		'TXT_CANCEL'						=> $TEXT['CANCEL'],

		// variables from module language file
		'TXT_HEADING'						=> $module_name,
		'MODULE_DIR'                        => $mod_dir,

		'TXT_FIELDS'						=> $TEXT['FIELD'],
		'TXT_SETTINGS'						=> $TEXT['SETTINGS'],
		'TXT_HELP'							=> $MENU['HELP'],
//		'HELP_ONCLICK'						=> 'onsubmit="javascript:Shadowbox.open({player: \'iframe\', title: \''.$MENU['HELP'].'\',  content: \''. PE_URL.'/modules/'.$mod_dir.'/languages/help.'.((file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/help.' . LANGUAGE .'.php')) ? LANGUAGE : 'EN').'.php?page_id='.(int) $page_id.'\'});return false; "',
        

		// module settings
  		'MOD_CANCEL_URL'					=> ADMIN_URL
	)
);
// make sure or field order...
// Include the ordering class
require(PE_PATH.'/framework/class.order.php');
// Create new order object an reorder
$order = new order(TABLE_PREFIX.'mod_Form_PE_fields', 'position', 'field_id', 'section_id');
$order->clean($section_id);
require(PE_PATH.'/modules/'.$mod_dir.'/functions.php');
$tpl->set_var(
	array(
		// variables from Website Baker framework
//		'EDIT_MODULE_CSS'					=> function_exists('edit_module_css') ? edit_module_css($mod_dir) : '',
		'PAGE_ID'							=> (int) $page_id,
		'SECTION_ID'						=> (int) $section_id,
		'ADMIN_URL'							=> ADMIN_URL,
		'MODULE_URL'                        => PE_URL.'/modules/'.$mod_dir,
		'PE_URL'							=> PE_URL,
		'LANGUAGE'							=> ((file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/' . LANGUAGE .'.php')) ? LANGUAGE : 'EN'),
		// variables from module language file
		'TEXT_HEADING_F'					=> $TEXT['MODIFY'].'/'.$TEXT['DELETE'].' '.$TEXT['FIELD'] ,
		'TEXT_HEADING_S'					=> $TEXT['SUBMISSIONS'],
		'TABLE_ID'							=> 'table_'.$section_id
	)
);

$tpl->set_block('main_block', 'field_block' , 'field_loop');
// Loop through existing fields
$query_fields = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_Form_PE_fields` WHERE section_id = '$section_id' ORDER BY position ASC");
if($query_fields->numRows() > 0) {
	$num_fields = $query_fields->numRows();
	$pos = 0;
	$row = 'row_a';
	while($field = $query_fields->fetchRow()) {
		$pos++;		

		switch ($field['type']){
			case 'textfield':
				$rt = $TEXT['SHORT_TEXT'];
				break;
			case 'textarea':
				$rt = $TEXT['LONG_TEXT'];
				break;
			case 'heading':
				$rt = $TEXT['HEADING'];
				break;
			case 'step':
				$rt = $MOD_FORM['FORM_STEP'];
				break;
			case 'select':
				$rt = $TEXT['SELECT_BOX'];
				break;
			case 'checkbox':
				$rt = $TEXT['CHECKBOX_GROUP'];
				break;
			case 'radio':
				$rt = $TEXT['RADIO_BUTTON_GROUP'];
				break;
			case 'filename':
				$rt = $TEXT['UPLOAD'].' '. $TEXT['FILE'];
				break;
			case 'date';
				$rt =  $TEXT['DATE'];
				break;
			case 'email':
				$rt = $TEXT['EMAIL_ADDRESS'];
				break;
			default:
				 $rt = '';
		}
		$multiselect_field='';
		if ($field['type'] == 'select') {
			$field['extra'] = explode(',',$field['extra']);
			$multiselect_field=''.(($field['extra'][1] == 'multiple') ? $TEXT['YES'] : $TEXT['NO']);
		}
		if ($field['type'] != 'group_begin') {
			$required_field = ''.(($field['required'] == 1) ? $TEXT['YES'] : $TEXT['NO']);
		}
		
		$tpl->set_var(
			array(
		// variables from Website Baker framework
//		'EDIT_MODULE_CSS'					=> function_exists('edit_module_css') ? edit_module_css($mod_dir) : '',
		'PAGE_ID'							=> (int) $page_id,
		'SECTION_ID'						=> (int) $section_id,
		'FIELD_ID'						    => $field['field_id'],
		'ADMIN_URL'							=> ADMIN_URL,
		'MODULE_URL'                        => PE_URL.'/modules/'.$mod_dir,
		'PE_URL'							=> PE_URL,
		'LANGUAGE'							=> ((file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/' . LANGUAGE .'.php')) ? LANGUAGE : 'EN'),

		// variables from global PE language files
		'TEXT_MODIFY'						=> $TEXT['MODIFY'],
		'TEXT_DELETE'						=> $TEXT['DELETE'],
		'TEXT_ARE_YOU_SURE'                 => $TEXT['ARE_YOU_SURE'],
		'TEXT_TYPE'						    => $TEXT['TYPE'],
		'TEXT_FIELD'					    => $TEXT['FIELD'],
		'TEXT_MULTISELECT'                  =>  $TEXT['MULTISELECT'], //(($field['type'] == 'select') ? $TEXT['MULTISELECT'] : ''),
		'TEXT_REQUIRED'                     => $TEXT['REQUIRED'], //(($field['type'] != 'group_begin') ? $TEXT['REQUIRED'] : ''),
		'TEXT_MOVE_UP'                      => $TEXT['MOVE_UP'],
		'TEXT_MOVE_DOWN'                    => $TEXT['MOVE_DOWN'],
		'MUVE_UP_STYLE'                     => (($pos != 1) ? '' : 'style="display:none"'),
		'MUVE_DOWN_STYLE'                   => (($pos != $num_fields) ? '' : 'style="display:none"'),
		'ROW_CLASS'                         => $row,
		'ROW_ID'	                        => $field['field_id'],

	    'field_field_title'                 => $field['title'],
		'field_title'                       => $field['title'],
		'type_field'                        => $rt,
		'required_field'                    => $required_field,		
		'multiselect_field'                 => $multiselect_field,
		
		// module settings
  		'MOD_CANCEL_URL'					=> ADMIN_URL
			)
		);
		$tpl->parse('field_loop', 'field_block', true);
	}
} else {
	$tpl->set_var('field_loop',$TEXT['NONE_FOUND']);
}

$tpl->set_block('main_block', 'submission_block' , 'submission_loop');
/*****************************************************************************************************************
?>

<h2><?php echo $TEXT['MODIFY'].'/'.$TEXT['DELETE'].' '.$TEXT['FIELD']; ?></h2>
<?php

// Loop through existing fields
$query_fields = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_Form_PE_fields` WHERE section_id = '$section_id' ORDER BY position ASC");
if($query_fields->numRows() > 0) {
	$num_fields = $query_fields->numRows();
	$pos = 0;
	$row = 'row_a';
	?>
	<div>
    <ul id="p0">
	<?php
	while($field = $query_fields->fetchRow()) {
		$pos++;		
		?>
        <li id="p0" style="margin-bottom:1px;">
       	<table cellpadding="2" cellspacing="0" border="0" width="100%">
		<tr class="<?php echo "row_a"; //$row; ?>" height="20" onmouseover="this.style.backgroundColor = '#F1F8DD'" onmouseout="this.style.backgroundColor = '#ECF3F7'" style="border:white solid 2px;">
			<td width="20" style="padding-left: 5px;>
				<a href="<?php echo PE_URL; ?>/modules/Form_PE/modify_field.php?page_id=<?php echo $page_id; ?>&section_id=<?php echo $section_id; ?>&field_id=<?php echo $field['field_id']; ?>" title="<?php echo $TEXT['MODIFY']; ?>">
					<img src="<?php echo ADMIN_URL; ?>/images/modify_16.png" border="0" alt="^" />
				</a>
			</td>		
			<td>
				<a href="<?php echo PE_URL; ?>/modules/Form_PE/modify_field.php?page_id=<?php echo $page_id; ?>&section_id=<?php echo $section_id; ?>&field_id=<?php echo $field['field_id']; ?>">
					<?php echo $field['title']; ?>
				</a>
			</td>
			<td width="175">
				<?php
				echo $TEXT['TYPE'].':';
				if($field['type'] == 'textfield') {
					echo $TEXT['SHORT_TEXT'];
				} elseif($field['type'] == 'textarea') {
					echo $TEXT['LONG_TEXT'];
				} elseif($field['type'] == 'heading') {
					echo $TEXT['HEADING'];
				} elseif($field['type'] == 'select') {
					echo $TEXT['SELECT_BOX'];
				} elseif($field['type'] == 'checkbox') {
					echo $TEXT['CHECKBOX_GROUP'];
				} elseif($field['type'] == 'radio') {
					echo $TEXT['RADIO_BUTTON_GROUP'];
				} elseif($field['type'] == 'filename') {
					echo "Upload File";
				} elseif($field['type'] == 'date') {
					echo "Date";
				} elseif($field['type'] == 'email') {
					echo $TEXT['EMAIL_ADDRESS'];
				}
				?>
			</td>
			<td width="95">		
			<?php 
			if ($field['type'] != 'group_begin') {
				echo $TEXT['REQUIRED'].': '; if($field['required'] == 1) { echo $TEXT['YES']; } else { echo $TEXT['NO']; }
			}
			?>
			</td>
			<td width="110">
			<?php
			if ($field['type'] == 'select') {
				$field['extra'] = explode(',',$field['extra']);
				echo $TEXT['MULTISELECT'].': '; if($field['extra'][1] == 'multiple') { echo $TEXT['YES']; } else { echo $TEXT['NO']; }
			}
			?>
			</td>
			<td width="20">
			<?php if($pos != 1) { ?>
				<a href="<?php echo PE_URL; ?>/modules/Form_PE/move_to.php?page_id=<?php echo $page_id; ?>&section_id=<?php echo $section_id; ?>&field_id=<?php echo $field['field_id']; ?>&where=up" title="<?php echo $TEXT['MOVE_UP']; ?>">
					<img src="<?php echo ADMIN_URL; ?>/images/up_16.png" border="0" alt="^" />
				</a>
			<?php } ?>
			</td>
			<td width="20">
			<?php if($pos != $num_fields) { ?>
				<a href="<?php echo PE_URL; ?>/modules/Form_PE/move_to.php?page_id=<?php echo $page_id; ?>&section_id=<?php echo $section_id; ?>&field_id=<?php echo $field['field_id']; ?>&where=down" title="<?php echo $TEXT['MOVE_DOWN']; ?>">
					<img src="<?php echo ADMIN_URL; ?>/images/down_16.png" border="0" alt="v" />
				</a>
			<?php } ?>
			</td>
			<td width="20">
				<a href="javascript: confirm_link('<?php echo $TEXT['ARE_YOU_SURE']; ?>', '<?php echo PE_URL; ?>/modules/Form_PE/delete_field.php?page_id=<?php echo $page_id; ?>&section_id=<?php echo $section_id; ?>&field_id=<?php echo $field['field_id']; ?>');" title="<?php echo $TEXT['DELETE']; ?>">
					<img src="<?php echo ADMIN_URL; ?>/images/delete_16.png" border="0" alt="X" />
				</a>
			</td>
		</tr>
<!--
        <tr><td collspan="8" style="border:0; margin:0; padding:0; height:1px; background-color: white;"></td></tr>
-->
		<?php
		// Alternate row color
		if($row == 'row_a') {
			$row = 'row_b';
		} else {
			$row = 'row_a';
		}
?>
		</table>
        </li>
<?php
	}
	?>
    </ul>
	<?php
} else {
	echo $TEXT['NONE_FOUND'];
}
*****************************************************************************************************************/
// Query submissions table
$query_submissions = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_Form_PE_submissions` WHERE section_id = '$section_id' ORDER BY submitted_when ASC");
if($query_submissions->numRows() > 0) {
	// List submissions
	$row = 'row_a';
	while($submission = $query_submissions->fetchRow()) {
		$tpl->set_var(
			array(
		// variables from Website Baker framework
//		'EDIT_MODULE_CSS'					=> function_exists('edit_module_css') ? edit_module_css($mod_dir) : '',
		'PAGE_ID'							=> (int) $page_id,
		'SECTION_ID'						=> (int) $section_id,
		'SUBMISSION_ID'					    => $submission['submission_id'],
		'ADMIN_URL'							=> ADMIN_URL,
		'MODULE_URL'                        => PE_URL.'/modules/'.$mod_dir,
		'PE_URL'							=> PE_URL,
		'LANGUAGE'							=> ((file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/' . LANGUAGE .'.php')) ? LANGUAGE : 'EN'),

		// variables from global PE language files
		'TEXT_DELETE'						=> $TEXT['DELETE'],
		'TEXT_SUBMISSION_ID'			    => $TEXT['SUBMISSION_ID'],
		'TEXT_SUBMITTED'			        => $TEXT['SUBMITTED'],
		'TEXT_OPEN'                         => $TEXT['OPEN'],
		'TEXT_ARE_YOU_SURE'                 => $TEXT['ARE_YOU_SURE'],
		'ROW_CLASS'                         => $row,

	    'field_submission_id'               => $submission['submission_id'],
		'field_submission_when'             => gmdate(TIME_FORMAT.', '.DATE_FORMAT, $submission['submitted_when']+TIMEZONE),
		
		// module settings
  		'MOD_CANCEL_URL'					=> ADMIN_URL
			)
		);
		// Alternate row color
		if($row == 'row_a') {
			$row = 'row_b';
		} else {
			$row = 'row_a';
		}
		$tpl->parse('submission_loop', 'submission_block', true);
	}
} else {
	$tpl->set_var('submission_loop','<tr><td>'.$TEXT['NONE_FOUND'].'</td></tr>');
}
// Parse template objects output
$tpl->parse('main', 'main_block', false);
$tpl->pparse('output', 'page',false, false);

//insert_drag_drop(5);
/*
//if($info_area) {
	$Pacer->Code_Injection_Add('js_file','jquery.js');			
	$Pacer->Code_Injection_Add('js_file','jquery.jgrowl.js');			
	$Pacer->Code_Injection_Add('js_file','jquery.tablednd.js');
	$Pacer->Code_Injection_Add('js_file','jquery.blockUI.js');

	$Pacer->Code_Injection_Add('css_file','jquery.jgrowl.css');
	$Pacer->Code_Injection_Add('js_file','jquery.alerts.js');			
	$Pacer->Code_Injection_Add('css_file','jquery.alerts.css');	
*/
/*
	$Pacer->Code_Injection_Add('js_script','
	Shadowbox.init({
		language:   "'.strtolower(((file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/' . LANGUAGE .'.php')) ? LANGUAGE : 'EN')).'", 
		skipSetup: true,
		title: "SharmWomen - Home",
		players: ["iframe","img"],
		adapter: "jquery"
	});
');

	$Pacer->Code_Injection_Add('js_file',PE_URL.'/pacer/shadowbox-build-3.0b/shadowbox.js');
	$Pacer->Code_Injection_Add('css_file',PE_URL.'/pacer/shadowbox-build-3.0b/shadowbox.css');
*/

	$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
var prevRows = {};
$(\'#table_'.$section_id.'\').tableDnD({
	onDragStart: function(table, row) {
   		for (var i=0; i<table.tBodies[0].rows.length;i++) {
			prevRows[i] = table.tBodies[0].rows[i].id;
		}
	},
	onDrop: function(table, row) {
   		for (var i=0; i<table.tBodies[0].rows.length;i++) {
			if (table.tBodies[0].rows[i].id == row.id) {
				if(row.id!=prevRows[i]) {
					$.get("'.PE_URL.'/modules/'.$mod_dir.'/move_to.php", { page_id : '.$page_id.', section_id : '.$section_id.', field_id : row.id, position : i } );
				}
				return true;
			}
		}
		return false;
   	}
});
$(\'#table_'.$section_id.' tr\').hover(function() {
	if ($(this.cells[0]).hasClass(\'table_dnd_td\')) {
		$(this.cells[0]).addClass(\'showDragHandle\');
		$(this).css({\'background-color\' : \'#F1F8DD\'});
	}
}, function() {
	if ($(this.cells[0]).hasClass(\'table_dnd_td\')) {
		$(this.cells[0]).removeClass(\'showDragHandle\');
		$(this).css({\'background-color\' : \'#ECF3F7\'});
	}
});
});
');
/*
	$Pacer->Code_Injection_Replace('js_code','/function confirm_link/i','','function _not_used_');
	$Pacer->Code_Injection_Add('js_script','
function confirm_link(message, url, cmd) {
	jConfirm(message, "'.$Pacer->Translate('Confirmation needed').'", function(r) {
		if(r) { 
			if (url) { 
				self.location.href = url; 
			} else { 
				if (cmd) eval(cmd); 
			} 
		}
	});
}'
);
*/
	$Pacer->Code_Injection_Add('css_script','
table.table_dnd {
	background-color:#ECF3F7;

}
td.table_dnd_td {
	border-bottom:solid 3px white;
	padding:4px;

}
td.whileDrag {
	background-color: #eee;
}
.showDragHandle {
	background-image: url('.THEME_URL.'/images/pacer/updown2.gif);
	background-repeat: no-repeat;
	background-position: center center;
	cursor: move;
}
tr.setting_table_header, td.setting_table_header {
	background-color:#2B7C98;
	color:white;
	font-size:11px;
	padding:2px;
	text-align:left;
}
');

//}
?>