<?php
/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : Form_PE                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : modify_settings.php                                        *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************

*/

// manually include the config.php file (defines the required constants)
require('../../config.php');
require(PE_PATH.'/modules/admin.php');

// prevent this file from being accessed directly
if (!defined('PE_PATH')) die(header('Location: ../../index.php'));

// obtain module directory
$mod_dir = basename(dirname(__FILE__));

// include module.functions.php (introduced with PE 2.7)
require_once(PE_PATH . '/framework/module.functions.php');
// unset page/section IDs defined via GET before including the admin file (we expect POST here)
unset($_GET['page_id']);
unset($_GET['section_id']);
// convert page/section id to numbers (already checked by /modules/admin.php but kept for consistency)
$page_id = (isset($_POST['page_id'])) ? (int) $_POST['page_id'] : '';
$section_id = (isset($_POST['section_id'])) ? (int) $_POST['section_id'] : '';

// include the module language file depending on the backend language of the current user
if (!@include(get_module_language_file($mod_dir))) return;

// 2nd level...
//require_once(PE_PATH.'/framework/class.admin.php');
//$admin = new admin('Pages', 'pages_modify',false);

//START HEADER HERE
// include the module language file depending on the backend language of the current user
if (!@include(get_module_language_file($mod_dir))) return;

//START HEADER HERE
require_once(PE_PATH.'/modules/'.$mod_dir.'/functions.php');
module_header_footer($page_id,$mod_dir);
//END HEADER HERE

// include module backend.css file in <body> (only for PE < 2.6.7)
#include_module_css($mod_dir, 'backend.css');

// Get header and footer
$query_content = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_Form_PE_settings` WHERE `section_id` = '$section_id'");
$setting = $query_content->fetchRow();

// Set raw html <'s and >'s to be replace by friendly html code
$raw = array('<', '>');
$friendly = array('&lt;', '&gt;');
?>
<?php
// include template parser class and set template
require_once(PE_PATH . '/include/phplib/template.inc');
$tpl = new Template(dirname(__FILE__) . '/htt/');
$tpl->set_file('page', 'backend_template_settings.htt');
$tpl->set_block('page', 'main_block', 'main');

// obtain display option from the database table
$table = TABLE_PREFIX . 'mod_Form_PE_settings';
$sql = "SELECT * FROM `$table`
	WHERE `section_id` = '$section_id'";
$sql_result = $database->query($sql);
$settings = $sql_result->fetchRow();

$email_from_value = str_replace($raw, $friendly, ($setting['email_from']));
$email_fromname_value = str_replace($raw, $friendly, ($setting['email_fromname']));
if (function_exists('edit_module_css')){
	ob_start();
	edit_module_css($mod_dir);
	$edit_module_css = ob_get_contents();
	ob_end_clean();
} else $edit_module_css = '';

// replace static template placeholders with values from language file
$tpl->set_var(
	array(
		// variables from Website Baker framework
		'EDIT_MODULE_CSS'					=> $edit_module_css,
		'PAGE_ID'							=> (int) $page_id,
		'SECTION_ID'						=> (int) $section_id,
		'ADMIN_URL'							=> ADMIN_URL,
		'PE_URL'							=> PE_URL,
		'THEME_URL'							=> THEME_URL,

		// variables from global PE language files
		'TXT_SAVE'							=> $TEXT['SAVE'],
		'TXT_CANCEL'						=> $TEXT['CANCEL'],

		// variables from module language file
		'TXT_BASIC_SETTINGS'				=> $HEADING['GENERAL_SETTINGS'],
		'MODULE_NAME'						=> $module_name,

		'use_captcha'                       => $settings['use_captcha'],
		'des_use_captcha'                   => '',
		'txt_use_captcha'                   => $TEXT['CAPTCHA_VERIFICATION'],
		'use_captcha_true_checked'			=> (($settings['use_captcha']==true) ? 'checked' : ''),
		'use_captcha_false_checked'			=>(($settings['use_captcha']==true) ? '' : 'checked'),
		'max_submissions'                   => $settings['max_submissions'],
		'des_max_submissions'               => '',
		'txt_max_submissions'               => $TEXT['MAX_SUBMISSIONS_PER_HOUR'],
		'stored_submissions'                => $settings['stored_submissions'],
		'des_stored_submissions'            => '',
		'txt_stored_submissions'            => $TEXT['SUBMISSIONS_STORED_IN_DATABASE'],
		'header'                            => str_replace(array("{","}"),array("[","]"),$settings['header']),
		'des_header'                        => '',
		'txt_header'                        => $TEXT['HEADER'],
		'field_loop'                      	=> str_replace(array("{","}"),array("[","]"),$settings['field_loop']),
		'des_field_loop'                    => '',
		'txt_field_loop'                    => $TEXT['FIELD'].' '.$TEXT['LOOP'],
		'footer'                            => str_replace(array("{","}"),array("[","]"),$settings['footer']),
		'des_footer'                        => '',
		'txt_footer'                        => $TEXT['FOOTER'],
		'upload_files_folder'               => $settings['upload_files_folder'],
		'des_upload_files_folder'           => '',
		'txt_upload_files_folder'           => $MOD_FORM['UPLOAD_FILE_FOLDER'],
		'MEDIA_DIRECTORY'                   => PE_PATH . MEDIA_DIRECTORY,
		'date_format'                      	=> $settings['date_format'],
		'des_date_format'  	                => '',
		'DATE_FORMAT_SETTINGS'              => $MOD_FORM['DATE_FORMAT_SETTINGS'],

		'txt_date_format' 	                => $MOD_FORM['DATE_FORMAT'],
		'FILE_UPLOAD_SETTINGS'				=> $MOD_FORM['FILE_UPLOAD_SETTINGS'],
		'attach_file'                       => $settings['attach_file'],
		'des_attach_file'                   => '',
		'txt_attach_file'                   => $MOD_FORM['ATTACH_FILE'],
		'attach_file_true_checked'			=> (($settings['attach_file']==true) ? 'checked' : ''),
		'attach_file_false_checked'			=>(($settings['attach_file']==true) ? '' : 'checked'),
		'max_file_size_kb'                  => $settings['max_file_size_kb'],
		'des_max_file_size_kb'     	        => '',
		'txt_max_file_size_kb' 	            => $MOD_FORM['MAX_FILE_SIZE_KB'],
		'upload_only_exts'             		=> $settings['upload_only_exts'],
		'des_upload_only_exts'      		=> '',
		'txt_upload_only_exts'		        => $MOD_FORM['UPLOAD_ONLY_EXTS'],
		'upload_file_chmode'                => $settings['upload_file_chmode'],
		'des_upload_file_chmode'            => '',
		'txt_upload_file_chmode'          	=> $MOD_FORM['UPLOAD_FILE_CHMODE'],
		
		'EMAIL_SETTINGS'					=> $TEXT['EMAIL'].' '.$TEXT['SETTINGS'],
		'email_to'                          => $settings['email_to'],
		'des_email_to'     	                => '',
		'txt_email_to' 	                    => $TEXT['EMAIL'].' '.$TEXT['TO'],
		
		'CUSTOM'						 	=> $TEXT['CUSTOM'],
		
		'email_from' 		                => ((substr($settings['email_from'], 0, 5) != 'field') ? $settings['email_from'] : ''),
		'des_email_from_field'     	        => '',
		'txt_email_from_field' 	            => $TEXT['EMAIL'].' '.$TEXT['FROM'],

		'email_fromname'	              	=> ((substr($settings['email_fromname'], 0, 5) != 'field') ? $settings['email_fromname'] : ''),
		'des_email_fromname_field'          => '',
		'txt_email_fromname_field' 	        => $TEXT['EMAIL'].' '.$TEXT['NAME'],

		'email_fromname'                    => $settings['email_fromname'],
		'des_email_fromname'                => '',

		'email_subject'             		=> $settings['email_subject'],
		'des_email_subject'         		=> '',
		'txt_email_subject'         		=> $TEXT['EMAIL'].' '.$TEXT['SUBJECT'],

		'SUCCESS_SETTINGS'					=> $TEXT['SUCCESS'].' '.$TEXT['SETTINGS'],

		'success_email_to'                  => $settings['success_email_to'],
		'des_success_email_to'  	   	    => '',
		'txt_success_email_to'	 	        => $TEXT['EMAIL'].' '.$TEXT['TO'],
		'success_email_from'                => $settings['success_email_from'],
		'des_success_email_from'     	    => '',
		'txt_success_email_from' 	        => $TEXT['EMAIL'].' '.$TEXT['FROM'],
		'success_email_fromname'            => $settings['success_email_fromname'],
		'des_success_email_fromname'  	    => '',
		'txt_success_email_fromname'        => $TEXT['EMAIL'].' '.$TEXT['NAME'],
		'success_email_subject'         	=> $settings['success_email_subject'],
		'des_success_email_subject'     	=> '',
		'txt_success_email_subject'     	=> $TEXT['EMAIL'].' '.$TEXT['SUBJECT'],
		'success_email_text'             	=> $settings['success_email_text'],
		'des_success_email_text'         	=> '',
		'txt_success_email_text'         	=> $TEXT['EMAIL'].' '.$TEXT['TEXT'],
		'txt_success_page'                  => $TEXT['SUCCESS'].' '.$TEXT['PAGE'],
		'NONE'								=> $TEXT['NONE'],

		'TXT_ENABLED'						=> $TEXT['ENABLED'],
		'TXT_DISABLED'						=> $TEXT['DISABLED'],

		// module settings
		'MOD_SAVE_URL'						=> PE_URL. str_replace("\\","/",substr(dirname(__FILE__),strlen(PE_PATH))).'/save_settings.php',
		'MOD_CANCEL_URL'					=> PE_URL.'/admin/pages/modify.php?page_id='.$page_id
	)
);

function give_me_elist($email_value,$java=true,$fname = '',$type='email'){
	global $database, $section_id, $TEXT, $tpl;
	$tpl->set_block('main_block', $fname.'_block' , $fname);
	$rt = false;
	$s = '';
	$query_email_fields = $database->query("SELECT `field_id`,`title` FROM `".TABLE_PREFIX."mod_Form_PE_fields` WHERE `section_id` = '$section_id' AND ( `type` = '$type' ) ORDER BY `position` ASC");
	if($query_email_fields->numRows() > 0) {
		while($field = $query_email_fields->fetchRow()) {
			$s = "<option value=\"field".$field['field_id']."\"";
			if($email_value == 'field'.$field['field_id']) {
				$s .= " selected";
				$rt = true;
			}
			if ($java) $s .= " onclick=\"javascript: document.getElementById('". $fname."').style.display = 'none';\"";
			$s .= ">".$TEXT['FIELD'].': '.$field['title']. "</option>";
			$tpl->set_var('options_'.$fname, $s);
      		$tpl->parse($fname, $fname.'_block', true);
		}
	}
	return $rt;
}

function give_me_plist($page,$fname){
	global $database, $admin, $tpl;
	$tpl->set_block('main_block', $fname.'_block' , $fname);
	// Get exisiting pages and show the pagenames
	$query = $database->query("SELECT * FROM `".TABLE_PREFIX."pages` WHERE `visibility` <> 'deleted'");
	while($mail_page = $query->fetchRow()) {
		if(!$admin->page_is_visible($mail_page)) continue;
		$mail_pagename = $mail_page['menu_title'];
		$success_page = $mail_page['page_id'];
		//$rt .= $success_page.':'.$success_page.':';
		if($page == $success_page) {
			$selected = ' selected';
		} else {
			$selected = '';
		}
		$s = '<option value="'.$success_page.'"'.$selected.'>'.$mail_pagename.'</option>';
		$tpl->set_var('options_'.$fname, $s);
  		$tpl->parse($fname, $fname.'_block', true);
	}
}

$rt1 = give_me_elist($email_from_value,true,'email_from_f','email');

$rt2 = give_me_elist($email_fromname_value,true,'email_fromname_f','textfield');

give_me_elist($settings['success_email_to'],false,'success_email_to','email');

give_me_plist($settings['success_page'],'success_page');

$tpl->set_var('display_email_from_field', (($rt1) ? 'none' : 'block'));
$tpl->set_var('display_email_fromname_field', (($rt2) ? 'none' : 'block'));

// Parse template objects output
$tpl->parse('main', 'main_block', false);
$tpl->pparse('output', 'page',false, false);
?>
<?php

	$Pacer->Code_Injection_Add('js_file','accordion.js');
	//$Pacer->Code_Injection_Add('js_file','jquery.textarea.autoResize.js');
	$Pacer->Code_Injection_Add('css_file',THEME_URL.'/css/accordion.css');
/*
	$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	$("#accordion").accordion({
		speed: "low", // @param : low, medium, fast
		defautContent: 0 // @param : number
	});
});
');
*/
/*
	$Pacer->Code_Injection_Add('js_script','
$(document).ready(function(){ 
	$(\'textarea\').autoResize({
   		onResize : function() {
        	$(this).css({opacity:0.8});
    	},
    	animateCallback : function() {
        	$(this).css({opacity:1});
    	},
    	animateDuration : 300,
    	extraSpace : 40
	});
});
');
*/
?>
<?php
// 2nd level...
// Print admin footer
$Pacer->print_footer();
// 2nd level...end
?>