<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : Form_PE                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : save_field.php                                             *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************

*/

require('../../config.php');

// Get id
if(!isset($_POST['field_id']) OR !is_numeric($_POST['field_id'])) {
	header("Location: ".ADMIN_URL."/pages/index.php");
	exit(0);
} else {
	$field_id = (int) $_POST['field_id'];
}

require_once(PE_PATH .'/pacer/pacer.php');

// Include PE admin wrapper script
$update_when_modified = true; // Tells script to update when this page was last updated
require(PE_PATH.'/modules/admin.php');

// Validate all fields
if($admin->get_post('title') == '' OR $admin->get_post('type') == '') {
	$Pacer->print_error($MESSAGE['GENERIC']['FILL_IN_ALL'], PE_URL.'/modules/Form_PE/modify_field.php?page_id='.$page_id.'&section_id='.$section_id.'&field_id='.$field_id);
} else {
	$title = $admin->add_slashes($admin->get_post('title'));
	$type = $admin->get_post('type');
	$required = $admin->get_post('required');
	$help =  $admin->add_slashes($admin->get_post('help'));
	$mail_qualifier =  $admin->add_slashes($admin->get_post('mail_qualifier'));
	$field_style =  $admin->add_slashes($admin->get_post('field_style'));
}

// Update row
$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET title = '$title', type = '$type', required = '$required', help = '$help', mail_qualifier = '$mail_qualifier', field_style = '$field_style' WHERE field_id = '$field_id'");
if($Pacer->database->is_error()) {
	$Pacer->print_error($database->get_error());
}
// If field type has multiple options, get all values and implode them
$list_count = $admin->get_post('list_count');
if(is_numeric($list_count)) {
	$values = array();
	for($i = 1; $i <= $list_count; $i++) {
		if($admin->get_post('value'.$i) != '') {
			$values[] = str_replace(",","&#44;",$admin->get_post('value'.$i));
		}
	}
	$value = implode(',', $values);
}
// Get extra fields for field-type-specific settings
if($admin->get_post('type') == 'textfield') {
	$length = $admin->get_post_escaped('length');
	$value = $admin->get_post_escaped('value');
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '$value', extra = '$length' WHERE field_id = '$field_id'");
} elseif($admin->get_post('type') == 'step') {
	$value = $title;
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '$value', extra = '' WHERE field_id = '$field_id'");
} elseif($admin->get_post('type') == 'textarea') {
	$value = $admin->get_post_escaped('value');
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '$value', extra = '' WHERE field_id = '$field_id'");
} elseif($admin->get_post('type') == 'heading') {
	$extra = $admin->get_post('template');
	if(trim($extra) == '') $extra = '<tr><td class="Form_PE_heading" colspan="3">{TITLE}{FIELD}</td></tr>';
	$extra = $admin->add_slashes($extra);
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '', extra = '$extra' WHERE field_id = '$field_id'");
} elseif($admin->get_post('type') == 'select') {
	$extra = $admin->get_post_escaped('size').','.$admin->get_post_escaped('multiselect');
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '$value', extra = '$extra' WHERE field_id = '$field_id'");
} elseif($admin->get_post('type') == 'checkbox') {
	$extra = $admin->get_post_escaped('seperator');
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '$value', extra = '$extra' WHERE field_id = '$field_id'");
} elseif($admin->get_post('type') == 'date') {
	$length = $admin->get_post_escaped('length');
	$value = $admin->get_post_escaped('value');
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '$value', extra = '$length' WHERE field_id = '$field_id'");
} elseif($admin->get_post('type') == 'radio') {
	$extra = $admin->get_post_escaped('seperator');
	$Pacer->database->query("UPDATE ".TABLE_PREFIX."mod_Form_PE_fields SET value = '$value', extra = '$extra' WHERE field_id = '$field_id'");
}

// Check if there is a db error, otherwise say successful
if($Pacer->database->is_error()) {
	$Pacer->print_error($Pacer->database->get_error(), PE_URL.'/modules/Form_PE/modify_field.php?page_id='.$page_id.'&section_id='.$section_id.'&field_id='.$field_id);
} else {
	$Pacer->print_success($Pacer->Translate('Success'), PE_URL.'/modules/Form_PE/modify_field.php?page_id='.$page_id.'&section_id='.$section_id.'&field_id='.$field_id);
}

// Print admin footer
//$admin->print_footer();

?>