<?php
/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : Form_PE                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : save_settings.php                                          *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************

*/

// include global configuration file
require('../../config.php');

// unset page/section IDs defined via GET before including the admin file (we expect POST here)
unset($_GET['page_id']);
unset($_GET['section_id']);

require_once(PE_PATH .'/pacer/pacer.php');

// include PE admin wrapper script to check permissions
$update_when_modified = true;
require(PE_PATH . '/modules/admin.php');

// convert page/section id to numbers (already checked by /modules/admin.php but kept for consistency)
$page_id = (isset($_POST['page_id'])) ? (int) $_POST['page_id'] : '';
$section_id = (isset($_POST['section_id'])) ? (int) $_POST['section_id'] : '';

$update_keys=array('header','field_loop','footer','field_loop','email_to','use_captcha','email_from','email_fromname','max_file_size_kb','date_format','email_subject','success_page','success_email_to','success_email_from','success_email_fromname',
'success_email_text','success_email_subject','max_submissions','stored_submissions','upload_files_folder','upload_file_chmode','attach_file','upload_only_exts','upload_only_exts');
foreach($update_keys as $key) {
	${$key} = (isset($_POST[$key])) ? $admin->add_slashes($_POST[$key]) : '';
}
$upd_extra = array('email_from_field','email_fromname_field');
foreach($upd_extra as $key) {
	${$key} = (isset($_POST[$key])) ? $admin->add_slashes($_POST[$key]) : '';
}

if($email_from_field != '') $email_from = $email_from_field;
if($email_fromname_field != '') $email_fromname = $email_fromname_field;
if(!is_numeric($max_file_size_kb)) $max_file_size_kb = 1024;
if(!is_numeric($max_submissions)) $max_submissions = 50;
if(!is_numeric($stored_submissions)) $stored_submissions = 100;

// Make sure max submissions is not greater than stored submissions if stored_submissions <>0
if($max_submissions > $stored_submissions) $max_submissions = $stored_submissions;

if (!$upload_files_folder) $upload_files_folder = MEDIA_DIRECTORY . '/';
if ((substr($upload_files_folder,-1,1) === "\\") or (substr($upload_files_folder,-1,1) === "/")) $upload_files_folder = substr($upload_files_folder,0,-1);

if(!is_numeric($upload_file_chmode) || $upload_file_chmode==0) $upload_file_chmode = '0666';

//Add folder for the files
require_once(PE_PATH.'/framework/functions.php');

//Fix bug /media 0600 ... inacessible...
change_mode(PE_PATH.MEDIA_DIRECTORY);
@chmod(PE_PATH.MEDIA_DIRECTORY, intval('0755', 8));

if ($upload_files_folder != MEDIA_DIRECTORY ) {
	if (!file_exists(PE_PATH.$upload_files_folder) && !is_dir(PE_PATH.$upload_files_folder)) make_dir(PE_PATH.$upload_files_folder,	$upload_file_chmode);
	if (is_dir(PE_PATH.$upload_files_folder)) {
		change_mode(PE_PATH.$upload_files_folder);
		@chmod(PE_PATH.$upload_files_folder, intval($upload_file_chmode, 8));
	}
}
//echo "<p>chmod=".PE_PATH.$upload_files_folder."  -  [". $upload_file_chmode."]";


// now loop over update values and create the SQL query string (this way we do not forget values)
$sql_key_values = '';
foreach($update_keys as $key) {
	$sql_key_values .= (($sql_key_values) ? ', ' : '' ) . "`$key` = '" . ${$key} . "'";
}

// write page settings to the module table
$table = TABLE_PREFIX . 'mod_Form_PE_settings';
$sql = "UPDATE `$table` SET $sql_key_values
	WHERE `section_id` = '$section_id'";
//die($sql);
$database->query($sql);

// Check if there is a db error, otherwise say successful
if($Pacer->database->is_error()) {
	$Pacer->print_error($Pacer->database->get_error(), ADMIN_URL . '/pages/modify.php?page_id=' . $page_id);
} else {
	$Pacer->print_success($Pacer->Translate('Success'), ADMIN_URL . '/pages/modify.php?page_id=' . $page_id);
}
?>