<?php
/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : Form_PE                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : view.php                                                   *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************

*/
// Must include code to stop this file being access directly
if(defined('PE_PATH') == false) { exit("Cannot access this file directly"); }


// obtain module directory
$mod_dir = basename(dirname(__FILE__));

// check if module language file exists for the language set by the user (e.g. DE, EN)
if(!file_exists(PE_PATH .'/modules/'.$mod_dir.'/languages/'.LANGUAGE .'.php')) {
	// no module language file exists for the language set by the user, include default module language file EN.php
	require_once(PE_PATH .'/modules/'.$mod_dir.'/languages/EN.php');
} else {
	// a module language file exists for the language defined by the user, load it
	require_once(PE_PATH .'/modules/'.$mod_dir.'/languages/'.LANGUAGE .'.php');
}

// check if frontend.css file needs to be included into the <body></body> of view.php
if((!function_exists('register_frontend_modfiles') || !defined('MOD_FRONTEND_CSS_REGISTERED')) &&  
	file_exists(PE_PATH .'/modules/'.$mod_dir.'/frontend.css')) {
	echo '<style type="text/css">';
	include(PE_PATH .'/modules/'.$mod_dir.'/frontend.css');
	echo "\n</style>\n";
} 

require_once(PE_PATH.'/include/captcha/captcha.php');

// obtain the settings of the output filter module
if(file_exists(PE_PATH.'/modules/output_filter/filter-routines.php')) {
	include_once(PE_PATH.'/modules/output_filter/filter-routines.php');
	$filter_settings = get_output_filter_settings();
} else {
	// no output filter used, define default settings
	$filter_settings['email_filter'] = 0;
}

// Function for generating an optionsfor a select field
if (!function_exists('make_option')) {
function make_option(&$n, $k, $values) {
	global $tooltip, $field;
	// start option group if it exists
	if (substr($n,0,2) == '[=') {
	 	$n = '<optgroup label="'.substr($n,2,strlen($n)).'">';
	} elseif ($n == ']') {
		$n = '</optgroup>';
	} else {
		if(in_array($n, $values)) {
			$n = '<option selected="selected" value="'.$n.'">'.$n.'</option>';
		} else {
			$n = '<option value="'.$n.'">'.$n.'</option>';
		}
	}
}
}
// Function for generating a checkbox
if (!function_exists('make_checkbox')) {
function make_checkbox(&$n, $idx, $params) {
	global $tooltip, $field;
	$field_id = $params[0][0];
	$seperator = $params[0][1];
	$err_class = $params[2][0];
	$label_id = 'wb_'.str_replace(" ", "_", $n);
	if(in_array($n, $params[1])) {
		$n = '<input class="'.$err_class.'checkbox'	.$tooltip.'"'.(($field['field_style']) ? ' style="'.$field['field_style'].'"':'').' type="checkbox" id="'.$label_id.'" name="field'.$field_id.'['.$idx.']" value="'.$n.'" checked="checked" />'.'<label for="'.$label_id.'" class="Form_PE_checkbox_label">'.$n.'</lable>'.$seperator;
	} else {
		$n = '<input class="'.$err_class.'checkbox'	.$tooltip.'"'.(($field['field_style']) ? ' style="'.$field['field_style'].'"':'').' type="checkbox" id="'.$label_id.'" name="field'.$field_id.'['.$idx.']" value="'.$n.'" />'.'<label for="'.$label_id.'" class="Form_PE_checkbox_label">'.$n.'</label>'.$seperator;
	}	
}
}
// Function for generating a radio button
if (!function_exists('make_radio')) {
function make_radio(&$n, $idx, $params) {

	global $tooltip, $field;
	$field_id = $params[0];
	$group = $params[1];
	$seperator = $params[2];
	$err_class =$params[3];
	$label_id = 'wb_'.str_replace(" ", "_", $n);
	
	if($n == $params[3]) { 
		$n = '<input class="'.$err_class.'radio'.$tooltip.'"'.(($field['field_style']) ? ' style="'.$field['field_style'].'"':''). ' type="radio" id="'.$label_id.'" name="field'.$field_id.'" value="'.$n.'" checked="checked" />'.'<label for="'.$label_id.'" class="Form_PE_radio_label">'.$n.'</label>'.$seperator;
	} else {
		$n = '<input class="'.$err_class.'radio'.$tooltip.'"'.(($field['field_style']) ? ' style="'.$field['field_style'].'"':'').' type="radio" id="'.$label_id.'" name="field'.$field_id.'" value="'.$n.'" />'.'<label for="'.$label_id.'" class="Form_PE_radio_label">'.$n.'</label>'.$seperator;
	}
}
}
// Generate temp submission id
function new_submission_id() {
	$submission_id = '';
	$salt = "abchefghjkmnpqrstuvwxyz0123456789";
	srand((double)microtime()*1000000);
	$i = 0;
	while ($i <= 7) {
		$num = rand() % 33;
		$tmp = substr($salt, $num, 1);
		$submission_id = $submission_id . $tmp;
		$i++;
	}
	return $submission_id;
}

global $Pacer;
$files_to_attach = array();
$upload_filename = '';
/////////////////////////////////////////
// Get settings
$query = $Pacer->database->query("SELECT * FROM ".TABLE_PREFIX."mod_Form_PE_settings WHERE section_id = '$section_id'");
if($query->numRows() > 0) {
	$fetch_settings = $query->fetchRow();
	$header = str_replace('{PE_URL}',PE_URL,$fetch_settings['header']);
	$field_loop = $fetch_settings['field_loop'];
	$footer = str_replace('{PE_URL}',PE_URL,$fetch_settings['footer']);
	$use_captcha = $fetch_settings['use_captcha'];
	$attach_file = $fetch_settings['attach_file'];
	$max_file_size = $fetch_settings['max_file_size_kb'] * 1024;
	$upload_only_exts = $fetch_settings['upload_only_exts'];
	$upload_file_chmode = $fetch_settings['upload_file_chmode'];
	$date_format = $fetch_settings['date_format'];
} else {
	$header = '';
	$field_loop = '';
	$footer = '';
	$attach_file = 0;
	$max_file_size = 1024 * 1024;
	$upload_only_exts = '';
	$upload_file_chmode = '';
	$date_format = '';
}

// Work-out if the form has been submitted or not
if($_POST == array()) {

// Set new submission ID in session
$_SESSION['form_submission_id'] = new_submission_id();

$multi_steps = $Pacer->database->get_one("SELECT type FROM ".TABLE_PREFIX."mod_Form_PE_fields WHERE section_id = '$section_id' AND type = 'step' LIMIT 1");
	
?>
<form name="Form_PE_<?php echo $section_id; ?>" class="form_validation<?php echo ($multi_steps)?' form_multi_steps':'';?>" action="<?php echo htmlspecialchars(strip_tags($_SERVER['PHP_SELF']))?>" method="post" enctype="multipart/form-data" >
<input type="hidden" name="submission_id" value="<?php echo $_SESSION['form_submission_id']; ?>" />
<?php
if(ENABLED_ASP) { // first add some honeypot-fields
?>
<input type="hidden" name="submitted_when" value="<?php $t=time(); echo $t; $_SESSION['submitted_when']=$t; ?>" />
<p style="display:none">
email address:
<label for="email">Leave this field email-address blank:</label>
<input id="email" name="email" size="56" value="" /><br />
Homepage:
<label for="homepage">Leave this field homepage blank:</label>
<input id="homepage" name="homepage" size="55" value="" /><br />
URL:
<label for="url">Leave this field url blank:</label>
<input id="url" name="url" size="61" value="" /><br />
Comment:
<label for="comment">Leave this field comment blank:</label>
<textarea id="comment" name="comment" cols="50" rows="10"></textarea><br />
</p>

<?php }
$last_STEP = -1;
$i = 0;
$step=false;
$ffields = array();
$query_fields = $Pacer->database->query("SELECT * FROM ".TABLE_PREFIX."mod_Form_PE_fields WHERE section_id = '$section_id' ORDER BY position ASC");
if($query_fields->numRows() > 0) {
	while($field = $query_fields->fetchRow()) {
		
		if (($field['type'] == 'step') or ($i==0)) {
			$step = true;
		}
		
		if ($field['type'] != 'step') {
			$ffields[$i] = $field; 
			if ($step) {
				$last_STEP++;
				$ffields[$i]['step'] = $last_STEP;
				$step = false;
			}
			$i++;
		}
	}
}
$first_MAX = true;
$cla=array();
if (count($ffields)>0) {
	foreach($ffields as $k => $field) {	
		// Set field values
		$field_id = $field['field_id'];
		$value = $field['value'];
		
		$tooltip = '';
		if ($field['help']) {
			$tooltip = " tooltip\" title=\"".nl2br(htmlspecialchars($field['title'].$Pacer->TOOLTIP_TITLE_SEPARATOR.$field['help']));
		}

		if (in_array($field_id,explode(",",((isset($_GET['err']))) ? $_GET['err'] : ''))) {
			$err_class = "Form_PE_err_";
		} else {
			$err_class = "Form_PE_";
		}
	
		// Print field_loop after replacing vars with values
		$vars = array('[TITLE]', '[REQUIRED]');
		if (($field['type'] == "radio") || ($field['type'] == "checkbox")) {
			$field_title = $field['title'];
		} else {
			$field_title = '<label for="field'.$field_id.'">'.$field['title'].'</label>';
		}
		$values = array($field_title);
		if ($field['required'] == 1) {
			$values[] = '*';
		} else {
			$values[] = '';
		}

		//echo "<strong>".$field['field_id']."[$k][$last_STEP][".$field['step']."]</strong><br>\n";

		if(array_key_exists('step',$field)) {
			if ($k>0) {
				echo '</table>';			
				echo '</div>';
			}
			echo '<div class="step" id="step_'.$field['step'].'">';
		
			if ($field['step']==$last_STEP) {
			    echo '<input type="hidden" class="link" value="submit_step" />';
			} else {
				echo '<input type="hidden" class="link" value="step_'.($field['step'] + 1).'" />';
			}
			echo $header;		
		} 
		
		if($field['type'] == 'textfield') {
			$vars[] = '[FIELD]';
			//$vx='<input type="text" name="field'.$field_id.'" id="field'.$field_id.'" maxlength="'.$field['extra'].'" value="'.(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:$value).'" class="textfield" />';
			//$values[] = preg_replace('/\{DATA\}/',$vx,$short_html);
			$values[] = '<input type="text" name="field'.$field_id.'" id="field'.$field_id.'" maxlength="'.$field['extra'].'" value="'.(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:$value).'" class="'.	$err_class.'text'.$tooltip.'"'.(($field['field_style']) ? ' style="'.$field['field_style'].'"':'').'/>';
		} elseif ($field['type'] == 'filename') {
			$vars[] = '[FIELD]';
			if ($first_MAX) $vmax = '<input type="hidden" name="MAX_FILE_SIZE" value="'.$max_file_size.'">'; else $vmax = '';
			$values[] = $vmax.'<input type="file" name="field'.$field_id.'" id="field'.$field_id.'" maxlength="'.$field['extra'].'" value="'.(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:$value).'" class="'.$err_class.'text'.$tooltip.'" /><span style="font-size:9px;"><br>'.sprintf($MOD_FORM['MAX_FILESIZE'],$max_file_size).'</span>';
			$first_MAX = false;
		} elseif($field['type'] == 'textarea') {
			$vars[] = '[FIELD]';
			$values[] = '<textarea name="field'.$field_id.'" id="field'.$field_id.'" class="'.$err_class.'textarea'.$tooltip.'" cols="25" rows="5"'.(($field['field_style']) ? ' style="'.$field['field_style'].'"':'').'>'.(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:$value).'</textarea>';
		} elseif($field['type'] == 'select') {
			$vars[] = '[FIELD]';
			$options = explode(',', $value);
			array_walk($options, 'make_option', (isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:array()));
			$field['extra'] = explode(',',$field['extra']);
			$values[] = '<select name="field'.$field_id.'[]" id="field'.$field_id.'" size="'.$field['extra'][0].'" '.$field['extra'][1].'="'.$field['extra'][1].'" class="'.$err_class.'select'.$tooltip.'">'.implode($options).'</select>';
		} elseif($field['type'] == 'heading') {
			$vars[] = '[FIELD]';
			//$vx = '<input type="hidden" name="field'.$field_id.'" id="field'.$field_id.'" value="===['.$field['title'].']===" />';
			//$values[] = preg_replace('/\{HEADING\}/',$vx,$heading_html);
			$values[] = '<input type="hidden" name="field'.$field_id.'" id="field'.$field_id.'" value="===['.$field['title'].']===" />';
			$tmp_field_loop = $field_loop;		// temporarily modify the field loop template
			$field_loop = $field['extra'];
		} elseif($field['type'] == 'checkbox') {
			$vars[] = '[FIELD]';
			$options = explode(',', $value);
			array_walk($options, 'make_checkbox', array(array($field_id,$field['extra']),(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:array()),array($err_class)));
			$options[count($options)-1]=substr($options[count($options)-1],0,strlen($options[count($options)-1])-strlen($field['extra']));
			$values[] = implode($options);
		} elseif($field['type'] == 'radio') {
			$vars[] = '[FIELD]';
			$options = explode(',', $value);
			array_walk($options, 'make_radio', array($field_id,$field['title'],$field['extra'], (isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:''),$err_class));
			$options[count($options)-1]=substr($options[count($options)-1],0,strlen($options[count($options)-1])-strlen($field['extra']));
			$values[] = implode($options);
		} elseif($field['type'] == 'email') {
			$vars[] = '[FIELD]';
			$values[] = '<input type="text" name="field'.$field_id.'" id="field'.$field_id.'" value="'.(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:'').'" maxlength="'.$field['extra'].'" class="'.$err_class.'email'.$tooltip.'" />';
		} elseif($field['type'] == 'date') {
			//$value = eregi_replace('[today]',gmdate($fetch_settings['date_format'],time()+TIMEZONE),$value);
			$vars[] = '[FIELD]';
			$cla['field'.$field_id] = "field".$field_id;
/*
			$values[] = '<input type="text" name="field'.$field_id.'" id="field'.$field_id.'"'.
			' maxlength="'.$field['extra'].'" value="'.(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:$value).'" class="'.$err_class.'date" />'.
     		"<img src=\"".PE_URL ."/modules/Form_PE/images/cal.gif\" id=\"field".$field_id."_trigger\" class=\"date_img\" title=\"Calendar\" />";
*/
			
			$values[] = '<table cellpadding="0" cellspacing="0" border="0"><tr><td>'.
			'<input type="text" name="field'.$field_id.'" id="field'.$field_id.'"'.
			' maxlength="'.$field['extra'].'" value="'.(isset($_SESSION['field'.$field_id])?$_SESSION['field'.$field_id]:$value).'" class="'.$err_class.'date'.$tooltip.'" />'.
			'</td><td>'.
     		'<img src="'.PE_URL .'/modules/Form_PE/images/cal.gif" id="field'.$field_id.'_trigger" class="Form_PE_date_img" title="'.$Pacer->Translate('Calendar').'" />'.
			'</td></tr></table>';
		}
		if(isset($_SESSION['field'.$field_id])) unset($_SESSION['field'.$field_id]);

		if($field['type'] != '') {
	        
			if (!array_search('[CLASS]',$vars)) {
				$vars[]='[CLASS]';
				$values[]="";			
			}
			echo str_replace($vars, $values, $field_loop);
		}
		if (isset($tmp_field_loop)) $field_loop = $tmp_field_loop;
	}
}

// Captcha
if($use_captcha) { 
	$vars = array('[TITLE]','[REQUIRED]','[FIELD]','[CLASS]');
	$values = array($Pacer->Translate('Verification'),'*','<div id="Form_PE_captcha">[CAPTCHA]</div>','');
	$html = str_replace($vars, $values, $field_loop);
	$html = explode("[CAPTCHA]",$html);
    echo $html[0];
	call_captcha();
	//echo "SSS=".$_SESSION['captcha'];
	echo $html[1];
}

// Print footer
echo $footer;

if ($last_STEP) {
/*
	echo '</div>';
	echo '<div id="navigation"> 							
	<input class="Form_PE_submit" type="reset" value="Reset Form" />
 	<input class="Form_PE_submit" type="submit" value="Submit" />
</div>';
*/
}

// Add form end code
?>
</form>
<?php

	$Pacer->Code_Injection_Add('js_file','jquery.js');			
	$Pacer->Code_Injection_Add('js_file','jquery.tooltip.js');
	$Pacer->Code_Injection_Add('js_file','jquery.alerts.js');
	if ($multi_steps) {
		$Pacer->Code_Injection_Add('js_file','jquery.form.wizard.js');			
		$Pacer->Code_Injection_Add('js_file','jquery.history.js');			
	}
	
	$Pacer->Code_Injection_Add('css_file','jquery.alerts.css');
	$Pacer->Code_Injection_Add('css_file',THEME_PATH.'/css/pacer/alerts.css');	
	
	$Pacer->Code_Injection_Add('css_file','jquery.tooltip.css');
	$Pacer->Code_Injection_Add('css_file',THEME_PATH.'/css/pacer/tooltip_style.css');	
	if ($multi_steps) {
		$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	$("form.form_multi_steps").formwizard({ historyEnabled : true, formPluginEnabled: false, validationEnabled : false}, { }, { resetForm: true, success: function(data){return false} });
});
');
	}
	if (count($cla)>0) {
		$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/calendar.js');
		ob_start();
		require_once(PE_PATH.'/include/jscalendar/calendar-system.css');
		$css = ob_get_contents();
		ob_end_clean();

		$Pacer->Code_Injection_Add('css_script',$css);

//		$Pacer->Code_Injection_Add('css_file',PE_URL.'/include/jscalendar/calendar-system.css');

		if(file_exists(PE_PATH .'/include/jscalendar/lang/calendar-'.strtolower(LANGUAGE) .'.js')) {
			$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/lang/calendar-'.strtolower(LANGUAGE) .'.js');
		} else {
			$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/lang/calendar-en.js');
		}
		$Pacer->Code_Injection_Add('js_file',PE_URL.'/include/jscalendar/calendar-setup.js');
		// today
		$jscal_today = date('Y/m/d');
		// first-day-of-week
		$jscal_firstday = '1'; // monday
		if(LANGUAGE=='EN') $jscal_firstday = '0'; // sunday
		
		$jscal_ifformat = $Pacer->convert_datetime_format('','',true, $Pacer->get_user_id());
		
		// load scripts for jscalendar
		$jscal_use_time = true; // whether to use a clock, too
		if ($date_format) $jscal_ifformat = $date_format; //"%Y-%m-%d"; // - format for jscalendar (default: from wb-backend-date-format)

		foreach($cla as $k => $v) {
			$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
Calendar.setup({
	inputField  : "'.$k.'",
	ifFormat    : "'.$jscal_ifformat.'",
	button      : "'.$k.'_trigger",
	firstDay    : '.$jscal_firstday.','.
	((isset($jscal_use_time) && $jscal_use_time==TRUE) ? '
	showsTime   : "true",
	timeFormat  : "24",':'').'
	date        : "'.$jscal_today.'",
	range       : [1970, 2037],
	step        : 1
});
});
');
		}
	}
} else {


	$Pacer->Code_Injection_Add('js_file','jquery.js');			
	$Pacer->Code_Injection_Add('js_file','jquery.alerts.js');
	$Pacer->Code_Injection_Add('css_file','jquery.alerts.css');
	$Pacer->Code_Injection_Add('css_file',THEME_PATH.'/css/pacer/alerts.css');	

	// Check that submission ID matches
	if(isset($_SESSION['form_submission_id']) AND isset($_POST['submission_id']) AND $_SESSION['form_submission_id'] == $_POST['submission_id']) {
		
		// Set new submission ID in session
		$_SESSION['form_submission_id'] = new_submission_id();
		
		if(ENABLED_ASP && ( // form faked? Check the honeypot-fields.
			(!isset($_POST['submitted_when']) OR !isset($_SESSION['submitted_when'])) OR 
			($_POST['submitted_when'] != $_SESSION['submitted_when']) OR
			(!isset($_POST['email']) OR $_POST['email']) OR
			(!isset($_POST['homepage']) OR $_POST['homepage']) OR
			(!isset($_POST['comment']) OR $_POST['comment']) OR
			(!isset($_POST['url']) OR $_POST['url'])
		)) {
			exit(header("Location: ".PE_URL.PAGES_DIRECTORY.""));
		}

		// Submit form data
		// First start message settings
		$query_settings = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_Form_PE_settings WHERE section_id = '$section_id'");
		if($query_settings->numRows() > 0) {
			$fetch_settings = $query_settings->fetchRow();
			$email_to = $fetch_settings['email_to'];
			$email_from = $fetch_settings['email_from'];
			if(substr($email_from, 0, 5) == 'field') {
				// Set the email from field to what the user entered in the specified field
				$email_from = htmlspecialchars($Pacer->add_slashes($_POST[$email_from]));
			}
			$email_fromname = $fetch_settings['email_fromname'];
			if(substr($email_fromname, 0, 5) == 'field') {
				// Set the email from field to what the user entered in the specified field
				$email_fromname = htmlspecialchars($Pacer->add_slashes($_POST[$email_fromname]));
			}
			$email_subject = $fetch_settings['email_subject'];
			$success_page = $fetch_settings['success_page'];
			$success_email_to = $fetch_settings['success_email_to'];
			if(substr($success_email_to, 0, 5) == 'field') {
				// Set the success_email to field to what the user entered in the specified field
				$success_email_to = htmlspecialchars($Pacer->add_slashes($_POST[$success_email_to]));
			}
			$success_email_from = $fetch_settings['success_email_from'];
			$success_email_fromname = $fetch_settings['success_email_fromname'];
			
			$success_email_text = $fetch_settings['success_email_text'];
			$success_email_subject = $fetch_settings['success_email_subject'];		
			$max_submissions = $fetch_settings['max_submissions'];
			$stored_submissions = $fetch_settings['stored_submissions'];
			$use_captcha = $fetch_settings['use_captcha'];
			$upload_files_folder = $fetch_settings['upload_files_folder'];
			$attach_file = $fetch_settings['attach_file'];
			$upload_file_chmode = $fetch_settings['upload_file_chmode'];
			$max_file_size = $fetch_settings['max_file_size_kb'] * 1024;

		} else {
			exit($Pacer->Translate('Under contruction'));
		}
		$email_body = '';
		
		// Create blank "required" array
		$required = array();
$s1 = array();
$fer = array();
		if (isset($captcha_error)) unset($captcha_error);
		// Captcha
		if($use_captcha) {
			if ((isset($_POST['captcha']) AND ($_POST['captcha'] == '')) 
			OR (!isset($_POST['captcha']))
			OR (!isset($_SESSION['captcha'])) 
			OR ($_POST['captcha'] != $_SESSION['captcha'])) {
				//$captcha_error = "[".$_POST['captcha'] .']-['. $_SESSION['captcha']."] ".$Pacer->Translate('The verification number (also known as Captcha) that you entered is incorrect. If you are having problems reading the Captcha, please email:').SERVER_EMAIL;
				$captcha_error = $Pacer->Translate('The verification number (also known as Captcha) that you entered is incorrect. If you are having problems reading the Captcha, please email:').SERVER_EMAIL;
			}
			if(isset($_SESSION['captcha'])) unset($_SESSION['captcha']);
		} 
		// Loop through fields and add to message body
		// Get list of fields
		$values_to_serialize = array();
		$query_fields = $Pacer->database->query("SELECT * FROM ".TABLE_PREFIX."mod_Form_PE_fields WHERE ( section_id = '$section_id' AND type != 'step' ) ORDER BY position ASC");
		if($query_fields->numRows() > 0) {
			while($field = $query_fields->fetchRow()) {
				// Add to message body
				if ($field['type'] != '') {
					if((!empty($_POST['field'.$field['field_id']])) or (($field['type'] == 'filename') and (!empty($_FILES['field'.$field['field_id']]['name'])))) {
						if (isset($_POST['field'.$field['field_id']])) {	
							if (is_array($_POST['field'.$field['field_id']])) {
								$_SESSION['field'.$field['field_id']] = $_POST['field'.$field['field_id']];
							} else {
								$_SESSION['field'.$field['field_id']] = htmlspecialchars($_POST['field'.$field['field_id']]);
							}
						}
						// if the output filter is active, we need to revert (dot) to . and (at) to @ (using current filter settings)
						// otherwise the entered mail will not be accepted and the recipient would see (dot), (at) etc.
						if ($filter_settings['email_filter']) {
							$field_value = $_POST['field'.$field['field_id']];
							$field_value = str_replace($filter_settings['at_replacement'], '@', $field_value);
							$field_value = str_replace($filter_settings['dot_replacement'], '.', $field_value);
							$_POST['field'.$field['field_id']] = $field_value;
						}
						
						if($field['type'] == 'email' AND $wb->validate_email($_POST['field'.$field['field_id']]) == false) {
							$email_error = $Pacer->Translate('The email address you entered is invalid');
							$fer[]=$field['field_id'];
						}

						if($field['type'] == 'heading') {
							$email_body .= $_POST['field'.$field['field_id']]."\n\n";
							$values_to_serialize[$field['field_id']] = array($field['title'] => $_POST['field'.$field['field_id']]);
						} elseif($field['type'] == 'filename') {
							$email_body .= $field['title'].': '.basename($_FILES['field'.$field['field_id']]['name'])."\n\n";
							$values_to_serialize[$field['field_id']] = array($field['title'] => $_FILES['field'.$field['field_id']]['name']);

							$s1[$field['title']] = basename($_FILES['field'.$field['field_id']]['name']); // save ser label_name => value,,,
						} elseif (!is_array($_POST['field'.$field['field_id']])) {
							$email_body .= $field['title'].': '.$_POST['field'.$field['field_id']]."\n\n";
							$values_to_serialize[$field['field_id']] = array($field['title'] => $_POST['field'.$field['field_id']]);

							$s1[$field['title']] = $_POST['field'.$field['field_id']]; // save ser label_name => value,,,
						} else {
							$email_body .= $field['title'].": \n";
							$s1[$field['title']]='';
						//	print_r($_POST['field'.$field['field_id']]);
							foreach ($_POST['field'.$field['field_id']] as $k => $v) {
								$email_body .= $v."\n";
/// TO DO								$values_to_serialize[$field['field_id']] = array($field['title'] => $_POST['field'.$field['field_id']]);

								$s1[$field['title']] .= $v; // save ser label_name => value,,,
							}
							$email_body .= "\n";
						}
					} elseif($field['required'] == 1) {
						$required[] = $field['title'];
						$fer[]=$field['field_id'];
					}
// File Upload ------------------------------------------------------//
					if($field['type'] == 'filename'){
						if($_FILES['field'.$field['field_id']]['name'] != ""){
							$timestamp = date('dmYhms');
							$filename = basename($_FILES['field'.$field['field_id']]['name']);
/*
							print_r($_FILES);
							echo "<p>P=".$field['field_id'];
*/
							$testtest = $Pacer->upload_one_file('field'.$field['field_id'],PE_PATH.$upload_files_folder,$timestamp.'-'.$filename,$upload_only_exts,$upload_file_chmode);

//							$testtest = upload_one_file('field'.$field['field_id'],PE_PATH.$upload_files_folder,$timestamp.'-'.$filename,$upload_only_exts,$upload_file_chmode);
							if ($testtest!==true) {
							//print_r($testtest);
								$upload_error = "<b>".$Pacer->Translate('There was an error uploading the file:'). $filename ."(".$testtest."), ".$Pacer->Translate('please try again!')."<b>";
								$fer[]=$field['field_id'];
							} else {
								$upload_file_webloc = str_replace(PE_PATH,"",$upload_files_folder);
								$file_url = PE_URL . $upload_file_webloc . "/" .$timestamp . "-" . $filename;
							
					////		$email_body .= str_replace("{TITLE}",$field['title'],					str_replace("{DATA}",$file_url,$fetch_settings['uploadfile_html']))."\n";
								$email_body .= $field['title'].'(Uploaded): [url]'.$file_url. (($testtest !== false) ? "[/url]" : " (Upload FAILED!)")."\n\n";
					        	if ($attach_file == 1) {
									$upload_filename = $upload_file_webloc . "/". $timestamp . "-" . $filename; // . '|';
									$files_to_attach[PE_PATH.$upload_files_folder. "/". $timestamp . "-" . $filename] = $filename;
								}
							}
						}
					}
// File Upload ------------------------------------------------------//
				}
			}
		}
		$values_to_serialize = serialize($values_to_serialize);

		//$bmsg ='</ul><a href="'.htmlspecialchars(strip_tags($_SERVER['PHP_SELF'])). (($fer) ? '?err='.implode(',',$fer):''). '">'.$Pacer->Translate('Back').'</a>';
		$bmsg ='</ul>';
		$bk = htmlspecialchars(strip_tags($_SERVER['PHP_SELF'])). (($fer) ? '?err='.implode(',',$fer):'');

		// Check if the user forgot to enter values into all the required fields
		if($required != array()) {
			$error_msg = $Pacer->Translate('You must enter details for the following fields').':<br /><ul>';
			foreach($required AS $field_title) {$error_msg .= '<li>'.$field_title; }
			if(isset($email_error)) $error_msg .= '<li>'.$email_error.'</li>';
			if(isset($captcha_error)) $error_msg .= '<li>'.$captcha_error.'</li>';
			$error_msg .= $bmsg;
			$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	jAlert(\''.$error_msg.'\', "'.$wb->page['page_title'].'",function(r) {
		self.location.href = "'.$bk.'";
	});
});
');
		} else {

			if(isset($upload_error)) {
				$error_msg = '<ul>';
				$error_msg .= '<li>'.$upload_error.'</li>';
				$error_msg .= $bmsg;
				$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	jAlert("'.$error_msg.'", "'.$wb->page['page_title'].'",function(r) {
		self.location.href = "'.$bk.'";
	});
});
');
			} elseif(isset($email_error)) {
				$error_msg = '<ul>';
				$error_msg .= '<li>'.$email_error.'</li>';
				$error_msg .= $bmsg;
				$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	jAlert("'.$error_msg.'", "'.$wb->page['page_title'].'",function(r) {
		self.location.href = "'.$bk.'";
	});
});
');
			} elseif(isset($captcha_error)) {
				$error_msg = '<ul>';
				$error_msg .= '<li>'.$captcha_error.'</li>';
				$error_msg .= $bmsg;
				$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	jAlert("'.$error_msg.'", "'.$wb->page['page_title'].'",function(r) {
		self.location.href = "'.$bk.'";
	});
});
');
			} else {
				// Check how many times form has been submitted in last hour
				$last_hour = time()-3600;
				$submissions = (int) $Pacer->database->get_one("SELECT count(submission_id) FROM ".TABLE_PREFIX."mod_Form_PE_submissions WHERE submitted_when >= '$last_hour'");
				if($submissions > $max_submissions) {
					// Too many submissions so far this hour
					$error_msg= $Pacer->Translate('Sorry, this form has been submitted too many times so far this hour. Please retry in the next hour.');
					$success = false;
				} else {
					$success = true;	
					// Now send the email + attachment...
					if($email_to != '') {
						$email_body_no_url = eregi_replace('\[url\]','',eregi_replace('\[/url\]','',$email_body));
						if($Pacer->Send($email_from,$email_to,$email_subject,$email_body_no_url,$email_fromname,$files_to_attach)) {
							$success = true;
							$files_to_attach = array();
						} else {
							$success = false;
							//echo $Pacer->Translate('Mail Routine');
							$error_msg =$Pacer->Translate('Mail Routine Error');
						}
					}				
					if(($success==true) && ($success_email_to != '')) {
						if($Pacer->Send($success_email_from,$success_email_to,$success_email_subject,$success_email_text,$success_email_fromname)) {
							$success = true;
						} else {
							$success = false;
							//echo $Pacer->Translate('Mail Routine');
							$error_msg =$Pacer->Translate('Mail Routine Error');
						}
					}				

// Write submission to database -------------------------------------------------//
					if($success==true) {
						// Write submission to database
						if($wb->is_authenticated() AND $wb->get_user_id() > 0) {
							$submitted_by = $wb->get_user_id();
						} else {
							$submitted_by = 0;
						}
						$email_body = $Pacer->add_slashes($email_body);
					
						$s2 = array('submitted_when' => date(DATE_FORMAT.' '.TIME_FORMAT,time()),'submitted_by' => $submitted_by,'upload_filename' => $upload_filename,'ip'=> $Pacer->get_ip());
						
						$upload_data_serialized = $Pacer->add_slashes(serialize(array_merge($s1,$s2)));
						
						$values_to_serialize = $Pacer->add_slashes(serialize($values_to_serialize));
						
						$Pacer->database->query("INSERT INTO ".TABLE_PREFIX."mod_Form_PE_submissions (page_id,section_id,submitted_when,submitted_by,body,upload_filename,upload_data_serialized,ip,referer,fields_serialized) VALUES ('".PAGE_ID."','$section_id','".time()."','$submitted_by','$email_body','$upload_filename','$upload_data_serialized','".$Pacer->get_ip()."', '". $Pacer->get_referer()."', '$values_to_serialize' )");
						
						if($Pacer->database->is_error()) {
							$success = false;
							//echo $Pacer->Translate('Database');
							$error_msg =$Pacer->Translate('Database Error');

						} else {
// Make sure submissions table isn't too full -----------------------------------//
							if($stored_submissions){
								$submissions=$Pacer->database->get_one("SELECT COUNT(submission_id) FROM ".TABLE_PREFIX."mod_Form_PE_submissions WHERE section_id='$section_id'");
								if ($submissions>$stored_submissions){
									$submissions -= $stored_submissions;
									$Pacer->database->query("DELETE FROM ".TABLE_PREFIX."mod_".$module_directory."_submissions ORDER BY submitted_when ASC LIMIT $submissions");
								}
							}						
						}
					}
// Write submission to database -------------------------------------------------//
				}
			}	
		}
	}

// If email was sent successfully ----------------------------------------------//
	if(isset($success) AND $success == true) {
	   if ($success_page=='none') {
			//echo str_replace("\n","<br />",nl2br($success_email_text));
			$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	jAlert("'.$success_email_text.'", "'.$wb->page['page_title'].'");
});
');
  		} else {
			$row = $Pacer->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE `page_id` = '$success_page'");
		 	echo $Pacer->Code_Injection_Buid_Code('js_script',str_replace('_','',(($row['target'])?$row['target']:'self')).".location.href='".PE_URL.PAGES_DIRECTORY.$row['link'].PAGE_EXTENSION."';");
		}
// Clearing session on success -------------------------------------------------//
		$rows = $Pacer->database->queryAll("SELECT field_id FROM ".TABLE_PREFIX."mod_Form_PE_fields WHERE section_id = '$section_id' AND required = 1");
		foreach($rows as $row) {
			if(isset($_SESSION['field'.$row['field_id']])) unset($_SESSION['field'.$row['field_id']]);
		}
	} else {
		if(isset($success) AND $success == false) {
			//echo $Pacer->Translate('Error');
			$Pacer->Code_Injection_Add('js_script','
$(document).ready(function() {
	jAlert("'.$error_msg.'", "'.$wb->page['page_title'].'",function(r) {
		self.location.href = self.location.href;
	});
});
');
			
		}
	}	
// If email was sent successfully ----------------------------------------------//
}
?>