<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : code                                                       *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : modify.php                                                 *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */


// Setup template object
$template = new Template(PE_PATH.'/modules/code/htt');
$template->set_file('page', 'modify.htt');
$template->set_block('page', 'main_block', 'main');

// Get page content
$query = "SELECT content,whatis FROM ".TABLE_PREFIX."mod_code WHERE section_id = '$section_id'";
$contents = $Pacer->database->queryRow($query);
$content = (htmlspecialchars($contents['content']));
$whatis = (int)$contents['whatis'];
$params=array(
'0'=>array(
	'code'=>$Pacer->Translate('None'),
	'syntax'=>'',
	'info'=>$Pacer->Translate('None, just your input')
), 
'1'=>array(
	'code'=>'PHP',
	'syntax'=>'php',
	'info'=>'&lt;?php '.$Pacer->Translate('Your input').'  ?&gt;'
), 
'2'=>array(
	'code'=>'HTML',
	'syntax'=>'html',
	'info'=>$Pacer->Translate('Your input')
),
'3'=>array(
	'code'=>'Javascript',
	'syntax'=>'js',
	'info'=>htmlspecialchars('<script type="text/javascript">'.$Pacer->Translate('Your input').'</script>')
),
'4'=>array(
	'code'=>'Css',
	'syntax'=>'css',
	'info'=>htmlspecialchars('<style type="text/css">'.$Pacer->Translate('Your input').'</style>')
));
// Insert vars
$template->set_var(
	array(
		'PAGE_ID'				=> $page_id,
		'SECTION_ID'			=> $section_id,
		'REGISTER_EDIT_AREA'	=> function_exists('registerEditArea') ? registerEditArea('content'.$section_id, $params[$whatis]['syntax'],(($params[$whatis]['syntax'])?false:true)) : '',
		'PE_URL'				=> PE_URL,
		'PE_PATH_BS'			=> addslashes(PE_PATH),
		'PE_PATH'				=> PE_PATH,
		'PACER_URL'				=> PACER_URL,

		'ACTION_SYNTAX'			=> PE_URL.'/modules/code',
		'CONTENT'				=> $content,
		'TEXT_SAVE'				=> $TEXT['SAVE'],
		'TEXT_CANCEL'			=> $TEXT['CANCEL'],
		'TEXT_TEST'				=> $Pacer->Translate('Check Syntax'),
'TEXT_WHATIS'				=> $Pacer->Translate('Code language'),
'TEXT_TEMPLATE'				=> $Pacer->Translate('Template'),
'TEXT_TEST'				=> $Pacer->Translate('Check Syntax')
	)
);
$array_info = '';
$array_syntax='';
$template->set_block('main_block', 'whatis_block', 'whatis');

foreach($params as $k => $v) {
	$template->set_var(
		array(
			'OPTION_TEXT' => $v['code'],
			'OPTION_VALUE' => $k,
			'OPTION_SELECTED' => (($k==$whatis)? ' selected="selected"':'')
		)
	);
	$array_info.= (($array_info) ? ', ':'').'\''.$v['info'].'\'';
	$array_syntax.= (($array_syntax) ? ', ':'').'\''.$v['syntax'].'\'';

	$template->parse('whatis', 'whatis_block', true);
}
// Insert vars
$template->set_var(
	array(
		'ARRAY_INFO'				=> $array_info,
		'ARRAY_SYNTAX'				=> $array_syntax
	)
);



// Parse template object
$template->set_unknowns('keep');
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page', false);

?>