<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : edit_module_files.php                                      *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

// prevent this file from being accessed directly
if(!(isset($_POST['page_id']) && isset($_POST['section_id']) && isset($_POST['action']) 
	&& isset($_POST['mod_dir'])  && isset($_POST['edit_file']))) die(header('Location: index.php')); 

// include configuration file and admin wrapper script
require('../config.php');

// include the and admin wrapper script
require(PE_PATH.'/modules/admin.php');

// leave if the required module.functions.php file does not exist
if(!file_exists(PE_PATH .'/framework/module.functions.php')) {
	echo 'The required file: /framework/module.functions.php is missing - script stopped.';
	die;
}

// register the textarea to use edit_area
echo (function_exists('registerEditArea')) ? registerEditArea('code_area', 'css', false) : '';

// set default text output if varibles are not defined in the global WB language files
$HEADING_CSS_FILE = (isset($GLOBALS['TEXT']['HEADING_CSS_FILE'])) ?$GLOBALS['TEXT']['HEADING_CSS_FILE'] :'Actual module file: ';
$TXT_EDIT_CSS_FILE = (isset($GLOBALS['TEXT']['TXT_EDIT_CSS_FILE'])) ?$GLOBALS['TEXT']['TXT_EDIT_CSS_FILE'] :'Edit the CSS definitions in the textarea below.';

// include functions to edit the optional module CSS files (frontend.css, backend.css)
require_once(PE_PATH .'/framework/module.functions.php');

// check if the module directory is valid
$mod_dir = check_module_dir($_POST['mod_dir']);
if($mod_dir == '') {
	echo 'The specified module directory is invalid - script stopped.';
	die;
};

// check if action is: save or edit
if($_POST['action'] == 'save' && mod_file_exists($mod_dir, $_POST['edit_file'])) {
	/** 
		SAVE THE UPDATED CONTENTS TO THE CSS FILE
	*/
	$css_content = '';
	if (isset($_POST['css_data']) && strlen($_POST['css_data']) > 0) {
		$css_content = stripslashes($_POST['css_data']);
	}

	$bytes = 0;
	if ($css_content != '') {
		// open the module CSS file for writting
		$mod_file = @fopen(PE_PATH .'/modules/' .$mod_dir .'/' .$_POST['edit_file'], 'wb');
		// write new content to the module CSS file
		$bytes = @fwrite($mod_file, $css_content);
		// close the file
		@fclose($mod_file);
	}

	// write out status message
	if($bytes == 0 ) {
		$admin->print_error($TEXT['ERROR'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
	} else {
		$admin->print_success($TEXT['SUCCESS'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
	}


} else {
	/** 
		MODIFY CONTENTS OF THE CSS FILE VIA TEXT AREA 
	*/
	// check if module backend.css file needs to be included into the <body>
	if((!method_exists($admin, 'register_backend_modfiles') || !isset($_GET['page_id']))
			&& file_exists(PE_PATH .'/modules/'.$mod_dir.'/backend.css')) {
		echo '<style type="text/css">';
		include(PE_PATH .'/modules/' .$mod_dir .'/backend.css');
		echo "\n</style>\n";
	}

	// check which module file to edit (frontend.css, backend.css or '')
	$css_file = (in_array(basename($_POST['edit_file']), array('frontend.css','frontend_'.$section_id.'.css', 'backend.css'))) ? $_POST['edit_file'] : '';

	include(PE_PATH .'/modules/' .$mod_dir .'/info.php');

	// display output
	if($css_file == '') {
		// no valid module file to edit; display error message and backlink to modify.php
		echo "<h2>Nothing to edit</h2>";
		echo "<p>No valid module file exists for this module.</p>";
		$output  = "<a href=\"#\" onclick=\"javascript: window.location = '";
		$output .= ADMIN_URL ."/pages/modify.php?page_id=" .$page_id ."'\">back</a>";
		echo $output;
	
	} else {
		// store content of the module file in variable
		$css_content = @file_get_contents(PE_PATH .'/modules/' .$mod_dir .'/' .$css_file);
		// write out heading
		echo '<br><div class="page-info" align="left">
		<p>' .$module_name.' - '. $HEADING_CSS_FILE .$css_file .'</p></div>';


		//echo '<h2>' .$HEADING_CSS_FILE .'"' .$css_file .'"</h2>';
		// include button to switch between frontend.css and backend.css (only shown if both files exists)
//		toggle_css_file($mod_dir, $css_file); 
		echo "<br>";
		echo '<p>' .$TXT_EDIT_CSS_FILE .'</p>';

		// output content of module file to textareas
	?>
		<form id="edit_module_file" name="edit_module_file" action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" style="margin: 0;">
	  	<input type="hidden" name="page_id" value="<?php echo $page_id; ?>">
	  	<input type="hidden" name="section_id" value="<?php echo $section_id; ?>">
	  	<input type="hidden" name="mod_dir" value="<?php echo $mod_dir; ?>">
		<input type="hidden" name="edit_file" value="<?php echo $css_file; ?>" />
	  	<input type="hidden" name="action" value="save">
		<textarea id="code_area" name="css_data" cols="115" rows="25" wrap="VIRTUAL" style="margin:2px;"><?php
			echo htmlspecialchars($css_content); ?>
		</textarea>

  			<table cellpadding="0" cellspacing="0" border="0" width="100%">
  			<tr>
    			<td align="left" width="50%">
 				<input name="save" type="submit" onclick="javascript:jQuery.blockUI()" value="<?php echo $TEXT['SAVE'];?>"  class="settings_button" />
    			</td><!--
  				<td align="center">
			    	<?php toggle_css_file($mod_dir, $css_file); ?> 
    			</td>
-->	
  				<td align="right" width="50%">
      			<input type="button" value="<?php echo $TEXT['CANCEL']; ?>"
						onclick="javascript: self.location = '<?php echo ADMIN_URL;?>/pages/modify.php?page_id=<?php echo $page_id; ?>'" class="settings_button"/>
  				</td>
  			</tr>
  			</table>
		</form>
		<?php 
	}
}

// Print admin footer
$admin->print_footer();

?>