<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : massmailer                                                 *
 *           Version : PE 4.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : email_select.php                                           *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

require_once('../../config.php');

if(defined('PE_PATH') == false) { exit("Cannot access this file directly"); }

require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'users');

// Load Language file
if(LANGUAGE_LOADED) {
    require_once(PE_PATH.'/modules/massmailer/languages/EN.php');
    if(file_exists(PE_PATH.'/modules/massmailer/languages/'.LANGUAGE.'.php')) {
        require_once(PE_PATH.'/modules/massmailer/languages/'.LANGUAGE.'.php');
    }
}

// Setup template object
$template = new Template(PE_PATH.'/modules/massmailer');
$template->set_file('page', 'email_select.html');
$template->set_block('page', 'main_block', 'main');

$page_id = $_POST['page_id'];
$section_id = $_POST['section_id'];
$num_emails = $_POST['num_emails'];

// Select emails for deletion if any
if($num_emails){
	// Get existing mail values from database
	$database = new database();
	$query = "SELECT id, date, subject FROM ".TABLE_PREFIX."mod_massmailer ORDER BY id DESC";
	$results = $database->query($query);
	if($database->is_error()) {
		$admin->print_error($database->get_error(), 'index.php');
	}
	// Insert values into the delete mail menu
	$template->set_block('main_block', 'list_block', 'list');
	if($results->numRows() > 0) {
		while($mails = $results->fetchRow()) {
			$date = gmdate(DATE_FORMAT,$mails['date']+TIMEZONE).' - '.gmdate(TIME_FORMAT,$mails['date']+TIMEZONE);
			$template->set_var('VALUE', $mails['id']);
			$template->set_var('DATE', $date);
			$template->set_var('SUBJECT', $mails['subject']);
			$template->parse('list', 'list_block', true);
		}
	} else {
		// Insert single value to say no mails were found
		$template->set_var('NAME', $TEXT['NONE_FOUND']);
		$template->parse('list', 'list_block', true);
	}

	// Insert language headings
	$template->set_var(array(
		'HEADING_DELETE_MAIL' => $MMTEXT['MAIL_DELETE']
		)
	);

	// Insert language text and messages
	$template->set_var(array(
		'TEXT_SELECT_MAIL' => $MMTEXT['SELECT_MAIL'],
		'TEXT_DELETE' => $TEXT['DELETE'],
		'TEXT_BACK' => $TEXT['BACK']
		)
	);

	$template->set_var(array(
		'PAGE_ID' => $page_id,
		'SECTION_ID' => $section_id,
		'PE_URL' => PE_URL
		)
	);

	// Parse template object
	$template->parse('main', 'main_block', false);
	$template->pparse('output', 'page');

} else {
	// No mail to delete
	echo '<p align="center">'.$MMTEXT['MAIL_NO_DELETED'];
	echo '<br /><br />';
	echo '<a href="'.ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'">'.$TEXT['BACK'].'</a></p>';
}

// Print admin footer
$admin->print_footer();
?>