<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : massmailer                                                 *
 *           Version : PE 4.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : make_group.php                                             *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

require_once('../../config.php');

if(defined('PE_PATH') == false) { exit("Cannot access this file directly"); }

require_once(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'users');

// Load Language file
if(LANGUAGE_LOADED) {
    require_once(PE_PATH.'/modules/massmailer/languages/EN.php');
    if(file_exists(PE_PATH.'/modules/massmailer/languages/'.LANGUAGE.'.php')) {
        require_once(PE_PATH.'/modules/massmailer/languages/'.LANGUAGE.'.php');
    }
}

// Setup template object
$template = new Template(PE_PATH.'/modules/massmailer');
$template->set_file('page', 'make_group.html');
$template->set_block('page', 'main_block', 'main');

$page_id = $_POST['page_id'];
$section_id = $_POST['section_id'];

// Get existing value from database
$database = new database();
$query = "SELECT user_id, username, display_name FROM ".TABLE_PREFIX."users WHERE user_id != '1' and active = '1' ORDER BY username";
//uc $query = "SELECT user_id, username, display_name FROM ".TABLE_PREFIX."users ORDER BY username";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_error($database->get_error(), 'index.php');
}

// Insert values into the modify/remove menu
$template->set_block('main_block', 'list_block', 'list');
if($results->numRows() > 0) {
	while($user = $results->fetchRow()) {
		$template->set_var('VALUE', $user['user_id']);
		$template->set_var('NAME', $user['display_name']);
		$template->set_var('USERNAME', $user['username']);
		$template->parse('list', 'list_block', true);
	}
} else {
	// Insert single value to say no users were found
	$template->set_var('NAME', $TEXT['NONE_FOUND']);
	$template->parse('list', 'list_block', true);
}

// Insert language headings
$template->set_var(array(
	'HEADING_NEW_MAIL_GROUP' => $MMHEADING['NEW_MAIL_GROUP']
	)
);
// Insert language text and messages
$template->set_var(array(
	'TEXT_SELECT_USERS' => $MMTEXT['SELECT_USERS'],
	'TEXT_GROUP' => $TEXT['GROUP'],
	'TEXT_NAME' => $TEXT['NAME'],
	'TEXT_SAVE_NEW_GROUP' => $MMTEXT['SAVE_NEW_GROUP'],
	'TEXT_BACK' => $TEXT['BACK']
	)
);

$template->set_var(array(
	'PAGE_ID' => $page_id,
	'SECTION_ID' => $section_id,
	'PE_URL' => PE_URL,
	'CONTENT' => $content
	)
);

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');
?>