<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : massmailer                                                 *
 *           Version : PE 4.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : modify.php                                                 *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

if(defined('PE_PATH') == false) { exit("Cannot access this file directly"); }


// Setup template object
$template = new Template(PE_PATH.'/modules/massmailer');
$template->set_file('page', 'pemmget.php');
$template->set_block('page', 'main_block', 'main');



// Load Language file
if(LANGUAGE_LOADED) {
    require_once(PE_PATH.'/modules/massmailer/languages/EN.php');
    if(file_exists(PE_PATH.'/modules/massmailer/languages/'.LANGUAGE.'.php')) {
        require_once(PE_PATH.'/modules/massmailer/languages/'.LANGUAGE.'.php');
    }
}
	
//create the new addresses table if it doesnt exist, only needed on updated systems new installs should create during install
	$mod_massmailer_addresses = 'CREATE TABLE IF NOT EXISTS `'.TABLE_PREFIX.'mod_massmailer_addresses` ('
			. ' `group_id` INT(11) NOT NULL DEFAULT \'0\','
			. ' `mail_to` TEXT NOT NULL'
			. ' )';
	$database->query($mod_massmailer_addresses);
	
// Get the current users id and email;
$current_user = $admin->get_user_id();
$current_user_mail = $admin->get_email();

// Number of emails
$query = "SELECT id FROM ".TABLE_PREFIX."mod_massmailer";
$results = $database->query($query);
$num_emails = $results->numRows();

// Update NWTC Newsletter members group
$query = "SELECT DISTINCT email, user_id FROM ".TABLE_PREFIX."users WHERE active ='1'";
$results = $database->query($query);
if($database->is_error()) {
  $admin->print_error($database->get_error(), 'index.php');
}

	// Insert new members in members table
$select_users = $database->query("SELECT DISTINCT email, user_id FROM ".TABLE_PREFIX."users WHERE active ='1'");
			if($database->is_error()) {
				$admin->print_error($database->get_error(), 'index.php');
			}
			$mail_to = '';
			while($usr = $select_users->fetchRow()) {
				$mail_to .= $usr['user_id'].',';
			}
			$mail_to = substr($mail_to, 0, -1);
			// Insert new members into massmailer_groups table.
			if($mail_to != '' and $mail_to != '1') {
				$query_update = $database->query("UPDATE ".TABLE_PREFIX."mod_massmailer_groups SET mail_to = '$mail_to' WHERE group_id = 6");
				if($database->is_error()) { 
					$admin->print_error($database->get_error(), 'index.php');
				}
			}

// Update subscripe table if there are new active users
$query = "SELECT user_id, username, display_name, email FROM ".TABLE_PREFIX."users WHERE active = '1'";
$results = $database->query($query);
if($database->is_error()) {
  $admin->print_error($database->get_error(), 'index.php');
}
if($results->numRows() > 0){
	// Insert new active users in subscripe table
	while($user_id = $results->fetchRow()) {
		$uid = $user_id['user_id'];
		$username = $user_id['username'];
		$display_name = $user_id['display_name'];
		$email = $user_id['email'];
		$active_users[] = $uid;
		$query_subscripe = "SELECT user_id FROM ".TABLE_PREFIX."mod_massmailer_subscripe WHERE user_id = '$uid' LIMIT 1";
		$results_subscripe = $database->query($query_subscripe);
		if($results_subscripe->numRows() == 0){
			$query_insert = "INSERT INTO ".TABLE_PREFIX."mod_massmailer_subscripe SET user_id='$uid', username='$username', display_name='$display_name', email='$email'";
			$results_insert = $database->query($query_insert);
		}
	}
}

// Fetch all users from subscripe table
$subscripe_users = array();
$results = $database->query("SELECT user_id FROM ".TABLE_PREFIX."mod_massmailer_subscripe");
if($results->numRows() > 0){
	while($user_id = $results->fetchRow()) {
		$subscripe_users[] = $user_id['user_id'];
	}
}

// Remove deleted PE group from massmailer_group table
$m_wb_group = $database->query("SELECT wb_group_id FROM ".TABLE_PREFIX."mod_massmailer_groups WHERE wb_group_id > '0'");
if($m_wb_group->numRows() > 0) {
	while($mail_wb_group = $m_wb_group->fetchRow()) {
		$mail_wb_group = $mail_wb_group['wb_group_id'];
		// If group is deleted then remove the group from massmailer
		$group_result = $database->query("SELECT group_id FROM ".TABLE_PREFIX."groups WHERE group_id = '$mail_wb_group' LIMIT 1");
		if(!($group_result->numRows() > 0)) {
			$database->query("DELETE FROM ".TABLE_PREFIX."mod_massmailer_groups WHERE wb_group_id = '$mail_wb_group'");
			if($database->is_error()) {
				$admin->print_error($database->get_error(), 'index.php');
			}
		}
	}
}

// Get PE user groups.
$id_results = $database->query("SELECT group_id, name FROM ".TABLE_PREFIX."groups");
if($id_results->numRows() > 0){
	while($group = $id_results->fetchRow()) {
		$group_name = $group['name'];
		$group_id = $group['group_id'];
		$current_groups_name = $database->query("SELECT group_name FROM ".TABLE_PREFIX."mod_massmailer_groups WHERE group_name = '$group_name'");
		if($database->is_error()) {
			$admin->print_error($database->get_error(), 'index.php');
		}
		// Old mail group
		if($current_groups_name->numRows() > 0){
			$select_users = $database->query("SELECT user_id FROM ".TABLE_PREFIX."users WHERE group_id = '$group_id' and active = '1'");
			if($database->is_error()) {
				$admin->print_error($database->get_error(), 'index.php');
			}
			$mail_to = '';
			while($usr = $select_users->fetchRow()) {
				$mail_to .= $usr['user_id'].',';
			}
			$mail_to = substr($mail_to, 0, -1);
			if($mail_to != '' and $mail_to != '1') {
				$query_update = $database->query("UPDATE ".TABLE_PREFIX."mod_massmailer_groups SET mail_to = '$mail_to' WHERE group_name = '$group_name'");
				if($database->is_error()) {
					$admin->print_error($database->get_error(), 'index.php');
				}
			}
		} else {
			// New mail group
			$select_users = $database->query("SELECT user_id FROM ".TABLE_PREFIX."users WHERE group_id = '$group_id' and active ='1'");
			if($database->is_error()) {
				$admin->print_error($database->get_error(), 'index.php');
			}
			$mail_to = '';
			while($usr = $select_users->fetchRow()) {
				$mail_to .= $usr['user_id'].',';
			}
			$mail_to = substr($mail_to, 0, -1);
			// Insert new wb user group(s) into massmailer_groups table.
			if($mail_to != '' and $mail_to != '1') {
				$query_insert = $database->query("INSERT INTO ".TABLE_PREFIX."mod_massmailer_groups SET group_name='$group_name', mail_to='$mail_to', wb_group='1', wb_group_id='$group_id'");
				if($database->is_error()) { 
					$admin->print_error($database->get_error(), 'index.php');
				}
			}
		}
	}
}

// Delete selected mail group
if(isset($_POST['delete_id']) && !empty($_POST['delete_id'])){
	$delete_id = $_POST['delete_id'];

	//Delete custom made mail groups, wb users mail group can't be deleted
	$query_wb_group = $database->query("SELECT wb_group FROM ".TABLE_PREFIX."mod_massmailer_groups WHERE group_id = '$delete_id'");
	if($query_wb_group->numRows() > 0){
		while($wb_grp = $query_wb_group->fetchRow()) {
			$wb_group = $wb_grp['wb_group'];
		}
	}
	if(!$wb_group){
		// Delete mail groups except 'All users' group.
		if ($delete_id != 1){
			$database->query("DELETE FROM ".TABLE_PREFIX."mod_massmailer_groups WHERE group_id = '$delete_id'");
			if($database->is_error()) {
				$admin->print_error($database->get_error(), 'index.php');
			} else {
				echo "<SCRIPT>alert('".$MMTEXT['MAIL_GROUP_DELETE']."');</SCRIPT>";
			}
	    } else {
			echo "<SCRIPT>alert('".$MMTEXT['NO_WB_GROUP_DELETE']."');</SCRIPT>";
		}
	} else {
		echo "<SCRIPT>alert('".$MMTEXT['NO_WB_GROUP_DELETE']."');</SCRIPT>";
	}
}

// get selected mail group id
if(isset($_POST['group_id']) && !empty($_POST['group_id'])){
	$sel_group_id = $_POST['group_id'];
}
elseif(isset($_SESSION['sel_group_id']) && !empty($_SESSION['sel_group_id'])){	
	$sel_group_id =$_SESSION['sel_group_id'];
} else {
	$sel_group_id = 1;
}

// Get existing value from database
$database = new database();

// Get mail groups from database
$query = "SELECT group_id, group_name, mail_to FROM ".TABLE_PREFIX."mod_massmailer_groups ORDER BY wb_group DESC";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_error($database->get_error(), 'index.php');
}

// Insert values into the mail group
$template->set_block('main_block', 'select_mail_block', 'select_mail');
if($results->numRows() > 0) {
	// Loop through mail groups
	while($mail_group = $results->fetchRow()) {
		$template->set_var('GROUP_VALUE', $mail_group['group_id']);
		if($mail_group['group_id'] == $sel_group_id ){
			$template->set_var('SELECTED', 'selected');
		}
		else {
			$template->set_var('SELECTED', '');
		}
		$template->set_var('GROUP_NAME', $mail_group['group_name']);
		$template->parse('select_mail', 'select_mail_block', true);
	}
} else {
	// Insert single value to say no mail groups were found
	$template->set_var('NAME', $TEXT['NONE_FOUND']);
	$template->parse('select_mail', 'select_mail_block', true);
}

// Get admin mail
$query = "SELECT email FROM ".TABLE_PREFIX."users WHERE user_id = '1' and active = '1' LIMIT 1";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_error($database->get_error(), 'index.php');
}
$user = $results->fetchRow();

// get current user
$query = "SELECT user_id, username, display_name FROM ".TABLE_PREFIX."users WHERE user_id != '$current_user' and active = '1' ORDER BY username";
$results = $database->query($query);
if($database->is_error()) {
	$admin->print_error($database->get_error(), 'index.php');
}

// only one mail to admin
$current_user == '1'?$cc = '':$cc = $user['email'];

// Insert values into the New Mail group
$template->set_block('main_block', 'list_block', 'list');
if($results->numRows() > 0) {
	while($user = $results->fetchRow()) {
		$template->set_var('VALUE', $user['user_id']);
		$template->set_var('NAME', $user['display_name']);
		$template->set_var('USERNAME', $user['username']);
		$template->parse('list', 'list_block', true);
	}
} else {
	// Insert single value to say no users/mails were found
	$template->set_var('NAME', $TEXT['NONE_FOUND']);
	$template->parse('list', 'list_block', true);
}

// Insert language headings
$template->set_var(array(
	'HEADING_SUBSCRIPE_USER' => $MMHEADING['SUBSCRIPE'],
	'HEADING_MODIFY_DELETE_USER' => $HEADING['MODIFY_DELETE_USER'],
	'HEADING_SEND_massmailer' => $MMHEADING['SEND_massmailer'],
	'ADD_ADD_TO_GROUP' => $MMHEADING['ADD_TO_GROUP']
	)
);

// Insert language text and messages
$template->set_var(array(
	'TEXT_FROM' => $TEXT['FROM'],
	'TEXT_TO' => $TEXT['TO'],
	'TEXT_SUBJECT' => $TEXT['SUBJECT'],
	'TEXT_SELECT_MAIL_GROUP' => $MMTEXT['SELECT_MAIL_GROUP'],
	'TEXT_NEW_GROUP' => $MMTEXT['NEWGROUP'],
	'TEXT_MODIFY' => $TEXT['MODIFY'],
	'TEXT_DELETE' => $TEXT['DELETE'],
	'TEXT_DELETE_MAIL' => $MMTEXT['MAIL_DELETE'],
	'TEXT_MANAGE_GROUPS' => $TEXT['MANAGE_GROUPS'],
	'TEXT_WRITE_ADDRESS' => $MMTEXT['WRITE_USER_ADDRESS'],
	'TEXT_UNSUBSCRIPED_MESS1' => $MMTEXT['UNSUBSCRIPED_MESS1'],
	'TEXT_UNSUBSCRIPED_MESS2' => $MMTEXT['UNSUBSCRIPED_MESS2'],
	'TEXT_UNSUBSCRIPED' => $MMTEXT['UNSUBSCRIPED'],
	'TEXT_UNSUBSCRIPE' => $MMTEXT['UNSUBSCRIPE'],
	'TEXT_SUBSCRIPE' => $MMTEXT['SUBSCRIPE'],
	'CONFIRM_DELETE' => $MESSAGE['USERS']['CONFIRM_DELETE']
	)
);

// get all active users and compare them with current mail group
// Select supscriped users
$users_subscripe = array();
$query_subscripe = $database->query("SELECT user_id FROM ".TABLE_PREFIX."mod_massmailer_subscripe WHERE subscripe ='1'");
if($query_subscripe->numRows() > 0) {
	while($row = $query_subscripe->fetchRow()) {
		$users_subscripe[] = $row['user_id'];
	}
}
// *All users group*
$email=array();
if($sel_group_id == '1'){
	// Get 'all users' email group except the current user and admin
	$query = "SELECT email, user_id  FROM ".TABLE_PREFIX."users WHERE active = '1' and user_id != '1' and user_id != '$current_user'";
	$get_content = $database->query($query);
	// Make a comma-separated group of all subscripe-users Email Adresses and User id's
	if($get_content->numRows() > 0) {
		while($row = $get_content->fetchRow()) {
			// don't select unsubscriped users
			if(array_search($row['user_id'], $users_subscripe)) {
			array_push($email,trim($row['email']));
				$users_id = $row['user_id'] . ",";
				
			}
		}
	}
	// Strip the last char
	$users_id = substr($users_id, 0, -1);
	$query = "UPDATE ".TABLE_PREFIX."mod_massmailer_groups SET mail_to = '$users_id' WHERE group_id = '$sel_group_id'";
	$database->query($query);

} else {
	// *administrator made groups and wb groups*
	// Get selected email group
	$query_content = $database->query("SELECT mail_to FROM ".TABLE_PREFIX."mod_massmailer_groups WHERE group_id = '$sel_group_id'");
	$fetch_content = $query_content->fetchRow();
	$user_group = $fetch_content['mail_to'];
	$user_group = explode(',',$user_group);

	// Get and insert all user email adresses in users array
	$users = array();
	$query_users = $database->query("SELECT user_id, email FROM ".TABLE_PREFIX."users");
	if($query_users->numRows() > 0) {
		while($user = $query_users->fetchRow()) {
			// Insert user info into users array
			$user_id = $user['user_id'];
			$users[$user_id]['email'] = $user['email'];
		}
	}
	// Get subscriped user mail adresses and make bcc string.
	foreach ($user_group as $id_user) {
		if($users[$id_user]['email'] && array_search($id_user, $users_subscripe)){
			//$email .= trim($users[$id_user]['email']).', ';
			array_push($email,trim($users[$id_user]['email']));
		}
	}

}
// current users email address
$my_email = $admin->get_email();
	//get all from extra addresses where group_id=group id.... 
	$query_moreusers = $database->query("SELECT mail_to FROM ".TABLE_PREFIX."mod_massmailer_addresses where group_id=".$sel_group_id." ORDER BY mail_to");
	if($query_moreusers->numRows() > 0) {
		while($moreuser = $query_moreusers->fetchRow()) {
			// Insert user info into users array
			array_push($email,trim($moreuser['mail_to']));
		}
	}
$email=implode(", ",array_unique($email));
$email=trim(str_replace(", , ",", ",$email),", ");





// default message
if(isset($_SESSION['content'])){
	$content =$_SESSION['content'];
	}
else{
	$content = $MMTEXT['FOOTER']."  ". PE_URL."   ";
	}
//set subject
	if(isset($_SESSION['subject'])){
	$subject =$_SESSION['subject'];
	}
else{
	$subject ="";
	}

// Insert vars
$template->set_var(array(
	'CURRENT_USER_MAIL' => $current_user_mail,
	'PAGE_ID' => $page_id,
	'SECTION_ID' => $section_id,
	'CONTENT' => $content,
	'SEL_GROUP_ID' => $sel_group_id,
	'PE_URL' => PE_URL,
	'SUBJECT' => $subject,
	'NUM_EMAILS' => $num_emails,
	'EMAILS' => $email,
	'MY_EMAIL' => $my_email,
	'CC' => $cc,
	'TEXT_SEND_MAIL' => $MMTEXT['SEND_MAIL'],
	'DELETE' => $MMTEXT['DELETE_GROUP'],
	'TEXT_CANCEL' => $TEXT['CANCEL'],
	'TEMPLATE' => DEFAULT_TEMPLATE
	)
);

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

 

?>



