<?php
/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : menu_link                                                  *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : modify.php                                                 *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */
 
// prevent this file from being accessed directly
if (!defined('PE_PATH')) die(header('Location: ../../index.php'));

// Obtain module directory
require(PE_PATH.'/modules/'.basename(dirname(__FILE__)).'/info.php');


// Include standard module functions 
require_once(PE_PATH . '/framework/module.functions.php');

// include the module language file depending on the backend language of the current user
require_once(get_module_language_file($module_directory));

// Include module functions
//require_once(PE_PATH.'/modules/'.$module_directory.'/functions.php');

// Execute dependencies for backend
resolve_module_dependencies($module_directory,false);

// Get module settings
$settings = $Pacer->database->queryRow("SELECT * FROM `".TABLE_PREFIX."mod_".$module_directory."` WHERE `section_id` = '$section_id'");
$anchor = $settings['anchor'];

$fields=array();

// Build Page
//resolve_module_backend_modify_body($fields,'','modify',false);

// Get new submission_id
$submission_id = form_submission_id();

// now get the tree
$page_layout = $Pacer->PageLayout();
$links = array();

//print_r($page_layout);
foreach($page_layout as $k => $page){
	$links[$page['page_id']] = str_repeat('-&nbsp;',((int)$page['level'])*1).$page['page_title'];
}
// get target-window for actual page
$target = $Pacer->database->get_one("SELECT target  FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'");

$options_target_page_id=array_merge(array($TEXT['PLEASE_SELECT']=>'0',$MOD_MENU_LINK['EXTERNAL_LINK']=>'-1'),array_flip($links));
$options_redirect_type=array('301 - '.$Pacer->Translate('Permanently')=>'301','302 - '.$Pacer->Translate('Temporary')=>'302');
$options_target=array($TEXT['NEW_WINDOW']=>'_blank',$TEXT['SAME_WINDOW']=>'_self',$TEXT['TOP_FRAME']=>'_top',$Pacer->Translate('Popup')=>'popup',$Pacer->Translate('Modal')=>'modal');

$targets = array();
foreach($links as $pid=>$l) {
	if($sections = $Pacer->database->queryAll("SELECT section_id, module FROM ".TABLE_PREFIX."sections WHERE page_id = '$pid' ORDER BY position")) {
		foreach($sections as $section) {
			// get section-anchor
			if(defined('SEC_ANCHOR') && SEC_ANCHOR!='') {
				$targets[$pid][] = SEC_ANCHOR.$section['section_id'];
			} else {
				$targets[$pid] = array();
			}
			if($section['module'] == 'wysiwyg') {
				if($content = $Pacer->database->get_one("SELECT content FROM ".TABLE_PREFIX."mod_wysiwyg WHERE section_id = '".$section['section_id']."' LIMIT 1")) {
					if(preg_match_all('/<(?:a[^>]+name|[^>]+id)\s*=\s*"([^"]+)"/i',$content, $match)) {
						foreach($match[1] AS $t) {
							$targets[$pid][$t] = $t;
						}
					}
				}
			}
		}
	}
}


// Get fields definition
require_once(PE_PATH.'/modules/'.$module_directory.'/fields_settings.php');

// Get fields values
$fields = load_module_backend_fields_value($fields,$settings);

// Build Page
resolve_module_backend_body($fields,array('DISPLAY_HELP_BUTTON'=>true),'settings',false);

$script="function populate() {
		o=document.getElementById('target_page_id');
		d=document.getElementById('anchor');
		e=document.getElementById('extern');
		var mitems=new Array();
		mitems['0']=[' ','0'];
		mitems['-1']=[' ','0'];
		";
foreach($links AS $pid=>$link) {
	$str="mitems['$pid']=[";
	$str.="' ',";
	$str.="'0',";
	if(is_array($targets)) {
		if (array_key_exists($pid,$targets)) {
			foreach($targets[$pid] AS $value) {
				$str.="'#$value',";
				$str.="'$value',";
			}
			$str=rtrim($str, ',');
		}
		$str.="];\n";
	}
	$script.=$str;
}
$script.="
		d.options.length=0;
		cur=mitems[o.options[o.selectedIndex].value];
		d.options.length=cur.length/2;
		j=0;
		for(var i=0;i<cur.length;i=i+2) {
			d.options[j].text=cur[i];
			d.options[j].value=cur[i+1];
			if(d.options[j].value=='".$anchor."') d.options[j].selected=true;
			j++;
		}
		if(o.value=='-1') {
			e.disabled = false;
			jQuery('tr.cl_extern').show();
			jQuery('tr.cl_anchor').hide();
		} else {
			e.disabled = true;
			jQuery('tr.cl_extern').hide();
			jQuery('tr.cl_anchor').show();			
		}
		var i=0;
		jQuery('#form_modify_".$section_id." tr.row_a:visible, #form_modify_".$section_id." tr.row_b:visible').each(function(){
			if (i % 2) {
				jQuery(this).removeClass('row_a');
				jQuery(this).addClass('row_b');
			} else {
				jQuery(this).removeClass('row_b');
				jQuery(this).addClass('row_a');
			}
			i++;
		});
}
jQuery(document).ready(function() {
	populate();	
});";
$Pacer->Code_Injection_Add('js_script',$script);
?>