<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : menu_link                                                  *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : save_settings.php                                          *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************

*/

require('../../config.php');

// Be sure dont print header
$print_info_banner = false;

// Update Page modified by and when
$update_when_modified = true;

// Include PE admin wrapper script
require(PE_PATH.'/modules/admin.php');

// Obtain module directory
require(PE_PATH.'/modules/'.basename(dirname(__FILE__)).'/info.php');

// Where to go back to
$js_back = ADMIN_URL.'/pages/modify.php?'.http_build_query( array('page_id'=>$page_id,'section_id'=>$section_id,'modify_pgm'=>'modify.php','submission_id'=>$admin->get_post('submission_id')));

$js_back = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'&section_id='.$section_id; //.'&modify_pgm='.'modify_settings.php'.'&submission_id='.$admin->get_post('submission_id');

// Include standard module functions 
require_once(PE_PATH . '/framework/module.functions.php');

// Include the module language file depending on the backend language of the current user
@include(get_module_language_file($module_directory));

// Include module functions
//require_once(PE_PATH.'/modules/'.$module_directory.'/functions.php');

// Include module fields
require_once(PE_PATH.'/modules/'.$module_directory.'/fields_settings.php');

// Get new submission_id
$submission_id = form_submission_id();

// Get posted values from form
$fields = get_module_backend_body($fields);


// Do extra settings work-out here
if (($fields['target_page_id']['value']=='0') || ($fields['target_page_id']['value']=='-1' && trim($fields['extern']['value'])=='')) {
	$admin->print_error($MESSAGE['GENERIC']['FILL_IN_ALL'],$js_back);
	exit();
}

// get target-window for actual page
$target = $Pacer->database->get_one("SELECT target  FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'");
if ($fields['target']['value']!=$target) {
	$target=$fields['target']['value'];	
	if(!update_into_table("pages",array('target'=>$target),array('page_id'=>$page_id))) {
		$Pacer->print_error($Pacer->Translate("Failed")." ".$database->get_error(), $js_back);
		exit();
	}
}
unset($fields['target']);

/*
// If we have some validation error, print error and go back to prev page.
module_backend_fields_check($js_back);
*/

// Update table, Check if there is a db error, otherwise say successful
if(!update_into_table("mod_".$module_directory."",$fields,array('page_id'=>$page_id,'section_id'=>$section_id))) {
	$Pacer->print_error($Pacer->Translate("Failed")." ".$database->get_error(), $js_back);
} else {
	$Pacer->LogEvent(sprintf($Pacer->Translate("Module %s - Settings updated"),$module_name));
    $Pacer->print_success($Pacer->Translate("Success"), $js_back);
}
?>