<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : output_filter                                              *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : tool.php                                                   *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
*/

// prevent this file from being accessed directly
if(!defined('PE_PATH')) die(header('Location: ../index.php'));
$admin->print_sub_header($Pacer->Translate('Pacer Frontend Output Filter'),$Pacer->Translate('This filter the output before displaying it on the frontend. ...'),str_replace('\\','/',str_replace(PE_PATH,PE_URL,dirname(__FILE__))).'/icon.png');

// check if module language file exists for the language set by the user (e.g. DE, EN)
if(!file_exists(PE_PATH .'/modules/output_filter/languages/'.LANGUAGE .'.php')) {
	// no module language file exists for the language set by the user, include default module language file EN.php
	require_once(PE_PATH .'/modules/output_filter/languages/EN.php');
} else {
	// a module language file exists for the language defined by the user, load it
	require_once(PE_PATH .'/modules/output_filter/languages/'.LANGUAGE .'.php');
}
// check if data was submitted
if(isset($_POST['save_settings'])) {
	// get overall output filter settings
	$email_filter = (isset($_POST['email_filter']) && $_POST['email_filter'] == '1') ? '1' : '0';
	$mailto_filter = (isset($_POST['mailto_filter']) && $_POST['mailto_filter'] == '1') ? '1' : '0';
	
	// get email replacement settings
	$at_replacement = isset($_POST['at_replacement']) ?strip_tags($_POST['at_replacement']) : '';
	$at_replacement = (strlen(trim($at_replacement)) > 0) ? $admin->add_slashes($at_replacement) : '(at)';
	$dot_replacement = isset($_POST['dot_replacement']) ?strip_tags($_POST['dot_replacement']) : '';
	$dot_replacement = (strlen(trim($dot_replacement)) > 0) ? $admin->add_slashes($dot_replacement) : '(dot)';
	
	// update database settings
	$database->query("UPDATE " .TABLE_PREFIX ."mod_output_filter SET email_filter = '$email_filter', 
		mailto_filter = '$mailto_filter', at_replacement = '$at_replacement', dot_replacement = '$dot_replacement'");

	// check if there is a database error, otherwise say successful
	if($database->is_error()) {
		$admin->print_error($database->get_error(), $js_back);
	} else {
		$admin->print_success($MESSAGE['PAGES']['SAVED'], ADMIN_URL.'/admintools/tool.php?tool=output_filter');
	}

} else {
	// write out heading
//	echo '<h2>' .$MOD_MAIL_FILTER['HEADING'] .'</h2>';

	// include filter functions
	require_once(PE_PATH .'/modules/output_filter/filter-routines.php');
	
	// read the mail filter settings from the database 
	$data = get_output_filter_settings();
	
	// output the form with values from the database
	echo '<br /><p>' .$MOD_MAIL_FILTER['HOWTO'] .'</p><br />';
?>
<form name="store_settings" action="<?php echo $_SERVER['REQUEST_URI'];?>" method="post">
	<table width="98%" cellspacing="4" cellpadding="5px" class="row_a">
	<tr><td colspan="2"><strong><?php echo $MOD_MAIL_FILTER['BASIC_CONF'];?>:</strong></td></tr>
	<tr>
		<td width="240"><?php echo $MOD_MAIL_FILTER['EMAIL_FILTER'];?>:</td>
		<td>
			<input type="radio" <?php echo ($data['email_filter']=='1') ?'checked="checked"' :'';?>
				name="email_filter" value="1" id="email_filter_1" />&nbsp;<label for="email_filter_1"><?php echo $MOD_MAIL_FILTER['ENABLED'];?></label>
			<input type="radio" <?php echo (($data['email_filter'])=='0') ?'checked="checked"' :'';?>
				name="email_filter" value="0" id="email_filter_0" />&nbsp;<label for="email_filter_0"><?php echo $MOD_MAIL_FILTER['DISABLED'];?></label>
		</td>
	</tr>
	<tr>
		<td><?php echo $MOD_MAIL_FILTER['MAILTO_FILTER'];?>:</td>
		<td>
			<input type="radio" <?php echo ($data['mailto_filter']=='1') ?'checked="checked"' :'';?>
				name="mailto_filter" value="1" id="mailto_filter_1" />&nbsp;<label for="mailto_filter_1"><?php echo $MOD_MAIL_FILTER['ENABLED'];?></label>
			<input type="radio" <?php echo (($data['mailto_filter'])=='0') ?'checked="checked"' :'';?>
				name="mailto_filter" value="0" id="mailto_filter_0" />&nbsp;<label for="mailto_filter_0"><?php echo $MOD_MAIL_FILTER['DISABLED'];?></label>
		</td>
	</tr>
    </table>
    <br />
	<table width="98%" cellspacing="4" cellpadding="5px" class="row_a">

	<tr><td colspan="2"><strong><?php echo $MOD_MAIL_FILTER['REPLACEMENT_CONF'];?>:</strong></td></tr>
	<tr>
		<td  width="240"><?php echo $MOD_MAIL_FILTER['AT_REPLACEMENT'];?>:</td>
		<td><input type="text" style="width: 160px" value="<?php echo $data['at_replacement'];?>" 
			name="at_replacement"/></td>
	</tr>
	<tr>
		<td><?php echo $MOD_MAIL_FILTER['DOT_REPLACEMENT'];?>:</td>
		<td><input type="text" style="width: 160px" value="<?php echo $data['dot_replacement'];?>" 
			name="dot_replacement"/></td>
	</tr>
	</table>
    <br />
	<p align="center"><input type="submit" name="save_settings" style="margin-top:10px; width:140px;" value="<?php echo $TEXT['SAVE']; ?>" /></p>
</form>
<?php
}

?>
    <br />
        <br />