<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : wysiwyg                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : manage_history.php                                         *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

//require('../../config.php');
if(!defined('PE_PATH')) exit('Direct access to this file is not allowed');

// obtain module directory
require(dirname(__FILE__).'/info.php');

// Include PE admin wrapper script
$update_when_modified = true; // Tells script to update when this page was last updated
//require_once(PE_PATH.'/modules/admin.php');

// include core functions of PE 2.7 to edit the optional module CSS files
@include_once(PE_PATH .'/framework/module.functions.php');

// Include the PE functions file
require_once(PE_PATH.'/framework/functions.php');
// some compatibility-functions
if(!function_exists('umlauts_to_entities')) {
function umlauts_to_entities($str, $charset) {
	return($str);
}
}
if(!function_exists('gzuncompress')) {
function gzuncompress($str, $level=6) {
	return($str);
}
}

require_once(PE_PATH.'/modules/'.$module_directory.'/functions.php');
global $MOD_WYSIWYG;
// execute dependencies
resolve_module_dependencies($module_directory,false);

// Template
$t = new Template(dirname(__FILE__).'/templates', 'remove');
$t->halt_on_error = 'no';
$t->set_file('history', 'manage_history.htt');
// clear the comment-block, if present
 $t->set_block('history', 'CommentDoc'); $t->clear_var('CommentDoc');
$t->set_block('history', 'Entries', 'ENTRIES');

$table_wysiwyg      = TABLE_PREFIX.'mod_wysiwyg';
$table_wysiwyg_hist = TABLE_PREFIX.'mod_wysiwyg_hist';
$table_pages        = TABLE_PREFIX.'pages';

// something to delete?
if(isset($_GET['delete']) && is_numeric($_GET['delete'])) {
	$query = $database->query("DELETE FROM `$table_wysiwyg_hist` WHERE `h_id` = {$_GET['delete']} LIMIT 1");
}

// something to restore?
if(isset($_GET['restore']) && is_numeric($_GET['restore'])) {
	// store actual content in history
	$restore = (int)$_GET['restore'];
	$autosaved = $version = 0;
	$query = $database->query("SELECT `last_version`, `hist_autosave`, `content`, `content_comment` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
	$row = $query->fetchRow();
	$old_content = $row['content']; // we don't need addslahes, because content will be compressed
	$old_comment = addslashes($row['content_comment']);
	$hist_version = $row['last_version']+1;
	if($row['hist_autosave'])
		$autosaved = 1;
	// copy old content from history to actual content
	$query = $database->query("SELECT `version`,`content`, `comment` FROM `$table_wysiwyg_hist` WHERE `h_id` = $restore");
	if($query->numRows()>0) {
		$row = $query->fetchRow();
		$hist_content = addslashes(gzuncompress($row['content']));
		$hist_comment = addslashes($row['comment']);
		$version = $row['version'];
		$text = addslashes(umlauts_to_entities(strip_tags($hist_content), strtoupper(DEFAULT_CHARSET)));
		$database->query("UPDATE `$table_wysiwyg` SET `content` = '$hist_content', `content_comment` = '$hist_comment',`text` = '$text' WHERE `section_id` = $section_id");
	}
	$database->query("UPDATE `$table_wysiwyg` SET `last_version` = $hist_version WHERE `section_id` = $section_id");
	$database->query("INSERT `$table_wysiwyg_hist` (`section_id`,`version`,`autosaved`,`date`,`user_id`,`comment`,`content`) VALUES ($section_id,$hist_version,$autosaved,".time().",".$admin->get_user_id().",'".addslashes($MOD_WYSIWYG['AUTOSAVED_HIST_REST']." ($version)\n$old_comment")."','".addslashes(gzcompress($old_content))."')");
	// drop old content from history
	$query = $database->query("DELETE FROM $table_wysiwyg_hist WHERE `h_id` = $restore LIMIT 1");
}

// fetch all info-entries from history (don't fetch content)
$entries = array();
$query = $database->query("SELECT `h_id`,`version`,`autosaved`,`date`,`user_id`,`comment` FROM `$table_wysiwyg_hist` WHERE `section_id` = '$section_id' ORDER BY `version`");
if($query->numRows() > 0)	{
	while($row = $query->fetchRow()) {
		$entries[$row['h_id']]['date'] = date(DATE_FORMAT.' '.TIME_FORMAT, $row['date']);
		$tmp = $admin->get_user_details($row['user_id']);
		$entries[$row['h_id']]['user'] = "{$tmp['display_name']} ({$tmp['username']})";
		$entries[$row['h_id']]['comment'] = nl2br($row['comment']);
		$entries[$row['h_id']]['version'] = $row['version'];
		$entries[$row['h_id']]['autosaved'] = $row['autosaved'];
	}
}
// Get page link
$get_link = $database->query("SELECT `link` FROM `$table_pages` WHERE `page_id` = $page_id");
$res = $get_link->fetchRow();
$link = $res['link'];

$t->set_var(array(
	'HIDDEN' => 'style="display:none !important;"',
	'HEADING' => $MOD_WYSIWYG['HISTORY'],
	'VERSION_STR' => $TEXT['VERSION'],
	'DATE_STR' => $TEXT['DATE'],
	'COMMENT_STR' => $TEXT['COMMENT'],
	'USER_STR' => $TEXT['USER'],
	'ACTIONS_STR' => $TEXT['ACTIONS'],
	'BACK_STR' => $TEXT['BACK'],
	'BACK_ONCLICK' => 'javascript: window.location = \''.ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'&amp;status=original\';',
	'CANCEL_STR' => $TEXT['CANCEL'],
	//'ADMIN_FOOTER' => $footer,
	'CANCEL_ONCLICK' => 'javascript: window.location = \''.ADMIN_URL.'/pages/index.php\';'
	
));

$row = 1;
foreach($entries AS $h_id=>$entry) {
	if($row==1)
		$class = 'row_a';
	else
		$class = 'row_b';
	$row = ++$row%2;
	
	$t->set_var(array(
		'CLASS_ROW_AB' => $class,
		'VERSION' => ($entry['autosaved']==0?$entry['version'].' !':$entry['version']),
		'DATE' => $entry['date'],
		'COMMENT' => $entry['comment'],
		'USER' => $entry['user'],
		'VIEW_LINK' => $admin->page_link($link).'?status=history&h_id='.$h_id.'&amp;s_id='.$section_id,
		'VIEW_IMAGE' => THEME_URL.'/images/view_16.png',
		'VIEW_STR' => $TEXT['VIEW'],
//		'RESTORE_LINK' => PE_URL.'/modules/wysiwyg/manage_history.php?page_id='.$page_id.'&amp;section_id='.$section_id.'&amp;restore='.$h_id,
		'RESTORE_LINK' => ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'&amp;section_id='.$section_id.'&amp;restore='.$h_id.'&amp;modify_pgm=manage_history.php',
		
		'RESTORE_IMAGE' => THEME_URL.'/images/restore_16.png',
		'RESTORE_STR' => $TEXT['RESTORE'],
//		'DELETE_LINK' => PE_URL.'/modules/wysiwyg/manage_history.php?page_id='.$page_id.'&amp;section_id='.$section_id.'&amp;delete='.$h_id,
		'DELETE_LINK' => ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'&amp;section_id='.$section_id.'&amp;delete='.$h_id.'&amp;modify_pgm=manage_history.php',
		'DELETE_IMAGE' => THEME_URL.'/images/delete_16.png',
		'DELETE_STR' => $TEXT['DELETE']
	));
	$t->parse('ENTRIES','Entries', TRUE);
}
$t->pparse('Output', 'history');
?>