<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : wysiwyg                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : modify.php                                                 *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

if(!defined('PE_PATH')) exit('Direct access to this file is not allowed');

// include module.functions.php (introduced with WB 2.7)
require_once(PE_PATH . '/framework/module.functions.php');

// obtain module directory
require(dirname(__FILE__).'/info.php');

require_once(PE_PATH.'/modules/'.$module_directory.'/functions.php');

$force_use_tiny_mce_smart_buttons=false;

resolve_module_dependencies($module_directory,false,'MOD_WYSIWYG');

// Template
$t = new Template(dirname(__FILE__).'/templates', 'remove');
//$t->halt_on_error = 'no';
$t->set_file('modify', 'modify.htt');
// clear the comment-block, if present
 $t->set_block('modify', 'CommentDoc'); $t->clear_var('CommentDoc');
$t->set_block('modify', 'ShowIsOriginal', 'SHOWISORIGINAL');
$t->set_block('modify', 'ShowIsOriginal2', 'SHOWISORIGINAL2');
$t->set_block('modify', 'ShowUseWCCheck', 'SHOWUSEWCCHECK');
$t->set_block('modify', 'ShowIsNotOriginal', 'SHOWISNOTORIGINAL');

$table_wysiwyg      = TABLE_PREFIX.'mod_wysiwyg';
$table_wysiwyg_hist = TABLE_PREFIX.'mod_wysiwyg_hist';
$table_pages        = TABLE_PREFIX.'pages';
$table_sections     = TABLE_PREFIX.'sections';

// Get page link
$get_link = $database->query("SELECT `link` FROM `$table_pages` WHERE `page_id` = $page_id");
$res = $get_link->fetchRow();
$link = $res['link'];

// check if working_content is present (not empty)
$query = $database->query("SELECT LENGTH(`working_content`) AS `len` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
$row = $query->fetchRow();
$wc_present = $row['len'];

// check if history is empty
$query = $database->query("SELECT COUNT(*) AS `hist` FROM `$table_wysiwyg_hist` WHERE `section_id` = $section_id");
$row = $query->fetchRow();
$hist_present = $row['hist'];

// work out what to load (content or working_content)
if(isset($_GET['status']) && $_GET['status']=='workingcopy') { // use working_content if present, else copy content
	if($wc_present) { $content_field = 'working_content'; $content_comment_field = 'working_content_comment'; }
	else { $content_field = 'content'; $content_comment_field = 'content_comment'; }
	$status = 'workingcopy';
} elseif(!isset($_GET['status'])) { // use working_content if present, else use content
	if($wc_present) { // changed in 2.7.4.4 - load content always, use new icon to load working-copy
		$content_field = 'content'; // = 'working_content';
		$content_comment_field = 'content_comment'; // = 'working_content_comment';
		$status = 'original'; // = 'workingcopy';
	} else {
		$content_field = 'content';
		$content_comment_field = 'content_comment';
		$status = 'original';
	}
} else { // use content
	$content_field = 'content';
	$content_comment_field = 'content_comment';
	$status = 'original';
}
if($status == 'original') {
	$original_stat = ' checked="checked"';
	$workingcopy_stat = '';
} else {
	$original_stat = '';
	$workingcopy_stat = ' checked="checked"';
}	

// check if use_workingcopy is set
// check if autosave is active for this section - saves content on every change in history
$query = $database->query("SELECT `use_workingcopy`,`hist_autosave` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
$row = $query->fetchRow();
$autosave = $row['hist_autosave'];
$use_workingcopy = (int)($row['use_workingcopy']);
$history_add_stat = '';
if($autosave) {
	$autosave_stat = ' checked="checked"';
} else {
	$autosave_stat = '';
}

// Get content
$query = $database->query("SELECT `$content_field` AS `content`, `$content_comment_field` AS `comment`, `hist_autosave_num` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
$row = $query->fetchRow();
$content = htmlspecialchars($row['content']);
$comment = $row['comment'];
$hist_autosave_num = $row['hist_autosave_num'];

if(!isset($wysiwyg_editor_loaded)) {
	$wysiwyg_editor_loaded=true;

	if (!defined('WYSIWYG_EDITOR') OR WYSIWYG_EDITOR=="none" OR !file_exists(PE_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php')) {
		function show_wysiwyg_editor($name,$id,$content,$width,$height) {
			echo '<textarea name="'.$name.'" id="'.$id.'" style="width: '.$width.'; height: '.$height.';">'.$content.'</textarea>';
		}
	} else {
		$id_list=array();
		$query_wysiwyg = $database->query("SELECT `section_id` FROM `$table_sections` WHERE `page_id` = $page_id AND `module` = 'wysiwyg'");
		if($query_wysiwyg->numRows() > 0) {
			while($wysiwyg_section = $query_wysiwyg->fetchRow()) {
				$entry='content'.$wysiwyg_section['section_id'];
				array_push($id_list,$entry);
			}
			require_once(PE_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');
		}
	}
}

// fetch editor
/*
ob_start();
show_wysiwyg_editor('content'.$section_id,'content'.$section_id,$content,'725px','350px');
$editor_field = ob_get_contents();
ob_end_clean();
*/
$force_use_tiny_mce_smart_buttons=true;
require_once(PE_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.func.php');
					
$editor_field = show_wysiwyg_editor('content'.$section_id, 'content'.$section_id, $content, 730, 300,array('no_output'=>true,'class'=>'expanding300-400 settings_textarea '));
					

$t->set_var(array(
	'HIDDEN' => 'style="display:none !important;"',
	'ID1' => 'id1'.'wysiwyg'.$section_id,
	'ID2' => 'id2'.'wysiwyg'.$section_id,
	'ID3' => 'id3'.'wysiwyg'.$section_id,
	'USE_WORINGCOPY_STR' => $MOD_WYSIWYG['USE_WORKINGCOPY'],
	'USE_WORKINGCOPY_CHECKED' => ($use_workingcopy?'checked="checked"':''),
	'FORM_NAME' => 'wysiwyg'.$section_id,
	'FORM_ACTION' => PE_URL.'/modules/wysiwyg/save.php',
	'PAGE_ID' => $page_id,
	'SECTION_ID' => $section_id,
	'STATUS' => $status,
	'WYSIWYG_EDITOR' => $editor_field,
	'SAVE_STR' => $TEXT['SAVE'],
	'COMMENT_STR' => $MOD_WYSIWYG['COMMENT'],
	'COMMENT' => $comment,
	'ORIGINAL_STAT' => $original_stat,
	'HISTORY_ADD_STAT' => $history_add_stat,
	'WORKINGCOPY_STAT' => $workingcopy_stat,
	'AUTOSAVE_STAT' => $autosave_stat,
	'PUBLISH_CHANGES_STR' => $MOD_WYSIWYG['PUBLISH_CHANGES'],
	'SAVE_TO_HIST_STR' => $MOD_WYSIWYG['SAVE_TO_HISTORY'],
	'DELETE_WORKINGCOPY_STR' => $MOD_WYSIWYG['DELETE_WORKINGCOPY'],
	'DELETE_WORKINGCOPY_ASK' => $MOD_WYSIWYG['DELETE_WORKINGCOPY'].'?',
	'SAVE_ALWAYS_TO_HIST_STR' => $MOD_WYSIWYG['SAVE_ALWAYS_TO_HISTORY'],
	'SAVE_WORKINGCOPY_STR' => (($status=='original'&&$wc_present)?$MOD_WYSIWYG['OVERWRITE_WORKINGCOPY']:$MOD_WYSIWYG['SAVE_WORKINGCOPY']),
	'MAX_STR' => $MOD_WYSIWYG['MAX'],
	'MAX' => $hist_autosave_num,
	'CANCEL_STR' => $TEXT['CANCEL']
));

if($status == 'original')
	$t->set_var(array(
		'TYPE_CLASS' => 'mod_wysiwyg_original_b',
		'TYPE_TEXT' => ($wc_present?$MOD_WYSIWYG['ORIGINAL']:''),
//		'LINK_VIEW' => PE_URL."/modules/wysiwyg/manage_history.php?page_id=$page_id&amp;section_id=$section_id",
		'LINK_VIEW' => ADMIN_URL."/pages/modify.php?page_id=$page_id&amp;section_id=$section_id&amp;modify_pgm=manage_history.php",
		'LINK_TARGET' => '',
		'LINK_VIEW_STR' => $MOD_WYSIWYG['MANAGE_HISTORY'],
		'LINK_ORIGINAL' => ADMIN_URL."/pages/modify.php?page_id=$page_id&amp;status=workingcopy",
		'LINK_ORIGINAL_STR' => ($wc_present?$MOD_WYSIWYG['TO_WORKINGCOPY']:$MOD_WYSIWYG['MAKE_WORKINGCOPY'])
	));
else
	$t->set_var(array(
		'TYPE_CLASS' => 'mod_wysiwyg_wcopy_b',
		'TYPE_TEXT' => $MOD_WYSIWYG['WORKINGCOPY'],
		'LINK_VIEW' => $admin->page_link($link).'?status=workingcopy',
		'LINK_TARGET' => 'target="_blank"',
		'LINK_VIEW_STR' => $MOD_WYSIWYG['TO_VIEW'],
		'LINK_ORIGINAL' => ADMIN_URL."/pages/modify.php?page_id=$page_id&amp;status=original",
		'LINK_ORIGINAL_STR' => $MOD_WYSIWYG['TO_ORIGINAL']
	));

if($status=='original') {
	$t->clear_var('ShowIsNotOriginal');
	$t->parse('SHOWISORIGINAL', 'ShowIsOriginal');
	$t->parse('SHOWISORIGINAL2', 'ShowIsOriginal2');
	$t->parse('SHOWUSEWCCHECK', 'ShowUseWCCheck');
} else {
	$t->clear_var('ShowIsOriginal');
	$t->clear_var('ShowIsOriginal2');
	$t->clear_var('ShowUseWCCheck');
	$t->parse('SHOWISNOTORIGINAL', 'ShowIsNotOriginal');
}

$t->pparse('Output', 'modify');
?>