<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : wysiwyg                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : save.php                                                   *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

require('../../config.php');

// include module.functions.php (introduced with WB 2.7)
require_once(PE_PATH . '/framework/module.functions.php');

// obtain module directory
require(dirname(__FILE__).'/info.php');

// include the module language file depending on the backend language of the current user
if (!@include(get_module_language_file($module_directory))) return;

// Include PE admin wrapper script
$update_when_modified = true; // Tells script to update when this page was last updated
require(PE_PATH.'/modules/admin.php');

// Include the PE functions file
require_once(PE_PATH.'/framework/functions.php');
// some compatibility-functions
if(!function_exists('umlauts_to_entities')) {
function umlauts_to_entities($str, $charset=DEFAULT_CHARSET) {
	return($str);
}
}
if(!function_exists('gzcompress')) {
function gzcompress($str, $level=6) {
	return($str);
}
}

$table_wysiwyg      = TABLE_PREFIX.'mod_wysiwyg';
$table_wysiwyg_hist = TABLE_PREFIX.'mod_wysiwyg_hist';

// work out what to do
$save_old_content_in_hist_comment = '';
$save_old_content_in_hist = FALSE; // save actual stored content in history BEFORE saving new one
                                   // -> triggered by: publish working copy or auto-save active
$save_old_working_in_hist_comment = '';
$save_old_working_in_hist = FALSE; // save actual stored working copy in history BEFORE saving new one
					    										 // -> triggered by: overwrite working copy with actual content
$save_content = FALSE; // save from $_POST as content
$save_working = FALSE; // save from $_POST as working copy
$delete_working = FALSE; // delete working copy
$autosaved = 0; // whether hist_autosave was set (has to be 0 or 1)
$hist_autosave_num = 0; // max number of autosaved history-entries to keep 

// update hist_autosave_num
if(isset($_POST['hist_autosave_num'])) {
	$hist_autosave_num = (int)$_POST['hist_autosave_num'];
	$query = $database->query("SELECT `hist_autosave_num` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
	$row = $query->fetchRow();
	if($hist_autosave_num != $row['hist_autosave_num'])
		$database->query("UPDATE `$table_wysiwyg` SET `hist_autosave_num` = $hist_autosave_num WHERE `section_id` = $section_id");
}

// update use_workingcopy if comes from original-view
if(isset($_POST['status']) && $_POST['status']=='original') {
	if(isset($_POST['use_workingcopy']))
		$use_workingcopy = (int)$_POST['use_workingcopy'];
	else
		$use_workingcopy = 0;
	$database->query("UPDATE `$table_wysiwyg` SET `use_workingcopy` = $use_workingcopy WHERE `section_id` = $section_id");
}

// Check what to save
if(isset($_POST['content'.$section_id]) && isset($_POST['status']) && isset($_POST['saveas'])) {
	if($_POST['status']=='original') {
		if($_POST['saveas']=='original') { // save and publish
			$save_content = TRUE;
			$status = 'original';
		} elseif($_POST['saveas']=='workingcopy') { // save as working-copy -- store old working copy in history
			$save_working = TRUE; 
			//$save_old_working_in_hist = TRUE; 
			//$save_old_working_in_hist_comment = $MOD_WYSIWYG['AUTOSAVED_WC_OVER'];
			$save_old_working_in_hist = FALSE;  // changed in 2.7.5.2: do not save old wc in history
			$save_old_working_in_hist_comment = '';
			$status = 'workingcopy';
		}
		// check if user wants to store content in history
		if(isset($_POST['history']) && $_POST['history']=='add' || isset($_POST['hist_autosave']) && $_POST['hist_autosave']=='true') {
			if($_POST['saveas']=='original') // but don't save old content to history if saveas==workingcopy
				$save_old_content_in_hist = TRUE;
		}
		if(isset($_POST['hist_autosave']) && $_POST['hist_autosave']=='true' && !isset($_POST['history']))
			$autosaved = 1;
			
		// set or unset autosave in wysiwyg
		$query = $database->query("SELECT `hist_autosave` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
		$row = $query->fetchRow();
		if(isset($_POST['hist_autosave']) && !$row['hist_autosave'])
			$database->query("UPDATE `$table_wysiwyg` SET `hist_autosave` = 1 WHERE `section_id` = $section_id");
		elseif(!isset($_POST['hist_autosave']) && $row['hist_autosave'])
			$database->query("UPDATE `$table_wysiwyg` SET `hist_autosave` = 0 WHERE `section_id` = $section_id");
	} elseif($_POST['status']=='workingcopy') {
		if($_POST['saveas']=='workingcopy') { // save actual working-copy
			$save_working = TRUE;
			$status = 'workingcopy';
		}	elseif($_POST['saveas']=='original') { // publish actual working-copy -- store old content in history before
			// check if autosave is on
			$query = $database->query("SELECT `hist_autosave` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
			$row = $query->fetchRow();
			$save_content = TRUE;
			$save_old_content_in_hist = TRUE;
			//if(!$row['hist_autosave']) // don't add additional comment if autosave is on // changed in 2.7.5.2: show it every time
				$save_old_content_in_hist_comment = $MOD_WYSIWYG['AUTOSAVED_WC_PUBL'];
			if($row['hist_autosave'])
				$autosaved = 1;
			$delete_working = TRUE;
			$status = 'original';
		} elseif($_POST['saveas']=='delete') { // delete actual working-copy
			$delete_working = TRUE;
			//$save_old_working_in_hist = TRUE;
			//$save_old_working_in_hist_comment = $MOD_WYSIWYG['AUTOSAVED_WC_REM'];
			$save_old_working_in_hist = FALSE; // changed in 2.7.5.2: do not save old wc in history
			$save_old_working_in_hist_comment = '';
			$status = 'original';
		}
	}
}

// perform actions
if(isset($_POST['content'.$section_id]) && isset($_POST['comment'])) {
	$now = time();
	$content = $admin->add_slashes($_POST['content'.$section_id]);
	$comment = $admin->add_slashes($_POST['comment']);
	if($save_old_content_in_hist) { // save actual stored content in history BEFORE
		$query = $database->query("SELECT `content`, `content_comment`, `last_version` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
		$row = $query->fetchRow();
		if($row['content'] != '') {
			$old_content = addslashes(gzcompress($row['content']));
			$tmp_comment = ($save_old_content_in_hist_comment!='')?$save_old_content_in_hist_comment.': ':'';
			$old_content_comment = addslashes($tmp_comment.$row['content_comment']);
			$version = $row['last_version']+1;
			$database->query("UPDATE `$table_wysiwyg` SET `last_version` = $version WHERE `section_id` = $section_id");
			$database->query("INSERT `$table_wysiwyg_hist` (`section_id`,`version`,`autosaved`,`date`,`user_id`,`comment`,`content`) VALUES ($section_id,$version,$autosaved,$now,".$admin->get_user_id().",'$old_content_comment','$old_content')");
		}
	}
	if($save_old_working_in_hist) { // save actual stored working copy in history BEFORE
		$query = $database->query("SELECT `working_content` AS `content`, `working_content_comment` AS `content_comment`, `last_version`, `hist_autosave` FROM `$table_wysiwyg` WHERE `section_id` = $section_id");
		$row = $query->fetchRow();
		if($row['content'] != '') {
			$old_content = addslashes(gzcompress($row['content']));
			$tmp_comment = ($save_old_working_in_hist_comment!='')?$save_old_working_in_hist_comment.': ':'';
			$old_content_comment = addslashes($tmp_comment.$row['content_comment']);
			$version = $row['last_version']+1;
			if($row['hist_autosave'])
				$autosaved = 1;
			$database->query("UPDATE `$table_wysiwyg` SET `last_version` = $version WHERE `section_id` = $section_id");
			$database->query("INSERT `$table_wysiwyg_hist` (`section_id`,`version`,`autosaved`,`date`,`user_id`,`comment`,`content`) VALUES ($section_id,$version,$autosaved,$now,".$admin->get_user_id().",'$old_content_comment','$old_content')");
		}
	}
	if($save_content) {
		$text = addslashes(umlauts_to_entities(strip_tags($content), strtoupper(DEFAULT_CHARSET)));
		$database->query("UPDATE `$table_wysiwyg` SET `content` = '$content', `content_comment` = '$comment',`text` = '$text' WHERE `section_id` = $section_id");
	}
	if($save_working) {
		$database->query("UPDATE `$table_wysiwyg` SET `working_content` = '$content', `working_content_comment` = '$comment' WHERE `section_id` = $section_id");
	}
	if($delete_working) { // drop working_content
		$query = "UPDATE `$table_wysiwyg` SET `working_content` = '', `working_content_comment` = '' WHERE `section_id` = $section_id";
		$database->query($query);
	}
	// clean history
	if($autosaved && $hist_autosave_num>0) {
		if($query = $database->query("(SELECT `version` FROM  `$table_wysiwyg_hist` WHERE `section_id` = '$section_id' AND `autosaved` = 1 ORDER BY `version` DESC LIMIT $hist_autosave_num) ORDER BY `version` ASC")) {
			if($query->numRows() > 0)	{
				$row = $query->fetchRow();
				$last_version_to_keep = $row['version'];
				$query = $database->query("DELETE FROM `$table_wysiwyg_hist` WHERE `section_id` = '$section_id' AND `autosaved` = 1 AND `version` < $last_version_to_keep");
			}
		}
	}
}

// Check if there is a database error, otherwise say successful
if($database->is_error()) {
	$admin->print_error($database->get_error(), $js_back);
} else {
	$admin->print_success($MESSAGE['PAGES']['SAVED'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'&status='.$status);
}

// Print admin footer
$admin->print_footer();
?>
