<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 * 
 **********************************************************************************
 *     Software Name : The Pacer Edition CMS                                      *
 *       Module Name : wysiwyg                                                    *
 *           Version : PE 3.0                                                     *
 *          Platform : The Pacer Edition CMS x.                                   *
 *        Build Date : October 19, 2010                                           *
 *        Build Time : 10:00:00                                                   *
 *         File Name : upgrade.php                                                *
 *       Port Author : The Pacer Edition CMS Development Team                     *
 *               URL : http://www.thepaceredition.com                             *
 * Copyright License : http://www.thepaceredition.com/?pid=11                     *
 *      EULA License : http://www.thepaceredition.com/?pid=13                     *
 ********************************************************************************** 
 * THIS ADDON MODULE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED      *
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER       *
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       *
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,            *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR             *
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF         *
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS             *
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                   *
 *                                                                                *
 **********************************************************************************
 * The terms of The Pacer Edition CMS License as published by The Pacer           *
 * Edition CMS though the scope of modifying and/or providing commercial and/or   *
 * open source add-ons, documentation, modifications, patches, updates, is bound  *
 * by the copyright terms outlined at <http://www.thepaceredition.com>            *
 *                                                                                *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will             *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty         *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
 *                                                                                *
 * Copyright (C) 2009-2010, THEPACEREDITION.COM (DARKSTAR INCORPORATED)           *
 *                                                                                *
 **********************************************************************************
 *  Website Baker Project <http://www.websitebaker.org/>                          *
 *  Copyright (C) 2004-2009, Ryan Djurovich                                       *
 **********************************************************************************
 */

require('../../config.php');

echo "<strong>WYSIWYG upgrade ...</strong><br>";

function wysiwyg_upgrade_add_col($database, $table, $col, $desc) {
	$query = $database->query("DESCRIBE `$table` `$col`");
	if($query->numRows() == 0) {
		$database->query("ALTER TABLE `$table` ADD `$col` $desc");
	}
	if($database->is_error()) echo $database->get_error()."<br>"; else echo "ok<br>";
}

$table = TABLE_PREFIX.'mod_wysiwyg';
echo "Adding field `last_version` to mod_wysiwyg ... ";
wysiwyg_upgrade_add_col($database, $table, 'last_version', "INT NOT NULL DEFAULT '0' AFTER `page_id`");
echo "Adding field `hist_autosave` to mod_wysiwyg ... ";
wysiwyg_upgrade_add_col($database, $table,  'hist_autosave', "TINYINT NOT NULL DEFAULT 0 AFTER `last_version`");
echo "Adding field `hist_autosave_num` to mod_wysiwyg ... ";
wysiwyg_upgrade_add_col($database, $table,  'hist_autosave_num', "INT NOT NULL DEFAULT 6 AFTER `hist_autosave`");
echo "Adding field `use_workingcopy` to mod_wysiwyg ... ";
wysiwyg_upgrade_add_col($database, $table,  'use_workingcopy', "TINYINT NOT NULL DEFAULT 0 AFTER `hist_autosave_num`");
echo "Adding field `content_comment` to mod_wysiwyg ... ";
wysiwyg_upgrade_add_col($database, $table,  'content_comment', "TEXT NOT NULL AFTER `content`");
echo "Adding field `working_content` to mod_wysiwyg ... ";
wysiwyg_upgrade_add_col($database, $table, 'working_content', "LONGTEXT NOT NULL");
echo "Adding field `working_content_comment` to mod_wysiwyg ... ";
wysiwyg_upgrade_add_col($database, $table, 'working_content_comment', "TEXT NOT NULL");

// Create table wysiwyg_hist
$table = TABLE_PREFIX.'mod_wysiwyg_hist';
$query = $database->query("SHOW TABLES LIKE '$table'");
if($query->numRows() == 0) {
	echo "Adding table mod_wysiwyg_hist ... ";
	$database->query("CREATE TABLE `".TABLE_PREFIX."mod_wysiwyg_hist` (
		`h_id` INT NOT NULL AUTO_INCREMENT,
		`section_id` INT NOT NULL,
		`version` INT NOT NULL,
		`autosaved` TINYINT NOT NULL DEFAULT 0,
		`date` INT NOT NULL,
		`user_id` INT NOT NULL,
		`comment` TEXT NOT NULL,
		`content` LONGBLOB NOT NULL,
		PRIMARY KEY ( `h_id` ))"
	);
} else {
	echo "Adding field `version` and INDEX to mod_wysiwyg_hist ... ";
	wysiwyg_upgrade_add_col($database, $table, 'version', "INT NOT NULL AFTER `section_id`");
	$database->query("ALTER TABLE `$table` ADD INDEX (`version`)");
	echo "Adding field `autosaved` mod_wysiwyg_hist ... ";
	wysiwyg_upgrade_add_col($database, $table, 'autosaved', "TINYINT NOT NULL DEFAULT 0 AFTER `version`");
}
if($database->is_error()) echo $database->get_error()."<br>"; else echo "ok<br>";
