<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 ******************************************************************************
 * Software Name: The Pacer Edition CMS                                       *
 *    Build Date: May 02,2010                                                 *
 *    Build Time: 11:00:00                                                    *
 *     File Name: pacer_base.php                                              *
 *           URL: http://www.jcwebden.com                                     *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS Copyright License:                                *
 *    Copyright 2010 The Pacer Edition (JCWEBDEN.COM)                         *
 *    <http://www.jcwebden.com/online/legal/copyright.php>                    *
 *                                                                            *
 ******************************************************************************
 *    The Pacer Edition CMS End User License Agreement (EULA)                 * 
 *    <http://www.jcwebden.com/online/legal/eula-license.php>                 *
 *                                                                            * 
 ******************************************************************************
 * The Pacer Edition CMS is provided as open source/commercial software.      *
 * Providing commercial applications within the scope of The Pacer            *
 * Edition CMS software; You can redistribute The Pacer Edition CMS           *
 * and/or modify it under the terms of The Pacer Edition Copyright License    *
 * as published by The Pacer Edition CMS though the scope of modifing         *
 * and/or providing commercial and/or open source add-ons, documentation,     *
 * modifications, patches, updates, is bound by the copyright terms layed     *
 * out at <http://www.jcwebden.com/online/legal/copyright.php>                *
 *                                                                            *
 * The Pacer Edition CMS is distributed ASIS in the hope that it will         *
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty     *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    *
 *                                                                            *
 * Copyright (C) 2010,                                                        *
 * The Pacer Edition CMS                                                      *
 * JCWEBDEN.COM (DARKSTAR INCORPORATED)                                       *
 *                                                                            *
 ******************************************************************************
 * Website baker License:                                                     *
 * GNU General Public License                                                 *
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>                      *
 * The following must accompany any and all parts of this script              *
 * Website Baker Project <http://www.websitebaker.org/>                       *
 * Copyright (C) 2004-2009, Ryan Djurovich                                    *
 ******************************************************************************
 */

if (!class_exists('Pacer_Base')) {
	class Pacer_Base {
/******* Init *******************************************************************/
		var $pacer_settings = array();
		/*--- OS Specific ---*/
		var $OS_WINDOWS;
		var $OS_UNIX;
		var $CRLF;
		/*--- MDB2 ---*/
		var $database = null;

		/*--- Cache ---*/
		var $CACHE = null;
	
		var $SYSTEM = null;
		var $OS_GUESS = null;
/******* Canstants **************************************************************/
		var $TOOLTIP_TITLE_SEPARATOR = '_-_';

		function __construct() {
			/*--- OS Specific ---*/
			if (substr(PHP_OS, 0, 3) == 'WIN') {	
				$this->OS_WINDOWS=true;
				$this->OS_UNIX=false;
				$this->CRLF= "\r\n";
    		} else {
				$this->OS_WINDOWS=false;
				$this->OS_UNIX=true;
				$this->CRLF= "\r";
    		}

			// PEAR System
			$this->SYSTEM = new System();
			// PEAR OS Guess
			$this->OS_GUESS = new OS_Guess();
			/*--- Init ---*/
			$this->Init_PearDb();
			$this->Init();
			$this->Init_Cache();
			
		}  
/******* Init ****************************************************************/
		private function Init(){
			$this->Get_All_Setting();
			// To get the date function working properly we have to set the time zone
			if ($this->pacer_settings['default_timezone_name'])
				date_default_timezone_set($this->pacer_settings['default_timezone_name']);
		}
/******* Common ****************************************************************/
		function Get_All_Setting(){
			$this->pacer_settings = array();
			$rows = $this->database->queryAll("SELECT `name`,`value` FROM `".TABLE_PREFIX."pacer_settings` WHERE `name` LIKE 'pacer_%'");
			foreach($rows as $row) {
//				$this->pacer_settings[str_replace('pacer_','',$this->strip_slashes($row['name']))] = $row['value'];
				$this->pacer_settings[str_replace('pacer_','',$row['name'])] = $row['value'];
			}
		}
		function Get_Setting($name,$dont_update_pacer_settings_array = false){
			$p = $this->database->get_one("SELECT value FROM ".TABLE_PREFIX."pacer_settings WHERE name = 'pacer_$name'");
			if($dont_update_pacer_settings_array != true) {
				$this->pacer_settings[$name] = $p;
			} 
			return $p;
		}
		function Set_Setting($fields){
			foreach($fields as $k => $v){
				$this->database->query("UPDATE `".TABLE_PREFIX."pacer_settings` SET `value` = '".((isset($v['value']))?$v['value']:'')."' WHERE `name` = 'pacer_".$k."'");
				if($this->database->is_error()) die("Error: ".__FILE__.":".__LINE__." ".$this->database->get_error());
			}
		}

		function Print_Page_Generated($msg=''){
			global $starttime;
			$endtime = array_sum(explode(" ",microtime()));
			if (!$starttime) $starttime = $endtime;
			printf('<!-- Pacer [v %s] - Page%s generated in %.3f seconds.%s -->', 
				$this->pacer_settings['version'],
				((defined('FRONTEND') && $this->pacer_settings['compress_output']=='1')?' possibly compressed,':''),
				$endtime - $starttime,
				(($msg) ? ' ['.$msg.']' :'')
			);
		}

		function Print_Site_Activated(){
			if ($this->pacer_settings['site_maintenance_enabled']!=1) return;
			if (!$this->pacer_settings['site_maintenance_message']) return;
			if ( (int) $this->pacer_settings['site_maintenance_start'] > time() ) return;
			if ( (int) $this->pacer_settings['site_maintenance_end'] < time() ) return;
			// inject body...
			$m = str_replace(array("\r\n","\n\r","\n","\r"),array("<br />","<br />","<br />","<br />"),addslashes(nl2br($this->pacer_settings['site_maintenance_message'])));
			$this->Code_Injection_Add('js_file','jquery.js');
			$this->Code_Injection_Add('js_script','
jQuery(document).ready(function() {
	jQuery(\'body\').html(\''.str_replace(array('[FROM]','[TO]'),array(date('Y-m-d H:i',(int) $this->pacer_settings['site_maintenance_start']),date('Y-m-d H:i',(int) $this->pacer_settings['site_maintenance_end'])),$m).'\');
});
');
		}
		
		function Print_Tracking_Code($html){
			if ($this->pacer_settings['internal_statistics']) {
				$class_name = 'pacer_statistics';
				if (!class_exists($class_name)) {
					if(file_exists(PE_PATH.'/modules/'.$class_name.'/class.'.$class_name.'.php')) {
						require_once (PE_PATH.'/modules/'.$class_name.'/class.'.$class_name.'.php');
					}
				}
				if (class_exists($class_name)) {
					ob_start(); // prevent output....
					new pacer_statistics();
					ob_end_clean();
				}
			}
			if (($this->pacer_settings['tracking_code_enabled']) && ($this->pacer_settings['tracking_code'])) {
				/*
				$dbg=$this->Pacer_all_nlcr_2_br($this->pacer_settings['tracking_code'],'');
				$this->Code_Injection_Add('js_script','jQuery(document).ready(function(){
	jQuery(\'body\').append(\''.addslashes($dbg).'\');
})');
				*/
				// not possible to inject due to problem executing scripts....
				$html = str_ireplace('</body>',$this->pacer_settings['tracking_code'].'</body>',$html);
			}
			return $html;
		}

		function Print_Seo($page_id){
			$seo = array('meta'=>array(),'title'=>'','bot'=>array());			
			
			$page = $this->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '$page_id'");
			if(!is_array($page)) $page = array('description'=>'','keywords'=>'');
			
			$arr = array('title'=>WEBSITE_TITLE,'description'=>(($page['description'])?$page['description']:WEBSITE_DESCRIPTION),'keywords'=>(($page['keywords'])?$page['keywords']:WEBSITE_KEYWORDS),'author'=>WEBSITE_AUTHOR,'generator'=>WEBSITE_GENERATOR);
			foreach($arr as $k => $v){
				if (($v) & ($this->pacer_settings['website_'.$k.'_autoinclude'])) {
					switch($k){
						case 'title':
							if (WEBSITE_TITLE_TEMPLATE) {
								$vars = array('[WEBSITE_TITLE]','[PAGE_TITLE]','[MENU_TITLE]','[PAGE_TITLE_DISPLAY]','[PAGE_SUB_TITLE_DISPLAY]');
								$values = array(WEBSITE_TITLE, PAGE_TITLE, MENU_TITLE,((defined('PAGE_TITLE_DISPLAY'))?PAGE_TITLE_DISPLAY:''),((defined('PAGE_SUB_TITLE_DISPLAY'))?PAGE_SUB_TITLE_DISPLAY:''));
								$v = str_replace($vars, $values,WEBSITE_TITLE_TEMPLATE);
							}
							$seo['title'] = '<title>'.$v.'</title>';
							break;
						default:
							$seo['meta'][] ='<meta name="'.$k.'" content="'.$v.'" />';				
					}
				}
			}
			if ($this->pacer_settings['seo_verification_key']) {
				$seo['meta'][] ='<meta name="verify-v1" content="'.$this->pacer_settings['seo_verification_key'].'" />';
			}
				
			foreach(array('index','follow','archive', 'snippet') as $v) {
				if (!array_key_exists('seo_'.$v,$page)) continue;
				if ($page['seo_'.$v]=='1') $seo['bot'][] = $v;
				elseif ($page['seo_'.$v]=='0') $seo['bot'][] = "no".$v;
				else {
					if ($this->pacer_settings['seo_meta_robots_'.$v]=='1') $seo['bot'][] = $v;
					elseif ($this->pacer_settings['seo_meta_robots_'.$v]=='0') $seo['bot'][] = "no".$v;
				}
			}
			if (count($seo['bot'])) $seo['meta'][] ='<meta name="robots" content="'.implode(',',$seo['bot']).'" />';
			if($seo['title']) $this->Code_Injection_Add('html_replace',$seo['title'],'head','~<title[\s>].*</title[\s>]~iU');
			if(count($seo['meta'])) $this->Code_Injection_Add('html_code',implode("\n",$seo['meta']));
		}

		function get_ip(){
   			if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        		$ip = $_SERVER['HTTP_X_FORWARDED_FOR']; }
    		elseif (isset($_SERVER['HTTP_CLIENT_IP'])) {
        		$ip = $_SERVER['HTTP_CLIENT_IP']; }
    		else {
        		$ip = $_SERVER['REMOTE_ADDR']; }
    		return $ip;
		} 
		function get_referer(){
			if(array_key_exists('HTTP_REFERER',$_SERVER)) {
				$referer = $_SERVER['HTTP_REFERER'];
			} elseif (getenv('HTTP_REFERER')) {
				$referer = getenv('HTTP_REFERER');
			} else $referer = '';
			return $referer;
		} 
		
		function get_session($var){
			return (isset($_SESSION[$var])) ? $_SESSION[$var]:null;
		}
		function Translate($text, $module_specific = '',$lang='',$text_id=''){
			
			if(!trim($text)) return '';
			if(is_numeric(trim($text))) return $text;
			
			if (!$lang) $lang = LANGUAGE;
			if (!trim($text_id)) /* Get EN text_id for text */
				$text_id = $this->database->get_one("SELECT text_id FROM ".TABLE_PREFIX."pacer_translations WHERE lang_id = 'EN' AND value = '".addslashes($text)."' LIMIT 1");
			
			if (trim($text_id)) { /* There is a Lang text_id for text */
				if ($lang=='EN') return $text; /* is already Lang == EN return */
				/* Search Lang text_id for text */
				$new_text = $this->database->get_one("SELECT value FROM ".TABLE_PREFIX."pacer_translations WHERE lang_id ='$lang' AND text_id = '".addslashes($text_id)."' LIMIT 1");
				if ($new_text) return $new_text;
			} else {
				/* Got no Lang text_id for text */
				/* Search last EN text_id (_pacer,NNNN) key */
				if ($text_id = $this->database->get_one("SELECT text_id FROM ".TABLE_PREFIX."pacer_translations WHERE lang_id ='EN' AND text_ID LIKE '_pacer_,%' ORDER BY text_id DESC LIMIT 1"))
					list($none,$text_id) = explode(',',$text_id);
				else 
					$text_id = 0;
				/* Next text_id key */
				$text_id = sprintf('_pacer_,%04d',intval($text_id)+1);

				/* Always insert as 'EN' */
				$this->Update_Translation($text_id,$text,'EN'); 
			}
			return $text;
		}		
		function Update_Translation($text_id,$text,$lang=''){
			if((!trim($text)) && (!trim($text_id))) return;
			$sql = "SELECT lang_id FROM ".TABLE_PREFIX."pacer_translations WHERE lang_id ='".(($lang) ? $lang:LANGUAGE)."' AND text_id = '".addslashes($text_id)."'";
			$query = $this->database->query($sql);
			if($this->database->is_error()) die("Error: ".__FILE__.":".__LINE__." ".$sql.$this->database->get_error());
			if($query->numRows() == 0) {
				$e = debug_backtrace();
				$i = (count($e)>1)?count($e)-1:0;
				$m = str_replace(PE_PATH,'',$e[$i]['file']).":".$e[$i]['line'];
				$sql = "INSERT INTO ".TABLE_PREFIX."pacer_translations SET value = '".addslashes($text)."', lang_id ='".(($lang) ? $lang:LANGUAGE)."', text_id = '".addslashes($text_id)."', first_seen_at = '".addslashes($m)."'";
			} else {
				$sql = "UPDATE ".TABLE_PREFIX."pacer_translations SET value = '".addslashes($text)."' WHERE lang_id ='".(($lang) ? $lang:LANGUAGE)."' AND text_id = '".addslashes($text_id)."'";
			}
			$this->database->query($sql);
			if($this->database->is_error()) die("Error: ".__FILE__.":".__LINE__." ".$this->database->get_error());			
		}		
		function Load_Translation($lang){
			$file = PE_PATH.'/languages/EN.php';
			if (!file_exists($file)) return false;
			require($file);
			$K_MENU = $MENU;
			$K_OVERVIEW = $OVERVIEW;
			$K_HEADING = $HEADING;
			$K_MESSAGE = $MESSAGE;
			$K_TEXT = $TEXT;

			$MENU = '';
			$OVERVIEW = '';
			$HEADING = '';
			$MESSAGE = '';
			$TEXT = '';
	
			$file = PE_PATH.'/languages/'.$lang.'.php';
			if (!file_exists($file)) return false;
			require($file);
	
			$this->get_translation_key($MENU,$K_MENU,$lang,'MENU');
			$this->get_translation_key($OVERVIEW,$K_OVERVIEW,$lang,'OVERVIEW');
			$this->get_translation_key($HEADING,$K_HEADING,$lang,'HEADING');
			$this->get_translation_key($MESSAGE,$K_MESSAGE,$lang,'MESSAGE');
			$this->get_translation_key($TEXT,$K_TEXT,$lang,'TEXT');
			$this->LogEvent(sprintf($this->Translate("Loaded language pack %s"),$lang));	
			return true;
		}
		private function get_translation_key($arr,$karr,$language,$name){
			$rt = array();
			foreach($karr as $k => $v) {
				$nk = "$".$name."['".strtoupper($k)."']";
				if (is_array($v)) {
					foreach($v as $kk => $vv){
						if(isset($arr[$k][$kk])) $this->Update_Translation($nk."['".strtoupper($kk)."']",$arr[$k][$kk],$language);
					}	
				} else {
					if(isset($arr[$k])) $this->Update_Translation($nk,$arr[$k],$language);
				}
			}
		}
		function Languages_List(){
			require_once(PE_PATH.'/framework/functions-utf8.php');
			$language_list = array();
			foreach($this->database->queryAll("SELECT * FROM ".TABLE_PREFIX."addons WHERE type = 'language' order by name") as $addon) {
				$language_list[entities_to_7bit($addon['name'])] = array('name'=>$addon['name'],'directory'=>$addon['directory']);
			}
			ksort($language_list);
			return $language_list;
		}
		function friendly_html($string){
			if (!$string) return '';
			// Set raw html <'s and >'s to be replace by friendly html code
			$raw = array('<', '>','');
			$friendly = array('&lt;', '&gt;', '?php');
			// This code removes any <?php tags and adds slashes

			return str_replace($raw, $friendly, $string);
		}
		function unfriendly_html($string){
			if (!$string) return '';
			// Set raw html <'s and >'s to be replace by friendly html code
			$raw = array('<', '>','');
			$friendly = array('&lt;', '&gt;', '?php');
			// This code removes any <?php tags and adds slashes
			return str_replace($friendly, $raw , $string);
		}
		function Tags_List($page_id) {
			$tags_list = array();
			// get all tags...		
			foreach ($this->database->queryAll("SELECT page_id, tags FROM `" .TABLE_PREFIX ."pages` WHERE tags != ''") as $k => $row){
				$page_tags=unserialize($row['tags']);
				foreach($page_tags as $t){
					// create reference...
					if(!array_key_exists($t,$tags_list)) $tags_list[$t] = array('name'=>$t,'checked'=>false,'id'=>'tag_'.uniqid());
					// mark it if from the same page_id...
					if($row['page_id']==$page_id) $tags_list[$t]['checked']=true;
				}
			}
			return $this->Tags_Order($tags_list);			
		}
		
		function Tags_Order($tags){
			switch (strtolower($this->pacer_settings['tags_order'])){
				case 'name asc':
					ksort($tags);
					break;
				case 'name desc':
					krsort($tags);
					break;
			}
			return $tags;			
		}
		
		function Tags_Delete($tags){
			if (!is_array($tags) && ($tags)) $tags=array($tags=>$tags); 
			if (count($tags) == 0) return;
			foreach ($this->database->queryAll("SELECT page_id, tags FROM `" .TABLE_PREFIX ."pages` WHERE tags != ''") as $k => $row){
				$upd=false;
				$page_tags=unserialize($row['tags']);
				foreach($tags as $t){
					if (array_key_exists($t,$page_tags)) {
						unset($page_tags[$t]);
						$upd=true;
					}
				}
				if ($upd){
					if(count($page_tags)>0)
						$page_tags=serialize($this->Tags_Order($$page_tags));
					else
						$page_tags='';
					$this->database->query("UPDATE `" .TABLE_PREFIX ."pages` SET tags = '$page_tags' WHERE page_id = '".$row['page_id']."'");
					if ($this->database->is_error())
						$this->Pacer_die($this->database->get_error());
				}
			}
		}
		function Tags_Show($page_id) {
			global $wb;
			$settings = $this->database->queryRow("SELECT * FROM `" .TABLE_PREFIX ."pages` WHERE page_id = '$page_id'");
			if ($settings['show_tags'] != '1' && $settings['show_tags'] != '3') return;
			$tags = array();
			if ($settings['show_tags'] == '2' || $settings['show_tags'] == '3') {
				foreach($this->Tags_List($page_id) as $k => $v) {
					$tags[$k]=$k;	
				}
			} else {	
				$tags = $this->Tags_Order(unserialize($settings['tags']));
			}
			if (count($tags)==0) return;

			echo "<div class=\"taglist\"><h3>".$this->Translate((($settings['show_tags'] == '2' || $settings['show_tags'] == '3')?'Select by feature...':'More like this...'))."</h3>\n";
			
			foreach($tags as $k => $v){
				// get the pages with the Tag...
				$pages = $this->database->queryAll("SELECT * FROM " .TABLE_PREFIX ."pages WHERE tags != '' AND tags LIKE '%:\"".addslashes($k)."\";%' order by page_id");

				$tag_id = uniqid();
				$tag_name = $k;
				$count_rows = count($pages);
				$first_line = true;
				foreach($pages as $row) {	
					$page_link = $wb->page_link($row['link']);
					$page_title = $row['menu_title'];
					if ($first_line){
						$first_line=false;
						echo "<a href=\"javascript:jQuery('#taglist_$tag_id').toggle();void(0);\">$tag_name ($count_rows)</a><br />\n";
						echo "<ul class=\"tagslist\" id=\"taglist_$tag_id\" style=\"display:none;\">\n";
					}
					echo "<li><a href=\"$page_link\">$page_title</a></li>\n";
				}
				echo "</ul>\n";
			}
			echo "</div>\n";
		}

		function add_slashes($input) {
			if ( get_magic_quotes_gpc() ) { //|| ( !is_string($input) ) ) {
				return $input;
			}
			if (is_array($input)){
				$arr=array();
				foreach($input as $k => $v){
					if (is_array($v)){
						foreach($v as $kk => $vv){
							if (is_array($vv)){
								foreach($vv as $kkk => $vvv){
									$arr[addslashes($k)][addslashes($kk)][addslashes($kkk)]=addslashes($vvv);
								}
							} else $arr[addslashes($k)][addslashes($kk)]=addslashes($vv);
						} 
					} else $arr[addslashes($k)]=addslashes($v);
				}
				return $arr;
			} else return addslashes($input);
		}
		function strip_slashes($input) {
			if ( !get_magic_quotes_gpc() ) { // ( !is_string($input) ) ) {
				return $input;
			}
			if (is_array($input)){
				$arr=array();
				foreach($input as $k => $v){
					if (is_array($v)){
						foreach($v as $kk => $vv){
							if (is_array($vv)){
								foreach($vv as $kkk => $vvv){
									$arr[stripslashes($k)][stripslashes($kk)][stripslashes($kkk)]=stripslashes($vvv);
								}
							} else $arr[stripslashes($k)][stripslashes($kk)]=stripslashes($vv);
						} 
					} else $arr[stripslashes($k)]=stripslashes($v);
				}
				return $arr;
			} else return stripslashes($input);
		}
		function escape_backslashes($input) {
			return str_replace("\\","\\\\",$input);
		}
		function Get_Session_Id(){
			return session_id();
		}
/******* PEAR Db ***************************************************************/
		private function Init_PearDb() {
			/*
			if (!class_exists('PacerDb')) {
				// PEAR Database abstraction layer
				require_once(PACER_PATH.'/pear/MDB2.php');
				// Pacer Database class	
				require_once(PACER_PATH.'/pacer_db.php');
			}
			$this->database = new PacerDb();
			*/	
		    $this->database = new database();
		}
	/**
     * Upload one file
     *
     * @param string	$fileid  		Form field name contaning the file to upload 
     * @param string	$upload_folder	Folder to upload to
     * @param string	$filename		Dedtination filen name 
     * @param string	$only_exts		List of allowed file extensions comma separated or 'all' for no restriction
     * @param string	$chmod			Chmod for uploaded file, default '0666' 
     */
		function upload_one_file($fileid,$upload_folder,$filename,$only_exts = 'jpg,pdf,xls',$chmod = '0666'){
			
			// PEAR Upload file	
			require_once(PACER_PATH.'/pear/Upload.php');
	
			$upload = new http_upload();
			
			if (PEAR::isError($upload)) return (string) $upload->errorMsg();
			
			if ($chmod) $upload->setChmod(intval($chmod, 8));
			$file = $upload->getFiles($fileid,true);
			if (PEAR::isError($file)) return (string) $file->getMessage();
			if (PEAR::isError($upload)) return (string) $upload->errorMsg();

			if (($only_exts) && $only_exts!='all') {
				$a = explode(",",$only_exts);
				$file->setValidExtensions($a,'accept');
			} else {
				$a = array('NOT_POSSIBLE_ONE');
				$file->setValidExtensions($a,'deny');
			}

			if (!$file->isMissing()) {
				if ($file->isValid()) {
					$file->setName($filename);
					$dest_name = $file->moveTo($upload_folder);
					if (PEAR::isError($dest_name)) return (string) $dest_name->getMessage();
				} elseif ($file->isError()) return (string) $file->errorMsg();

			} else {
			//	return (string) $file->errorMsg();
			}
			return true;
		}
    /**
     * Upload one file
     *
     * @param string	$fileid  		Form field name contaning the file to upload 
     * @param string	$upload_folder	Folder to upload to
     * @param string	$filename		Dedtination filen name 
     * @param string	$only_exts		List of allowed file extensions comma separated or 'all' for no restriction
     * @param string	$chmod			Chmod for uploaded file, default '0666' 
     */     
		function request_one_file($url,$method = '',$params=array()){
		/*			
			require (PACER_PATH.'/pear/HTTP/Request2.php');
			$request = new HTTP_Request2($url);
			
			$request->setMethod (($method) ? $method : HTTP_Request2::METHOD_POST);
			if($params) $request->addPostParameter($params);
			$erg=$request->send();
 			if (true == PEAR::isError($erg)) {
				return $erg;
 			}
 			return $request->getBody();
*/
			require (PACER_PATH.'/pear/HTTP/Request.php');
			$request = new HTTP_Request($url,$params);
 			$request->setMethod ( ($method!='') ? $method : HTTP_REQUEST_METHOD_POST );
 			$erg=$request->sendRequest();
 			if (true == PEAR::isError($erg)) {
				return $erg;
 			}
 			return $request->getResponseBody();


		}
    /**
     * Download one file TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO TO DO
     *
     * @param string	$filename		Dedtination filen name 
     */     
		function download_one_file($filename,$op='send',$what='file',$type='',$filename_forced='',$params=array()){
		
			// PEAR Download file	
			require_once(PACER_PATH.'/pear/HTTP/Download.php');

			PEAR::setErrorHandling(PEAR_ERROR_PRINT);
			switch ($what){
    			case 'file':
        			$params['file'] = $filename;
    				break;
    			case 'resource':
        			$params['resource'] = fopen($filename, 'rb');
    				break;
    			case 'data':
        			$params['data'] = file_get_contents($filename);
    				break;
				case 'string':
        			$params['data'] = $filename;
    				break;
			}
			switch ($op){
   				case 'static':
        			HTTP_Download::staticSend($params);
    				break; 
    			case 'send':
        			$h = new HTTP_Download;
        			if ($filename_forced) $h->file=$filename_forced;
					$h->setParams($params);
        			$h->send();
    				break;
    			case 'arch':
        			HTTP_Download::sendArchive($filename, $what,$type);
    				break;
			}
		}
		function Is_Activated(){
			// check is /index.php has been patched...
			// and so on..
			return true;
		}
			
		function Init_Cache() {
			if ($this->pacer_settings['cache_enabled']) {
				$options = array(
		    	    //'pearErrorMode' => CACHE_LITE_ERROR_DIE,
					'cacheDir' => (($this->pacer_settings['cache_folder']) ? PE_PATH.$this->pacer_settings['cache_folder']:TEMP_PATH.'/cached_pages/'),
    				'lifeTime' => (($this->pacer_settings['cache_lifetime']) ? (int)$this->pacer_settings['cache_lifetime'] : 3600),
					'automaticCleaningFactor' => (($this->pacer_settings['cache_cleaning_factor']) ? (int)$this->pacer_settings['cache_cleaning_factor'] : 0),
				);
				if (!is_dir($options['cacheDir'])) {
					require(PE_PATH.'/framework/functions.php');
					make_dir($options['cacheDir'],OCTAL_DIR_MODE);
				}
				// PEAR Cache Lite	
				require_once(PACER_PATH.'/pear/Cache/Lite.php');
				// Create a Cache_Lite object
				$this->CACHE = new Cache_Lite($options);
			}
		}
		
		function Cache_Key($extra_keys = array()) {
			$keys = array_merge(array('action','cancel','pid','sid','page_id','section_id','id','mbox'),$extra_keys);
			if (isset($_POST)) { // add all $POST starting with '_' eg: _section
				foreach($_POST as $k => $v){
					if (preg_match('/^_/',$k))
						$keys[]=$k;
				}
			}
			$cid = $_SERVER['PHP_SELF'].(($_SERVER['QUERY_STRING'])?'?'.$_SERVER['QUERY_STRING']:'');
			foreach($keys as $k){
				if (isset($_POST[$k]))
					$cid.=((preg_match('/\?/',$cid))?'&':'?').$k.'='.$_POST[$k];
			}
			return $cid;	
		}
		
		function Cache_Start() {
			if (($this->CACHE) && ($this->pacer_settings['cached_pages'])) { 
				if ( $data = $this->CACHE->get($this->Cache_Key()) ) {
					echo $data;
					$this->Print_Page_Generated('cached');
					$this->Tidy();
					$this->GzPage_Finish();
					die();
				}
			}
		}
		function Cache_Finish($html=false) {
			if (($this->CACHE) && ($this->pacer_settings['cached_pages'])) { 
				if($html===false){
					if (ob_get_level()!=0) $html = ob_get_contents(); 
				}
				if($html!==false) {
					$this->CACHE->save($html,$this->Cache_Key());
				}
			}
		}
		function Cache_Clear() {
			if ($this->CACHE) {
				$this->CACHE->clean();
			}
		}
/******************************************************************/
		function Tidy($html=false) {
			if($html===false){
				$html = ob_get_contents();
				if (ob_get_level() && ob_get_length()) ob_clean();
			}
			if (($this->pacer_settings['tidy_enabled']) && (class_exists('tidy'))) {
				$Encoding = defined('DEFAULT_CHARSET') ? DEFAULT_CHARSET : 'utf-8';
				$Encoding = str_replace('-','',$Encoding);
				$TidyConfig = array(
					'indent'						=>	false,
       				'clean'							=>	true,
   					'drop-proprietary-attributes'	=>	true,
   			 		//'output-xhtml'					=>	true,
   		 			'show-body-only'				=>	false,
      				//'word-2000'						=>	false,
					'wrap-sections'					=>	false,
					'hide-comments'					=>	true,
       				'wrap'							=>	1024
   				); 
				$tidy = new tidy;
				$tidy->parseString($html, $TidyConfig, $Encoding);
				$tidy->cleanRepair();
				if ($tidy->errorBuffer) {
					$this->LogError("Tidy Clean & Repair errors:\n".$tidy->errorBuffer);
				}
				$html = tidy_get_output($tidy);
			}
			if ($this->pacer_settings['source_encoded']) 
				echo $this->Pacer_encode_page($html);
			else 
				$this->GzPage_Finish($html);
		}
/******************************************************************/
		function Pacer_purifyHtml($html,$encoding='',$doctype=''){
			$file = PACER_PATH.'/htmlpurifier/library/HTMLPurifier.auto.php';
			if (!file_exists($file)) return $html;
			require_once($file);
			if (!$encoding) $encoding = (defined('DEFAULT_CHARSET') ? DEFAULT_CHARSET : 'utf-8');
			if (!$doctype) {
				$doctype = 'XHTML 1.0 Transitional';
    /* guess
	* HTML 4.01 Strict
    * HTML 4.01 Transitional
    * XHTML 1.0 Strict
    * XHTML 1.0 Transitional
    * XHTML 1.1
	*/
			}
			$config = HTMLPurifier_Config::createDefault();
    		$config->set('Core.Encoding', $encoding);
			$config->set('HTML.Doctype', $doctype); // replace with your doctype
    		$config->set('Cache.SerializerPath', TEMP_PATH);

    		$purifier = new HTMLPurifier($config);

    		return $purifier->purify($html);
		}
		function Pacer_compressHtml($htmlSourceCode,$removeComments = true){
		// Initialize a returning variable
		$returnValue = '';
		try {
			// Check if the given parameter matches datatype string
			if(is_string($htmlSourceCode)){
				// Exclude pre- or code-tags
				preg_match_all(
					'!(<(?:code|pre).*>[^<]+</(?:code|pre)>)!',
					$htmlSourceCode,
					$pre
				);
				// Remove all pre- or code-tags
				$htmlSourceCode = preg_replace(
					'!<(?:code|pre).*>[^<]+</(?:code|pre)>!',
					'#pre#',
					$htmlSourceCode
				);
				// Remove HTML-comments if required
				if($removeComments === true){
					$htmlSourceCode = preg_replace(
						'/<!--(?!\/\/)(.|\s)*?(?!\/\/)-->/',
						'',
						$htmlSourceCode
					);
				}
				// Remove new lines, spaces and tabs
				$htmlSourceCode = preg_replace(
					'/[\r\n\t]+/',
					' ',
					$htmlSourceCode
				);
				$htmlSourceCode = preg_replace(
					'/>[\s]+</',
					'> <',						// was '><',
					$htmlSourceCode
				);
				$htmlSourceCode = preg_replace(
					'/[\s]+/',
					' ',
					$htmlSourceCode
				);
				if(!empty($pre[0])){
					foreach($pre[0] as $tag){
						// Return pre- and code-tags
						$htmlSourceCode = preg_replace(
							'!#pre#!',
							$tag,
							$htmlSourceCode,
							1
						);
					}
				}
				// Remove preceding and trailing spaces and write
				// the processed sourcecode into the returning variable
				$returnValue = trim($htmlSourceCode);
				// Delete the original sourcecode
				unset($htmlSourceCode);
			} else{
				// Throw an exception in case of an invalid method parameter
				throw new Exception(
					'Method "' .
					__FUNCTION__ .
					'" of class "CodeCompressor" reported an error: ' .
					'Invalid parameter!'
				);
			}
		} catch(Exception $e){
			// Catch all occuring exceptions form the preceding codeblock
			// and write the errormessages into the returning variable
			$returnValue = $e->getMessage();
		}
		// Return the filled variable
		return $returnValue;
	}

		function Print_Error($msg,$link,$class='') {
			$_SESSION['error']=$msg;
			
			if ($class) $_SESSION['error_class']=$class;
			if($link) $this->Redirect_To($link);//.((preg_match('/\?/i',$link)) ? '&' : '?').'error='.$msg);
		}
		function Print_Success($msg,$link='index.php') {
			$_SESSION['success']=$msg;
			if($link) $this->Redirect_To($link);//.((preg_match('/\?/i',$link)) ? '&' : '?').'success='.$msg);
		}
		function Redirect_To($link,$target='self',$redirect_type=''){
			$link = preg_replace('/&amp;/i','&',$link);
			if (headers_sent()) {
				echo '<script type="text/javascript">'.(($target)?$target.'.':'').'location.href = \''.$link.'\';</script>';
			} else {
				if ($redirect_type=='301') {
					header('HTTP/1.1 301 Moved Permanently');
				}
				header('Location: '.$link);
			}
			die();
		}
/******************************************************************/

		function print_header() {
			return;
		}
		
		function print_footer($show_footer=true) {
			if ($show_footer){
				$footer_template = new Pacer_Template(THEME_PATH.'/templates');
				$footer_template->set_file('page', 'footer.htt');
				$footer_template->set_block('page', 'footer_block', 'header');
				$footer_template->parse('header', 'footer_block', false);
				$footer_template->pparse('output', 'page');			
			}
			$html = ob_get_clean();
			$this->Tidy($this->Code_Injection($html));		
		}

		function print_page_header($page_id,$message='') {
			global $admin, $TEXT, $HEADING, $MESSAGE, $module_directory;
			global $section_id;
			// Get page details
			$results_array=$admin->get_page_details($page_id);

			// Get display name of person who last modified the page
			$user=$admin->get_user_details($results_array['modified_by']);

			// Convert the unix ts for modified_when to human a readable form
			if($results_array['modified_when'] != 0) {
				$modified_ts = gmdate(TIME_FORMAT.', '.DATE_FORMAT, $results_array['modified_when']+TIMEZONE);
			} else {
				$modified_ts = 'Unknown';
			}

			// Include page info script
			$template = new Pacer_Template(THEME_PATH.'/templates');
			$template->set_file('page', 'pages_modify.htt');
			$template->set_block('page', 'main_block', 'main');
			$template->set_var(array(
								'PAGE_ID' => $results_array['page_id'],
								'PAGE_TITLE' => ($results_array['page_title']),
								'MODIFIED_BY' => $user['display_name'],
								'MODIFIED_BY_USERNAME' => $user['username'],
								'MODIFIED_WHEN' => $modified_ts,
								'ADMIN_URL' => ADMIN_URL
								)
			);
			if($modified_ts == 'Unknown') {
				$template->set_var('DISPLAY_MODIFIED', 'hide');
			} else {
				$template->set_var('DISPLAY_MODIFIED', '');
			}

			// Work-out if we should show the "manage sections" link
			$sid = $this->database->get_one("SELECT section_id FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' AND module = 'menu_link'");
			if($sid) {
				$template->set_var('DISPLAY_MANAGE_SECTIONS', 'display:none');
				$template->set_var('SECTION_ID_DISPLAY', '');
			} elseif(MANAGE_SECTIONS == 'enabled') {
				$template->set_var('TEXT_MANAGE_SECTIONS', $HEADING['MANAGE_SECTIONS']);
				$template->set_var('SECTION_ID_DISPLAY', (($section_id)?' | '.$this->Translate('Section Id').':'.$section_id:''));
			} else {
				$template->set_var('DISPLAY_MANAGE_SECTIONS', 'display:none');
				$template->set_var('SECTION_ID_DISPLAY', '');
			}
/*			
			if ((preg_match('|pages/modify\.php$|i',$_SERVER['PHP_SELF'])) 
															 
			or (preg_match('|pages/sections\.php$|i',$_SERVER['PHP_SELF'])) 
			or (preg_match('|pages/settings\.php$|i',$_SERVER['PHP_SELF']))) {
				$template->set_var('DISPLAY_MODULE_BACKEND', 'display:none');
			} else {
				$template->set_var('DISPLAY_MODIFY_PAGE', $this->Translate('Module backend'));
			}
			
			if ((preg_match('|pages/modify\.php$|i',$_SERVER['PHP_SELF'])) 
				$template->set_var('DISPLAY_MODIFY_PAGE', 'display:none');
			if ((preg_match('|pages/modify\.php$|i',$_SERVER['PHP_SELF'])) 
				$template->set_var('DISPLAY_MODIFY_PAGE', 'display:none');
			if ((preg_match('|pages/modify\.php$|i',$_SERVER['PHP_SELF'])) 
				$template->set_var('DISPLAY_MODIFY_PAGE', 'display:none');
			
				<a href="{ADMIN_URL}/pages/modify.php?page_id={PAGE_ID}" style="{DISPLAY_MODULE_BACKEND}">{TEXT_MODULE_BACKEND}</a>
		<font style="{DISPLAY_MODULE_BACKEND}">|</font>
		
		<a href="{ADMIN_URL}/pages/modify.php?page_id={PAGE_ID}" style="{DISPLAY_MANAGE_SECTIONS}">{TEXT_MODIFY_PAGE}</a>
		<font style="{DISPLAY_MANAGE_SECTIONS}">|</font>
		<a href="{ADMIN_URL}/pages/settings.php?page_id={PAGE_ID}" style="{DISPLAY_MANAGE_SECTIONS}">{TEXT_CHANGE_SETTINGS}</a>
		<font style="{DISPLAY_MANAGE_SECTIONS}">|</font>
		<a href="{ADMIN_URL}/pages/sections.php?page_id={PAGE_ID}" style="{DISPLAY_MANAGE_SECTIONS}">{TEXT_MANAGE_SECTIONS}		
*/
  			// Insert language TEXT
			$template->set_var(array(
								'TEXT_ID' => $this->Translate('Page Id'),
								'TEXT_TITLE' => $this->Translate('Title'),
								'TEXT_MODIFY_PAGE' => $HEADING['MODIFY_PAGE'],
								'TEXT_CURRENT_PAGE' => $TEXT['CURRENT_PAGE'],
								'TEXT_CHANGE_SETTINGS' => $TEXT['CHANGE_SETTINGS'],
								'LAST_MODIFIED' => $MESSAGE['PAGES']['LAST_MODIFIED'],
								'HEADING_MODIFY_PAGE' => (($message)?$message:$this->Translate('Modify'))
								)
			);
			// Parse and print header template
			$template->parse('main', 'main_block', false);
			$template->pparse('output', 'page');
			
			if ($module_directory) $this->print_page_header_image($module_directory);
		
		}
		
		function print_page_header_image($module_directory) {
			// Is there a module icon= Then display it... 
			$file='/modules/'.$module_directory.'/icon.png';
			if (file_exists(PE_PATH.$file)){
				$this->Code_Injection_Add('js_script','jQuery(document).ready(function() {
	jQuery(\'div.page-image img\').attr(\'src\',\''.PE_URL.$file.'\');
	jQuery(\'div.page-image\').removeClass(\'hide\');
});');
			}
		}
		
		function print_section_header($page_id,$section_id) {
			global $admin, $TEXT, $HEADING, $MESSAGE;
			
			// get template used for the displayed page (for displaying block details)
			if (SECTION_BLOCKS) {
				if ($page_template = $this->database->get_one("SELECT `template` from `" . TABLE_PREFIX . "pages` WHERE `page_id` = '$page_id' ")){
					$page_template = ($page_template) ? $page_template:DEFAULT_TEMPLATE;
					// include template info file if exists
					if (file_exists(PE_PATH . '/templates/' . $page_template . '/info.php')) {
						include_once(PE_PATH . '/templates/' . $page_template . '/info.php');
					}
				}
			}
	
			// Get sections for this page
			$module_permissions = $_SESSION['MODULE_PERMISSIONS'];
			if ($section = $this->database->queryRow("SELECT section_id, module, block, note, publ_start, publ_end
	FROM ".TABLE_PREFIX."sections WHERE page_id = '$page_id' ".(($section_id)? " AND section_id = '$section_id'":"")." ORDER BY position ASC")) {
				$section_id = $section['section_id'];
				$module = $section['module'];
				//Have permission?
				if(!is_numeric(array_search($module, $module_permissions))) {
					// Include the modules editing script if it exists
					if(file_exists(PE_PATH.'/modules/'.$module.'/modify.php')) {
						echo '<a name="'.$section_id.'"></a>';
						// output block name if blocks are enabled
						if (SECTION_BLOCKS) {
							if (isset($block[$section['block']]) && trim(strip_tags(($block[$section['block']]))) != '') {
								$block_name = htmlentities(strip_tags($block[$section['block']]));
							} else {
								if ($section['block'] == 1) {
									$block_name = $TEXT['MAIN'];
								} else {
									$block_name = '#' . (int) $section['block'];
								}
							}
						}
						$status="";
						if($section['publ_start']!='0' || $section['publ_end']!='0') {
							$page = $this->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '".$section['page_id']."'");
							if(!$admin->page_is_active($page)) $status=$Pacer->Translate('Not active');
			   			}
						// Include page info script
						$template = new Template(THEME_PATH.'/templates');
						$template->set_file('page', 'pages_modify_section.htt');
						$template->set_block('page', 'section_block', 'section');

						$template->set_var(array(
								'BLOCK_STYLE' => (SECTION_BLOCKS)?'':'display:none;',
								//'SECTION_STYLE' => (MANAGE_SECTIONS==='enabled')?'':'display:none;',
								'TEXT_SECTION' => MANAGE_SECTIONS.$TEXT['SECTION'],
								'SECTION_ID' => $section_id,
								'TEXT_BLOCK' => (SECTION_BLOCKS)?$this->Translate('Block').':':'',
								'BLOCK_NAME' => (SECTION_BLOCKS)?$block_name:'',
								'TEXT_MODULE' => $this->Translate('Module'),
								'MODULE' => $module,
								'STATUS' => '('.$status.')',
								'STATUS_STYLE' => (!$status)?'display:none;':'',
								'TEXT_NOTE' => $this->Translate('Note'),
								'NOTE' => nl2br($section['note']),
								'NOTE_STYLE' => (!$section['note'])?'display:none;"':'',
								'THEME_URL' => THEME_URL,
								'TEXT_CLICK_TO_HIDE' =>  $this->Translate('Click to hide'),
								'TEXT_CLICK_TO_VIEW_INFO' =>  $this->Translate('Click to view info'),
								'LINK_TO_VIEW_INFO' => 'javascript:ShadowboxOpenHtml(\''. ADMIN_URL.'/modules/details.php?file='.$module.'&module='.$module.'&noheader=1.\',\''.$this->Translate('Info for module').': '.$module.'\');'
								)
						);
						// Parse and print header template
						$template->parse('section', 'section_block', false);
						$template->pparse('output', 'page');
					}
				}
			
			}
			
		}
		function PageLayout(){
			return $this->make_list(0);	
		}	
		private function make_list($parent) {
			global $TEXT;
			static $playout = array();
			static $lv = array();
			
			$query = "SELECT * FROM ".TABLE_PREFIX."pages WHERE parent = '$parent'" .((PAGE_TRASH != 'inline') ?
				" AND visibility != 'deleted'" : "") ." ORDER BY position ASC";
			$get_pages = $this->database->query($query);
			if($get_pages->numRows() > 0)	{
				while($page = $get_pages->fetchRow()) {
					// Get user perms
					$admin_groups = explode(',', str_replace('_', '', $page['admin_groups']));
					$admin_users = explode(',', str_replace('_', '', $page['admin_users']));

					$in_group = FALSE;
					foreach($this->get_groups_id() as $cur_gid){
			   		 if (in_array($cur_gid, $admin_groups)) {
			   	    	 $in_group = TRUE;
			   		 }
					}
					if(($in_group) OR is_numeric(array_search($this->get_user_id(), $admin_users))) {
						if($page['visibility'] == 'deleted') {
							if(PAGE_TRASH == 'inline') {
								$can_modify = true;
							} else {
								$can_modify = false;
							}
						} elseif($page['visibility'] != 'deleted') {
							$can_modify = true;
						}
					} else {
						if($page['visibility'] == 'private') {
							continue;
						}
						else {
							$can_modify = false;
						}
					}
					// Work out how many pages there are for this parent						
					$get_page_subs = $this->database->query("SELECT page_id FROM ".TABLE_PREFIX."pages WHERE parent = '".$page['page_id']."'" . ((PAGE_TRASH != 'inline') ? " AND visibility!='deleted'" : ""));

					$pp = array('parent_n_pages' => $get_page_subs->numRows(),'can_modify' => $can_modify);
					switch ($page['visibility']) {
						case 'public':
							$pp['visibility_icon'] = 'visible_16.png';
							$pp['visibility_text'] = $TEXT['PUBLIC'];
							break;
						case 'private':
							$pp['visibility_icon'] = 'private_16.png';
							$pp['visibility_text'] = $TEXT['PRIVATE'];
							break;
						case 'registered':
							$pp['visibility_icon'] = 'keys_16.png';
							$pp['visibility_text'] = $TEXT['REGISTERED'];
							break;
						case 'hidden':
							$pp['visibility_icon'] = 'hidden_16.png';
							$pp['visibility_text'] = $TEXT['HIDDEN'];
							break;
						case 'none':
							$pp['visibility_icon'] = 'none_16.png';
							$pp['visibility_text'] = $TEXT['NONE'];
							break;
						case 'deleted':
							$pp['visibility_icon'] = 'deleted_16.png';
							$pp['visibility_text'] = $TEXT['DELETED'];
							break;
					}
					$pp['seo_freq'] = $page['seo_freq'];
					$pp['seo_index'] = $page['seo_index'];
					$pp['seo_follow'] = $page['seo_follow'];
					$pp['seo_archive'] = $page['seo_archive'];
					$pp['seo_snippet'] = $page['seo_snippet'];

					$pp['sections'] = array();
					$query = "SELECT * FROM ".TABLE_PREFIX."sections WHERE page_id = '".$page['page_id']."' ORDER BY position ASC";
					$get_sections = $this->database->query($query);
					if($get_sections->numRows() > 0)	{
						$now = time();
						while($section = $get_sections->fetchRow()) {
							$pp['sections'][$section['section_id']] = $section; 		
							if (($now>=$section['publ_start'] OR $section['publ_start']==0) 
							AND ($now<=$section['publ_end'] OR $section['publ_end']==0)) {
								$pp['sections'][$section['section_id']]['published'] = true;
								$pp['sections'][$section['section_id']]['published_icon'] = 'clock_16.png';
							} else {
								$pp['sections'][$section['section_id']]['published'] = false;
								$pp['sections'][$section['section_id']]['published_icon'] = 'clock_red_16.png';
							}
							if(SECTION_BLOCKS) {
								if($page['template'] != '') {
									$template_location = PE_PATH.'/templates/'.$page['template'].'/info.php';
								} else {
									$template_location = PE_PATH.'/templates/'.DEFAULT_TEMPLATE.'/info.php';
								}
								unset($block);
								if(file_exists($template_location))	require($template_location);
								// Check if $menu is set
								// Make our own menu list
								if(!isset($block[1]) OR $block[1] == '') $block[1] = $TEXT['MAIN'];
								$pp['sections'][$section['section_id']]['block_name'] = (isset($block[$section['block']])) ? $block[$section['block']]:$TEXT['BLOCK'] . '#' . (int) $section['block'];
							} else {
								$pp['sections'][$section['section_id']]['block_name'] = '';
							}
						}
					}
					$lv[$page['level']] = $page['page_id'];
					
					for($i=$page['level']+1;$i<count($lv);$i++) {
						$lv[$i]='';
						unset($lv[$i]);
					}
					$playout[implode('-',$lv)] = array_merge($page,$pp);
					//$playout = array_merge($playout,$this->make_list($page['page_id']));
					$this->make_list($page['page_id']);
				}
			}
			return $playout;
		}
		// Get the current users id
		function get_user_id() {
			return (array_key_exists('USER_ID',$_SESSION)) ? (int) $_SESSION['USER_ID']:0;
		}
		// Get the current users cookies
		function get_user_cookies($what='editor') {
			if($cookies=$this->database->get_one("SELECT `user_cookies` FROM `".TABLE_PREFIX."users` WHERE `user_id`='".$this->get_user_id()."'")){
				$cookies=unserialize($cookies);
			} else {
				$cookies=array();
			}
			if(($what) && (!array_key_exists($what,$cookies))) $cookies[$what]=array();
			if($what) return $cookies[$what];
			else return $cookies;
		}
		// Set the current users cookies
		function set_user_cookies($what) {
			$cookies=$this->get_user_cookies('');
			// can i use array_merge ??
			foreach($what as $k => $v){
				foreach($v as $kk => $vv){
					$cookies[$k][$kk]=$vv;
				}
			}
			$cookies=serialize($cookies);
			$this->database->query("UPDATE `".TABLE_PREFIX."users` SET `user_cookies` = '".$cookies."' WHERE `user_id`='".$this->get_user_id()."'");		
		}
		// Check if the user is already authenticated or not
		function is_authenticated() {
			if(isset($_SESSION['USER_ID']) AND $_SESSION['USER_ID']!="" AND is_numeric($_SESSION['USER_ID'])) {
				return true;
			} else {
				return false;
			}
		}
		// Get the current users group id
		function get_group_id() {
			return $_SESSION['GROUP_ID'];
		}
		// Get the current users group ids
		function get_groups_id() {
			return split(",", $_SESSION['GROUPS_ID']);
		}
		// Get the salutation
		function get_salutation() {
    		list($Hour,$AM) = explode(" ",gmdate("h a",time()+TIMEZONE));
		    if (strtolower($AM) == 'am') $when = 'Morning';
        	else {
            	$Hour = (int) $Hour;
				if ($Hour < 6)                        // According to Wikipedia, afternoon is before 6;
                	$when = 'Afternoon';
            	elseif ($Hour < 9)                        // According to Wikipedia, evening is before 9;
                	$when = 'Evening';
            	else
                	$when = 'Night';
        	}
			return $this->Translate('Good '. $when);
  		}
		function convert_datetime_format($DATE_FORMAT = '', $TIME_FORMAT = '',$use_time = true, $user_id = 0){
			$user_id = (int) $user_id;
			if ($user_id==0) {
				if (!$DATE_FORMAT) $DATE_FORMAT = DEFAULT_DATE_FORMAT;
				if (!$TIME_FORMAT) $TIME_FORMAT = DEFAULT_TIME_FORMAT;
			} else {
				if (!$DATE_FORMAT) $DATE_FORMAT = DATE_FORMAT;
				if (!$TIME_FORMAT) $TIME_FORMAT = TIME_FORMAT;
			}
			switch($DATE_FORMAT) {
				case 'd.m.Y':
				case 'd M Y':
				case 'l, jS F, Y':
				case 'jS F, Y':
				case 'D M d, Y':
				case 'd-m-Y':
				case 'd/m/Y':
					$jscal_format = 'd.m.Y'; // dd.mm.yyyy hh:mm
					$jscal_ifformat = '%d.%m.%Y';
					break;
				case 'm/d/Y':
				case 'm-d-Y':
				case 'M d Y':
				case 'm.d.Y':
					$jscal_format = 'm/d/Y'; // mm/dd/yyyy hh:mm
					$jscal_ifformat = '%m/%d/%Y';
					break;
				default:
					$jscal_format = 'Y-m-d'; // yyyy-mm-dd hh:mm
					$jscal_ifformat = '%Y-%m-%d';
					break;
			}
			$jscal_format .= ' H:i';
			if ($use_time) $jscal_ifformat .= ' %H:%M:%S';

			return $jscal_ifformat;
		}
		
		function Pacer_all_nlcr_2_br($input,$br_tag='<br />'){
			return str_replace(array("\n\r","\r\n","\n","\r"), array($br_tag,$br_tag,$br_tag,$br_tag),$input);
		}

		function Pacer_die($msg='',$backtrace=true){
			$this->LogError($msg);
			echo "<pre>".$msg."<br />";
			echo '----------------'."<br />";
        	echo $this->Translate('Debug backtrace').': '."<br />";
        	echo '----------------'."<br />";
        	foreach(debug_backtrace() as $t) {
            	echo "\t" . '@ ';
          		if(isset($t['file'])) echo $t['file'] . ':' . $t['line'];
            	else {
               	 	// if file was not set, I assumed the functioncall
                	// was from PHP compiled source (ie XML-callbacks).
                	echo $this->Translate('<PHP inner-code>');
            	}
            	echo ' -- ';

            	if(isset($t['class'])) echo $t['class'] . $t['type'];
            	echo $t['function'];
            	if(isset($t['args']) && sizeof($t['args']) > 0) echo '(...)';
            	else echo '()';
            	echo "<br />";
			}
            echo "</pre>";
			die(); 
		}	
				
		function Page_Scrollers(){
			if (defined('FRONTEND')){
				if (!array_key_exists('page_scrollers',$this->pacer_settings) || !$this->pacer_settings['page_scrollers']) return;
			}
			$url=((defined('FRONTEND'))?TEMPLATE_DIR:THEME_URL);
			$this->Code_Injection_Add('css_file','jquery.page_scrollers.css');
			$this->Code_Injection_Add('css_file',$url.'/css/jquery.page_scrollers.css');
			$this->Code_Injection_Add('js_file','jquery.page_scrollers.js');
			//if (!file_exists($url.'/images/back_top.gif')) $url = PACER_URL;
			$this->Code_Injection_Add('js_script','jQuery(document).ready(function() {
	jQuery("a#back_to_top img, a#back_to_bottom img").each(function() {
		jQuery(this).attr("src","'.$url.'"+jQuery(this).attr("src"));
		var tb = jQuery(this).parent().attr("id");
		switch(tb){
			case "back_to_top":
				tb = "'.$this->Translate('Go to Top').'";
				break;
			case "back_to_bottom":
				tb = "'.$this->Translate('Go to Bottom').'";
				break;
		}
		jQuery(this).attr("title",tb);																		   
	});
});'); 
 		}
		
		function Page_Hide_Status_Bar(){
			if (defined('FRONTEND')) {
				if (array_key_exists('hide_status_bar',$this->pacer_settings) && $this->pacer_settings['hide_status_bar']) { 
					$this->Code_Injection_Add('js_file','jquery.hide_status_bar.js');		
				}
			}
		}
		
		function Page_Disable_Right_Click(){
			if (defined('FRONTEND')) {
				if (array_key_exists('disable_right_click',$this->pacer_settings) && $this->pacer_settings['disable_right_click']) { 
					$this->Code_Injection_Add('js_file','jquery.rightClick.js');		
				}
			}
		}
		
		function create_empty_index_php($folder,$back=0){
			if (!is_dir($folder)) return false;		
			$folder=$folder.'/index.php';
			if (file_exists($folder)) return false;
			$back=(int)$back;
			if ($back>0) 
				$back=str_repeat('../',$back);
			else
				$back='./';
			$content = "<"."?php\n".
str_replace('config.php','index.php',$this->pacer_settings['copyright']).
"\n".
"die(header('Location: ".$back."index.php'));".
"\n".
"?".">";
			file_put_contents($folder,$content);
		}
		function human_file_size($size,$roundup=0, $decimals=0,$short=false) {
			$b = (($short)?' B':' Bytes');
			$filesizename = array($b, " kB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB");
			if (($roundup > 0) && ($decimals == 0)) {
				$addition=.45;
			} else {
				$addition = 0 ;
			}

			if ($size == 0) {
				$retstring = "0 kB";
			} else {
				$retstring = round($size/pow(1024, ($i = floor(log($size, 1024))))+$addition, $decimals) . $filesizename[$i];
			}
			return $retstring;
		}
		function human_file_perms($perms='',$file='') {
			if ($file) $perms=fileperms($file);
			if (($perms & 0xC000) == 0xC000) {
    			// Socket
			    $info = 's';
			} elseif (($perms & 0xA000) == 0xA000) {
			    // Symbolic Link
			    $info = 'l';
			} elseif (($perms & 0x8000) == 0x8000) {
    			// Regular
			    $info = '-';
			} elseif (($perms & 0x6000) == 0x6000) {
			    // Block special
			    $info = 'b';
			} elseif (($perms & 0x4000) == 0x4000) {
			    // Directory
			    $info = 'd';
			} elseif (($perms & 0x2000) == 0x2000) {
			    // Character special
			    $info = 'c';
			} elseif (($perms & 0x1000) == 0x1000) {
			    // FIFO pipe
			    $info = 'p';
			} else {
			    // Unknown
			    $info = 'u';
			}

			// Owner
			$info .= (($perms & 0x0100) ? 'r' : '-');
			$info .= (($perms & 0x0080) ? 'w' : '-');
			$info .= (($perms & 0x0040) ?
            (($perms & 0x0800) ? 's' : 'x' ) :
            (($perms & 0x0800) ? 'S' : '-'));

			// Group
			$info .= (($perms & 0x0020) ? 'r' : '-');
			$info .= (($perms & 0x0010) ? 'w' : '-');
			$info .= (($perms & 0x0008) ?
            (($perms & 0x0400) ? 's' : 'x' ) :
            (($perms & 0x0400) ? 'S' : '-'));

			// World
			$info .= (($perms & 0x0004) ? 'r' : '-');
			$info .= (($perms & 0x0002) ? 'w' : '-');
			$info .= (($perms & 0x0001) ?
            (($perms & 0x0200) ? 't' : 'x' ) :
            (($perms & 0x0200) ? 'T' : '-'));

			return $info;
		}
		function build_link($param=array(),$delete_param=array()){
			$arr = array();
			if ($_SERVER['QUERY_STRING']) {
				$q=explode('&',str_replace('&amp;','&',$_SERVER['QUERY_STRING']));
				foreach($q as $v){
					$qq=explode('=',$v);
					$arr[$qq[0]]=(isset($qq[1])?$qq[1]:'');
				}
			}
			foreach($param as $k => $v){
				$arr[$k]=$v;
			}
			$q='';
			foreach($arr as $k => $v){
				//if(in_array($k,$delete_param)) continue;
				$q.=(($q)?'&':'').$k.'='.$v;
			}
			if (($q) ) { //|| count($delete_param)) {
				$url = str_replace($_SERVER['QUERY_STRING'],'',$_SERVER['REQUEST_URI']);
				$url.= ((preg_match('|\?|',$url))?'':'?').$q;
				return $url;
			} else {
				return $_SERVER['REQUEST_URI'];
			}
		}
		function new_submission_id() {
			$submission_id = '';
			$salt = "abchefghjkmnpqrstuvwxyz0123456789";
			srand((double)microtime()*1000000);
			$i = 0;
			while ($i <= 7) {
				$num = rand() % 33;
				$tmp = substr($salt, $num, 1);
				$submission_id = $submission_id . $tmp;
				$i++;
			}
			return $submission_id;
		}
		/*
		function Pacer_Show_Section($section_id) {
			// Get outside objects
			global $TEXT,$MENU,$HEADING,$MESSAGE;
			global $globals;
			global $database;
			global $wb;
			$admin = & $wb;
			
			$this_content='';	
			
			if ($section = $this->database->queryRow(sprintf("SELECT * FROM %ssections WHERE section_id ='%d'",TABLE_PREFIX,$section_id))){
				$page_id=$section['page_id'];
				$this_content='';	
				ob_start();
				require(PE_PATH.'/modules/'.$section['module'].'/view.php');
				$this_content=ob_get_contents();
				ob_end_clean();
			}
			if (!$this_content)
				return $this->Pacer_Zone_Warning($section_id);
			else return $this_content;
		}
		*/
		function Change_Template() {
			if (!$this->pacer_settings['admin_console']) return;
			// Change Template - Admin Console
			if(isset($_GET['template'])) {
				$template = filter_var($_GET['template']);
    			if ($template) {
					define('TEMPLATE',$template);
    				$_SESSION['template'] = $template;
				} else {
    				unset($_SESSION['template']);	
				}
			} elseif (isset($_SESSION['template']) && $_SESSION['template'] != '') {
    			define('TEMPLATE',$_SESSION['template']);
			}

			// safety... the Template exists and is not a Theme...
			if (defined('TEMPLATE')) {
				if((!file_exists(PE_PATH.'/templates/'.TEMPLATE.'/index.php')) 
				|| ($this->database->get_one(sprintf("SELECT function FROM %saddons WHERE type = '%s' AND directory = '%s' AND function = '%s'",TABLE_PREFIX,'template',TEMPLATE,'template'))!='template')
				){
					// reload myself with template=''
					$this->Redirect_To('?&template=');
				}
			}
		}
		
		function get_frontend_private_messages(){
			global $wb;
			
			$module_directory ='pacer_private_messages';
			$file = PE_PATH.'/modules/'.$module_directory.'/info.php';
			if (file_exists($file)){
				require ($file);
				require_once(PE_PATH.'/modules/'.$module_directory.'/functions.php');
				if (get_pm_active_for_user()){
					$all = (int) get_pm_number('inbox');
					if ($all) {
						$new = (int) get_pm_number('new');
						$settings = $this->database->queryRow(sprintf("SELECT * FROM %smod_%s_settings WHERE section_id = '%d'",TABLE_PREFIX,$module_directory,get_pm_section()));
						if($new){
							if ($settings['frontend_template_new_messages'])
								$template = $settings['frontend_template_new_messages'];
							else	
								$template = "You have %d new message(s)";
						} else {
							if ($settings['frontend_template_no_messages'])
								$template = $settings['frontend_template_no_messages'];
							else	
								$template = "No new messages";			
						}
						$page_link = $this->database->get_one("SELECT link FROM ".TABLE_PREFIX."pages WHERE page_id = '".get_pm_page()."'");
						$page_link = $wb->page_link($page_link);
						return sprintf('<a title="%s" href="%s">'.$this->Translate($template).'</a>',$this->Translate('Inbox'),$page_link,$new);	
					}
				}
			}
			return '';
		}
		
		function get_user_defined_constants($limit_to_user=true){
			$raw = get_defined_constants(true); // limit it to user defined constants....
			$arr=array();
			foreach ($raw['user'] as $k => $v) {
				if ($limit_to_user){
					switch(strtolower($k)){
						case 'db_password':
						case 'db_username':
						case 'wbmailer_smtp_password':
						case 'wbmailer_smtp_username':
							continue;
							break;
						default:
							$arr[$k]=$v;
					}
				} else $arr[$k]=$v;
			}
			return $arr;
		}
		function hide_base_url($html,$force=0){
			if (defined('FRONTEND') || ($force>0)) {
				if (($force>1) || (array_key_exists('hide_base_url',$this->pacer_settings) && $this->pacer_settings['hide_base_url'])) { 
					// href="	|	href='  
					// src="	|	src='
					$html = preg_replace('|"'.PE_URL.'|','"'.PE_PATH_RELATIVE,$html);
					$html = preg_replace('|\''.PE_URL.'|','\''.PE_PATH_RELATIVE,$html);
					// url(
					$html = preg_replace('|\('.PE_URL.'|','('.PE_PATH_RELATIVE,$html);					
				}
			}
			return $html;
		}
			
	} // class
} // if class_exists
?>