<?php
// $Id$

/*

 The Pacer Edition Project <http://www.jcwebden.com/>
 Copyright (C) 2009, John P. and Stefano R.

 Pacer Edition is free and Commercial software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the License,
 or (at your option) any later version.

 Pacer Edition is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
if (!class_exists('Pacer_Cloner')) {

	// Include the WB functions file
	require_once(PE_PATH.'/framework/functions.php');

	// Include the ordering class
	require_once(PE_PATH.'/framework/class.order.php');
			
	class Pacer_Cloner extends Pacer {
/******* Init *******************************************************************/
		private $debug = false;
		private $export = false;
		private $sql = '';
		private $page_id_marker = "p_a_g_e__i_d";
		private $section_id_marker = "s_e_c_t_i_o_n__i_d";
		private $pages = array();
		private $action = '';
		
		var $from_page_id;
		var $to_page_id;
		var $from_section_id;
		var $to_section_id;
		
		function __construct(){
			parent::__construct();
		}
		function Pacer_Cloner_Export_Clone_File($params) {
				
			if (!is_array($params)) $params=array();
			$file = (array_key_exists('file',$params))?$params['file']:get_class($this);
			$pages_id = (array_key_exists('pages',$params))?$params['pages']:'';
			$this->action = (array_key_exists('action',$params))?$params['action']:'';
			
			$this->export=true;
			$this->to_page_id = 0;
			$pages = array();
			if ((!$pages_id) || ($pages_id===array())) {
				foreach($this->database->queryAll("SELECT page_id FROM ".TABLE_PREFIX."pages ORDER BY position'") as $pages){
					$pages_id[]=$pages['page_id'];
				}
				$pages = array();
			}
			
			//loop pages
			foreach($pages_id as $this->from_page_id){
				$pages['pages'][$this->from_page_id]=$this->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '".$this->from_page_id."'");
				
				$pages['sql']['pages'][$this->from_page_id]=$this->Pacer_Cloner_Create_Generic_Insert('pages',$pages['pages'][$this->from_page_id],array('page_id'));
				
				//loop sections
				$sections = $this->database->queryAll("SELECT * FROM `".TABLE_PREFIX."sections` WHERE `page_id` = '".$this->from_page_id."' ORDER BY position");				
				foreach($sections as $section){
					$this->from_section_id = $section['section_id'];
					$pages['sections'][$this->from_page_id][$section['section_id']]=$section;
					
					$pages['sql']['sections'][$this->from_page_id][$section['section_id']]=$this->Pacer_Cloner_Create_Generic_Insert('sections', $section,array('section_id'));
					$this->sql=array();
					$this->Pacer_Cloner_File_Index($section);	
					$pages['sql']['files'][$this->from_page_id][$section['section_id']]=$this->sql;
				}
			}

			$pages = serialize($pages);
			$this->download_one_file($pages,'send','string','',$file);
		}

		function Pacer_Cloner_Clone_From_File($file) {
			// replace into sql - page_id and section_id
			// insert new page, new file /pages ...... like add.php
			// insert other files as of sql from file
			if ($this->pages=file_get_contents($file)){
				if(($this->pages=unserialize($this->pages))!==false){
					$this->params=$this->pages['params'];
					if ($this->Pacer_Cloner_Clone_From_File_PreFlight()){
						
						echo "<pre>";
						print_r($this->pages);
						echo "</pre>";
					}
				}
			}
		}
			
		function Pacer_Cloner_Clone_From_File_PreFlight($do_update=false) {
			// params:	action	overwrite	(overwrite all existing or add)
			// 			action	ipl 		(delete all page tree and add)
			// 			action	add	 		(add)
			// 			action	replace	 	(find page if exists (by page_title) otherwise insert)
			//
			// On files the only update possible is delete all and insert anew doe to the face that the key for each file can be different, can also solve order position of each file/record
			
			foreach($this->pages['pages'] as $page_id => $page){
				
				// check is page_id exists....? replace
				// check is page_title exists....? rename?
				$page_action='';
				if($this->to_page_id=$this->database->get_one("SELECT page_id FROM ".TABLE_PREFIX."pages WHERE page_title = '".$page['page_title']."'")){
					$page_action='DELETE';
					if($do_update){
						$sub_pages = get_subs($this->to_page_id, array());
						foreach($sub_pages AS $sub_page_id) {
							delete_page($sub_page_id);
						}
						// Delete page
						delete_page($this->to_page_id);
					}
				} else {
					$this->to_page_id=$this->database->get_one("SELECT MAX(page_id)+1 FROM ".TABLE_PREFIX."pages");
				}
				if($do_update){
					
				}
				foreach($this->pages['sections'][$page_id] as $section_id => $section){
					if($do_update){
						//remove existing??	
					
					}
					
				}	
			}
			return true;
		}

		function Pacer_Cloner_Clone_From_Page($from_page_id,$to_page_id) {

			$this->from_page_id = $from_page_id;
			$this->to_page_id = $to_page_id;
			$sections = $this->database->queryAll("SELECT * FROM `".TABLE_PREFIX."sections` WHERE `page_id` = '".$this->from_page_id."' ORDER BY position");
			foreach($sections as $section){
				$this->from_page_id = $section['page_id'];
				$this->from_section_id = $section['section_id'];
				// Get new order for section
				$order = new order(TABLE_PREFIX.'sections', 'position', 'section_id', 'page_id');
				$section['position'] = $order->get_new($this->to_page_id);
				$section['page_id'] = $this->to_page_id;
				$section['section_id'] = $this->to_section_id;
				// Add new record into the sections table
				
				$sql=$this->Pacer_Cloner_Create_Generic_Insert('sections',$section,array('section_id'));
				$this->database->query($sql);
				if($this->database->is_error()) {
					$this->LogError($this->database->get_error()."<br />".$sql);
					if ($this->debug) {
						echo $this->database->get_error()."<br />".$sql;
					}
				}
				// Get the section id
				$this->to_section_id = $this->database->last_Insert_Id();
				
				$section['section_id'] = $this->to_section_id;
				$this->Pacer_Cloner_File_Index($section);				
			}
		}
		
		private function Pacer_Cloner_Create_Generic_Insert($table,$data,$skip_fields = array()){
			$fields = array();
			$values = array();
			foreach($data as $k => $v){
				if (!in_array($k,$skip_fields)){
					if (($this->export) && ($k=='page_id')) $v = $this->page_id_marker;
					elseif (($this->export) && ($k=='section_id')) $v=$this->section_id_marker;
					$fields[]='`'.$k.'`';
					$values[]='\''.addslashes($v).'\'';
				}
			}
			if (!$this->export){
				$fields = implode(",",$fields);
				$values = implode(",",$values);
				return "INSERT INTO `".TABLE_PREFIX.$table."` ($fields) VALUES ($values)";
			} else{
				return array('table'=>$table,'fields'=>$fields,'values'=>$values);
			}
		}
	
		private function Pacer_Cloner_File_Index($section){
			// Module Settings
				switch($section['module']){
					case 'pacer_form':
					case 'pacer_media_player':
					case 'pacer_image_slider':
					case 'pacer_poll_system':
					case 'pacer_marquee':
					case 'pacer_compare_table':
					case 'pacer_countdown':
					case 'pacer_download_repository':
					case 'pacer_star_rating':
					case 'pacer_blog':
					case 'pacer_wrapper':
					case 'pacer_private_messages':
					case 'pacer_guestbook':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_settings');
						break;
				}
				// Module Generic
				switch($section['module']){
					case 'wysiwyg':
					case 'code':
					case 'section_picker':
					case 'menu_link':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module']);
						break;
				}
				// Module Specifics
				switch($section['module']){
					case 'pacer_media_player':
					case 'pacer_download_repository':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_groups','group_id');
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_file_ext','fileext_id');
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_files','file_id');
						break;
					case 'pacer_image_slider':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_file_ext','fileext_id');
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_files','file_id');
						break;	
					case 'pacer_form':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_file_ext','fileext_id');
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_fields','field_id');
						// Dont clone Submissions
						break;	
					case 'pacer_statistics':
					case 'pacer_marquee':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_page','file_id');
						break;
					case 'pacer_star_rating':
					case 'pacer_poll_system':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_question','question_id');
						// Dont clone votes
						break;
					case 'pacer_compare_table':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_groups','group_id');
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_files','file_id');
						break;
					case 'pacer_private_messages':
					case 'pacer_guestbook':
						//dont copy messages
						//$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_messages','message_id');
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_file_ext','fileext_id');
						break;	
					case 'pacer_blog':
						// Dont clone Comments
						break;
					case 'wysiwyg':
						$this->Pacer_Cloner_Clone_File('mod_'.$section['module'].'_hist','h_id');
						break;
					case 'code':
						break;
					case 'section_picker':
						break;
					case 'menu_link':
						break;
				}				
		}
		
		private function Pacer_Cloner_Clone_File($table,$skip_field=''){
			if ($froms = $this->database->queryAll("SELECT * FROM `".TABLE_PREFIX.$table."` WHERE `page_id` = '".$this->from_page_id."' AND `section_id` = '".$this->from_section_id."'")) {
				foreach($froms as $from){
					$from['page_id'] = $this->to_page_id;
					$from['section_id'] = $this->to_section_id;
					$sql = $this->Pacer_Cloner_Create_Generic_Insert($table,$from,array($skip_field));
					if ($this->export)
						$this->sql[]=$sql;
					else {
						$this->database->query($sql);
						if($this->database->is_error()) {
							$this->LogError($this->database->get_error()."<br />".$sql);
							if ($this->debug) {
								echo $this->database->get_error()."<br />".$sql;
							}
						}
					}
				}
			}
		}
	} //class
} //defined
?>