<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: pacer_code_injection.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

if (!class_exists('Pacer_Code_Injection')) {
	
	class Pacer_Code_Injection extends Pacer_Mail {
		private $codetop_marker = '<!--Code_Injection_%s_Shows_Here!-->';
	
	const IGNORE = '$1';

		var $files = array();
		var $files_remove = array();
		var $files_order = array();
		var $html_source = array('html'=>'','head'=>'','body'=>'');
		private $script_source = array('js_script'=>'','css_script'=>'','js_file'=>'','css_file'=>'');
		
		
		function __construct() {
//		echo "<p>".__FILE__."</p>";
			parent::__construct();
		}
		function Code_Injection_Buid($where = 'head'){
			$html = '';
			$arr=array('html_code','css_file','css_script','js_file','js_script');
			//if ($where=='body')	$arr[]='html_code';
			//if ($where=='head')	$arr[]='html_code';
			foreach($arr as $k) {		
				if (!array_key_exists($k,$this->files)) continue;
				foreach($this->files[$k] as $kk => $vv) {
					// Avoid double inclusion eg. jquery.js and jquery.min|pack|-1.3.2 .js
					
					switch($k){ 
						case 'js_file':
							if ($vv['file']=='jquery.js') {
								if ($this->Code_Injection_Search_jQuery($where)!==false){
									$this->files[$k][$kk]['done'] = true;
									$vv['done'] = true;
									break;
								}
							}
							break;
					}
					
					if(isset($vv['done'])) continue;				
					if($vv['where']!=$where) continue;
					if($vv['condition']) $condition = $vv['condition']; else $condition = '';
					$vv = $vv['file'];
					$this->files[$k][$kk]['done'] = true;
					$html .= $this->Code_Injection_Buid_Code($k,$vv,true,$condition);
				}
			}
			return $html;
		}
		
		function Code_Injection_Search_jQuery($where='head'){
			// when there'll be a better regex to test these conditions...
			// 	4.	jquery-1.3.2.js
			// 	3.	jquery.min.js
			// 	2.	jquery.pack.js
			// 	1.	jquery.js
			
			if (preg_match('|(<script.* src=.*jquery\.js.*</script>)|i',$this->html_source[$where],$matches))	
				return $matches[0];
			if (preg_match('|(<script.* src=.*jquery\.min\.js.*</script>)|i',$this->html_source[$where],$matches))
				return $matches[0];			
			if (preg_match('|(<script.* src=.*jquery\.pack\.js.*</script>)|i',$this->html_source[$where],$matches))
				return $matches[0];
			if (preg_match('|(<script.* src=.*jquery-[0-9]\.[0-9]\.[0-9]\.js.*</script>)|i',$this->html_source[$where],$matches))
				return $matches[0];
			
			return false;
		}
		function Code_Injection_Buid_Code($type, $file, $crlf = true, $condition = ''){
			$chunks = array("","",$file,"","",(($crlf) ? "\n":""));
			$file_path = str_replace(PE_URL,PE_PATH,$file);
			$file_url = str_replace(PE_PATH,PE_URL,$file);

			switch($type){
				case 'js_file':
					$chunks[1] = '<script type="text/javascript" src="';
					$chunks[2] = ((dirname($file)=='.') ? PACER_URL.'/js/'.$file:$file_url);
      	            $chunks[3] = '"></script>';
					break;
				case 'js_script':
					$chunks[1] = '<script type="text/javascript">
<!--
';
					$chunks[2] = $file;
           	        $chunks[3] = '
-->
</script>';
					break;
				case 'css_file':
					$chunks[1] = '<link href="';
					$chunks[2] = ((dirname($file)=='.') ? PACER_URL.'/css/'.$file:$file_url);
                   	$chunks[3] = '" rel="stylesheet" type="text/css" />';
					break;
				case 'css_script':
/*
					$chunks[1] = '<style type="text/css">
<!--
';
*/
					$chunks[1] = '<style type="text/css">';
       	            $chunks[2] = $file;
/*
					$chunks[3] = '
-->
</style>';
*/
					$chunks[3] = '</style>';
					break;
				case 'php_file':
					$chunks[2] = file_get_contents( ((dirname($vv)=='.') ? PACER_PATH.'/php/':'').$file);
               	    ob_start();
					eval($chunks[2]);
					$chunks[2] = ob_get_contents();
					ob_end_clean();		
					break;
				case 'pear_file':
					$chunks[2] = file_get_contents(((dirname($vv)=='.') ? PACER_PATH.'/pear/':'').$file);
               	    ob_start();
					eval($chunks[2]);
					$chunks[1] = ob_get_contents();
					ob_end_clean();		
					break;
				case 'html_code':
					$chunks[1] = '';
       	            $chunks[2] = $file;
					$chunks[3] = '';
					break;
				case 'html_replace':
					$chunks[1] = '';
       	            $chunks[2] = $file;
					$chunks[3] = '';
					$condition='';
					break;
			}
			
			if ($condition) {
				$chunks[0] = '<!--['.$condition.']>';
				$chunks[4] = '<![endif]-->';
			}
			return implode('',$chunks);
		}

		function Code_Injection_Buid_Condensed($where = 'head'){
			$this->script_source = array('css_file'=>'','css_script'=>'','js_file'=>'','js_script'=>'');
			foreach($this->script_source as $k => $v) {		
				if (!array_key_exists($k,$this->files)) continue;
				foreach($this->files[$k] as $kk => $vv) {
					if($vv['where']!=$where) continue;
					
					list($script_type,$script) = explode('_',$k);
					
					
					
					if ($script=='script')					
						$file = $vv['file'];
					else
						$file = ((dirname($vv['file'])=='.') ? PACER_URL.'/'.$script_type.'/'.$vv['file']:$vv['file']);


					$script_type = $k;
					$type = $k;
					$condition = $vv['condition'];
					$file_path = str_replace(PE_URL,PE_PATH,$file);
					$file_url = str_replace(PE_PATH,PE_URL,$file);
				    $file_a = str_replace(PE_URL,'',((dirname($file)=='.') ? PACER_URL.'/'.$script_type.'/'.$file:$file_url));							
					
					switch($type){
						case 'js_file':
							$js = file_get_contents(PE_PATH.$file_a);
							// Dont compress files as they could be already packed
							//if ((false) && (!preg_match('/\(p,a,c,k,e,r\)/i',$js))){
							//	$js = $this->CodeTop_compress_js($js);
//								$this->script_source[$script_type] .= "\n/* File: ".$file_a." */\n";
								if ($condition)
									$this->script_source[$script_type] .= '<!--['.$condition.']>';
								$this->script_source[$script_type] .= $js;
								unset($this->files[$k][$kk]);
								if ($condition)
									$this->script_source[$script_type] .= '<![endif]-->';
							//}
							break;
						case 'js_script':
//							$this->script_source[$script_type] .= "\n/* Script */\n";
							if ($condition)
								$this->script_source[$script_type] .= '<!--['.$condition.']>';
							$this->script_source[$script_type] .= $this->CodeTop_compress_js($file);
							if ($condition)
								$this->script_source[$script_type] .= '<![endif]-->';
							unset($this->files[$k][$kk]);
							break;
						case 'css_file':
//							$this->script_source[$script_type] .= "\n/* File: ".$file_a." */\n";
							$this->script_source[$script_type] .= $this->Code_Injection_Buid_Condensed_Resolve_Url(file_get_contents(PE_PATH.$file_a),PE_URL.$file_a);
							unset($this->files[$k][$kk]);
							break;
						case 'css_script':
							//from where?
							/*
							$arr=debug_backtrace();
							foreach($arr as $k)
								echo "<pre>".$k['file']."</pre>";
								
							*/
							$file_a = '';
//							$this->script_source[$script_type] .= "\n/* Style: ".$file_a." */\n";
							$this->script_source[$script_type] .= $this->Code_Injection_Buid_Condensed_Resolve_Url($file,$file_a);
							unset($this->files[$k][$kk]);
							break;
					}
				}
			}
			$cid = $this->Cache_Key();
			foreach($this->script_source as $k => $v){	
				if ($v) {
					if (preg_match('/_file/',$k)) {
						$cache_id = $k.'|'.$cid;
						if (!$data = $this->CACHE->get($cache_id))
							$this->CACHE->save(
								$this->hide_base_url(
									(($k=="css_file")?$this->CodeTop_compress_css($v):$v)
								,1)
							,$cache_id);
						$this->Code_Injection_Add($k,PACER_URL.'/pacer_output_cache.php?pid='.base64_encode($cache_id),$where);
					} else {
						$this->Code_Injection_Add($k,$v,$where,'',false);
					}
				}
				$this->script_source[$k] = '';
			}
		}
		
		function Code_Injection_Buid_Condensed_Resolve_Url($css,$file){
			if (!$file)
				$url = PE_URL;
			else $url = dirname($file);
			
			if (preg_match('/url/i',$css)){
				$css = preg_replace('/\.\.\/\.\.\/\.\.\//', str_replace(PE_PATH,PE_URL,dirname(dirname(dirname($url)))).'/',$css);
				$css = preg_replace('/\.\.\/\.\.\//', str_replace(PE_PATH,PE_URL,dirname(dirname($url))).'/',$css);
				$css = preg_replace('/\.\.\//', str_replace(PE_PATH,PE_URL,dirname($url)).'/',$css);
				$css = preg_replace('/\.\//',str_replace(PE_PATH,PE_URL,$url).'/',$css);
			}
			
			return $css;
		}
		
function CodeTop_compress_css($buffer,$replace_url='') {
/* remove comments */
    $buffer = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $buffer);
/* remove tabs, spaces, new lines, etc. */        
    $buffer = str_replace(array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), '', $buffer);
/* remove unnecessary spaces */        
    $buffer = str_replace('{ ', '{', $buffer);
    $buffer = str_replace(' }', '}', $buffer);
    $buffer = str_replace('; ', ';', $buffer);
    $buffer = str_replace(', ', ',', $buffer);
    $buffer = str_replace(' {', '{', $buffer);
    $buffer = str_replace('} ', '}', $buffer);
    $buffer = str_replace(': ', ':', $buffer);
    $buffer = str_replace(' ,', ',', $buffer);
    $buffer = str_replace(' ;', ';', $buffer);
	
	if($replace_url) $buffer = str_replace($replace_url, '', $buffer);

return $buffer;
}
function CodeTop_compress_js($buffer) {
	//return $buffer;
	/**/
	// constants
	// zero encoding - just removal of white space and comments
		$parser = new ParseMaster();
		// make safe
		$parser->escapeChar = '\\';
		// protect strings
		$parser->add('/\'[^\'\\n\\r]*\'/', self::IGNORE);
		$parser->add('/"[^"\\n\\r]*"/', self::IGNORE);
		// remove comments
		$parser->add('/\\/\\/[^\\n\\r]*[\\n\\r]/', ' ');
		$parser->add('/\\/\\*[^*]*\\*+([^\\/][^*]*\\*+)*\\//', ' ');
		// protect regular expressions
		$parser->add('/\\s+(\\/[^\\/\\n\\r\\*][^\\/\\n\\r]*\\/g?i?)/', '$2'); // self::IGNORE
		$parser->add('/[^\\w\\x24\\/\'"*)\\?:]\\/[^\\/\\n\\r\\*][^\\/\\n\\r]*\\/g?i?/', self::IGNORE);
		// remove: ;;; doSomething();
		///////if ($this->_specialChars) $parser->add('/;;;[^\\n\\r]+[\\n\\r]/');
		// remove redundant semi-colons
		$parser->add('/\\(;;\\)/', self::IGNORE); // protect for (;;) loops
		$parser->add('/;+\\s*([};])/', '$2');
		// apply the above
		$buffer = $parser->exec($buffer);

		// remove white-space
		$parser->add('/(\\b|\\x24)\\s+(\\b|\\x24)/', '$2 $3');
		$parser->add('/([+\\-])\\s+([+\\-])/', '$2 $3');
		$parser->add('/\\s+/', '');
		// done
		return $parser->exec($buffer);
/**/ 
}
		function CodeTop_Load_Source($html) {
			
			
			$this->html_source=array('html'=>'','head'=>'','body'=>'');
			if (!$html) {
				if (ob_get_level())
					$html = ob_get_contents();
			}
			$this->html_source['html']=$html;
/*			
			if($html){
				require(PACER_PATH.'/simple_html_dom.php');
				$html = str_get_html($html);
				foreach($html->find('head') as $e) {
					$this->html_source['head']=$e->outertext;
				}
				foreach($html->find('body') as $e) {
					$this->html_source['body']=$e->outertext;
				}
				unset($html);
			}
			print_r($this->html_source); die("aa");
		
*/
	
			$el = preg_split('/<\/head[^>]*>/i',$this->html_source['html']);
			$this->html_source['head'] = (count($el)>0) ? $el[0].'</head>' : '';
			if($this->html_source['head']){ // where to put code_marker?
							
			
			}
			
			$this->html_source['body'] = (count($el)>1) ? $el[1] : '';
		}
		
		function CodeTop_Place_Marker($where,$marker){
			// if codetop_marker is not defined in template, then insert after <$where> tag...
			if (stristr($this->html_source['html'],$marker)!==false) return true;
			
			// is there a jquery.js ??? if so inject after that line... 
			if ($where=='head') {
				$w = $this->Code_Injection_Search_jQuery($where);
				if ($w!==false){
					$this->html_source[$where]=preg_replace('|'.$w.'|i',$w."\n".$marker,$this->html_source[$where]);
					$this->html_source['html']=$this->html_source['head'].$this->html_source['body'];
				}
			}
			
			if (stristr($this->html_source['html'],$marker)!==false) return true;
			
			// after last '<meta ', '<head>', '</title' or </title ' tag
			if ($el = preg_split('~(</?[^>]+>)~iU', $this->html_source['head'], -1,PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE)) {
				if ($this->CodeTop_Place_Marker_Injection($el,$marker,$where,'<meta ')!==false) return true;

				if ($this->CodeTop_Place_Marker_Injection($el,$marker,$where,'<head>')!==false) return true;
				if ($this->CodeTop_Place_Marker_Injection($el,$marker,$where,'</title')!==false) return true;
				if ($this->CodeTop_Place_Marker_Injection($el,$marker,$where,'</title ')!==false) return true;
			}
			// just after <head>
			$this->html_source[$where]=preg_replace('/<'.$where.'(.*?)>/is','<'.$where.'$1'.'>
'.$marker,$this->html_source[$where]);	
			$this->html_source['html']=$this->html_source['head'].$this->html_source['body'];
			
			// final check
			if (stristr($this->html_source['html'],$marker)!==false) return true;
			else return false;
		}
		
		function CodeTop_Place_Marker_Injection($el,$marker,$where,$meta){
			$last_element='';
			foreach($el as $k=>$v){
				if(trim($v)) {
					if(preg_match('~'.$meta.'~iU',$v)) {
						$last_element=$v;
					}
				}
			}
			if ($last_element){
				$this->html_source[$where]=preg_replace('~'.$last_element.'~i',$last_element.'
'.$marker,$this->html_source[$where]);	
				$this->html_source['html']=$this->html_source['head'].$this->html_source['body'];		
				return true;
			}
			return false;
		}
		function CodeTop_Show_Here($where = 'head') {
			$this->Code_Injection_Replacements($where);
			if ($where=='head') {
				if ((defined('FRONTEND')) && ($this->pacer_settings['condense_scripts']) && ($this->CACHE))
					$this->Code_Injection_Buid_Condensed($where);
				$marker=sprintf($this->codetop_marker,ucwords($where));
				if ($this->CodeTop_Place_Marker($where,$marker)){		
					return str_replace($marker,$this->Code_Injection_Buid($where),$this->html_source['html']);
				}
			} elseif($where=='body'){
				$marker='</body>';
				return str_ireplace($marker,$this->Code_Injection_Buid($where).$marker,$this->html_source['html']);
			}
			return $this->html_source['html'];
		}
		function Code_Injection_Replacements($where='head'){
			$arr=array('html_replace');
			foreach($arr as $k) {		
				if (!array_key_exists($k,$this->files)) continue;
				foreach($this->files[$k] as $kk => $vv) {
					if(isset($vv['done'])) continue;				
					if($vv['where']!=$where) continue;
					if(!$vv['condition']) continue;
					$condition = $vv['condition'];
					$vv = $vv['file'];
					$this->files[$k][$vv]['done'] = true;
					$this->html_source[$where]=preg_replace($condition,$vv,$this->html_source[$where],1);			
					$this->html_source['html']=$this->html_source['head'].$this->html_source['body'];
				}
			}						
		}
		function Code_Injection_Add($type = 'js_file',$file,$where = 'head',$condition = '',$file_must_exist=true,$position_first = false) {
			$file_url = str_replace(PE_PATH,PE_URL,$file);
			switch($type){
				case 'js_file':
					$fx = str_replace(PE_URL,PE_PATH,((dirname($file)=='.') ? PACER_URL.'/js/'.$file:$file_url));
					if ($file_must_exist){
						if (!file_exists($fx)) return;
					}
					break;            
				case 'css_file':
					$fx = str_replace(PE_URL,PE_PATH,((dirname($file)=='.') ? PACER_URL.'/css/'.$file:$file_url));
					if ($file_must_exist){
						if (!file_exists($fx)) return;
					}
					break;            
			}
			if ($position_first){
				$arr = $this->files[$type];
				$this->files[$type] = array();
			}
			$this->files[$type][$file]['file'] = $file;
			$this->files[$type][$file]['where'] = $where;
			$this->files[$type][$file]['condition'] = $condition;
			$this->files_order[]=$this->files[$type][$file];
			
			if ($position_first){
				$this->files[$type] = array_merge($this->files[$type],$arr);
			}
		}
		function Code_Injection_HasFile($type = 'js_file',$file,$where = 'head') {
			return ($this->files[$type][$file]['file']);
		}
		function Code_Injection_Replace($type = 'js_file',$file,$where = 'head',$replace = '') {
			$this->files_remove[$type][$file]['file'] = $file;
			$this->files_remove[$type][$file]['where'] = $where;
			$this->files_remove[$type][$file]['replace'] = $replace;
			unset($this->files[$type][$file]);
		}
		function Code_Injection_Remove($type = 'js_file',$file) {
			unset($this->files[$type][$file]);
			$this->files_remove[$type][$file]['file'] = $file;
		}
		function Code_Injection($html,$where = 'head') {
			$this->CodeTop_Load_Source($html);
			
			if($this->pacer_settings['code_injection_enabled']!=1) return $this->html_source['html'];
			
			$needed = false;
		
			if ($rows = $this->database->queryAll("SELECT name, value FROM ".TABLE_PREFIX."pacer_settings WHERE  `name` LIKE 'pacer_code_injection_%_file_".$where."_%' AND ( `frontend` = '".(((defined('FRONTEND')) && (!defined('BACKEND')))?1:2)."' OR `frontend` = '3' ) ORDER BY name")){
				
				$std_files = $this->files;
				$this->files = array();	
				foreach ($rows as $k => $details) {			
					$el = explode('_',$details['name']);
					$this->Code_Injection_Add($el[3].'_' .$el[4],$details['value'],$where);	
				}
				foreach($std_files as $k => $v) {
					foreach($v as $kk => $vv){
						$this->files[$k][$kk] = $vv;
					}
				}
			}
			
			foreach($this->files_remove as $k => $v) {
				foreach($v as $kk => $vv){
					foreach($this->files as $kf => $vf){
						foreach($vf as $kkf => $vvf){
							if ($kkf==$kk) {
								unset($this->files[$k][$kk]);
								break 2;
							}
						}
					}
					if (isset($vv['replace']))
						$this->html_source['html'] = preg_replace($vv['file'],$vv['replace'],$this->html_source['html']);
				}
			}
			
			foreach($this->files as $k => $v) {
				foreach($v as $kk => $vv){
					if ($this->Code_Injection_Is_Needed($kk,$k,$where)) {
						$needed = true;
					} else {
						unset($this->files[$k][$kk]);
					}
				}
			}
			if ($needed) {
				$this->html_source['html']=$this->CodeTop_Show_Here($where);
				
				if ($where!='body') {
					$this->html_source['html']=$this->CodeTop_Show_Here('body');
					//die($this->html_source['html']);
				}
			}
			return $this->html_source['html'];
		}
		function Code_Injection_Is_Needed($file,$type = 'js_file',$where = 'head') {
			$code = $this->Code_Injection_Buid_Code($type,$file,false);
			if (stripos($this->html_source[$where],$code)!==false)
				return false;	
			else
				return true;
		}
	}
	
class ParseMaster {
	public $ignoreCase = false;
	public $escapeChar = '';
	
	// constants
	const EXPRESSION = 0;
	const REPLACEMENT = 1;
	const LENGTH = 2;
	
	// used to determine nesting levels
	private $GROUPS = '/\\(/';//g
	private $SUB_REPLACE = '/\\$\\d/';
	private $INDEXED = '/^\\$\\d+$/';
	private $TRIM = '/([\'"])\\1\\.(.*)\\.\\1\\1$/';
	private $ESCAPE = '/\\\./';//g
	private $QUOTE = '/\'/';
	private $DELETED = '/\\x01[^\\x01]*\\x01/';//g
	
	public function add($expression, $replacement = '') {
		// count the number of sub-expressions
		//  - add one because each pattern is itself a sub-expression
		$length = 1 + preg_match_all($this->GROUPS, $this->_internalEscape((string)$expression), $out);
		
		// treat only strings $replacement
		if (is_string($replacement)) {
			// does the pattern deal with sub-expressions?
			if (preg_match($this->SUB_REPLACE, $replacement)) {
				// a simple lookup? (e.g. "$2")
				if (preg_match($this->INDEXED, $replacement)) {
					// store the index (used for fast retrieval of matched strings)
					$replacement = (int)(substr($replacement, 1)) - 1;
				} else { // a complicated lookup (e.g. "Hello $2 $1")
					// build a function to do the lookup
					$quote = preg_match($this->QUOTE, $this->_internalEscape($replacement))
					         ? '"' : "'";
					$replacement = array(
						'fn' => '_backReferences',
						'data' => array(
							'replacement' => $replacement,
							'length' => $length,
							'quote' => $quote
						)
					);
				}
			}
		}
		// pass the modified arguments
		if (!empty($expression)) $this->_add($expression, $replacement, $length);
		else $this->_add('/^$/', $replacement, $length);
	}
	
	public function exec($string) {
		// execute the global replacement
		$this->_escaped = array();
		
		// simulate the _patterns.toSTring of Dean
		$regexp = '/';
		foreach ($this->_patterns as $reg) {
			$regexp .= '(' . substr($reg[self::EXPRESSION], 1, -1) . ')|';
		}
		$regexp = substr($regexp, 0, -1) . '/';
		$regexp .= ($this->ignoreCase) ? 'i' : '';
		
		$string = $this->_escape($string, $this->escapeChar);
		$string = preg_replace_callback(
			$regexp,
			array(
				&$this,
				'_replacement'
			),
			$string
		);
		$string = $this->_unescape($string, $this->escapeChar);
		
		return preg_replace($this->DELETED, '', $string);
	}
		
	public function reset() {
		// clear the patterns collection so that this object may be re-used
		$this->_patterns = array();
	}

	// private
	private $_escaped = array();  // escaped characters
	private $_patterns = array(); // patterns stored by index
	
	// create and add a new pattern to the patterns collection
	private function _add() {
		$arguments = func_get_args();
		$this->_patterns[] = $arguments;
	}
	
	// this is the global replace function (it's quite complicated)
	private function _replacement($arguments) {
		if (empty($arguments)) return '';
		
		$i = 1; $j = 0;
		// loop through the patterns
		while (isset($this->_patterns[$j])) {
			$pattern = $this->_patterns[$j++];
			// do we have a result?
			if (isset($arguments[$i]) && ($arguments[$i] != '')) {
				$replacement = $pattern[self::REPLACEMENT];
				
				if (is_array($replacement) && isset($replacement['fn'])) {
					
					if (isset($replacement['data'])) $this->buffer = $replacement['data'];
					return call_user_func(array(&$this, $replacement['fn']), $arguments, $i);
					
				} elseif (is_int($replacement)) {
					return $arguments[$replacement + $i];
				
				}
				$delete = ($this->escapeChar == '' ||
				           strpos($arguments[$i], $this->escapeChar) === false)
				        ? '' : "\x01" . $arguments[$i] . "\x01";
				return $delete . $replacement;
			
			// skip over references to sub-expressions
			} else {
				$i += $pattern[self::LENGTH];
			}
		}
	}
	
	private function _backReferences($match, $offset) {
		$replacement = $this->buffer['replacement'];
		$quote = $this->buffer['quote'];
		$i = $this->buffer['length'];
		while ($i) {
			$replacement = str_replace('$'.$i--, $match[$offset + $i], $replacement);
		}
		return $replacement;
	}
	
	private function _replace_name($match, $offset){
		$length = strlen($match[$offset + 2]);
		$start = $length - max($length - strlen($match[$offset + 3]), 0);
		return substr($match[$offset + 1], $start, $length) . $match[$offset + 4];
	}
	
	private function _replace_encoded($match, $offset) {
		return $this->buffer[$match[$offset]];
	}
	
	
	// php : we cannot pass additional data to preg_replace_callback,
	// and we cannot use &$this in create_function, so let's go to lower level
	private $buffer;
	
	// encode escaped characters
	private function _escape($string, $escapeChar) {
		if ($escapeChar) {
			$this->buffer = $escapeChar;
			return preg_replace_callback(
				'/\\' . $escapeChar . '(.)' .'/',
				array(&$this, '_escapeBis'),
				$string
			);
			
		} else {
			return $string;
		}
	}
	private function _escapeBis($match) {
		$this->_escaped[] = $match[1];
		return $this->buffer;
	}
	
	// decode escaped characters
	private function _unescape($string, $escapeChar) {
		if ($escapeChar) {
			$regexp = '/'.'\\'.$escapeChar.'/';
			$this->buffer = array('escapeChar'=> $escapeChar, 'i' => 0);
			return preg_replace_callback
			(
				$regexp,
				array(&$this, '_unescapeBis'),
				$string
			);
			
		} else {
			return $string;
		}
	}
	private function _unescapeBis() {
		if (isset($this->_escaped[$this->buffer['i']])
			&& $this->_escaped[$this->buffer['i']] != '')
		{
			 $temp = $this->_escaped[$this->buffer['i']];
		} else {
			$temp = '';
		}
		$this->buffer['i']++;
		return $this->buffer['escapeChar'] . $temp;
	}
	
	private function _internalEscape($string) {
		return preg_replace($this->ESCAPE, '', $string);
	}
}
	
	
}
?>