<?php
if (!class_exists('Pacer_Compress_Page')) {
	class Pacer_Compress_Page extends Pacer_Logs {
		/******* GzPage *****************************************************************/
		private $compress_if_possible = true;
		private $compression_level = 9; 
		private $uncompressed = 0;
		private $compressed = 0;
		private $encoding = '0';
		private static $buffering_started = false;

		function __construct(){
			parent::__construct();
			// determine compression method
			if ((!headers_sent()) && (array_key_exists('HTTP_ACCEPT_ENCODING',$_SERVER))){
				if (strpos(strtolower($_SERVER['HTTP_ACCEPT_ENCODING']),'x-gzip') !== false) $this->encoding= "x-gzip";
				elseif (strpos(strtolower($_SERVER['HTTP_ACCEPT_ENCODING']),'gzip') !== false) $this->encoding = "gzip";
			}
		}
		function GzPage_Start() {
			if (!$this->buffering_started) {
				$this->buffering_started = true;
				ob_start(); 
				ob_implicit_flush(0);
			}
		}
		private function gzDocOut($html) {
			$this->uncompressed = strlen($html);
			if ($this->uncompressed>0) {
				if (($this->encoding) && (function_exists('gzencode')) && ($this->compress_if_possible)) {
				   header("Content-Encoding: ".$this->encoding);
				   return gzencode($html,$this->compression_level);
				} else return $html;
			} else return '';
		}
	    function GzPage_Finish($html='') {
			if ($this->buffering_started) {
				$this->buffering_started = false;
				if ($this->pacer_settings['compress_output']==1) {
					if (!$html) $html=ob_get_contents();
					$aString = $this->gzDocOut($this->hide_base_url($html));
					$this->compressed = strlen($aString);
					if (ob_get_level() && ob_get_length()) ob_end_clean();	
					print $aString;
				} else {
					if ($html) echo $this->hide_base_url($html);
					elseif(ob_get_level() ) {
						$html = ob_get_contents();
						ob_end_flush();
						echo $this->hide_base_url($html);
					}
				}
				flush();
			}
			if ($this->pacer_settings['compress_output_debug']==1) {
				$ratio = (($this->compressed!=0 && $this->uncompressed!=0) ? round(100 / ($this->uncompressed / $this->compressed),2):0);
				$this->LogEvent(sprintf("%s | %d / %d = %d%% | %s | %s",$_SERVER['PHP_SELF'],$this->uncompressed,$this->compressed,$ratio, $this->encoding,$this->compression_level));
			}
    	}
		private function Pacer_javascript_escape($input){
			$escaped = "";
			static $passChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789*@-_+./";
			$l = strlen($input);
			for ($i = 0; $i < $l; $i++){
				$char = $input{$i};
				if (strpos($passChars, $char) === false){ // $char is not in the list of $passChars. Encode in hex format
					$escaped .= sprintf("%%%02X", ord($char));
				} else {
					$escaped .= $char;
				}
			}
    		return $escaped;
		}
		function Pacer_encode_page($html,$key=''){
			$s=$this->Pacer_javascript_escape($html);
			if(!$key) {srand(time());$key=rand(1,9);}
			$parts=array();
			$parts = preg_split('/<head[^>]*>/i',$html);
			$ta = '';
			$head = $parts[0];
			$parts[0]='';
			$s= implode('',$parts);
			for($i=0;$i<strlen($s);$i++)$ta.=chr(ord(substr($s,$i,1))+(int)$key);
			$ta=$this->Pacer_javascript_escape($ta);
			return $head."
<head>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=".(defined('DEFAULT_CHARSET') ? DEFAULT_CHARSET : 'utf-8')."\" />
<!--// Encrypted using The Pacer Edition CMS Encryption technology //-->
<script type=\"text/javascript\">
<!--//
document.write(unescape('%3C%73%63%72%69%70%74%20%6C%61%6E%67%75%61%67%65%3D%22%6A%61%76%61%73%63%72%69%70%74%22%3E%66%75%6E%63%74%69%6F%6E%20%64%46%28%73%29%7B%76%61%72%20%73%31%3D%75%6E%65%73%63%61%70%65%28%73%2E%73%75%62%73%74%72%28%30%2C%73%2E%6C%65%6E%67%74%68%2D%31%29%29%3B%20%76%61%72%20%74%3D%27%27%3B%66%6F%72%28%69%3D%30%3B%69%3C%73%31%2E%6C%65%6E%67%74%68%3B%69%2B%2B%29%74%2B%3D%53%74%72%69%6E%67%2E%66%72%6F%6D%43%68%61%72%43%6F%64%65%28%73%31%2E%63%68%61%72%43%6F%64%65%41%74%28%69%29%2D%73%2E%73%75%62%73%74%72%28%73%2E%6C%65%6E%67%74%68%2D%31%2C%31%29%29%3B%64%6F%63%75%6D%65%6E%74%2E%77%72%69%74%65%28%75%6E%65%73%63%61%70%65%28%74%29%29%3B%7D%3C%2F%73%63%72%69%70%74%3E'));dF('".$ta.$key."');
//-->
</script>
<!--// Encrypted using The Pacer Edition CMS Encryption technology //-->";	
		}
	}
}
?>