<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: pacer_db.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

if (!class_exists('PacerDb')) {
	class PacerDb {
		var $mdb2 = null;
		var $error ='';
		private $last_statement = '';
		
		private static $_db_settings = null;
		
		/***************/
		/* CONSTRUCTOR */
		/***************/
		public function __construct($db_type='', $db_host='', $db_name='', $db_username='', $db_password='',$db_charset='',$db_debug=false) {
			
			$this->_db_settings = array('DB_TYPE'=>'','DB_HOST'=>'','DB_NAME'=>'', 'DB_USERNAME'=>'', 'DB_PASSWORD'=>'', 'DB_CHARSET'=>'', 'DB_DEBUG'=>'');
			$this->error='';
			
			if (!$db_type) { // Get it from external variables... (config.php)
				global $DB_TYPE,$DB_NAME,$DB_HOST,$DB_USERNAME,$DB_PASSWORD,$DB_CHARSET,$DB_DEBUG;
				foreach($this->_db_settings as $k => $v){
					$this->_db_settings[$k] = ((isset(${$k}))?${$k}:((defined($k))?constant($k):''));
				}
			} else { // Params passed to class
				if (is_array($db_type)) { // as associative array
					foreach($db_type as $k => $v){
						$k = strtoupper($k);
						$this->_db_settings[$k]	= $v;
					}
				} else { // as single fields
					foreach($this->_db_settings as $k => $v){
						$kk = strtolower($k);
						$this->_db_settings[$k]	= ${$k};
					}
				}
			}
			foreach($this->_db_settings as $k => $v){ // Unset external variables
				unset(${$k});
			}
			if (defined('PACER_DB_DEBUG')) $this->_db_setting['DB_DEBUG'] = true;
			
			// Connect to database
			$this->connect($this->_db_settings['DB_TYPE'], $this->_db_settings['DB_HOST'], $this->_db_settings['DB_NAME'], $this->_db_settings['DB_USERNAME'], $this->_db_settings['DB_PASSWORD']);
			// Check for database connection error
			if($this->is_error()) 
				die($this->get_error());
		}
		function get_db_setting($setting){
			return $this->_db_settings[$setting];	
		}
		// Connect to the database
		function connect($db_type, $db_host, $db_name, $db_username, $db_password) {
			$dsn=$db_type.'://' . $db_username.':'.$db_password.'@'.$db_host.'/'.$db_name;
			
			$this->mdb2 = new MDB2();
			$this->db_handle = $this->mdb2->factory($dsn);
			$pear = new PEAR();
			
    		// With PEAR::isError you can differentiate between an error or
    		// a valid connection.
    		if ($pear->isError($this->db_handle)) {
	        	$this->connected = false;
				$this->error = $this->db_handle->getMessage();
   			} else {
				// set the default fetchmode
				$this->db_handle->setFetchMode(MDB2_FETCHMODE_ASSOC);
				$this->connected = true;
			}
			return $this->connected;
		}
	
		// Disconnect from the database
		function disconnect() {
			if($this->connected==true) {
				$this->db_handle->disconnect();
				return true;
			} else {
				return false;
			}
		}
	
		// Run a query
		function query($statement) {
			$this->error='';
			$this->last_statement=$statement;
			$result = $this->db_handle->query($statement); //, true, true); //, $type);
        	if (!$this->mdb2->isResultCommon($result)) {
//			if (PEAR::isError($result)) {
    			$this->set_error($result->getMessage());
				return null;
			} else {
				return $result;
			}
		}

		// Run a query and return an associative array if result
		function queryRow($statement) {
			$this->error='';
			$this->last_statement=$statement;
			$this->do_debug($statement);
			$result = $this->db_handle->queryRow($statement); //, true, true); //, $type);
			if (!is_array($result)) {
//			if (PEAR::isError($result)) {
//    			$this->set_error($result->getMessage());
				return null;
			} else {
				return $result;
			}
		}
		
		// Run a query and return all rows in an associative array if result
		function queryAll($statement) {
			$this->error='';
			$this->last_statement=$statement;
			$this->do_debug($statement);
			$result = $this->db_handle->queryAll($statement); //, true, true); //, $type);
			if (!is_array($result)) {
//			if (PEAR::isError($result)) {
//    			$this->set_error($result->getMessage());
				return null;
			} else {
				return $result;
			}
		}
		
		function fetchRow($colnum = 'x') {
			$fetchmode = is_numeric($colnum) ? MDB2_FETCHMODE_ORDERED : MDB2_FETCHMODE_ASSOC;
        	return $this->fetchRow($fetchmode);
		}

		// Gets the first column of the first row
		function get_one($statement) {
		/**** MDB2 give some problem..
			unset($this->error);
			$result = &$this->db_handle->queryOne($statement);
        	if (!MDB2::isResultCommon($result)) {
//			if (PEAR::isError($result)) {
    			$this->set_error($result->getMessage());
				return null;
			} else {
				return $result;
			}
		*/
		//	$result = &$this->query($statement);
			$this->error='';
			$this->last_statement=$statement;
			$this->do_debug($statement);
			$result = $this->db_handle->query($statement); //, true, true); //, $type);
        	if ($this->mdb2->isResultCommon($result)) {
				while($row=$result->fetchRow()){
					foreach($row as $v) {
						return $v;
						break;
					}
				}
			} else {
	   			$this->set_error($result->getMessage());
				//die($statement);
			}
		}
		
		// Replace record ( INSERT if not exists, UPDATE if exists )
		function replace($table,$fields) {
			die("NOT YET IMPLEMENTED");
			$this->error='';
			$result = $this->db_handle->replace($table,$fields);
        	if (!$this->mdb2->isResultCommon($result)) {
//			if (PEAR::isError($result)) {
    			$this->set_error($result->getMessage());
				return null;
			} else {
				return $result;
			}
		}
		// Set the DB error
		function set_error($message = null) {
			$this->error = $message;
			/*
			if(strpos($message, 'no such table')) {
				$this->error_type = $TABLE_DOES_NOT_EXIST;
			} else {
				$this->error_type = $TABLE_UNKNOWN;
			}
			*/
		}
	
		// Return true if there was an error
		function is_error() {
			return (!empty($this->error)) ? true : false;
		}
	
		// Return the error
		function get_error() {
			return $this->error;
		}
		
		// Return last_id
		function last_Insert_Id($table = '', $key = 'id') {
			return $this->get_one("SELECT LAST_INSERT_ID()");
			//return $this->db_handle->lastInsertId($table, $key);
		}
/*
		// Get error
		function error() {
			if(isset($this->error)) {
				return $this->error;
			} else {
				return null;
			}
		}
*/
		private function do_debug($statement){	
			if ($this->_db_settings['DB_DEBUG']){
				global $Pacer;
				if($Pacer) {
					$Pacer->LogEvent($statement);
				}
			}
		}
		// Return last_statement
		function last_statement() {
			return $this->last_statement;
		}
	}
}
?>