<?php
// $Id$

/*

 The Pacer Edition Project <http://www.jcwebden.com/>
 Copyright (C) 2009, John P. and Stefano R.

 Pacer Edition is free and Commercial software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the License,
 or (at your option) any later version.

 Pacer Edition is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
if (!class_exists('Pacer_Flood_Control')) {
	class Pacer_Flood_Control{
/******* Init *******************************************************************/
		function Pacer_Flood_Control($options) {
			global $Pacer;
			// PEAR Flood Control
			require_once(PACER_PATH.'/pear/HTTP/FloodControl.php');
			try {
 			   $ip = HTTP_FloodControl::getUserIP();
			} catch (HTTP_FloodControl_Exception $e) {
    			$Pacer->Pacer_die($e);
			}
			try {
    			$fc =& new HTTP_FloodControl();
    			$result = $fc->setContainer('MDB2', array(
        			'dsn' => $Pacer->database->db_handle,
        			'table' => TABLE_PREFIX.'pacer_flood_logs',
        			'autooptimize' => true
    			));
				// Optional incremental lock
				if($Pacer->pacer_settings['flood_control_incremental'])
					$fc->setIncrementalLock(true);
    			// Optional probability of garbage collection
				if($Pacer->pacer_settings['flood_control_probability'])
					$fc->setProbability((int)$Pacer->pacer_settings['flood_control_probability']);

				$ip_parts = explode('.', $ip);
   				$subnet = $ip_parts[0] . $ip_parts[1];
				$checks= array('subnet'=>array(	'timeframe'=>$Pacer->pacer_settings['flood_control_subnet_timeframe'],
												'attempts'=>$Pacer->pacer_settings['flood_control_subnet_attempts'],
												'msg'=>$Pacer->Translate('Too many requests from the same subnet.'),
												'test'=>$subnet),
							   'ip'=>array(	'timeframe'=>$Pacer->pacer_settings['flood_control_ip_timeframe'],
												'attempts'=>$Pacer->pacer_settings['flood_control_ip_attempts'],
												'msg'=>$Pacer->Translate('Too many requests from the same ip.'),
												'test'=>$ip),
							   'session'=>array('timeframe'=>$Pacer->pacer_settings['flood_control_session_timeframe'],
												'attempts'=>$Pacer->pacer_settings['flood_control_session_attempts'],
												'msg'=>$Pacer->Translate('Too many requests from the same ip.'),
												'test'=>session_id())
							   );
				foreach($checks as $k => $v) {
					if($v['attempts']) {
						if (!$fc->check(array($v['timeframe']=>$v['attempts']), $v['test'])) {
        					//$Pacer->Pacer_
							die(str_replace('[MESSAGE_PLACEHOLDER]',$v['msg'],$Pacer->pacer_settings['flood_control_message']));
    					} 
					}
				}
			} catch (HTTP_FloodControl_Exception $e) {
    			$Pacer->Pacer_die($e);
			}
		}
	}
}
?>