<?php
if (!class_exists('Pacer_Images')) {
	class Pacer_Images extends Pacer_Super_User {
/******* Init *******************************************************************/
		function __construct() {
			parent::__construct();
		}
		function Pacer_Images_Resize($imgfile,$max_width=0,$max_height=0,$use_cache=true,$quality=100,$no_output=false,$force_jpg=false,$action='scale') {
			if (!$no_output){
				if (!file_exists($imgfile)) $imgfile = PACER_PATH.'/images/img_not_found.gif';
			} else {
				$use_cache = false;
				//$quality = 100;
			}
			$image = $imgfile;
			$filename = basename($imgfile);
			
			$size = getimagesize($image);
			$width = $size[0];
			$height = $size[1];
			$ext = $size['mime'];
			
			if (($max_width!=0) && ($max_height!=0)) {
				// get the ratio needed
				$x_ratio = $max_width / $width;
				$y_ratio = $max_height / $height;
			} else {
				$x_ratio = 1;
				$y_ratio = 1;
				$max_width = $width;
				$max_height = $height;
			}
			
			$src_xoffset=0;
			$src_yoffset=0;
			
			// $options_aspect=array($Pacer->Translate('Play original size')=>'',$Pacer->Translate('Strech to player size')=>'strech',$Pacer->Translate('Fit to player size')=>'fit',$Pacer->Translate('Crop to player size')=>'crop');

			
			switch($action){
				case 'crop': // crop as big as player
					$tn_width = $width;
					$tn_height = $height;
					if ($height>$max_height){
						$tn_height = $max_height;
						$src_yoffset = ($max_height - $height) / 2;
					}
					if ($width>$max_width){
						$tn_width = $max_width;
						$src_xoffset = ($max_width - $width) / 2;
					}
					break;
				case 'strech': // resize to player dimension
					$tn_width = $max_width;
					$tn_height = $max_height;
					break;
				case 'fit': // fit x|y to player dimension
					if (($x_ratio * $height) < $max_height) {
						$tn_height = ceil($x_ratio * $height);
						$tn_width = $max_width;
					} else {
						$tn_width = ceil($y_ratio * $width);
						$tn_height = $max_height;
					}
					break;
				case 'scale': // scale x|y to player dimension ONLY IF IMAGE IS BIGGER 	
				default:
					// if image already meets criteria, load current values in
					// if not, use ratios to load new size info
					if (($width <= $max_width) && ($height <= $max_height) ) {
						$tn_width = $width;
						$tn_height = $height;
					} else if (($x_ratio * $height) < $max_height) {
						$tn_height = ceil($x_ratio * $height);
						$tn_width = $max_width;
					} else {
						$tn_width = ceil($y_ratio * $width);
						$tn_height = $max_height;
					}
			}

			/* Caching additions by Trent Davies */
			// first check cache
			// cache must be world-readable
			if ($use_cache) {
				$cache_dir = PE_PATH.'/temp/cached_images';
				if (!is_dir($cache_dir)) @mkdir ($cache_dir);
				$use_cache = is_dir($cache_dir); 
				$cache_dir .= '/'; 
			}
			if ($use_cache) {
				$imageModified = @filemtime($image);
				$thumbModified = @filemtime($resized);

				$send_304 = false;
    			if (php_sapi_name() == 'apache') {
	       			// if our web server is apache
			        // we get check HTTP
        			// If-Modified-Since header
		    	    // and do not send image
		        	// if there is a cached version
		        	$ar = apache_request_headers();
			        if (isset($ar['If-Modified-Since']) && // If-Modified-Since should exists
           			($ar['If-Modified-Since'] != '') && // not empty
            		(strtotime($ar['If-Modified-Since']) >= $thumbModified)) // and grater than
            			$send_304 = true;                                     // image_time
    			}
			    if ($send_304) {
		       		// Sending 304 response to browser
        			// "Browser, your cached version of image is OK
        			// we're not sending anything new to you"
        			header('Last-Modified: '.gmdate('D, d M Y H:i:s', $thumbModified).' GMT', true, 304);
        			exit(); // bye-bye
    			}
				
				//$resized = $cache_dir.$tn_width.'x'.$tn_height.'-'.$filename;
				$resized = $cache_dir.$filename;
				
				header("Content-type: image/jpeg");
				// if thumbnail is newer than image then output cached thumbnail and exit
				if($imageModified<$thumbModified) {
					header("Last-Modified: ".gmdate("D, d M Y H:i:s",$thumbModified)." GMT");
					readfile($resized);
					exit;
				}
			}
			// read image
			switch ($ext) { 
				case 'image/jpg':     // jpg
				case 'image/jpeg':     // jpeg
					$src = imagecreatefromjpeg($image);
					break;
				case 'image/png':     // png
					$src = imagecreatefrompng($image);
					if($force_jpg) {
						$image = str_ireplace(".png",".jpg",$image);
						$resized = str_ireplace(".png",".jpg",$resized);
					}
					break;
				case 'image/gif':     // gif
					$src = imagecreatefromgif($image);
					if($force_jpg) {
						$image = str_ireplace(".gif",".jpg",$image);
						$resized = str_ireplace(".gif",".jpg",$resized);
					}
					break;
				default:
					if (!$no_output){				
						$this->Pacer_Images_Resize(PACER_PATH.'/images/img_not_found.gif',$max_width,$max_height,$use_cache,$quality);
					}
					return;
			}
			// set up canvas
			$dst = imagecreatetruecolor($tn_width,$tn_height);
			imageantialias ($dst, true);
			// copy resized image to new canvas
			imagecopyresampled($dst,$src,0,0,$src_xoffset,$src_yoffset,$tn_width,$tn_height,$width,$height);
			/* Sharpening adddition by Mike Harding */
			// sharpen the image (only available in PHP5.1)
			if (function_exists("imageconvolution")) {
				$matrix = array(array( -1, -1, -1 ),
							array( -1, 32, -1 ),
							array( -1, -1, -1 ) );
				$divisor = 24;
				$offset = 0;
				imageconvolution($dst, $matrix, $divisor, $offset);
			}
			if (!$no_output){
				// send the header and new image
				imagejpeg($dst, null, $quality);
				if ($use_cache) imagejpeg($dst, $resized, $quality); // write the thumbnail to cache as well...
			} else {
				imagejpeg($dst, $image, $quality); // write the file...
				//$this->LogEvent("Resized $imgfile [$action] from ${width}x${height} to ${tn_width}x${tn_height}");
			}
			// clear out the resources
			imagedestroy($src);
			imagedestroy($dst);
		}
		
		function image_constrain_dimensions($filename,$max_width,$max_height){
			if(file_exists($filename)){
				list($width,$height) = getimagesize($filename);
				// get the ratio needed
				$x_ratio = $max_width / $width;
				$y_ratio = $max_height / $height;	
				// if image already meets criteria, load current values in
				// if not, use ratios to load new size info
				if (($width <= $max_width) && ($height <= $max_height) ) {
					$tn_width = $width;
					$tn_height = $height;
				} else if (($x_ratio * $height) < $max_height) {
					$tn_height = ceil($x_ratio * $height);
					$tn_width = $max_width;
				} else {
					$tn_width = ceil($y_ratio * $width);
					$tn_height = $max_height;
				}
				return array($tn_width,$tn_height);
			} else return array($max_width,$max_height);
		}
		function create_dir_optimized($folder,$section_id='') {
	    	//Add folder for the files
			require_once(PE_PATH.'/framework/functions.php');
	
			if (!is_dir($folder)){
				make_dir($folder);
				$this->create_empty_index_php($folder,2);
			}
			if($section_id){
				$folder.='/.'.$section_id.'_optimized';
				if (!is_dir($folder)) {
					make_dir($folder);
					$this->create_empty_index_php($folder,3);
				}
			}
		}
		function create_file_optimized($section_id,$module_directory,$filename,$width,$height,$aspect){
			
			//Add folder for the files
			require_once(PE_PATH.'/framework/functions.php');
			$folder = PE_PATH.MEDIA_DIRECTORY.'/'.$module_directory;
			$target = $folder.'/.'.$section_id.'_optimized/'.$filename;
			if(file_exists($target)) unlink($target);
			$source = $folder.'/'.$filename;
			
			if(!file_exists($source)) return false;
			$quality = 80;
			$image_w=$width;
			$image_h=$height;
		
			// copy
			copy($source,$target);
			change_mode($target);
			// resize
			$this->Pacer_Images_Resize($target,$image_w,$image_h,false,$quality,true,false,$aspect);
			clearstatcache();
		}

		function rm_folder_optimized($module_directory,$section_id){
			// Include standard functions 
			require_once(PE_PATH . '/framework/functions.php');
			$folder = PE_PATH.MEDIA_DIRECTORY.'/'.$module_directory.'/.'.$section_id.'_optimized';
			if (is_dir($folder)) {
				rm_full_dir($folder);
				clearstatcache();
			}
		}
		function filelink_optimized($section_id,$filelink){
			$filelink=str_replace(PE_URL,PE_PATH,$filelink);
			if (file_exists($filelink)) {
				$filelink_o=dirname($filelink).'/.'.$section_id.'_optimized/'.basename($filelink);
				if (file_exists($filelink_o)) $filelink=$filelink_o;
			}
			return str_replace(PE_PATH,PE_URL,$filelink);
		}
	}
}
?>