<?php
/*

 The Pacer Edition Project <http://www.jcwebden.com/>
 Copyright (C) 2009, John P. and Stefano R.

 Pacer Edition is free and Commercial software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the License,
 or (at your option) any later version.

 Pacer Edition is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 Website Baker Project <http://www.websitebaker.org/>
 Copyright (C) 2004-2009, Ryan Djurovich

*/

if (!class_exists('Pacer_Logs')) {
	class Pacer_Logs extends Pacer_Styled_Menu {
/******* Init *******************************************************************/
		var $log_filename = '';
		function __construct() {
			parent::__construct();
			$this->log_filename=TEMP_PATH.'/pacer_log.txt';
		}
    /**
     * Log a message
     *
     * @param string  $msg  The message to log 
     *                      (may be empty for some debug line types)
     */
		function LogError($message) {
			if (!$this->pacer_settings['log_errors']) return;
			if (!file_exists($this->log_filename)){
				$this->LogError_Truncate(-1);
				require (PE_PATH.'/framework/functions.php');
				change_mode($this->log_filename);
			} else {
				$this->LogError_Truncate($this->pacer_settings['log_errors_max_len_kb']);
			}
			if ($fh = fopen($this->log_filename,"a+")) {
				fprintf($fh,"%s %s %d %s\n",date('Y-m-d H:i:s',time()),$this->get_ip(),$this->get_user_id(),$message);
				fclose($fh);
			}
		}
		function LogError_Flush() {
			clearstatcache();
			if ($fh = fopen($this->log_filename,"a+")) {
				fflush($fh);
				fclose($fh);
			}
		}
		function LogError_Truncate($size=-1) {
			$this->LogError_Flush();
			$size=(int)$size;
			if($size>0){
				$fsize=filesize($this->log_filename);
				$size = round($size * 1024 * 0.9,0);
				if ($fsize>$size){
					$file = preg_replace('/^.*\n/U','',substr(file_get_contents($this->log_filename),($size * -1)));
					if ($fh = fopen($this->log_filename,"w")) {
						fwrite($fh,$file);
						fclose($fh);
						return true;
					}
				}
			} elseif ($size=-1) {
				if ($fh = fopen($this->log_filename,"w")) {
					ftruncate($fh,$size);
					fclose($fh);
					return true;
				}
			} else { 
				//$size==0 = no truncate/unlimited
			}
			return false;
		}
		function LogError_Filename() {
			return $this->log_filename;
		}
    /**
     * Log an event message
     *
     * @param string  $msg  The message to log 
     *                      (may be empty for some debug line types)
     */
		function LogEvent($message){
			if (!$this->pacer_settings['log_events']) return;
			$this->database->query(sprintf("INSERT INTO %spacer_log (`logtime`, `message`, `ip`, `user`) VALUES ('%d','%s','%s','%d')",TABLE_PREFIX,time(),addslashes($message), $this->get_ip(),$this->get_user_id()) );
		}
		function LogUserAccess($user_id,$action='login',$from='',$page_id='',$note='') {
			// Update the users table with current ip and timestamp
			$get_ts = time();
			$get_ip = $this->get_ip();
			$get_session = session_id();
			$get_note = $note;
			$get_sdata = serialize($_SERVER);
			if ($from)
				$frontend = ($from=='backend')?'0':'1';
			elseif ((!defined('FRONTEND')) && (!defined('BACKEND')))
				$frontend = '1';
			elseif (defined('FRONTEND'))  
				$frontend = '1';
			else 
				$frontend = '0';
			switch(strtolower($action)) {
				case 'login':
					$query = "UPDATE ".TABLE_PREFIX."users SET login_when = '$get_ts', login_ip = '$get_ip', user_session = '$get_session', user_sdata = '$get_sdata' WHERE user_id = '$user_id'";
					$this->database->query($query);
				case 'autologout': // Logout is in cascade !!!
				case 'logout': // Logout is in cascade !!!
					// Purge entries older then 31 days...
					$query = "DELETE FROM ".TABLE_PREFIX."users_access WHERE `when` <= '".($get_ts - (3600*24*31))."'";
					$this->database->query($query);
					if ($this->pacer_settings['log_users_access']) {
						$query = "INSERT INTO ".TABLE_PREFIX."users_access (`user_id`, `action`, `when`, `ip`, `sdata`, `note`, `frontend`) VALUES ('$user_id', '$action', '$get_ts', '$get_ip', '$get_sdata', '$get_note', '$frontend')";
						$this->database->query($query);
					}
					break;
				case 'page':
					// Purge entries 
					$query = "DELETE FROM ".TABLE_PREFIX."users_access WHERE ( `action`='page' AND `when` <= '".($get_ts - (60*10)). "')";
					$this->database->query($query);	
					if ($this->pacer_settings['log_users_access']) {				
						$query = "INSERT INTO ".TABLE_PREFIX."users_access (`user_id`, `action`, `page_id`, `when`, `ip`, `sdata`, `note`, `frontend`) VALUES ('$user_id', '$action', '$page_id', '$get_ts', '$get_ip', '$get_sdata', '', '$frontend')";
						$this->database->query($query);
					}
					break;
				default:
					break;
			}
		}
	}
}
?>