<?php

// $Id$

/*

 The Pacer Edition Project <http://www.jcwebden.com/>
 Copyright (C) 2009, John P. and Stefano R.

 Pacer Edition is free and Commercial software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the License,
 or (at your option) any later version.

 Pacer Edition is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

if (!class_exists('Pacer_Mail')) {
	// PEAR Mail	
	require_once(PACER_PATH.'/pear/Mail.php');
	require_once(PACER_PATH.'/pear/Mail/mime.php');
	
	// Include new wbmailer class (subclass of PHPmailer)
	require_once(PE_PATH."/framework/class.wbmailer.php");

	class Pacer_Mail extends Pacer_Base{
		var $MAIL = null;
		var $From = null;
		var $FromName = null;
		private $MailParams = array();

		function __construct($options = ''){
			parent::__construct();

		
/*
string $backend - the name of the backend "mail" ,"smtp" , "sendmail"
array $params - a array of backend specific parameters.

List of parameter for the backends   
	  mail
            If safe mode is disabled, $params will be passed as the fifth argument to the PHP mail() function. 
			If $params is an array, its elements will be joined as a space-delimited string.
      sendmail
            $params["sendmail_path"] - The location of the sendmail program on the filesystem. Default is /usr/bin/sendmail .
            $params["sendmail_args"] - Additional parameters to pass to the sendmail. Default is -i .
      smtp
            $params["host"] - The server to connect. Default is localhost .
            $params["port"] - The port to connect. Default is 25 .
            $params["auth"] - Whether or not to use SMTP authentication. Default is FALSE.
            $params["username"] - The username to use for SMTP authentication.
            $params["password"] - The password to use for SMTP authentication.
            $params["localhost"] - The value to give when sending EHLO or HELO. Default is localhost
            $params["timeout"] - The SMTP connection timeout. Default is NULL (no timeout).
            $params["verp"] - Whether to use VERP or not. Default is FALSE.
            $params["debug"] - Whether to enable SMTP debug mode or not. Default is FALSE.
            $params["persist"] - Indicates whether or not the SMTP connection should persist over multiple calls to the send() method.
*/
		
/*
		// get mailer settings from database
			if ($setting['name'] == "wbmailer_routine") { $db_wbmailer_routine = $setting['value']; }
			if ($setting['name'] == "wbmailer_smtp_host") { $db_wbmailer_smtp_host = $setting['value']; }
			if ($setting['name'] == "wbmailer_smtp_auth") { $db_wbmailer_smtp_auth = (bool)$setting['value']; }
			if ($setting['name'] == "wbmailer_smtp_username") { $db_wbmailer_smtp_username = $setting['value']; }
			if ($setting['name'] == "wbmailer_smtp_password") { $db_wbmailer_smtp_password = $setting['value']; }
			if ($setting['name'] == "wbmailer_default_sendername") { $db_wbmailer_default_sendername = $setting['value']; }
			if ($setting['name'] == "server_email") { $db_server_email = $setting['value']; }
*/
		// set method to send out emails
		switch($this->pacer_settings['mail_routine']){
			case 'smtp':
				// use SMTP for all outgoing mails send by Website Baker
				$this->MailParams['host'] = $this->pacer_settings['mail_host'];
		    	$this->MailParams['port'] = $this->pacer_settings['mail_port'];
				// check if SMTP authentification is required
				if (($this->pacer_settings['mail_auth']==true) && ($this->pacer_settings['mail_password']) && ($this->pacer_settings['mail_username'])) {
					$this->MailParams['auth']		= $this->pacer_settings['mail_auth'];		// use SMTP authentification
					$this->MailParams['username'] = $this->pacer_settings['mail_username'];	// set SMTP username
					$this->MailParams['password'] = $this->pacer_settings['mail_password'];	// set SMTP password
				}

				if ($this->pacer_settings['mail_localhost'])	$this->MailParams["localhost"]= $this->pacer_settings['mail_localhost'];
				if ($this->pacer_settings['mail_timeout'])		$this->MailParams["timeout"]	= $this->pacer_settings['mail_timeout'];
				// Debug so that we see what's happenning for the moment.
				$this->MailParams["debug"]    	= $this->pacer_settings['mail_debug'];
       	 		$this->MailParams["verp"] 		= $this->pacer_settings['mail_timeout'];
        		$this->MailParams["persist"]	= $this->pacer_settings['mail_persist'];
				break;
			case 'sendmail':
	            $this->MailParams["sendmail_path"] = $this->pacer_settings['mail_sendmail_path'];
				$this->MailParams["sendmail_args"] = $this->pacer_settings['mail_sendmail_args'];
				break;
			case 'phpmailer':
			
				break;
			default: // mail
	
		}
		
		
		/*
		$m = new Mail;
		$this->MAIL = $m->factory(((array_key_exists('mail_routine',$this->pacer_settings)) ? $this->pacer_settings['mail_routine']:'mail'), $params);
		*/
		switch($this->pacer_settings['mail_routine']){
			case 'phpmailer':
				// create PHPMailer object and define default settings
				$this->MAIL = new wbmailer();
				break;
			default:
				$this->From	 	= $this->pacer_settings['mail_default_sender'];	// FROM: set default name
				$this->FromName = $this->pacer_settings['mail_default_sendername'];// FROM NAME: set default name
				// set default sender name
				if($this->FromName == 'Root User') {
					if(isset($_SESSION['DISPLAY_NAME'])) {
						$this->FromName = $_SESSION['DISPLAY_NAME']; // FROM NAME: display name of user logged in
					}
				}
				$this->MAIL =& Mail::factory(((array_key_exists('mail_routine',$this->pacer_settings)) ? $this->pacer_settings['mail_routine']:'mail'), $this->MailParams);
				if (PEAR::isError($this->MAIL)){
					if ($this->pacer_settings['mail_log_traffic']) {
						$msg='Mail Routine Error!';
						$this->LogEvent($msg);
					}
				}
		}	
	}
    /**
     * Send an email with file attachment
     *
     * @param string  $fromaddress
     * @param string  $toaddress
     * @param string  $subject
     * @param string  $message
     * @param string  $fromname
     * @param string  $file_attached
     *
     */     
		public function Send($fromaddress, $toaddress, $subject, $message, $fromname='',$file_attached='',$file_attached_inline='',$message_html='',$Cc='',$Bcc='') {
			
			if ($this->pacer_settings['mail_routine']=='phpmailer') 
				return $this->SendPHPMailer($fromaddress, $toaddress, $subject, $message, $fromname, $file_attached);
			
			$crlf = "\n";
			$mime = new Mail_mime($crlf);
			
			if (!$fromaddress) $fromaddress = $this->From;
			if (!$fromname) $fromname = $this->FromName;
			
			$hdrs_raw = array(
              'From'    => (($fromname) ? $fromname . ' <'.trim($fromaddress).'>':trim($fromaddress)),
              'Subject' => $subject
            );
			if ($Cc) $hdrs_raw['Cc'] = $Cc;
			if ($Bcc) $hdrs_raw['Bcc'] = $Bcc;
			
			if ($message) $mime->setTXTBody($message);
			if ($message_html) $mime->setHTMLBody($message_html);
			
			if($file_attached) {
				if(!is_array($file_attached)) 
					$file_attached = array($file_attached);
				foreach($file_attached as $file) {
					$mime->addAttachment ($file , 'application/octet-stream' , $file , true  , 'base64' );
				}
			}
			if($file_attached_inline) {
				if(!is_array($file_attached_inline)) 
					$file_attached_inline = array($file_attached_inline);
				foreach($file_attached_inline as $file) {
					$ext = explode('.',strtolower(basename($file)));
					$mime->addHTMLImage ($file , 'image/', $ext[count($ext)]);
				}
			}

			$body = $mime->get();
			$hdrs = $mime->headers($hdrs_raw);
			$to = $mime->encodeRecipients($toaddress);
						
			$send = $this->MAIL->send($to,$hdrs,$body);
			
			$result = (!(PEAR::isError($send)));
			
			if ($this->pacer_settings['mail_log_traffic']) {
				$msg = ((!$result)?'[SEND ERROR: '.$send.'], ':'')."To:$toaddress";
				foreach($hdrs_raw as $k => $v){
					$msg.=", $k:$v";
				}
				$msg.=", Text:$message";
				$this->LogEvent($msg);
			}
			return $result;
		}
	
		private function SendPHPMailer($fromaddress, $toaddress, $subject, $message, $fromname='', $file_attached='') {
		/* 
			INTEGRATED OPEN SOURCE PHPMAILER CLASS FOR SMTP SUPPORT AND MORE
			SOME SERVICE PROVIDERS DO NOT SUPPORT SENDING MAIL VIA PHP AS IT DOES NOT PROVIDE SMTP AUTHENTICATION
			NEW WBMAILER CLASS IS ABLE TO SEND OUT MESSAGES USING SMTP WHICH RESOLVE THESE ISSUE (C. Sommer)

			NOTE:
			To use SMTP for sending out mails, you have to specify the SMTP host of your domain
			via the Settings panel in the backend of Website Baker
		*/ 

			$fromaddress = preg_replace('/[\r\n]/', '', $fromaddress);
			$toaddress = preg_replace('/[\r\n]/', '', $toaddress);
			$subject = preg_replace('/[\r\n]/', '', $subject);
			$message_alt = $message;
			$message = preg_replace('/[\r\n]/', '<br \>', $message);
		
			// set user defined from address
			if ($fromaddress!='') {
				if($fromname!='') $this->MAIL->FromName = $fromname;         // FROM-NAME
				$this->MAIL->From = $fromaddress;                            // FROM:
				$this->MAIL->AddReplyTo($fromaddress);                       // REPLY TO:
			}
		
			// define recepient and information to send out
			$this->MAIL->AddAddress($toaddress);                            // TO:
			$this->MAIL->Subject = $subject;                                // SUBJECT
			$this->MAIL->Body = $message;                                   // CONTENT (HTML)
			$this->MAIL->AltBody = strip_tags($message_alt);				// CONTENT (TEXT)
		
			if($file_attached) {
				if(!is_array($file_attached)) 
					$file_attached = array($file_attached=>basename($file_attached));
				foreach($file_attached as $folder_file => $basename_file) {
					$this->MAIL->AddAttachment($folder_file, $basename_file);  // ATTACHMENT (FILE)
				}	
			}
		
			// check if there are any send mail errors, otherwise say successful
			$result = $this->MAIL->Send();
			if ($this->pacer_settings['mail_log_traffic']) {
				$msg = ((!$result)?'[SEND ERROR], ':'')."To:$toaddress";
				$msg.=", Subject:$subject";
				$msg.=", Text:$message";
				$this->LogEvent($msg);
			}
			return $result;
		}
	}
}
?>