<?php

// $Id$

/*

 The Pacer Edition Project <http://www.jcwebden.com/>
 Copyright (C) 2009, John P. and Stefano R.

 Pacer Edition is free and Commercial software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the License,
 or (at your option) any later version.

 Pacer Edition is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

require_once(PE_PATH.'/include/pclzip/pclzip.lib.php');
			
if (!class_exists('Pacer_Pack_N_Go')) {
	class Pacer_Pack_N_Go {
/******* Init *******************************************************************/	
		var $file_output_fs = null;
		private $file_output_db = null;
		var $file_output_db_zip = null;
		private $file_handle = null;
		private $settings = null;
		private $database;
		private $error = false;
		private $CRLF = null;
		private $db_name = null;
		
		function Pacer_Pack_N_Go($conf=array()) {
			global $Pacer;
			
			$site_name = $_SERVER['HTTP_HOST'];
			$this->database = $Pacer->database;
			$this->CRLF = $Pacer->CRLF;			
			$this->db_name = $Pacer->database->get_db_setting('DB_NAME');

 			if (is_array($conf))
     			$this->settings = array_merge($Pacer->pacer_settings,$conf);
			
			// Super Sets...
			if (array_key_exists('all',$this->settings)) { 
				$this->settings = array_merge($this->settings,array(''=>''));
			} elseif (array_key_exists('db',$this->settings)) {
				$this->settings = array_merge($this->settings,array(''=>''));
			} elseif (array_key_exists('site',$this->settings)) {
				$this->settings = array_merge($this->settings,array(''=>''));
			}
			
			if (!empty($this->settings['pack_n_go_exec_time_limit'])) {
				set_time_limit($this->settings['pack_n_go_exec_time_limit']);
			}
			if (!empty($this->settings['pack_n_go_memory_limit'])) {
				ini_set('memory_limit', $this->settings['pack_n_go_memory_limit']);
			}
						
			$this->file_output_db = TEMP_PATH.'/'.$this->db_name.'.sql';
			$this->file_output_db_zip = $this->file_output_db.'.zip';

			$this->file_output_fs = TEMP_PATH.'/'.$site_name.'.zip';
		}
		function Execute($action='') {
			if ((!preg_match('/^download/',$action)) || (filesize($this->file_output_fs)==0) || (filesize($this->file_output_db_zip)==0)){
				$this->do_cleanup(true);
				if (!$this->error) {
					$this->do_db($this->db_name);
				}
				if (!$this->error) {
					$this->do_fs(PE_PATH);
				}
			}
			if (!$this->error) {
				$this->do_actions(((preg_match('/^download/',$action))?$action:$this->settings['pack_n_go_method']));
			}
			$this->do_cleanup();
		}
		private function do_cleanup($force = false) {
			if (($this->settings['pack_n_go_remove_file_db']==true)||($force)) @unlink($this->file_output_db);
			if (($this->settings['pack_n_go_remove_file_db']==true)||($force)) @unlink($this->file_output_db_zip);
			if (($this->settings['pack_n_go_remove_file_fs']==true)||($force)) @unlink($this->file_output_fs);
		}
		private function do_db($db_name) {
			global $Pacer;
			$Pacer->LogEvent($Pacer->Translate("Pack n' Go - Database: ").$db_name);
			$this->open_output($this->file_output_db);
			if ($this->settings['pack_n_go_sql_drop_db']==true) $this->write_output($this->drop_db_statement($db_name));
			if ($this->settings['pack_n_go_sql_create_db']==true) $this->write_output($this->create_db_statement($db_name));
			if ($this->settings['pack_n_go_sql_use_db']==true) $this->write_output($this->use_db_statement($db_name));
//			$lt = $this->list_tables();
			foreach($this->list_tables() as $k => $table) {
				if (($this->settings['pack_n_go_sql_drop_table']==true)&&($this->settings['pack_n_go_sql_create_structure']==true)) $this->drop_table_structure($table);
				if ($this->settings['pack_n_go_sql_create_structure']==true) $this->dump_table_structure($table);
				if ($this->settings['pack_n_go_sql_create_data']==true) $this->dump_table_data($table);
			}
			$this->close_output();
			
			//create file db .zip
			$archive = new PclZip($this->file_output_db_zip);
 			if ($archive->add($this->file_output_db, PCLZIP_OPT_REMOVE_PATH, dirname($this->file_output_db)) == 0) {
    			$this->error=$archive->errorInfo(true);
			}
			@unlink($this->file_output_db);
		}
		private function do_fs($root) {
			global $Pacer;
			$Pacer->Cache_Clear();
			$Pacer->LogEvent($Pacer->Translate("Cache deleted"));
			$Pacer->Pacer_Super_User_Remove_Cached_Images();
			$Pacer->LogEvent($Pacer->Translate("Cached Images deleted"));
			$Pacer->LogEvent($Pacer->Translate("Pack n' Go - Filesystem: ").$root);
			//create file fs .zip
			$archive = new PclZip($this->file_output_fs);
 			if ($archive->add($root, PCLZIP_OPT_REMOVE_PATH, $root) == 0) {
    			$this->error=$archive->errorInfo(true);
			}
		}
		function do_actions($action){
			global $Pacer;
			//dispatch file
			switch($action){
				case 'server':
					break;
				case 'email':
				case 'server_email':
					if (!$Pacer->Send($this->settings['pack_n_go_mail_from'], $this->settings['pack_n_go_mail_to'], $this->settings['pack_n_go_mail_subject'], (($this->settings['pack_n_go_mail_body']) ? $this->settings['pack_n_go_mail_body'] : $this->Translate('Find all the files attached')).' - '.$this->file_output_fs.' ('.$Pacer->human_file_size(filesize($this->file_output_fs)) , __CLASS__, $this->file_output_fs)){
						$this->error = 'Email sending error';																																																																																				   					} else {																																																																																			   						$Pacer->LogEvent($Pacer->Translate("Pack n' Go - Email: ").$this->file_output_fs.' ('.$Pacer->human_file_size(filesize($this->file_output_fs)).')');
					}
					break;
				case 'download':
				case 'download_fs':
					$Pacer->LogEvent($Pacer->Translate("Pack n' Go - Download: ").$this->file_output_fs.' ('.$Pacer->human_file_size(filesize($this->file_output_fs)).')');
					$Pacer->download_one_file($this->file_output_fs);
					break;
				case 'download_db':
					$Pacer->LogEvent($Pacer->Translate("Pack n' Go - Download: ").$this->file_output_db_zip.' ('.$Pacer->human_file_size(filesize($this->file_output_db_zip)).')');
					$Pacer->download_one_file($this->file_output_db_zip);
					break;
			}
		}
		private function dump_table_structure($table) {
			$arr = $this->database->queryRow("SHOW CREATE TABLE ".$table);
			$arr = preg_replace('/\) ENGINE=.*/', ');',$arr['create table']);
			$this->write_output($arr);
		}
		private function drop_table_structure($table) {
			$this->write_output('DROP TABLE `'.$table."` IF EXISTS;");
		}
		private function dump_table_data($table) {
			$t = $this->database->query("SELECT * FROM ".$table);
			while ($t_row = $t->fetchRow()) {
				$ts = '';
	    		foreach($t_row as $k => $v) {
					if ($ts) $ts .= ', ';
					$ts .= "'".mysql_real_escape_string($v)."'";
				}
				$this->write_output("INSERT INTO ".$table. " ( ".$ts." );");
			}
		}
		private function list_tables() {
			$ts = array();
			$t = $this->database->query("SHOW TABLES");
			while ($t_row = $t->fetchRow()) {
				foreach($t_row as $k => $v) {
					$ts[] = $v;
					break;
				}
			}
			return $ts;
		}
		private function create_db_statement($db_name) {
			$arr=$this->database->queryRow("SHOW CREATE DATABASE ".$db_name);
			return $arr['create database'].";";
		}
		private function use_db_statement($db_name) {
			return "USE DATABASE `".$this->database->get_one("SHOW CREATE DATABASE ".$db_name)."`;";
		}
		private function drop_db_statement($db_name) {
			return "DROP DATABASE `$db_name`;";
		}
		private function write_output($line) {
			if (strlen($line) > 0) {
				$write_result = fwrite($this->file_handle, $line.$this->CRLF);
				if (!$write_result || ($write_result != strlen($line.$this->CRLF))) {
					return false;
        		}
    		}
		    return true;
		}
		private function open_output($filename) {
			$this->file_handle = fopen($filename, 'w');
		}
		private function close_output() {
    		if ($this->file_handle) {
				fclose($this->file_handle);
				unset($this->file_handle);
			}
		}
		function get_error(){
			return $this->error;
		}
	} // class
} // if class_exists
?>