<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: functions.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

if (!class_exists('Pacer_Scheduled_Jobs')) {

	class Pacer_Scheduled_Jobs{
		var $scripts_to_run = array();
		
		function Pacer_Scheduled_Jobs($job_id=0,$build_ajax=false){
			global $Pacer;
			if (($Pacer->pacer_settings['scheduled_jobs_run_on']=='3') // always
    			|| (($Pacer->pacer_settings['scheduled_jobs_run_on']=='1') && defined('FRONTEND'))
 				|| (($Pacer->pacer_settings['scheduled_jobs_run_on']=='2') && defined('BACKEND'))
				|| ($job_id) // or is a job_id specified
			) { 
				$time_and_window = time() + $Pacer->pacer_settings['scheduled_jobs_time_window'];
				$this->scripts_to_run = array();
			
				// and front/back end??
				$query = (($job_id)?sprintf("SELECT * FROM %spacer_jobs WHERE id='%d' LIMIT 1",TABLE_PREFIX,$job_id):sprintf("SELECT * FROM %spacer_jobs WHERE active = '%d' AND fire_time <= '%d'",TABLE_PREFIX,1,$time_and_window));
				foreach($Pacer->database->queryAll($query) as $k => $row) {
					$id=$row['id'];
			   		$scriptpath=$row['scriptpath'];
   					$name=$row['name'];
   					$time_interval=$row['time_interval'];
   					$fire_time=(($job_id)?time():$row['fire_time']);
   					$time_last_fired=$row['time_last_fired'];
   					$run_only_once=$row['run_only_once'];
					$fire_time_new = $fire_time + $time_interval;
  					$this->scripts_to_run[$id]="$scriptpath";
  		
					$queryX=($run_only_once)?sprintf("UPDATE %spacer_jobs SET active = '%d', time_last_fired = '%d' WHERE id = '%d'",TABLE_PREFIX,0,$fire_time,$id):sprintf("UPDATE %spacer_jobs SET fire_time = '%d', time_last_fired = '%d' WHERE id = '%d'",TABLE_PREFIX,$fire_time_new,$fire_time,$id);
					if (!$build_ajax) $Pacer->database->query($queryX);
				}
				if (!$build_ajax){
					// run the scheduled scripts
					foreach($this->scripts_to_run as $id=>$script_to_run) {
						$this->pacer_scheduled_jobs_fire_script($id,$script_to_run);
					}
				}
			}
		}

		function pacer_scheduled_jobs_fire_script($id,$script){
			global $Pacer;
			$md5_id=md5('PacerScheduledJob'.$id);
			if(!session_id()) session_start();	
			//check script is not already running
			if (!isset($_SESSION[$md5_id])) {
		      	$_SESSION[$md5_id]="currently-running";
      			$start_time = microtime(true);
				$fire_type = (function_exists('curl_exec') ) ? " PHP CURL " : " PHP fsockopen ";
      			//                 "://" satisfies both cases http:// and https://
				ob_start();
				if (strstr($script,"://") ) 
					$this->pacer_scheduled_jobs_fire_remote_script($script);
     			else {
					$fire_type=" PHP include ";
         			if (file_exists(PE_PATH.$script)) {
						include(PE_PATH.$script);
					} else {
						echo PE_PATH.$script." file not found!";
					}
       			}
      			$output=ob_get_contents();
				@ob_end_clean();
				
      			$execution_time=number_format((microtime(true) - $start_time), 5 )." seconds via".$fire_type;
				// truncate output to defined length
				$maxl=(int)$Pacer->pacer_settings['scheduled_jobs_max_error_log_length'];
     			if (!$maxl) $maxl=1200;
				$len = strlen($output);
				$output=substr($output, 0, $maxl);
				if ($len>$maxl)
					$output.="\n...";
				
  				// logs 
				$this->pacer_scheduled_jobs_save_log($id,$output,$execution_time);				
				$Pacer->LogEvent(sprintf($Pacer->Translate("Pacer Scheduled Jobs terminated: %s"),$script));
	
      			unset($_SESSION[$md5_id]);
 			}

		}

		function pacer_scheduled_jobs_fire_remote_script($url){
  			$url_parsed = parse_url($url);
  			$scheme = $url_parsed["scheme"];
  			$host = $url_parsed["host"];
  			$port = isset($url_parsed["port"]) ? $url_parsed["port"] : 80;
  			$path = isset($url_parsed["path"]) ? $url_parsed["path"] : "/";
  			$query = isset($url_parsed["query"]) ? $url_parsed["query"] : "";
  			$user = isset($url_parsed["user"]) ? $url_parsed["user"] : "";
  			$pass = isset($url_parsed["pass"]) ? $url_parsed["pass"] : "";
  			$useragent="ThePacerEditionScheduledJobs (http://thepaceredition.com/)";
  			$referer=$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
  			$buffer="";
  			if (function_exists('curl_exec')) {
   				$ch = curl_init($scheme."://".$host.$path);
   				curl_setopt($ch, CURLOPT_PORT, $port);
   				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
   				curl_setopt($ch, CURLOPT_HEADER, 0);
   				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);
   				curl_setopt($ch, CURLOPT_FAILONERROR,1); // true to fail silently
   				curl_setopt($ch, CURLOPT_AUTOREFERER,1);
   				curl_setopt($ch, CURLOPT_POSTFIELDS,$query);
   				curl_setopt($ch, CURLOPT_REFERER,$referer);
   				curl_setopt($ch, CURLOPT_USERAGENT,$useragent);
   				curl_setopt($ch, CURLOPT_USERPWD,$user.":".$pass);
   				$buffer = curl_exec($ch);
   				curl_close($ch);
  			} elseif ( $fp = @fsockopen($host, $port, $errno, $errstr, 30) ){
   				$header = "POST $path HTTP/1.0\r\nHost: $host\r\nReferer: $referer\r\n"
             			."Content-Type: application/x-www-form-urlencoded\r\n"
             			."User-Agent: $useragent\r\n"
          			    ."Content-Length: ". strlen($query)."\r\n";
   				if($user!= "") $header.= "Authorization: Basic ".base64_encode("$user:$pass")."\r\n";
   				$header.= "Connection: close\r\n\r\n";
   				fputs($fp, $header);
   				fputs($fp, $query);
   				if ($fp) while (!feof($fp)) $buffer.= fgets($fp, 8192);
   				@fclose($fp);
  			}
 			echo $buffer;
		}

		function pacer_scheduled_jobs_save_log($id,$output,$execution_time){
			global $Pacer;
			if ($Pacer->pacer_settings['scheduled_jobs_log']) {	
 				$now = time();
 				$output=htmlentities($output);
				$Pacer->database->query(sprintf("INSERT INTO %spacer_jobs_logs (`when`, `job_id`, `output`, `execution_time`) VALUES ('%d', '%d','%s','%s')",TABLE_PREFIX,$now,$id,addslashes($output),$execution_time));
			}
 			$Pacer->database->query(sprintf("UPDATE %spacer_jobs SET `last_log` = '%s' WHERE `id` = '%d'",TABLE_PREFIX,addslashes($output),$id));
		}
		
		function pacer_scheduled_jobs_build_ajax(){
			global $Pacer;
			$script = '';
			if (count($this->scripts_to_run)){
				$script = 'jQuery.post("'.PE_URL.'/index.php",{ scheduled_jobs_async : "'.(defined('FRONTEND')?'FRONTEND':'BACKEND').'" });';
			}
			return $script;
		}
	}
}
?>