<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: pacer_styled_menu.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */
if (!class_exists('SM2_Formatter')) {
	require_once(PE_PATH.'/modules/show_menu2/include.php');
}

if (!class_exists('Pacer_Styled_Menu')) {
	class Pacer_Styled_Menu extends Pacer_Images{
		private $zone_marker = '#\$Pacer->Pacer_Menu_a_la_Carte\s*\(\s*["|\'](.*?)\s*["|\']\)#i';
		
		var $zones = array();
		var $menu_template_path = null;
		var $menu_template_name = null;

		var $template_path = null;
		var $template_url = null;
		var $template_name = null;
		var $template_html = null;
		
		var $menu_id = null;
		var $menu_name = null;
		var $menu_directory = null;
		var $menu_path = null;
		var $menu_url = null;
		
		var $zone_name = null;

		function __construct() {
			parent::__construct();
		}
		
		function Pacer_Styled_Menu_Init($options='') {
			if (defined('TEMPLATE')){
				$this->template_name = TEMPLATE;
				$this->template_path = PE_PATH.'/templates/'.TEMPLATE.'/index.php';
				$this->template_url = PE_URL.'/templates/'.TEMPLATE.'/index.php';
			} elseif (defined('THEME')){
				$this->template_name = THEME;
				$this->template_path = PE_PATH.'/templates/'.THEME.'/index.php';
				$this->template_url = PE_URL.'/templates/'.THEME.'/index.php';
			}
			if(is_array($options)) {
				if(array_key_exists('menu_template_name',$options)) {
					$this->menu_template_name = $options['menu_template_name'];
					$this->menu_template_path = PE_PATH.'/templates/'.$this->menu_template_name.'/index.php';
				}
				if(array_key_exists('template_name',$options)) {
					$this->template_name = $options['template_name'];
					$this->template_path = PE_PATH.'/templates/'.$options['template_name'].'/index.php';
					$this->template_url = PE_URL.'/templates/'.$options['template_name'].'/index.php';
				}
				
				if(array_key_exists('zone_name',$options)) {
					$this->zone_name = $options['zone_name'];
				}

				$this->Pacer_Styled_Menu_Load_Template();
				if(array_key_exists('action',$options)) {
					if($options['action']=='render') $this->Pacer_Styled_Menu_Render_Zones();
				}
			}
		}

		function Pacer_Styled_Menu_Load_Template($filename='') {
			$this->zones = array();
			$this->template_html='';
			if($filename) $this->template_path = $filename;
			if(!file_exists($this->template_path)) {//die('Filename: '.$this->template_path.' not found!');
			} else {
				$this->template_html = file($this->template_path);
				$this->Pacer_Styled_Menu_Get_Zones();
			}
		}
		function Pacer_Styled_Menu_Get_Zones() {
			$this->zones = array();
			foreach($this->template_html as $line => $content){
				$temp_array=array();
				if(preg_match_all($this->zone_marker,$content,$temp_array)){
					foreach($temp_array[1] as $k => $v){
						$this->zones[$v] = array('line'=>$line,'html'=>$content);
					}
				}
			}
		}
		function Pacer_Styled_Menu_Render_Zones() {
			$this->Pacer_Styled_Menu_Get_Settings();
			if ($this->zone_name) $this->Pacer_Styled_Menu_Render_Zone($this->zone_name);
			else {
				foreach($this->zones as $zone => $v){
					$this->Pacer_Styled_Menu_Render_Zone($zone);
				}
			}
		}
		function Pacer_Styled_Menu_Render_Zone($zone) {
			if(!array_key_exists($zone,$this->zones)) return;
			return "<!-- zone $zone -->";
		}
		function Pacer_Styled_Menu_Css_Filename($id){
			return $this->Pacer_Styled_Menu_Base_Path($id).'/css/menu-id-'.$id.'.css';
		}
		function Pacer_Styled_Menu_Js_Filename($id){
			return $this->Pacer_Styled_Menu_Base_Path($id).'/js/menu-id-'.$id.'.css';
		}
		function Pacer_Styled_Menu_Base_Url($id){
			$filename = $this->database->get_one(sprintf("SELECT `template` FROM `%spacer_menu_zone` WHERE `id` = '%d' LIMIT 1",TABLE_PREFIX, $id ));
			
			return PE_URL.'/menus/'.$filename;
		}
		function Pacer_Styled_Menu_Template_Directory($id){
			if($filename = $this->database->get_one(sprintf("SELECT `menu` FROM `%spacer_menu_zone` WHERE `id` = '%d' LIMIT 1",TABLE_PREFIX, $id ))){
				if($filename = $this->database->get_one(sprintf("SELECT `menu_template` FROM `%spacer_menu` WHERE  `type` = '%s' AND `name` = '%s' LIMIT 1",TABLE_PREFIX,'menu', addslashes($filename)))) {
					if($filename = $this->database->get_one(sprintf("SELECT `directory` FROM `%saddons` WHERE `type` = '%s' AND `name` = '%s' LIMIT 1",TABLE_PREFIX,'pacer_menu', addslashes($filename)))){
						return $filename;
					}
				}
			}
			die('Missing template Directory!');
		}
		function Pacer_Styled_Menu_Template_Base_Url($id){
			return PE_URL.'/menus/'.$this->Pacer_Styled_Menu_Template_Directory($id);
		}
		function Pacer_Styled_Menu_Base_Path($id){
			$filename = $this->database->get_one(sprintf("SELECT `template` FROM `%spacer_menu_zone` WHERE `id` = '%d' LIMIT 1",TABLE_PREFIX, $id ));
			//return PE_PATH.'/menus/'.$filename;
			return PE_PATH.'/templates/'.$filename;
		}
		function Pacer_Styled_Menu_Render_Menu($zone,$html_example='',$menu='') {
			// find template->zone->menu_template link....
			
			if($menu) {
				if (!$row = $this->database->queryRow("SELECT * from ".TABLE_PREFIX."pacer_menu_zone WHERE template = '".$this->template_name."' AND zone = '".$zone."' AND menu = '".$menu."' AND type = 'menu'" )) return false;
			} else {
				if (!$row = $this->database->queryRow("SELECT * from ".TABLE_PREFIX."pacer_menu_zone WHERE template = '".$this->template_name."' AND zone = '".$zone."' AND type = 'menu' AND active = '1'" )) return false;
			}

			$this->menu_id = $row['id'];
			$this->menu_name = $row['menu'];
			
			$this->menu_directory = $this->Pacer_Styled_Menu_Template_Directory($this->menu_id);
			$this->menu_path = PE_PATH.'/menus/'.$this->menu_directory;
			$this->menu_url = PE_URL.'/menus/'.$this->menu_directory;
			
			unset($row);
			
			// find menu data....
			if (!$row = $this->database->queryRow("SELECT * from ".TABLE_PREFIX."pacer_menu WHERE type = 'menu' AND name = '".$this->menu_name."'")) return false;
			
			$menu_template = $row['menu_template'];
			$menu_color = $row['color'];
			// find menu_template data....
			$row_template = $this->database->queryRow("SELECT * from ".TABLE_PREFIX."pacer_menu_template WHERE name = '".$menu_template."' AND type = 'menu'");	
			
			// find color template data (if any)....
			$css_color = ($menu_color) ? $this->database->get_one("SELECT css from ".TABLE_PREFIX."pacer_menu_template WHERE name = '".$menu_color."' AND type = 'color'"):'';
//	$this->Pacer_die(print_r($row_template));
			// get data from template or menu definition ?
			foreach(array('html','css','js') as $v) {
				$row[$v]=($row[$v])?$row[$v]:$row_template[$v];
			}
			$html ="<!-- BEGIN html menu $zone -->\n<div id=\"menu-id-".$this->menu_id."\" class=\"menu-id-".$this->menu_id."\">\n";
			//$html ="<!-- BEGIN html menu $zone -->\n";
			foreach($row as $k => $v)
				$row[$k]=str_replace('[id]',$this->menu_id,$v);
			/*
			$aFlags = SM2_BUFFER+SM2_TRIM+SM2_NUMCLASS+SM2_NOCACHE;
			$aFlags = SM2_ALL;
			*/
			//print_r($row);
			
			//echo "<p>---------------------------------------</p>";
			$row['aoptions'] = $row['aoptions'] |= (SM2_BUFFER+SM2_NUMCLASS+SM2_NOCACHE);
			
			if ($row['languages_menu']) {
				if(!PAGE_LANGUAGES) return;
				$html_example = $this->build_menu_structure_languages($this->menu_id);
			}
			
			switch($row['use_icons']){
				case '1':
					$row['aoptions'] += SM2_USE_ICONS_TOP;
					break;
				case '2':
					$row['aoptions'] += SM2_USE_ICONS_LEFT;
					break;
				case '3':
					$row['aoptions'] += SM2_USE_ICONS_BOTTOM;
					break;
				case '4':
					$row['aoptions'] += SM2_USE_ICONS_RIGHT;
					break;
			}

			//$row['aoptions'] = $row['aoptions'] |= SM2_BUFFER;
			
			$html.= (($html_example)?$html_example:$this->Pacer_Styled_Menu_Render(array('aFlags'=>$row['aoptions'],'aMenu'=>$row['menu'],'aStart'=>$row['start'],'aMaxLevel'=>$row['maxlevel'],'aItemOpen'=>$row['itemopen'],'aItemClose'=>$row['itemclose'],'aMenuOpen'=>$row['menuopen'],'aMenuClose'=>$row['menuclose'],'aTopItemOpen'=>$row['topitemopen'],'aTopMenuOpen'=>$row['topmenuopen'])));

			$html.="\n</div>\n<!-- END html menu $zone -->\n";
			//$html.="<!-- END html menu $zone -->\n";
			
			$vars=array();
			$values=array();
			if (array_key_exists('show_menu2_data',$GLOBALS) && is_array($GLOBALS['show_menu2_data'])) {
				foreach($GLOBALS['show_menu2_data'] as $k => $v) {
					foreach($v as $kk => $vv) {
						foreach($vv as $kkk => $vvv) {
							$vars[$vvv['level']] = $vvv['level'];
						}
					}
				}
			}
			unset($GLOBALS['show_menu2_data']);
			foreach($vars as $k => $v){
				$values[] = ($v=='0')?'[lv]':'[lv+'.$v.']';
			}

			$vars[]=$this->menu_id;//$row['id'];
			$values[]='[id]';
			$vars[]=dirname($this->template_url);
			$values[]='[tp]';
			$vars[]=$this->Pacer_Styled_Menu_Template_Base_Url($this->menu_id);
			$values[]='[mp]';
			
			require($this->menu_path.'/info.php');
			
			if (isset($pacer_menu_dependencies['text']) && is_array($pacer_menu_dependencies['text'])) {
				foreach($pacer_menu_dependencies['text'] as $text) {
					$values[]='['.$text.']';
					$vars[]=$this->Translate($text);
				}
			}
			
			if (!$row['html']) $row['html'] = "[html]";
			$html = str_replace($values,$vars,str_replace('[html]',$html,$row['html']));
			
			$css = trim(str_replace($values,$vars,$row['css']));
			
			$css_c='';
			if($css_color){
				$css_c = trim(str_replace($values,$vars,$css_color));			
				if ($css_c) $css_c="\n/* BEGIN color css menu $zone */\n".$css_c."\n/* END color css menu $zone */\n";			
			}
			
			if (($css) || ($css_c)){
				$css = "/* BEGIN css menu $zone */\n".$css.$css_c."\n/* END css menu $zone */";
			}

			$js = trim(str_replace($values,$vars,$row['js']));
			if ($js) $js = "/* BEGIN js menu $zone */\n".$js."\n/* END js menu $zone */";

			return array('js_filename'=>$this->Pacer_Styled_Menu_Js_Filename($this->menu_id),'js'=>$js,'css'=>$css,'html'=>$html,'css_filename'=> $this->Pacer_Styled_Menu_Css_Filename($this->menu_id));
		}
		function Pacer_Menu_a_la_Carte($menu='') {
			$html = '';
			// Menu
			if(!$this->template_name) $this->Pacer_Styled_Menu_Init();
			if ($a = $this->Pacer_Styled_Menu_Render_Menu($menu)) {

				$this->resolve_menu_dependencies($this->menu_directory);

				if (($a['css_filename']) && (file_exists($a['css_filename'])))
					$this->Code_Injection_Add('css_file',$a['css_filename']);
				else {
					if ($a['css']) 
						$this->Code_Injection_Add('css_script',$a['css']);	
				}
				if (($a['js_filename']) && (file_exists($a['js_filename']))) 
					$this->Code_Injection_Add('js_file',$a['js_filename']);
				else { 
					if ($a['js']) 
						$this->Code_Injection_Add('js_script',$a['js']);
				}
				$html .= $a['html'];
			}
			// Widget
			if ($z = $this->Pacer_Styled_Menu_Render_Widget($menu)){
				if (($z['css_filename']) && (file_exists($z['css_filename']))) 
					$this->Code_Injection_Add('css_file',$z['css_filename']);
				else {
					if ($z['css']) 
						$this->Code_Injection_Add('css_script',$z['css']);	
				}
				if (($z['js_filename']) && (file_exists($z['js_filename']))) 
					$this->Code_Injection_Add('js_file',$z['js_filename']);
				else {
					if ($z['js']) 
						$this->Code_Injection_Add('js_script',$z['js']);
				}
				$html .= $z['html'];
			}
			echo (($html)?$html:$this->Pacer_Zone_Warning($menu));
		}
		function Pacer_Styled_Menu_Render_Widget($zone) {
			
			// find template->zone->menu_template link....
			if (!$row = $this->database->queryRow("SELECT * from ".TABLE_PREFIX."pacer_menu_zone WHERE template = '".$this->template_name."' AND zone = '".$zone."' AND type = 'widget' AND active = '1'")) return false;
			// find widget data....
			if (!$row_m = $this->database->queryRow("SELECT * from ".TABLE_PREFIX."pacer_menu WHERE type = 'widget' AND name = '".$row['menu']."'")) return false;
			$z=array('html'=>$row_m['html'],'css'=>$row_m['css'],'js'=>$row_m['js'],'js_filename'=>'','css_filename'=>'');
			if ($row_m['php']) {
				ob_start();
				eval($row_m['php']);
				$z['html'] = ob_get_contents();
				@ob_end_clean();
				if (!$z['html']) $z['html']=' '; // force ok
			}
			return $z;
		}
		function Pacer_Zone_Warning_Box($url,$msg,$narrative) {
			$template=((defined('TEMPLATE'))?$this->Translate('Page Template').': '.TEMPLATE:'');
			return sprintf('<a href="%s" style="font-weight:normal;"><div style="width:360px;min-height:48px;padding-left:50px;border:1px solid red;background: url(%s/images/alert.png) no-repeat;background-color:white;position:absolute;color:red;display:block;opacity:0.80;">%s<br />%s<br />%s</div></a>',$url,PACER_URL,$template,$msg,$narrative);
		}
		function Pacer_Zone_Warning($zone='',$name='') {
			if(($this->pacer_settings['zone_warning_enabled']) && ($this->get_user_id()===1)) {
				$this_msg='';
				switch(strtolower($zone)){
					case 'page_header':
					case 'page_footer':
					case 'website_disclaimer':
						$tr=debug_backtrace();
						$this_msg.='File: '.str_replace(PE_PATH,'',$tr[1]['file']).' - Line: '.$tr[1]['line'];
						$this_msg=$this->Pacer_Zone_Warning_Box(ADMIN_URL.'/settings/index.php',$this_msg,sprintf($this->Translate('You need to define %s information!'),strtoupper($zone)));
						break;
					case 'show_menu2':
						$t_z=$this->Translate('Menu');
						$t_h=PE_URL.'/templates/edit_template_files.php?file=/templates/'.TEMPLATE.'/index.php';
						$this_msg.='File: '.str_replace(PE_PATH,'',$this->template_path).' - Menu: '.$name;	
						$this_msg=$this->Pacer_Zone_Warning_Box($t_h,$this_msg,sprintf($this->Translate('You need to define %s (%s)!'),$t_z,$zone));
						
						break;
					default:
						if(is_numeric($zone)){
							$t_z=$this->Translate('Page Section');
							if($section=$this->database->queryRow(sprintf("SELECT * FROM %ssections WHERE section_id ='%d'",TABLE_PREFIX,$zone))){
								$t_h=ADMIN_URL.sprintf("/pages/modify.php?page_id=%d#%d",$section['page_id'],$section['section_id']);
							}else{
								if (defined('PAGE_ID')){
									$t_h=ADMIN_URL.sprintf("/pages/modify.php?page_id=%d",PAGE_ID);	
								}else{
									$t_h=ADMIN_URL."/pages/index.php";
								}
							}
							$tr=debug_backtrace();
							$this_msg.='File: '.str_replace(PE_PATH,'',$tr[1]['file']).' - Line: '.$tr[1]['line'];
						} else {
							$t_z=$this->Translate('Zone');
							$t_h=ADMIN_URL."/pacer/menu_a_la_carte/index.php";
							$this_msg.='File: '.str_replace(PE_PATH,'',$this->template_path).' - Line: '.$this->zones[$zone]['line'];	
						}
						$this_msg=$this->Pacer_Zone_Warning_Box($t_h,$this_msg,sprintf($this->Translate('You need to define %s (%s)!'),$t_z,$zone));
						break;	
				}
				return $this_msg;
			}
		}
		
		function Pacer_Zone($zone='') {
			if(!$this->template_name) $this->Pacer_Styled_Menu_Init();
			echo $this->Pacer_Styled_Menu_Render_Zone($zone);
		}
		function Pacer_Styled_Menu_Get_Settings() {
			if(!$this->template_name) die('Missing template name!');
		}
		// interface to sm_formatter
		function Pacer_Styled_Menu_Render($aOptions) {
			//print_r($aOptions);
			foreach(array('aFlags','aMenu','aStart','aMaxLevel','aItemOpen','aItemClose','aMenuOpen','aMenuClose','aTopItemOpen','aTopMenuOpen') as $k) {
				if ((array_key_exists($k,$aOptions)) && ($aOptions[$k]!='')) {
					${$k} = $aOptions[$k];
				} else {
					switch($k) { // Deafault if $aOptions not loaded
						case 'aStart':
							${$k} = SM2_ROOT; 			
							break;
						case 'aMaxLevel':
							${$k} = -1997; // 3 levels 	
							break;
						case 'aFlags':
							${$k} = SM2_TRIM+SM2_NUMCLASS;
							break;
						case 'aMenu':
							${$k} = 0; 			
							break;
						default:
							${$k} = false; 			
							break;					
					}
				}
			}
			//echo "<p>MENU=>".$aMenu . ' - ' .$aStart . ' - ' .$aMaxLevel . ' - ' .$aFlags . ' - ' .$aItemOpen . ' - ' .$aItemClose . ' - ' .$aMenuOpen . ' - ' .$aMenuClose . ' - ' .$aTopItemOpen . ' - ' .$aTopMenuOpen;
			return show_menu2($aMenu,$aStart,$aMaxLevel,$aFlags,$aItemOpen,$aItemClose,$aMenuOpen,$aMenuClose,$aTopItemOpen,$aTopMenuOpen);
		}
		function build_menu_structure_languages($menu_id){
			$img_path = $this->Pacer_Styled_Menu_Base_Url($menu_id).'/flags';
			$arr = $this->database->queryAll("SELECT language FROM ".TABLE_PREFIX."pages GROUP BY language ORDER BY level ASC, position ASC");
			$html ='<ul class="menu-top menu-0">';
			$one = 1;
			foreach($arr as $lang) {
				$lang_name = $this->database->get_one("SELECT name FROM ".TABLE_PREFIX."addons WHERE type = 'language' AND directory = '".$lang['language']."'");

				if ($one==1) $firstlast = ' menu-first';
				elseif (count($arr)==$one) $firstlast = ' menu-last';
				else $firstlast='';
				$one++;
				
				$html .='<li class="menu-0 menu-sibling'.$firstlast.(($lang['language']==LANGUAGE) ? ' menu-current' :'').'"><a href="'.PE_URL.'/?lang='.strtolower($lang['language']).'" title="'.$lang_name.'" target="_top"><img class="flag" src="'.$img_path.'/'.strtolower($lang['language']).'.png"/></a></li>';
			}
			$html .='</ul>';
			return $html;

		}
		
		function resolve_menu_dependencies($menu_directory) {
			// obtain menu directory
			require(PE_PATH.'/menus/'.$menu_directory.'/info.php');
			//die(PE_PATH.'/menus/'.$menu_directory.'/info.php');
			if (!isset($pacer_menu_dependencies) || !is_array($pacer_menu_dependencies)) return;
			foreach($pacer_menu_dependencies['frontend'] as $karr => $varr) {
				if (is_array($varr)) {
					foreach($varr as $k => $v) {
						switch ($k){
							case 'js_file':
							case 'css_file':
							case 'js_script':
							case 'css_script':
								$this->Code_Injection_Add($k,$v);
								break;
						}
					}
				}
			}
		}
	}
};
?>