<?php
/*

 The Pacer Edition Project <http://www.jcwebden.com/>
 Copyright (C) 2009, John P. and Stefano R.

 Pacer Edition is free and Commercial software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the License,
 or (at your option) any later version.

 Pacer Edition is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 Website Baker Project <http://www.websitebaker.org/>
 Copyright (C) 2004-2009, Ryan Djurovich

*/

if (!class_exists('Pacer_Super_User')) {
	class Pacer_Super_User extends Pacer_Code_Injection {
/******* Init *******************************************************************/
		function __construct() {
			parent::__construct();
		}
		function Pacer_Super_User_Show($user_id = '',$what = 'image',$max_width=0,$max_height=0,$use_cache=true,$quality=100) {
			$user_dir = $this->Pacer_Super_User_ImageFolder($user_id);
    		$filename = $user_dir . '/'.$user_id.'_user_'.$what.'.jpg';
			if (file_exists($filename)) {
				$this->Pacer_Images_Resize($filename,$max_width,$max_height,$use_cache,$quality);
			}
			return false;
		}
		function Pacer_Super_User_SaveImage($user_id = '',$what = 'image',$file_name = '') {
			$user_dir = $this->Pacer_Super_User_ImageFolder($user_id);
			$filename = $user_dir . '/'.$user_id.'_user_'.$what.'.jpg';
			$source = PE_PATH.'/temp/cached_images/'.$user_id.'_user_'.$what.'.jpg';
			if ($file_name) @copy($source,$filename); else @unlink($filename);
			@unlink($source);
			return false;
		}
		function Pacer_Super_User_ImageFolder($user_id = '') {
    		if ($user_id=='') $user_id = $this->get_user_id();
			$user_dir = PE_PATH.'/private/users'; 
			require_once(PE_PATH.'/framework/functions.php');
			
			if (!is_dir($user_dir)) make_dir($user_dir);
			$user_dir .= '/'.$user_id; 
			if (!is_dir($user_dir)) make_dir ($user_dir);
			
			if (!is_dir($user_dir)) die("Cannot create folder: $user_dir");
			
			return $user_dir;
		}
		
		function Pacer_Super_User_ImageUrl($user_id = '') {
    		if ($user_id=='') $user_id = $this->get_user_id();
			return PE_URL.'/private/users/'.$user_id; 
		}
		
		function Pacer_Super_User_Remove_ImageFolder($user_id = '') {
    		if ($user_id=='') $user_id = $this->get_user_id();
			$user_dir = PE_PATH.'/private/users/'.$user_id;
			if (is_dir($user_dir)) {
				if($handle = @opendir($user_dir)) {
    		        while (false !== ($file = readdir($handle))) {
   						if ($file != "." && $file != "..") @unlink($user_dir.'/'.$file);
        			}
    				closedir($handle);
					rmdir($user_dir);
				}
        	}
			// and chached images too
			$user_dir = PE_PATH.'/temp/cached_images';
			if($handle = @opendir($user_dir)) {
    			while (false !== ($file = readdir($handle))) {
   					if ($file != "." && $file != "..") {
						if (preg_match('/^'.$user_id.'_user_/i' ,$file)) @unlink($user_dir.'/'.$file);
        			}
				}
    			closedir($handle);
			}		
		}
		function Pacer_Super_User_Remove_Cached_Images(){
			$user_dir = PE_PATH.'/temp/cached_images';
			if($handle = @opendir($user_dir)) {
    			while (false !== ($file = readdir($handle))) {			
					if ($file != "." && $file != ".." && $file != "index.php" && $file != ".htaccess") {
						@unlink($user_dir.'/'.$file);
        			}
				}
    			closedir($handle);
			}		
		}
		function Pacer_Super_User_Trace($page_id){
			$user_id=$this->get_user_id();
			if($user_id) {
				if ($page_id) {
					$get_page_id = (int) $page_id;
				} elseif (defined('PAGE_ID')) {
					 $get_page_id = (int) PAGE_ID;
			 	} elseif (isset($_POST['page_id'])) {
					 $get_page_id = (int) $_POST['page_id'];
			 	} elseif (isset($_GET['page_id'])) {
					 $get_page_id = (int) $_GET['page_id'];
				} else $get_page_id = '';
				
				$this->LogUserAccess($user_id,'page','frontend',$get_page_id);
			}
		}		
		function Pacer_Super_User_Online($where='frontend',$timeframe_minutes=10,$format="complete"){
			$html = '';
			$who = $this->Pacer_Super_User_Who_Is_Online($where,$timeframe_minutes);
			if ($who != array()) {
				foreach($who as $k => $v){
					$html .= (($html)?', ':'').'<span class="who_is_online" title="'.'On page \''.$v['page_title'].'\'  since: '.date(DATE_FORMAT. ' '.TIME_FORMAT,(int)$v['when']).'">'.(($v['display_name'])?$v['display_name']:$v['username']).'</span>';
				}
			}
			return $html;
		}
		function Pacer_Super_User_Who_Is_Online($where='frontend',$timeframe_minutes=10){
			$who = array();
			switch($where){
				case 'backend':
					$frontend = " AND  frontend='0'";
					break;
				case 'frontend':
					$frontend = " AND frontend='1'";
					break;
				default:
					$frontend = "";
			}
			foreach($this->database->queryAll("SELECT `user_id`, max(`when`) as `when` FROM ".TABLE_PREFIX."users_access WHERE (`action`='page' AND `when` >= '".(time() - (60*$timeframe_minutes)). "'".$frontend.") GROUP BY `user_id` ORDER BY `when` DESC") as $k => $users){
				// a logout?
				if($action=$this->database->get_one("SELECT action FROM ".TABLE_PREFIX."users_access WHERE user_id = '".$users['user_id']."' ORDER BY `when` DESC LIMIT 1")){
					if ($action!='page') continue;
				}
				$actions=$this->database->queryAll("SELECT * FROM ".TABLE_PREFIX."users_access WHERE (`action`='page' AND `when` >= '".(time() - (60*$timeframe_minutes)).  "' AND user_id = '".$users['user_id']."') ORDER BY `when` DESC LIMIT 10");
				if (count($actions)) {
					$other = array('trail'=>'');
					$action = $actions[0];
					
					if ($page = $this->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '".$action['page_id']."'")) {
						$user = $this->database->queryRow("SELECT * FROM ".TABLE_PREFIX."users WHERE user_id = '".$users['user_id']."'"); 
						foreach($actions as $action){
							$other['trail'][]=$this->database->queryRow("SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id = '".$action['page_id']."'");
						}
						$who[$action['when']] = array_merge($user,$page,$action,$other);
					}
				}
			}
			ksort($who,SORT_NUMERIC);
			return $who;
		}
		function Pacer_Super_User_Get_Info($uid,$anonymous_img_path=''){
			$arr=array('user_firstname'=>'','user_lastname'=>'','user_address'=>'','user_zip'=>'','user_city'=>'','user_dob'=>'','user_country'=>'','user_telephone'=>'','user_signature'=>'','user_gender'=>'','user_skype'=>'','user_fax'=>'');
			if ($user = $this->database->queryRow("SELECT * FROM ".TABLE_PREFIX."users WHERE user_id = '$uid'")) {
				foreach($arr as $k => $v){
					$arr[$k] = $user[$k];
					if (($k=='user_dob') && ($user[$k])) $arr[$k] = date(DATE_FORMAT,(int)$user[$k]);
				}	
			}
			foreach(array('avatar','image','image_small') as $what) {
				$f=$this->Pacer_Super_User_ImageFolder($uid).'/'.$uid.'_user_'.$what.'.jpg';
				if (!file_exists($f)){
					if ($anonymous_img_path) {
						$f=$anonymous_img_path; 
						if (!file_exists($f))
							$f='';
					} else $f='';
				}
				$arr['user_'.$what]=str_replace(PE_PATH,PE_URL,$f);
			}
			return $arr;
		}
		function Pacer_Super_User_Get_Info_Arrays($uid,$anonymous_img_path=''){
			$arr=$this->Pacer_Super_User_Get_Info($uid,$anonymous_img_path);
			$x=array('vars'=>array(),'values'=>array());
			foreach($arr as $k => $v){
				$x['vars'][]='['.strtoupper($k).']';
				$x['values'][]=$v;
			}
			return $x;
		}
	}
}
?>