<?php
// $Id$

/*

 The Pacer Edition Project <http://www.jcwebden.com/>
 Copyright (C) 2009, John P. and Stefano R.

 Pacer Edition is free and Commercial software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the License,
 or (at your option) any later version.

 Pacer Edition is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
if (!class_exists('Pacer_Template')) {
	class Pacer_Template{
/******* Init *******************************************************************/
		private $settings = array();
		var $TPL = null;
		
		function __construct($opts = '') {
//			echo "<p>".__FILE__."</p>";
//			parent::Pacer_Pack_N_Go();
     		if(is_array($opts)) {
				$this->settings = $opts;
			} else {
				if ($opts) $this->settings['root'] = $opts;
			}
			if(!array_key_exists('root',$this->settings)) $this->settings['root'] = ADMIN_PATH.'/interface';
			if(!array_key_exists('engine',$this->settings)) $this->settings['engine'] = 'pe';
			
			$this->settings['engine'] = strtolower($this->settings['engine']);

			switch ($this->settings['engine']) {
				case 'itx':
					require_once(PACER_PATH.'/pear/HTML/Template/ITX.php');
					$this->TPL = new HTML_Template_ITX($this->settings['root']);
					break;
				case 'smarty':
					require_once(PACER_PATH.'/smarty/Smarty.class.php');
					$this->TPL = new Smarty;
					break;
				default:
					require_once(PE_PATH.'/include/phplib/template.inc');
					$this->TPL = new Template($this->settings['root']);
			}
			return $this->TPL;
		}

		function set_root($root) {
			switch ($this->settings['engine']) {
				case 'itx':
					$this->TPL->setRoot($root);
					break;
				case 'smarty':
					break;
				default:
					$this->TPL->set_root($root);
			}
		}
		
		function set_file($varname='',$filenane='',$removeUnknownVariables = true,$removeEmptyBlocks = true) {
			switch ($this->settings['engine']) {
				case 'itx':
					$this->TPL->loadTemplatefile($filenane,$removeUnknownVariables,$removeEmptyBlocks);
					break;
				case 'smarty':
					break;
				default:
					$this->TPL->set_file($varname,$filenane);
			}
		}
		
		function set_block($parent='',$varname='',$name='') {
			switch ($this->settings['engine']) {
				case 'itx':
					$this->TPL->setCurrentBlock($name);
					break;
				case 'smarty':
					break;
				default:
					$this->TPL->set_block($parent, $varname, $name);
			}
		}

		function set_var($varname='',$value='',$append = false) {
			switch ($this->settings['engine']) {
				case 'itx':
					$this->TPL->setVariable($varname,$value);
					break;
				case 'smarty':
					break;
				default:
					$this->TPL->set_var($varname,$value,$append);
			}
		}

		function parse($target, $varname, $append = false, $flag_recursion = false) {
			switch ($this->settings['engine']) {
				case 'itx':
					$this->TPL->parse($target, $flag_recursion);
					break;
				case 'smarty':
					break;
				default:
					$this->TPL->parse($target, $varname, $append);
			}
		}
		
		function pparse($target, $varname, $append = false, $clear = true) {
			switch ($this->settings['engine']) {
				case 'itx':
					$this->TPL->show($target);
					break;
				case 'smarty':
					break;
				default:
					$this->TPL->pparse($target, $varname, $append, $clear);
			}
		}
		
	} //class
} //defined
?>