<?php

require_once(PACER_PATH.'/pacer.php');
require_once(PE_PATH.'/framework/functions.php');


if (!class_exists('Pacer_Version_Check')) {
	class Pacer_Version_Check extends Pacer {
		private $xml = '';
		var $dl_msg = '';
		var $age = 0;
		private $temp_file = '';
		private $temp_unzip = '';
		private $debug = false;
		
		
		function __construct($update=true,$force_download=false){
			parent::__construct();
			$max_age = (int)$this->pacer_settings['updater_age'];
			if($max_age<1) $max_age = 86400;
			
			$this->age = (int)$this->database->get_one("SELECT release_date FROM ".TABLE_PREFIX."pacer_channels WHERE type = 'age'");

			if($update) {
				if ((time() > ($this->age+$max_age)) or ($force_download)) {
					$this->update_list();
					$this->database->query("UPDATE ".TABLE_PREFIX."pacer_channels SET body = '".$this->dl_msg."' WHERE type = 'age'");		
				}	
			} else {
				$this->dl_msg = $this->database->get_one("SELECT body FROM ".TABLE_PREFIX."pacer_channels WHERE type = 'age'");
				if ( (!$this->dl_msg) AND (time() > ($this->age+$max_age))) {
					$this->dl_msg = 'Connection to server is needed.';
				}
			}
		}
		
		private function create_list($fake=true){
			$tb = array();
	
			$installed_version = $this->database->get_one("SELECT value FROM ".TABLE_PREFIX."settings WHERE name = 'pe_version'");
			$tb['core,'.strtolower('core')] = array('type'=>'core','name'=>'WB','version'=>$installed_version);
			$installed_version = $this->Pacer_get_version();
			$tb['core,'.strtolower('pacer')] = array('type'=>'core','name'=>'Pacer','version'=>$installed_version);
	
			$rows = $this->database->queryAll("SELECT `version`, `name`, `type` , `pe_guid` FROM `".TABLE_PREFIX."addons` WHERE (`type` = 'module' )");
			foreach($rows as $row) {
				$tb['module,'.strtolower($row['name'])] = array('type'=>$row['type'],'name'=>$row['name'],'version'=>$row['version'],'guid'=>$row['pe_guid']);
			}
			if ($fake) return $tb;
			
			$ta = array('content'=>array('age'=>array('type'=>'age','release_date'=>'-'),'credentials'=>array('language'=>(LANGUAGE) ? strtoupper(LANGUAGE) : 'EN'),'module'=>array()));
			
			foreach($tb as $k => $v) {
				switch ($v['type']){
					case 'core':
					case 'module':
						$ta['content']['module'][] = array_merge($v,array('installed'=>'1','installed_version'=>$v['version'],'version'=>'-'));
						break;
				}
			}
			return $ta;
		}
		private function update_list() {
			$this->download_list();
			if(!$this->dl_msg) $this->parse_list();
			
			if(!$this->dl_msg) {
				if (!is_array($this->xml) or (!array_key_exists('content',$this->xml))) {
					$this->dl_msg = "The Pacer Edition Software Update System Is Not Available.<br />Comunication error(002): Available updates not found.";
					$this->xml = $this->create_list(false);   
				}
			}			
			$this->update_list_db();
		}
		private function download_list() {
			$this->xml = '';	
			$this->dl_msg = '';
			$postdata = base64_encode(serialize($this->create_list()));
			//$postkeys = base64_encode(serialize(array(base64_encode('1234'),base64_encode('5678'),base64_encode('91011'))));
			$postkeys = base64_encode(serialize(array('updater'=>basename(__FILE__),'GUID'=>$this->pacer_settings['guid'])));
			$locations = explode(',',$this->pacer_settings['updater_url']);
			if (count($locations)){
				foreach($locations as $location){
					$this->xml = $this->request_one_file($location.'/pacer_version_checker.php','',array('postData'=>array('data'=>$postdata,'keys'=>$postkeys)));
					if (is_object($this->xml)) {
						$this->dl_msg = "Server $location error: ".$this->xml->getMessage();
						$this->xml = '';
					} elseif(!$this->xml) $this->dl_msg='Server $location error(003): No channels.';
					else break; // done!
				}
			}
		}
		private function parse_list() {
			require_once(PACER_PATH.'/pacer_xml2assoc.php');
			$reader = new Pacer_Xml2Assoc;
			if ($this->xml) $this->xml = $reader->parseString($this->xml , true);
		}
		private function update_list_db() {		
			if (!$this->xml) return;
			if (!array_key_exists('content',$this->xml)) {
				$this->dl_msg = "Comunication error(004): Version Checker not found.";
				return;
			}
			if (!is_array($this->xml['content']))  {
				$this->dl_msg = "Comunication error(005): Version Checker Data incorrect.";
				return;
			}
			if (count($this->xml['content'])==0) return;
			// delete all channels //
			$this->database->query("TRUNCATE TABLE `".TABLE_PREFIX."pacer_channels`");
			foreach($this->xml['content'] as $type => $elements) {
				switch ($type) {
				case 'age':
					$this->database->query("INSERT INTO `".TABLE_PREFIX."pacer_channels` ( `type`,`release_date`,`url` ) VALUES ( '$type','".$elements['release_date']."','".$elements['link']."' );");
					if($this->database->is_error()) $this->Pacer_die($this->database->get_error());		
					break;
				case 'credentials':
/*
					echo "<p>";
					foreach($elements as $k => $v) {
						echo "$k: $v<br />";
					}
					echo "</p>";
*/
					break;
				case 'module':
				case 'news':
				case 'update':
					if (!array_key_exists('0',$elements)) $elements = array('0'=>$elements);
					foreach($elements as $kkvv => $element) {
						$values = array();
						$fields = array();
						if (array_key_exists('installed_version',$element)) $element['installed'] = (($element['installed_version']!='-') ? 1 : 0);
						foreach($element as $k => $v) {
							$fields[] = $k;
							//if (preg_match('/_date/i',$k)) $v = strtotime($v);
							$values[] = addslashes($v);
						}
						$this->database->query( "INSERT INTO `".TABLE_PREFIX."pacer_channels` ( `".implode('`,`',$fields)."` ) VALUES ( '".implode('\',\'',$values)."' );");
						
						if($this->database->is_error()) $this->Pacer_die($this->database->get_error());		
					}
					break;
				}				
			}
		}
		function Pacer_Version_Check_Element($guid){
			$status = 0; // 0=Not installed 1=Updated, 2=needs update
			if ($row = $this->database->queryRow("SELECT * FROM `".TABLE_PREFIX."pacer_channels` WHERE guid = '$guid' AND installed = '1'")) {
				$status = (($row['status']=='-1') ? 2:1);
			}
			return $status;
		}
		function Pacer_Version_Check_All(){
			$status = 0; // 0=Not installed 1=Updated, 2=needs update
			if ($row = $this->database->queryRow("SELECT * FROM `".TABLE_PREFIX."pacer_channels` WHERE guid = '$guid' AND installed = '1'")) {
				$status = (($row['status']=='-1') ? 2:1);
			}
			return $status;
		}
		
		function Pacer_Version_Check_Install_Pkg($guid){
			require_once(PE_PATH.'/include/pclzip/pclzip.lib.php');
			
			$this->dl_msg = '';
			
			if (!$row = $this->database->queryRow("SELECT * FROM `".TABLE_PREFIX."pacer_channels` WHERE guid = '$guid'")){
				$this->dl_msg = 'GUID error!';
				return false;	
			}
			$url = $row['dlinstall'];
			$type = $row['type'];
			
			// do not display notices and warnings during installation
			error_reporting(0);
			
			

			$root_folder = '';
			switch($type){
				case 'core':
					$root_folder = PE_PATH;
					break;
				case 'module':
					$root_folder = PE_PATH.'/modules';
					break;
				case 'menu':
					$root_folder = PE_PATH.'/menus';
					break;
			}
			$this->temp_file = TEMP_PATH.'/pesus_tmp.zip';
			$this->temp_unzip = TEMP_PATH.'/unzip/';
			$temp_dir = TEMP_PATH.'/';
			
			$this->Pacer_Version_Check_Install_Pkg_Cleanup();
			
			// Check if dest dir is writable
			if(!is_writable($root_folder)) {
				$this->dl_msg = 'Destination folder not writable!';
				return false;
			}
			// dl the url file to /temp
		
			$file_url = $this->request_one_file($url);
			if (is_object($file_url)) {
				$this->dl_msg = "Download error: ".$file_url->getMessage();
				$this->Pacer_Version_Check_Install_Pkg_Cleanup();
				return false;
			}
			if (!$file_url) {
				$this->dl_msg = "Download file error!";
				$this->Pacer_Version_Check_Install_Pkg_Cleanup();
				return false;
			}
			
			if($file_url) file_put_contents($this->temp_file,$file_url);
			
			if (!file_exists($this->temp_file)) {
				$this->dl_msg = "File error! ".$this->temp_file;
				$this->Pacer_Version_Check_Install_Pkg_Cleanup();
				return false;
			}
			
			// check
			$archive = new PclZip($this->temp_file);
			// Unzip the files to the temp unzip folder
			$list = $archive->extract(PCLZIP_OPT_PATH, $this->temp_unzip);
			
			// Check if uploaded file is a valid zip file
			if (!$list) {
				$this->Pacer_Version_Check_Install_Pkg_Cleanup();
				$this->dl_msg = 'Download file corrupted!';
				return false;
			}
			
			if ($type=='core') {
				$module_dir = $root_folder;
			} else {
				// Check if uploaded file is a valid Add-On file
				if (!file_exists($temp_unzip.'index.php')) {
					$this->Pacer_Version_Check_Install_Pkg_Cleanup();
					$this->dl_msg = 'Download file non valid!';
					return false;
				}
			
				// Remove any vars with name "module_directory"
				switch($type) {
					case 'module':
						unset($module_directory);
						break;
					case 'menu':
						unset($pacer_menu_directory);
						break;
				}
			
				// Include the modules info file
				require($this->temp_unzip.'info.php');
			
				switch($type) {
					case 'module':
						break;
					case 'menu':
						if(isset($pacer_menu_directory)) $module_directory = $pacer_menu_directory;
						break;
				}
			
				if ((!isset($module_directory)) || (!$module_directory)) {
					$this->Pacer_Version_Check_Install_Pkg_Cleanup();
					$this->dl_msg = 'Download file has info.php not valid!';
					return false;
				}	
			
				// Perform Add-on requirement checks before proceeding
				require(PE_PATH . '/framework/addon.precheck.inc.php');
				ob_start();
				preCheckAddon($this->temp_file);
				$this->dl_msg = ob_get_contents();
				ob_end_clean();
				if($this->dl_msg){
					$this->Pacer_Version_Check_Install_Pkg_Cleanup();
					return false;
				}
				// Delete the temp unzip directory
				if (is_dir($this->temp_unzip)) rm_full_dir($this->temp_unzip);
			
				// Check if this module is already installed
				// and compare versions if so
				switch($type) {
					case 'module':
						break;
					case 'menu':
						if(isset($pacer_menu_directory)) $module_directory = $pacer_menu_directory;
						break;
				}
				$new_module_version=$module_version;
			
				$action="install";
			
				// Set module directory
				$module_dir = $root_folder.'/'.$module_directory;
			
				if(is_dir($module_dir)) {
					if(file_exists($module_dir.'/info.php')) {
						require($module_dir.'/info.php');
						// Version to be installed is older than currently installed version
						switch($type) {
							case 'module':
								break;
							case 'menu':
								if(isset($pacer_menu_version)) $module_version = $pacer_menu_version;
								break;
						}				
						if (versionCompare($module_version, $new_module_version, '>')) {
							$this->Pacer_Version_Check_Install_Pkg_Cleanup();
							$this->dl_msg = 'Installed version newer!';
							return false;
						}
						$action="upgrade";
					}
				}
			
				$this->do_debug("Performing: ".$action);
				// Make sure the module dir exists, and chmod if needed
				if ($action=="install"){
					make_dir($module_dir);
					$this->do_debug("Make dir: ".$module_dir);
				}
			}
			
			// Unzip module to the module dir
			$list = $archive->extract(PCLZIP_OPT_PATH, $module_dir);
			clearstatcache();
			$this->Pacer_Version_Check_Install_Pkg_Cleanup();
			if(!$list) {
				$this->dl_msg = 'File cannot be unzipped!';
				return false;
			}
			$this->do_debug("File unzipped to: ".$module_dir);
			
			if ($type=='core') {
				$this->LogEvent('Installed: '.$row['name']);
			} else {
				// Chmod all the uploaded files
				$dir = dir($module_dir);
				while (false !== $entry = $dir->read()) {
				// Skip pointers
					if(substr($entry, 0, 1) != '.' && !is_dir($module_dir.'/'.$entry)) {
						// Chmod file
						change_mode($module_dir.'/'.$entry);
					}
				}
				clearstatcache();
				$this->do_debug("chmode: ".$module_dir);
			
				switch($type) {
					case 'module':
						$file=PE_PATH.'/modules/'.$module_directory.'/'.$action.'.php';
						break;
					case 'menu':
						$file = PE_PATH.'/menus/'.$module_directory.'/'.$action.'.php';					
						break;
				}
				if(file_exists($file)) {
					$this->do_debug("require: ".$file);
					require($file);
				}
			
				$this->do_debug("reload: ".$action.'/'.$type);
			
				if ($action=="install") {
					switch($type) {
						case 'module':
							// Load module info into DB
							$this->do_debug("load_module: ".PE_PATH.'/modules/'.$module_directory);
							load_module(PE_PATH.'/modules/'.$module_directory, false);
							break;
						case 'menu':
							$this->do_debug("load_menu: ".PE_PATH.'/menu/'.$module_directory);
							load_menu(PE_PATH.'/menu/'.$module_directory, false);
							break;
					}		
				} elseif ($action=="upgrade") {
					switch($type) {
						case 'module':
							$this->do_debug("upgrade_module: ".$module_directory);
							upgrade_module($module_directory, false);
							break;
						case 'menu':
							$this->do_debug("upgrade_menu: ".$module_directory);
							upgrade_menu($module_directory, false);
							break;
					}		
				}
				// Log result
				switch($action){
					case 'install':
						$this->LogEvent('Installed: '.$row['name']);
						break;
					case 'upgrade':
						$this->LogEvent('Upgraded: '.$row['name']);		
						break;
				}
			}
			return true;
		}
		private function Pacer_Version_Check_Install_Pkg_Cleanup(){
			if (is_dir($this->temp_unzip)) rm_full_dir($this->temp_unzip);
			if (($this->temp_file) && (file_exists($this->temp_file))) unlink($this->temp_file);
		}
		private function Pacer_Version_Check_getRemoteFile($url){
   			// get the host name and url path
   			$parsedUrl = parse_url($url);
   			$host = $parsedUrl['host'];
   			if (isset($parsedUrl['path'])) {
     			 $path = $parsedUrl['path'];
   			} else {
      			// the url is pointing to the host like http://www.mysite.com
      			$path = '/';
   			}

   			if (isset($parsedUrl['query'])) {
      			$path .= '?' . $parsedUrl['query'];
   			}

   			if (isset($parsedUrl['port'])) {
      			$port = $parsedUrl['port'];
   			} else {
      			// most sites use port 80
      			$port = '80';
   			}

   			$timeout = 10;
   			$response = '';

   			// connect to the remote server
   			$fp = @fsockopen($host, $port, $errno, $errstr, $timeout );

   			if( !$fp ) {
     			return false;
   			} else {
      			// send the necessary headers to get the file
      			fputs($fp, "GET $path HTTP/1.0\r\n" .
                 "Host: $host\r\n" .
                 "User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.3) Gecko/20060426 Firefox/1.5.0.3\r\n" .
                 "Accept: */*\r\n" .
                 "Accept-Language: en-us,en;q=0.5\r\n" .
                 "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n" .
                 "Keep-Alive: 300\r\n" .
                 "Connection: keep-alive\r\n" .
                 "Referer: http://$host\r\n\r\n");

      			// retrieve the response from the remote server
      			while ( $line = fread( $fp, 4096 ) ) {
        			 $response .= $line;
      			}

      			fclose( $fp );

      			// strip the headers
      			$pos      = strpos($response, "\r\n\r\n");
      			$response = substr($response, $pos + 4);
   			}

   			// return the file content
   			return $response;
		}
		private function do_debug($msg) {
			if ($this->debug) $this->LogEvent($msg);
		}
	}
}
?>