<?php

/*
 * $Id$
 * The Following license and copyright information must not be removed
 *
 * Software Name: The Pacer Edition CMS
 *    Build Date: July 31, 2009
 *    Build Time: 19:00:00
 *     File Name: edit_template_files.php
 *           URL: http://www.jcwebden.com
 *    PE License: Copyright 2009 The Pacer Edition (JCWEBDEN.COM)
 *                <http://www.jcwebden.com/online/legal/copyright.php>
 *    WB License: GNU General Public License
 *                <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 *
 * Copyright (C) 2009, JCWEBDEN.COM (DARKSTAR INCORPORATED)
 * 
 * The Pacer Edition CMS is provided as free open source software 
 * as well as providing commercial applications within the scope of 
 * The Pacer Edition CMS software;
 * You can redistribute The Pacer Edition CMS and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; version 3 of the License.
 * Though the scope of providing commercial add-ons is bound by the
 * copyright terms laid out at
 * <http://www.jcwebden.com/online/legal/copyright.php>
 *
 * The Pacer Edition CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * A copy of the GNU General Public License for Website Baker Core
 * is provided to you within this script named(GNULICENSE.txt)
 * it also made available by going to
 * <http://www.gnu.org/licenses/gpl-3.0-standalone.html>
 *
 * You should have received a copy of the GNU General Public License
 * along with The Pacer Edition CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * The Pacer Edition CMS <http://www.jcwebden.com/>
 * Copyright (C) 2009, The Pacer Edition (JCWEBDEN.COM)
 *
 * The following must accompany any and all parts of this script
 * Website Baker Project <http://www.websitebaker.org/>
 * Copyright (C) 2004-2009, Ryan Djurovich
 *
 */

// include configuration file and admin wrapper script
require('../config.php');

// Create new admin object
require(PE_PATH.'/framework/class.admin.php');
$admin = new admin('Templates', 'templates');

// include functions to edit the optional module CSS files (frontend.css, backend.css)
require_once(PE_PATH .'/framework/module.functions.php');

if(isset($_POST['file'])){
	$file=$_POST['file'];
} elseif(isset($_GET['file'])){
	$file=$_GET['file'];
} else {
	die(header('Location: index.php')); 
}
$file_url=PE_PATH.$file;

if(!file_exists($file_url)) die(header('Location: index.php')); 
if(!is_file($file_url)) die(header('Location: index.php')); 
if(!is_writable($file_url)) {
	$admin->print_error($Pacer->Translate('File not writable!'),$_SERVER['PHP_SELF'].'?file='.$file);
	exit();
}
/*** get the path info ***/
$info = pathinfo($file_url);
switch(strtolower($info['extension'])){
	case 'js':
		$ft='Java Script';
		$ftq='js';
		break;
	case 'css':
		$ft='Style Sheet';
		$ftq='css';
		break;
	case 'php':
	case 'php3':
	case 'php4':
	case 'php5':
		$ft='PHP Script';
		$ftq='php';
		break;
	case 'html':
	case 'htm':
		$ft='HTML';
		$ftq='html';
		break;
	default:
		$admin->print_error($Pacer->Translate('File extension not allowed!'),$_SERVER['PHP_SELF'].'?file='.$file);
		exit();
}

// check if action is: save
if(isset($_POST['action']) && $_POST['action'] == 'save') {
	/** 
		SAVE THE UPDATED CONTENTS TO THE FILE
	*/
	if (isset($_POST['code_area']) && strlen($_POST['code_area']) > 0)
		$content = stripslashes($_POST['code_area']);
	else $content = '';

	// open the file for writting
	$fp = fopen($file_url, 'wb');
	// write new content to the file
	$bytes = fwrite($fp, $content);
	// close the file
	fclose($fp);
	
	// write out status message
	if($bytes === strlen($content)) {
		$admin->print_success($TEXT['SUCCESS'],$_SERVER['PHP_SELF'].'?file='.$file);
	} else {
		$admin->print_error($TEXT['ERROR'],$_SERVER['PHP_SELF'].'?file='.$file);
	}

}
/** 
	MODIFY CONTENTS OF THE FILE VIA TEXT AREA 
*/

// register the textarea to use edit_area
echo (function_exists('registerEditArea')) ? registerEditArea('code_area', $ftq, false) : '';

if (file_exists(dirname($file_url).'/info.php')) require(dirname($file_url).'/info.php');

// display output
// store content of the module file in variable
$content = file_get_contents($file_url);
// write out heading
echo '<a name="myAnchor"></a>';
echo '<br /><div class="page-info" align="left">
<p>'.((isset($template_name))?$template_name:$ft).'</p></div>';
//echo "<br />";
//echo "<br />";
echo '<p>' .$Pacer->Translate('File').': '.$file .'</p>';
echo "<br />";

// output content of module file to textareas
?>
<script type="text/javascript">jQuery(document).ready(function(){self.location.href = "#myAnchor";});</script>
<form id="edit_template_file" name="edit_template_file" action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" style="margin: 0;">
    <textarea id="code_area" name="code_area" cols="115" rows="25" wrap="VIRTUAL" style="margin:2px;"><?php echo htmlspecialchars($content); ?></textarea>
    <input type="hidden" name="file" value="<?php echo $file; ?>" />
  	<input type="hidden" name="action" value="save"/>
  	<table cellpadding="0" cellspacing="0" border="0" width="98%">
  	<tr>
    	<td align="left" width="50%">
 			<input name="save" type="button" value="<?php echo $TEXT['SAVE'];?>" class="settings_button" style="width:100%;" onclick="javascript:jQuery('#code_area').html(editAreaLoader.getValue('code_area'));jQuery('form#edit_template_file').submit();" 
            />
    	</td>
  		<td align="right" width="50%">
   			<input type="button" value="<?php echo $TEXT['CANCEL']; ?>" class="settings_button"
                	onclick="javascript:window.parent.admin_console_close();" style="width:100%;"/>
		</td>
 	</tr>
 	</table>
</form>